/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */

//#define YYDEBUG 1

	#ifdef __cplusplus
		extern "C" {
	#endif

	#include <stdlib.h>
	#include <stdio.h>
	#include <string.h>
	#include <math.h>
	#include <errno.h>
	#include "../BasicTypes.h"
	#include "../Constants.h"
	#include "../WordCodes.h"
	#include "../CompileErrors.h"
	#include "../ErrorCodes.h"
	#include "../Version.h"


	#define SYMTABLESIZE 2000
	#define IFTABLESIZE 1000
	#define PARSEWARNINGTABLESIZE 10

	extern int yylex();
	extern char *yytext;
	int yyerror(const char *);
	int errorcode;
	extern int column;
	extern int linenumber;
	extern char *lexingfilename;
	extern int numincludes;
	extern int filenumber;
	extern char* include_filenames[];
	extern int include_filenames_counter;

	int *wordCode = NULL;
	unsigned int maxwordoffset = 0;		// size of the current wordCode array
	unsigned int wordOffset = 0;		// current location on the WordCode array

	unsigned int listlen = 0;
	unsigned int listlenmax = 0;
	unsigned int numberoflists = 0;

	unsigned int varnumber[IFTABLESIZE];	// stack of variable numbers in a statement to return the varmumber
	int nvarnumber=0;


	int functionDefSymbol = -1;	// if in a function definition (what is the symbol number) -1 = not in fundef
	int subroutineDefSymbol = -1;	// if in a subroutine definition (what is the symbol number) -1 = not in fundef

	struct label
	{
		char *name;
		int offset;
	};

	char *EMPTYSTR = "";
        char **symtable=NULL;
        int *symtableaddress=NULL;
        int *symtableaddresstype=NULL;
        int *symtableaddressargs=NULL;
        int numsyms = 0;
        int maxsymtable = 0; // size of the current symtable/symtableaddress/symtableaddresstype arrays



	// array to hold stack of if statement branch locations
	// that need to have final jump location added to them
	// the iftable is also used by for, subroutine, and function to insure
	// that no if,do,while,... is nested incorrectly
	unsigned int iftablesourceline[IFTABLESIZE];
	unsigned int iftabletype[IFTABLESIZE];
	int iftableid[IFTABLESIZE];			// used to store a sequential number for this if - unique label creation
	int iftableincludes[IFTABLESIZE];			// used to store the include depth of the code
	unsigned int iftablevariable[IFTABLESIZE];			// store the variable in a FOR to check at NEXT
	int numifs = 0;
	int nextifid;

	#define IFTABLETYPEIF 1
	#define IFTABLETYPEELSE 2
	#define IFTABLETYPEDO 3
	#define IFTABLETYPEWHILE 4
	#define IFTABLETYPEFOR 5
	#define IFTABLETYPEFUNCTION 6
	#define IFTABLETYPETRY 7
	#define IFTABLETYPECATCH 8
	#define IFTABLETYPEBEGINCASE 9
	#define IFTABLETYPECASE 10
	#define IFTABLETYPESUBROUTINE 11
	#define IFTABLETYPEINTERNAL 12


	// store the function variables here during a function definition
	unsigned int args[100];
	unsigned int argstype[100];
	int numargs = 0;

	#define ARGSTYPEVALUE 0
        #define ARGSTYPEVARARRAY 1

	// compiler workings - store in array so that interperter can display all of them
	int parsewarningtable[PARSEWARNINGTABLESIZE];
	int parsewarningtablelinenumber[PARSEWARNINGTABLESIZE];
	int parsewarningtablecolumn[PARSEWARNINGTABLESIZE];
        int parsewarningtablelexingfilenumber[PARSEWARNINGTABLESIZE];
	int numparsewarnings = 0;

        int basicParse(char *);

	void checkWordMem(unsigned int addedwords) {
		unsigned int t;
		if (wordOffset + addedwords + 1 >= maxwordoffset) {
                        maxwordoffset = maxwordoffset + addedwords + 2048;
			wordCode = realloc(wordCode, maxwordoffset * sizeof(int));
			for (t=wordOffset; t<maxwordoffset; t++) {
				*(wordCode+t) = 0;
                        }
		}
	}

	int bytesToFullWords(unsigned int size) {
		// return how many words will be needed to store "size" bytes
                return((size + sizeof(int) - 1) / sizeof(int));
	}

	void addOp(int op) {
		checkWordMem(1);
		wordCode[wordOffset] = op;
                wordOffset++;
		//printf("line=%i addOp op=%i\n",linenumber, op);
	}

        void addData(int data) {
                checkWordMem(1);
                wordCode[wordOffset] = data;
                wordOffset++;
        }

	void addIntOp(int op, int data) {
		addOp(op);
                addData(data);
	}

	void addIntIntOp(int op, int data, int data2) {
		addOp(op);
		addData(data);
		addData(data2);
	}

	void addFloatOp(int op, double data) {
		addOp(op);
		unsigned int wlen = bytesToFullWords(sizeof(double));
		checkWordMem(wlen);
		double *temp = (double *) (wordCode + wordOffset);
		*temp = data;
		wordOffset += wlen;
	}

	void addStringOp(int op, char *data) {
		addOp(op);
		unsigned int len = strlen(data) + 1;
		unsigned int wlen = bytesToFullWords(len);
		checkWordMem(wlen);
		strncpy((char *) (wordCode + wordOffset), data, len);
		wordOffset += wlen;
	}

	void clearIfTable() {
		int j;
		for (j = 0; j < IFTABLESIZE; j++) {
			iftablesourceline[j] = -1;
			iftabletype[j] = -1;
			iftableid[j] = -1;
			iftableincludes[j] = -1;
		}
		numifs = 0;
		nextifid = 0;
	}

	int testIfOnTable(int includelevel) {
		// return line number if there is an unfinished while.do.if.else
		// or send back -1
		if (numifs >=1 ) {
			if (iftableincludes[numifs-1]>=includelevel) {
				return iftablesourceline[numifs-1];
			}
		}
		return -1;
	}

	int testIfOnTableError(int includelevel) {
		// return Error number if there is an unfinished while.do.if.else
		// or send back 0
		if (numifs >=1 ) {
			if (iftableincludes[numifs-1]>=includelevel) {
				if (iftabletype[numifs-1]==IFTABLETYPEIF) return COMPERR_IFNOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEELSE) return COMPERR_ELSENOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEDO) return COMPERR_DONOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEWHILE) return COMPERR_WHILENOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEFOR) return COMPERR_FORNOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEFUNCTION) return COMPERR_FUNCTIONNOEND;
				if (iftabletype[numifs-1]==IFTABLETYPETRY) return COMPERR_TRYNOEND;
				if (iftabletype[numifs-1]==IFTABLETYPECATCH) return COMPERR_CATCHNOEND;
				if (iftabletype[numifs-1]==IFTABLETYPEBEGINCASE) return COMPERR_BEGINCASENOEND;
				if (iftabletype[numifs-1]==IFTABLETYPECASE) return COMPERR_CASENOEND;
				if (iftabletype[numifs-1]==IFTABLETYPESUBROUTINE) return COMPERR_SUBROUTINENOEND;
			}
		}
		return 0;
	}

	int newIf(int sourceline, int type, unsigned int variable) {
		iftablesourceline[numifs] = sourceline;
		iftabletype[numifs] = type;
		iftableid[numifs] = nextifid;
		iftableincludes[numifs] = numincludes;
		iftablevariable[numifs] = variable;
		nextifid++;
		numifs++;
		return numifs - 1;
	}

	void newParseWarning(int type) {
		// add warning to warnings table (if not maximum)
		if (numparsewarnings<PARSEWARNINGTABLESIZE) {
			parsewarningtable[numparsewarnings] = type;
			parsewarningtablelinenumber[numparsewarnings] = linenumber;
			parsewarningtablecolumn[numparsewarnings] = column;
                        parsewarningtablelexingfilenumber[numparsewarnings] = filenumber;
			numparsewarnings++;
		} else {
			parsewarningtable[numparsewarnings-1] = COMPWARNING_MAXIMUMWARNINGS;
			parsewarningtablelinenumber[numparsewarnings-1] = 0;
			parsewarningtablecolumn[numparsewarnings-1] = 0;
                        parsewarningtablelexingfilenumber[numparsewarnings-1] = 0;
		}
	}

	int getSymbol(char *name) {
		// get a symbol if it exists or create a new one on the symbol table
		int i;
		for (i = 0; i < numsyms; i++) {
                        if (symtable[i] && !strcasecmp(name, symtable[i]))
				return i;
		}

		//allocate memory if there is no more room for new symbol
		if(numsyms>=maxsymtable-1){
			maxsymtable += 1024;
			symtable = realloc(symtable, maxsymtable * sizeof(char*));
			symtableaddress = realloc(symtableaddress, maxsymtable * sizeof(int));
			symtableaddresstype = realloc(symtableaddresstype, maxsymtable * sizeof(int));
			symtableaddressargs = realloc(symtableaddressargs, maxsymtable * sizeof(int));
		}

		symtable[numsyms] = strdup(name);
		symtableaddress[numsyms] = -1;
		symtableaddresstype[numsyms] = -1;
		symtableaddressargs[numsyms] = -1;
		numsyms++;
		return numsyms - 1;
	}

	#define INTERNALSYMBOLEXIT 0 //at the end of the loop - all done
	#define INTERNALSYMBOLCONTINUE 1 //at the test of the loop
        #define INTERNALSYMBOLTOP 2 // at the top of the loop - all done

	int getInternalSymbol(int id, int type) {
		// an internal symbol used to jump an if
		int i;
		char name[32];
		sprintf(name,"___%d_%d", id, type);
		i = getSymbol(name);
		symtableaddresstype[i]=ADDRESSTYPE_SYSTEMCALL;
		return i;
	}

	void freeBasicParse() {
		// free all dynamically allocated stuff
		while(numsyms>0) free(symtable[--numsyms]);
		free(wordCode);
		wordCode=NULL;
		free(symtable);
		symtable=NULL;
		free(symtableaddress);
		symtableaddress=NULL;
		free(symtableaddresstype);
		symtableaddresstype=NULL;
		free(symtableaddressargs);
		symtableaddressargs=NULL;
		maxsymtable = 0;
		maxwordoffset = 0;

		while(include_filenames_counter>0){
			include_filenames_counter--;
			free(include_filenames[include_filenames_counter]);
		}
	}

	int initializeBasicParse() {
		int f;
		maxsymtable = 2048;
		symtable = malloc(maxsymtable * sizeof(char*));
		if(symtable)
			for(f=0;f<maxsymtable;f++) symtable[f]=NULL;
		symtableaddress = malloc(maxsymtable * sizeof(int));
		symtableaddresstype = malloc(maxsymtable * sizeof(int));
		symtableaddressargs = malloc(maxsymtable * sizeof(int));

		maxwordoffset = 2048;
		wordCode = malloc(maxwordoffset * sizeof(int));

		//no memory
		if(!wordCode || !symtable || !symtableaddress || !symtableaddresstype || !symtableaddressargs){
			freeBasicParse();
			return -1;
		}

		unsigned int t=maxwordoffset;
		while(t>0) wordCode[--t] = 0;
		wordOffset = 0;
		linenumber = 1;

		listlen = 0;
		listlenmax = 0;
		numberoflists = 0;

		addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
		return 0; 	// success in creating and filling
	}


	#ifdef __cplusplus
	}
	#endif



# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "basicParse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_B256ABS = 3,                    /* B256ABS  */
  YYSYMBOL_B256ACOS = 4,                   /* B256ACOS  */
  YYSYMBOL_B256ADD1 = 5,                   /* B256ADD1  */
  YYSYMBOL_B256ADDEQUAL = 6,               /* B256ADDEQUAL  */
  YYSYMBOL_B256ALERT = 7,                  /* B256ALERT  */
  YYSYMBOL_B256AMP = 8,                    /* B256AMP  */
  YYSYMBOL_B256AMPEQUAL = 9,               /* B256AMPEQUAL  */
  YYSYMBOL_B256AND = 10,                   /* B256AND  */
  YYSYMBOL_B256ARC = 11,                   /* B256ARC  */
  YYSYMBOL_B256ARRAYBASE = 12,             /* B256ARRAYBASE  */
  YYSYMBOL_B256ASC = 13,                   /* B256ASC  */
  YYSYMBOL_B256ASIN = 14,                  /* B256ASIN  */
  YYSYMBOL_B256ASSIGNED = 15,              /* B256ASSIGNED  */
  YYSYMBOL_B256ATAN = 16,                  /* B256ATAN  */
  YYSYMBOL_B256BEGINCASE = 17,             /* B256BEGINCASE  */
  YYSYMBOL_B256BINARYNOT = 18,             /* B256BINARYNOT  */
  YYSYMBOL_B256BINARYOR = 19,              /* B256BINARYOR  */
  YYSYMBOL_B256BITSHIFTL = 20,             /* B256BITSHIFTL  */
  YYSYMBOL_B256BITSHIFTR = 21,             /* B256BITSHIFTR  */
  YYSYMBOL_B256BLACK = 22,                 /* B256BLACK  */
  YYSYMBOL_B256BLUE = 23,                  /* B256BLUE  */
  YYSYMBOL_B256BOOLEOF = 24,               /* B256BOOLEOF  */
  YYSYMBOL_B256BOOLFALSE = 25,             /* B256BOOLFALSE  */
  YYSYMBOL_B256BOOLTRUE = 26,              /* B256BOOLTRUE  */
  YYSYMBOL_B256CALL = 27,                  /* B256CALL  */
  YYSYMBOL_B256CASE = 28,                  /* B256CASE  */
  YYSYMBOL_B256CATCH = 29,                 /* B256CATCH  */
  YYSYMBOL_B256CEIL = 30,                  /* B256CEIL  */
  YYSYMBOL_B256CHANGEDIR = 31,             /* B256CHANGEDIR  */
  YYSYMBOL_B256CHORD = 32,                 /* B256CHORD  */
  YYSYMBOL_B256CHR = 33,                   /* B256CHR  */
  YYSYMBOL_B256CIRCLE = 34,                /* B256CIRCLE  */
  YYSYMBOL_B256CLEAR = 35,                 /* B256CLEAR  */
  YYSYMBOL_B256CLG = 36,                   /* B256CLG  */
  YYSYMBOL_B256CLICKB = 37,                /* B256CLICKB  */
  YYSYMBOL_B256CLICKCLEAR = 38,            /* B256CLICKCLEAR  */
  YYSYMBOL_B256CLICKX = 39,                /* B256CLICKX  */
  YYSYMBOL_B256CLICKY = 40,                /* B256CLICKY  */
  YYSYMBOL_B256CLOSE = 41,                 /* B256CLOSE  */
  YYSYMBOL_B256CLS = 42,                   /* B256CLS  */
  YYSYMBOL_B256CONFIRM = 43,               /* B256CONFIRM  */
  YYSYMBOL_B256CONTINUEDO = 44,            /* B256CONTINUEDO  */
  YYSYMBOL_B256CONTINUEFOR = 45,           /* B256CONTINUEFOR  */
  YYSYMBOL_B256CONTINUEWHILE = 46,         /* B256CONTINUEWHILE  */
  YYSYMBOL_B256COS = 47,                   /* B256COS  */
  YYSYMBOL_B256COUNT = 48,                 /* B256COUNT  */
  YYSYMBOL_B256COUNTX = 49,                /* B256COUNTX  */
  YYSYMBOL_B256CURRENTDIR = 50,            /* B256CURRENTDIR  */
  YYSYMBOL_B256CYAN = 51,                  /* B256CYAN  */
  YYSYMBOL_B256DARKBLUE = 52,              /* B256DARKBLUE  */
  YYSYMBOL_B256DARKCYAN = 53,              /* B256DARKCYAN  */
  YYSYMBOL_B256DARKGREEN = 54,             /* B256DARKGREEN  */
  YYSYMBOL_B256DARKGREY = 55,              /* B256DARKGREY  */
  YYSYMBOL_B256DARKORANGE = 56,            /* B256DARKORANGE  */
  YYSYMBOL_B256DARKPURPLE = 57,            /* B256DARKPURPLE  */
  YYSYMBOL_B256DARKRED = 58,               /* B256DARKRED  */
  YYSYMBOL_B256DARKYELLOW = 59,            /* B256DARKYELLOW  */
  YYSYMBOL_B256DAY = 60,                   /* B256DAY  */
  YYSYMBOL_B256DBCLOSE = 61,               /* B256DBCLOSE  */
  YYSYMBOL_B256DBCLOSESET = 62,            /* B256DBCLOSESET  */
  YYSYMBOL_B256DBEXECUTE = 63,             /* B256DBEXECUTE  */
  YYSYMBOL_B256DBFLOAT = 64,               /* B256DBFLOAT  */
  YYSYMBOL_B256DBINT = 65,                 /* B256DBINT  */
  YYSYMBOL_B256DBNULL = 66,                /* B256DBNULL  */
  YYSYMBOL_B256DBOPEN = 67,                /* B256DBOPEN  */
  YYSYMBOL_B256DBOPENSET = 68,             /* B256DBOPENSET  */
  YYSYMBOL_B256DBROW = 69,                 /* B256DBROW  */
  YYSYMBOL_B256DBSTRING = 70,              /* B256DBSTRING  */
  YYSYMBOL_B256DEBUGINFO = 71,             /* B256DEBUGINFO  */
  YYSYMBOL_B256DEGREES = 72,               /* B256DEGREES  */
  YYSYMBOL_B256DIM = 73,                   /* B256DIM  */
  YYSYMBOL_B256DIR = 74,                   /* B256DIR  */
  YYSYMBOL_B256DIVEQUAL = 75,              /* B256DIVEQUAL  */
  YYSYMBOL_B256DO = 76,                    /* B256DO  */
  YYSYMBOL_B256EDITVISIBLE = 77,           /* B256EDITVISIBLE  */
  YYSYMBOL_B256ELLIPSE = 78,               /* B256ELLIPSE  */
  YYSYMBOL_B256ELSE = 79,                  /* B256ELSE  */
  YYSYMBOL_B256END = 80,                   /* B256END  */
  YYSYMBOL_B256ENDCASE = 81,               /* B256ENDCASE  */
  YYSYMBOL_B256ENDFUNCTION = 82,           /* B256ENDFUNCTION  */
  YYSYMBOL_B256ENDIF = 83,                 /* B256ENDIF  */
  YYSYMBOL_B256ENDSUBROUTINE = 84,         /* B256ENDSUBROUTINE  */
  YYSYMBOL_B256ENDTRY = 85,                /* B256ENDTRY  */
  YYSYMBOL_B256ENDWHILE = 86,              /* B256ENDWHILE  */
  YYSYMBOL_B256ERROR_ARGUMENTCOUNT = 87,   /* B256ERROR_ARGUMENTCOUNT  */
  YYSYMBOL_B256ERROR_ARRAYELEMENT = 88,    /* B256ERROR_ARRAYELEMENT  */
  YYSYMBOL_B256ERROR_ARRAYEVEN = 89,       /* B256ERROR_ARRAYEVEN  */
  YYSYMBOL_B256ERROR_ARRAYEXPR = 90,       /* B256ERROR_ARRAYEXPR  */
  YYSYMBOL_B256ERROR_ARRAYINDEX = 91,      /* B256ERROR_ARRAYINDEX  */
  YYSYMBOL_B256ERROR_ARRAYINDEXMISSING = 92, /* B256ERROR_ARRAYINDEXMISSING  */
  YYSYMBOL_B256ERROR_ARRAYLENGTH2D = 93,   /* B256ERROR_ARRAYLENGTH2D  */
  YYSYMBOL_B256ERROR_ARRAYNITEMS = 94,     /* B256ERROR_ARRAYNITEMS  */
  YYSYMBOL_B256ERROR_ARRAYSIZELARGE = 95,  /* B256ERROR_ARRAYSIZELARGE  */
  YYSYMBOL_B256ERROR_ARRAYSIZESMALL = 96,  /* B256ERROR_ARRAYSIZESMALL  */
  YYSYMBOL_B256ERROR_ASINACOSRANGE = 97,   /* B256ERROR_ASINACOSRANGE  */
  YYSYMBOL_B256ERROR_BOOLEANCONV = 98,     /* B256ERROR_BOOLEANCONV  */
  YYSYMBOL_B256ERROR_DBCOLNO = 99,         /* B256ERROR_DBCOLNO  */
  YYSYMBOL_B256ERROR_DBCONNNUMBER = 100,   /* B256ERROR_DBCONNNUMBER  */
  YYSYMBOL_B256ERROR_DBNOTOPEN = 101,      /* B256ERROR_DBNOTOPEN  */
  YYSYMBOL_B256ERROR_DBNOTSET = 102,       /* B256ERROR_DBNOTSET  */
  YYSYMBOL_B256ERROR_DBNOTSETROW = 103,    /* B256ERROR_DBNOTSETROW  */
  YYSYMBOL_B256ERROR_DBOPEN = 104,         /* B256ERROR_DBOPEN  */
  YYSYMBOL_B256ERROR_DBQUERY = 105,        /* B256ERROR_DBQUERY  */
  YYSYMBOL_B256ERROR_DBSETNUMBER = 106,    /* B256ERROR_DBSETNUMBER  */
  YYSYMBOL_B256ERROR_DIVZERO = 107,        /* B256ERROR_DIVZERO  */
  YYSYMBOL_B256ERROR_DOWNLOAD = 108,       /* B256ERROR_DOWNLOAD  */
  YYSYMBOL_B256ERROR_ENVELOPEMAX = 109,    /* B256ERROR_ENVELOPEMAX  */
  YYSYMBOL_B256ERROR_ENVELOPEODD = 110,    /* B256ERROR_ENVELOPEODD  */
  YYSYMBOL_B256ERROR_EXPECTEDARRAY = 111,  /* B256ERROR_EXPECTEDARRAY  */
  YYSYMBOL_B256ERROR_EXPECTEDSOUND = 112,  /* B256ERROR_EXPECTEDSOUND  */
  YYSYMBOL_B256ERROR_FILENOTOPEN = 113,    /* B256ERROR_FILENOTOPEN  */
  YYSYMBOL_B256ERROR_FILENUMBER = 114,     /* B256ERROR_FILENUMBER  */
  YYSYMBOL_B256ERROR_FILEOPEN = 115,       /* B256ERROR_FILEOPEN  */
  YYSYMBOL_B256ERROR_FILEOPERATION = 116,  /* B256ERROR_FILEOPERATION  */
  YYSYMBOL_B256ERROR_FILERESET = 117,      /* B256ERROR_FILERESET  */
  YYSYMBOL_B256ERROR_FILEWRITE = 118,      /* B256ERROR_FILEWRITE  */
  YYSYMBOL_B256ERROR_FOLDER = 119,         /* B256ERROR_FOLDER  */
  YYSYMBOL_B256ERROR_FREEDB = 120,         /* B256ERROR_FREEDB  */
  YYSYMBOL_B256ERROR_FREEDBSET = 121,      /* B256ERROR_FREEDBSET  */
  YYSYMBOL_B256ERROR_FREEFILE = 122,       /* B256ERROR_FREEFILE  */
  YYSYMBOL_B256ERROR_FREENET = 123,        /* B256ERROR_FREENET  */
  YYSYMBOL_B256ERROR_HARMONICLIST = 124,   /* B256ERROR_HARMONICLIST  */
  YYSYMBOL_B256ERROR_HARMONICNUMBER = 125, /* B256ERROR_HARMONICNUMBER  */
  YYSYMBOL_B256ERROR_IMAGEFILE = 126,      /* B256ERROR_IMAGEFILE  */
  YYSYMBOL_B256ERROR_IMAGERESOURCE = 127,  /* B256ERROR_IMAGERESOURCE  */
  YYSYMBOL_B256ERROR_IMAGESAVETYPE = 128,  /* B256ERROR_IMAGESAVETYPE  */
  YYSYMBOL_B256ERROR_IMAGESCALE = 129,     /* B256ERROR_IMAGESCALE  */
  YYSYMBOL_B256ERROR_INFINITY = 130,       /* B256ERROR_INFINITY  */
  YYSYMBOL_B256ERROR_INTEGERRANGE = 131,   /* B256ERROR_INTEGERRANGE  */
  YYSYMBOL_B256ERROR_INVALIDKEYNAME = 132, /* B256ERROR_INVALIDKEYNAME  */
  YYSYMBOL_B256ERROR_INVALIDPROGNAME = 133, /* B256ERROR_INVALIDPROGNAME  */
  YYSYMBOL_B256ERROR_INVALIDRESOURCE = 134, /* B256ERROR_INVALIDRESOURCE  */
  YYSYMBOL_B256ERROR_LOGRANGE = 135,       /* B256ERROR_LOGRANGE  */
  YYSYMBOL_B256ERROR_LONGRANGE = 136,      /* B256ERROR_LONGRANGE  */
  YYSYMBOL_B256ERROR_MAXRECURSE = 137,     /* B256ERROR_MAXRECURSE  */
  YYSYMBOL_B256ERROR_NETACCEPT = 138,      /* B256ERROR_NETACCEPT  */
  YYSYMBOL_B256ERROR_NETBIND = 139,        /* B256ERROR_NETBIND  */
  YYSYMBOL_B256ERROR_NETCONN = 140,        /* B256ERROR_NETCONN  */
  YYSYMBOL_B256ERROR_NETHOST = 141,        /* B256ERROR_NETHOST  */
  YYSYMBOL_B256ERROR_NETNONE = 142,        /* B256ERROR_NETNONE  */
  YYSYMBOL_B256ERROR_NETREAD = 143,        /* B256ERROR_NETREAD  */
  YYSYMBOL_B256ERROR_NETSOCK = 144,        /* B256ERROR_NETSOCK  */
  YYSYMBOL_B256ERROR_NETSOCKNUMBER = 145,  /* B256ERROR_NETSOCKNUMBER  */
  YYSYMBOL_B256ERROR_NETSOCKOPT = 146,     /* B256ERROR_NETSOCKOPT  */
  YYSYMBOL_B256ERROR_NETWRITE = 147,       /* B256ERROR_NETWRITE  */
  YYSYMBOL_B256ERROR_NEXTNOFOR = 148,      /* B256ERROR_NEXTNOFOR  */
  YYSYMBOL_B256ERROR_NONE = 149,           /* B256ERROR_NONE  */
  YYSYMBOL_B256ERROR_NOSUCHFUNCTION = 150, /* B256ERROR_NOSUCHFUNCTION  */
  YYSYMBOL_B256ERROR_NOSUCHLABEL = 151,    /* B256ERROR_NOSUCHLABEL  */
  YYSYMBOL_B256ERROR_NOSUCHSUBROUTINE = 152, /* B256ERROR_NOSUCHSUBROUTINE  */
  YYSYMBOL_B256ERROR_NOTARRAY = 153,       /* B256ERROR_NOTARRAY  */
  YYSYMBOL_B256ERROR_NOTIMPLEMENTED = 154, /* B256ERROR_NOTIMPLEMENTED  */
  YYSYMBOL_B256ERROR_NUMBERCONV = 155,     /* B256ERROR_NUMBERCONV  */
  YYSYMBOL_B256ERROR_NUMBEREXPR = 156,     /* B256ERROR_NUMBEREXPR  */
  YYSYMBOL_B256ERROR_ONEDIMENSIONAL = 157, /* B256ERROR_ONEDIMENSIONAL  */
  YYSYMBOL_B256ERROR_ONERRORSUB = 158,     /* B256ERROR_ONERRORSUB  */
  YYSYMBOL_B256ERROR_PENWIDTH = 159,       /* B256ERROR_PENWIDTH  */
  YYSYMBOL_B256ERROR_PERMISSION = 160,     /* B256ERROR_PERMISSION  */
  YYSYMBOL_B256ERROR_POLYPOINTS = 161,     /* B256ERROR_POLYPOINTS  */
  YYSYMBOL_B256ERROR_PRINTERNOTOFF = 162,  /* B256ERROR_PRINTERNOTOFF  */
  YYSYMBOL_B256ERROR_PRINTERNOTON = 163,   /* B256ERROR_PRINTERNOTON  */
  YYSYMBOL_B256ERROR_PRINTEROPEN = 164,    /* B256ERROR_PRINTEROPEN  */
  YYSYMBOL_B256ERROR_RADIX = 165,          /* B256ERROR_RADIX  */
  YYSYMBOL_B256ERROR_RADIXSTRING = 166,    /* B256ERROR_RADIXSTRING  */
  YYSYMBOL_B256ERROR_REFNOTASSIGNED = 167, /* B256ERROR_REFNOTASSIGNED  */
  YYSYMBOL_B256ERROR_RGB = 168,            /* B256ERROR_RGB  */
  YYSYMBOL_B256ERROR_SERIALPARAMETER = 169, /* B256ERROR_SERIALPARAMETER  */
  YYSYMBOL_B256ERROR_SETTINGMAXKEYS = 170, /* B256ERROR_SETTINGMAXKEYS  */
  YYSYMBOL_B256ERROR_SETTINGMAXLEN = 171,  /* B256ERROR_SETTINGMAXLEN  */
  YYSYMBOL_B256ERROR_SETTINGSGETACCESS = 172, /* B256ERROR_SETTINGSGETACCESS  */
  YYSYMBOL_B256ERROR_SETTINGSSETACCESS = 173, /* B256ERROR_SETTINGSSETACCESS  */
  YYSYMBOL_B256ERROR_SLICESIZE = 174,      /* B256ERROR_SLICESIZE  */
  YYSYMBOL_B256ERROR_SOUNDERROR = 175,     /* B256ERROR_SOUNDERROR  */
  YYSYMBOL_B256ERROR_SOUNDFILE = 176,      /* B256ERROR_SOUNDFILE  */
  YYSYMBOL_B256ERROR_SOUNDFILEFORMAT = 177, /* B256ERROR_SOUNDFILEFORMAT  */
  YYSYMBOL_B256ERROR_SOUNDLENGTH = 178,    /* B256ERROR_SOUNDLENGTH  */
  YYSYMBOL_B256ERROR_SOUNDNOTSEEKABLE = 179, /* B256ERROR_SOUNDNOTSEEKABLE  */
  YYSYMBOL_B256ERROR_SOUNDRESOURCE = 180,  /* B256ERROR_SOUNDRESOURCE  */
  YYSYMBOL_B256ERROR_SPRITENA = 181,       /* B256ERROR_SPRITENA  */
  YYSYMBOL_B256ERROR_SPRITENUMBER = 182,   /* B256ERROR_SPRITENUMBER  */
  YYSYMBOL_B256ERROR_SPRITESLICE = 183,    /* B256ERROR_SPRITESLICE  */
  YYSYMBOL_B256ERROR_SQRRANGE = 184,       /* B256ERROR_SQRRANGE  */
  YYSYMBOL_B256ERROR_STACKUNDERFLOW = 185, /* B256ERROR_STACKUNDERFLOW  */
  YYSYMBOL_B256ERROR_STRING2NOTE = 186,    /* B256ERROR_STRING2NOTE  */
  YYSYMBOL_B256ERROR_STRINGCONV = 187,     /* B256ERROR_STRINGCONV  */
  YYSYMBOL_B256ERROR_STRINGEXPR = 188,     /* B256ERROR_STRINGEXPR  */
  YYSYMBOL_B256ERROR_STRINGMAXLEN = 189,   /* B256ERROR_STRINGMAXLEN  */
  YYSYMBOL_B256ERROR_STRSTART = 190,       /* B256ERROR_STRSTART  */
  YYSYMBOL_B256ERROR_TOOMANYSOUNDS = 191,  /* B256ERROR_TOOMANYSOUNDS  */
  YYSYMBOL_B256ERROR_UNEXPECTEDRETURN = 192, /* B256ERROR_UNEXPECTEDRETURN  */
  YYSYMBOL_B256ERROR_UNSERIALIZEFORMAT = 193, /* B256ERROR_UNSERIALIZEFORMAT  */
  YYSYMBOL_B256ERROR_VARCIRCULAR = 194,    /* B256ERROR_VARCIRCULAR  */
  YYSYMBOL_B256ERROR_VARNOTASSIGNED = 195, /* B256ERROR_VARNOTASSIGNED  */
  YYSYMBOL_B256ERROR_VARNULL = 196,        /* B256ERROR_VARNULL  */
  YYSYMBOL_B256ERROR_WAVEFORMLOGICAL = 197, /* B256ERROR_WAVEFORMLOGICAL  */
  YYSYMBOL_B256ERROR_WAVOBSOLETE = 198,    /* B256ERROR_WAVOBSOLETE  */
  YYSYMBOL_B256EXISTS = 199,               /* B256EXISTS  */
  YYSYMBOL_B256EXITDO = 200,               /* B256EXITDO  */
  YYSYMBOL_B256EXITFOR = 201,              /* B256EXITFOR  */
  YYSYMBOL_B256EXITWHILE = 202,            /* B256EXITWHILE  */
  YYSYMBOL_B256EXP = 203,                  /* B256EXP  */
  YYSYMBOL_B256EXPLODE = 204,              /* B256EXPLODE  */
  YYSYMBOL_B256EXPLODEX = 205,             /* B256EXPLODEX  */
  YYSYMBOL_B256FASTGRAPHICS = 206,         /* B256FASTGRAPHICS  */
  YYSYMBOL_B256FILL = 207,                 /* B256FILL  */
  YYSYMBOL_B256FLOOR = 208,                /* B256FLOOR  */
  YYSYMBOL_B256FONT = 209,                 /* B256FONT  */
  YYSYMBOL_B256FOR = 210,                  /* B256FOR  */
  YYSYMBOL_B256FOREACH = 211,              /* B256FOREACH  */
  YYSYMBOL_B256FREEDB = 212,               /* B256FREEDB  */
  YYSYMBOL_B256FREEDBSET = 213,            /* B256FREEDBSET  */
  YYSYMBOL_B256FREEFILE = 214,             /* B256FREEFILE  */
  YYSYMBOL_B256FREENET = 215,              /* B256FREENET  */
  YYSYMBOL_B256FROMBINARY = 216,           /* B256FROMBINARY  */
  YYSYMBOL_B256FROMHEX = 217,              /* B256FROMHEX  */
  YYSYMBOL_B256FROMOCTAL = 218,            /* B256FROMOCTAL  */
  YYSYMBOL_B256FROMRADIX = 219,            /* B256FROMRADIX  */
  YYSYMBOL_B256FUNCTION = 220,             /* B256FUNCTION  */
  YYSYMBOL_B256GETARRAYBASE = 221,         /* B256GETARRAYBASE  */
  YYSYMBOL_B256GETBRUSHCOLOR = 222,        /* B256GETBRUSHCOLOR  */
  YYSYMBOL_B256GETCLIPBOARDIMAGE = 223,    /* B256GETCLIPBOARDIMAGE  */
  YYSYMBOL_B256GETCLIPBOARDSTRING = 224,   /* B256GETCLIPBOARDSTRING  */
  YYSYMBOL_B256GETCOLOR = 225,             /* B256GETCOLOR  */
  YYSYMBOL_B256GETPENWIDTH = 226,          /* B256GETPENWIDTH  */
  YYSYMBOL_B256GETSETTING = 227,           /* B256GETSETTING  */
  YYSYMBOL_B256GETSLICE = 228,             /* B256GETSLICE  */
  YYSYMBOL_B256GLOBAL = 229,               /* B256GLOBAL  */
  YYSYMBOL_B256GOSUB = 230,                /* B256GOSUB  */
  YYSYMBOL_B256GOTO = 231,                 /* B256GOTO  */
  YYSYMBOL_B256GRAPHHEIGHT = 232,          /* B256GRAPHHEIGHT  */
  YYSYMBOL_B256GRAPHSIZE = 233,            /* B256GRAPHSIZE  */
  YYSYMBOL_B256GRAPHVISIBLE = 234,         /* B256GRAPHVISIBLE  */
  YYSYMBOL_B256GRAPHTOOLBARVISIBLE = 235,  /* B256GRAPHTOOLBARVISIBLE  */
  YYSYMBOL_B256GRAPHWIDTH = 236,           /* B256GRAPHWIDTH  */
  YYSYMBOL_B256GREEN = 237,                /* B256GREEN  */
  YYSYMBOL_B256GREY = 238,                 /* B256GREY  */
  YYSYMBOL_B256GTE = 239,                  /* B256GTE  */
  YYSYMBOL_B256HOUR = 240,                 /* B256HOUR  */
  YYSYMBOL_B256IF = 241,                   /* B256IF  */
  YYSYMBOL_B256IN = 242,                   /* B256IN  */
  YYSYMBOL_B256IMAGEAUTOCROP = 243,        /* B256IMAGEAUTOCROP  */
  YYSYMBOL_B256IMAGECENTERED = 244,        /* B256IMAGECENTERED  */
  YYSYMBOL_B256IMAGECOPY = 245,            /* B256IMAGECOPY  */
  YYSYMBOL_B256IMAGECROP = 246,            /* B256IMAGECROP  */
  YYSYMBOL_B256IMAGEDRAW = 247,            /* B256IMAGEDRAW  */
  YYSYMBOL_B256IMAGEFLIP = 248,            /* B256IMAGEFLIP  */
  YYSYMBOL_B256IMAGEHEIGHT = 249,          /* B256IMAGEHEIGHT  */
  YYSYMBOL_B256IMAGELOAD = 250,            /* B256IMAGELOAD  */
  YYSYMBOL_B256IMAGENEW = 251,             /* B256IMAGENEW  */
  YYSYMBOL_B256IMAGEPIXEL = 252,           /* B256IMAGEPIXEL  */
  YYSYMBOL_B256IMAGERESIZE = 253,          /* B256IMAGERESIZE  */
  YYSYMBOL_B256IMAGEROTATE = 254,          /* B256IMAGEROTATE  */
  YYSYMBOL_B256IMAGESETPIXEL = 255,        /* B256IMAGESETPIXEL  */
  YYSYMBOL_B256IMAGESMOOTH = 256,          /* B256IMAGESMOOTH  */
  YYSYMBOL_B256IMAGETRANSFORMED = 257,     /* B256IMAGETRANSFORMED  */
  YYSYMBOL_B256IMAGETYPE_BMP = 258,        /* B256IMAGETYPE_BMP  */
  YYSYMBOL_B256IMAGETYPE_JPG = 259,        /* B256IMAGETYPE_JPG  */
  YYSYMBOL_B256IMAGETYPE_PNG = 260,        /* B256IMAGETYPE_PNG  */
  YYSYMBOL_B256IMAGEWIDTH = 261,           /* B256IMAGEWIDTH  */
  YYSYMBOL_B256IMGLOAD = 262,              /* B256IMGLOAD  */
  YYSYMBOL_B256IMGSAVE = 263,              /* B256IMGSAVE  */
  YYSYMBOL_B256IMPLODE = 264,              /* B256IMPLODE  */
  YYSYMBOL_B256INPUT = 265,                /* B256INPUT  */
  YYSYMBOL_B256INPUTFLOAT = 266,           /* B256INPUTFLOAT  */
  YYSYMBOL_B256INPUTINT = 267,             /* B256INPUTINT  */
  YYSYMBOL_B256INPUTSTRING = 268,          /* B256INPUTSTRING  */
  YYSYMBOL_B256INSTR = 269,                /* B256INSTR  */
  YYSYMBOL_B256INSTRX = 270,               /* B256INSTRX  */
  YYSYMBOL_B256INTDIV = 271,               /* B256INTDIV  */
  YYSYMBOL_B256ISNUMERIC = 272,            /* B256ISNUMERIC  */
  YYSYMBOL_B256KEY = 273,                  /* B256KEY  */
  YYSYMBOL_B256KEYPRESSED = 274,           /* B256KEYPRESSED  */
  YYSYMBOL_B256KILL = 275,                 /* B256KILL  */
  YYSYMBOL_B256LASTERROR = 276,            /* B256LASTERROR  */
  YYSYMBOL_B256LASTERROREXTRA = 277,       /* B256LASTERROREXTRA  */
  YYSYMBOL_B256LASTERRORLINE = 278,        /* B256LASTERRORLINE  */
  YYSYMBOL_B256LASTERRORMESSAGE = 279,     /* B256LASTERRORMESSAGE  */
  YYSYMBOL_B256LEFT = 280,                 /* B256LEFT  */
  YYSYMBOL_B256LENGTH = 281,               /* B256LENGTH  */
  YYSYMBOL_B256LET = 282,                  /* B256LET  */
  YYSYMBOL_B256LINE = 283,                 /* B256LINE  */
  YYSYMBOL_B256LJUST = 284,                /* B256LJUST  */
  YYSYMBOL_B256LOG = 285,                  /* B256LOG  */
  YYSYMBOL_B256LOGTEN = 286,               /* B256LOGTEN  */
  YYSYMBOL_B256LOWER = 287,                /* B256LOWER  */
  YYSYMBOL_B256LTE = 288,                  /* B256LTE  */
  YYSYMBOL_B256LTRIM = 289,                /* B256LTRIM  */
  YYSYMBOL_B256MAINTOOLBARVISIBLE = 290,   /* B256MAINTOOLBARVISIBLE  */
  YYSYMBOL_B256MAP = 291,                  /* B256MAP  */
  YYSYMBOL_B256MD5 = 292,                  /* B256MD5  */
  YYSYMBOL_B256MID = 293,                  /* B256MID  */
  YYSYMBOL_B256MIDX = 294,                 /* B256MIDX  */
  YYSYMBOL_B256MINUTE = 295,               /* B256MINUTE  */
  YYSYMBOL_B256MOD = 296,                  /* B256MOD  */
  YYSYMBOL_B256MONTH = 297,                /* B256MONTH  */
  YYSYMBOL_B256MOUSEB = 298,               /* B256MOUSEB  */
  YYSYMBOL_B256MOUSEBUTTON_CENTER = 299,   /* B256MOUSEBUTTON_CENTER  */
  YYSYMBOL_B256MOUSEBUTTON_DOUBLECLICK = 300, /* B256MOUSEBUTTON_DOUBLECLICK  */
  YYSYMBOL_B256MOUSEBUTTON_LEFT = 301,     /* B256MOUSEBUTTON_LEFT  */
  YYSYMBOL_B256MOUSEBUTTON_NONE = 302,     /* B256MOUSEBUTTON_NONE  */
  YYSYMBOL_B256MOUSEBUTTON_RIGHT = 303,    /* B256MOUSEBUTTON_RIGHT  */
  YYSYMBOL_B256MOUSEX = 304,               /* B256MOUSEX  */
  YYSYMBOL_B256MOUSEY = 305,               /* B256MOUSEY  */
  YYSYMBOL_B256MSEC = 306,                 /* B256MSEC  */
  YYSYMBOL_B256MULEQUAL = 307,             /* B256MULEQUAL  */
  YYSYMBOL_B256NE = 308,                   /* B256NE  */
  YYSYMBOL_B256NETADDRESS = 309,           /* B256NETADDRESS  */
  YYSYMBOL_B256NETCLOSE = 310,             /* B256NETCLOSE  */
  YYSYMBOL_B256NETCONNECT = 311,           /* B256NETCONNECT  */
  YYSYMBOL_B256NETDATA = 312,              /* B256NETDATA  */
  YYSYMBOL_B256NETLISTEN = 313,            /* B256NETLISTEN  */
  YYSYMBOL_B256NETREAD = 314,              /* B256NETREAD  */
  YYSYMBOL_B256NETWRITE = 315,             /* B256NETWRITE  */
  YYSYMBOL_B256NEXT = 316,                 /* B256NEXT  */
  YYSYMBOL_B256NOT = 317,                  /* B256NOT  */
  YYSYMBOL_B256OFFERROR = 318,             /* B256OFFERROR  */
  YYSYMBOL_B256ONERROR = 319,              /* B256ONERROR  */
  YYSYMBOL_B256OPEN = 320,                 /* B256OPEN  */
  YYSYMBOL_B256OPENB = 321,                /* B256OPENB  */
  YYSYMBOL_B256OPENFILEDIALOG = 322,       /* B256OPENFILEDIALOG  */
  YYSYMBOL_B256OPENSERIAL = 323,           /* B256OPENSERIAL  */
  YYSYMBOL_B256OR = 324,                   /* B256OR  */
  YYSYMBOL_B256ORANGE = 325,               /* B256ORANGE  */
  YYSYMBOL_B256OSTYPE = 326,               /* B256OSTYPE  */
  YYSYMBOL_B256OSTYPE_ANDROID = 327,       /* B256OSTYPE_ANDROID  */
  YYSYMBOL_B256OSTYPE_LINUX = 328,         /* B256OSTYPE_LINUX  */
  YYSYMBOL_B256OSTYPE_MACINTOSH = 329,     /* B256OSTYPE_MACINTOSH  */
  YYSYMBOL_B256OSTYPE_WINDOWS = 330,       /* B256OSTYPE_WINDOWS  */
  YYSYMBOL_B256OUTPUTVISIBLE = 331,        /* B256OUTPUTVISIBLE  */
  YYSYMBOL_B256OUTPUTTOOLBARVISIBLE = 332, /* B256OUTPUTTOOLBARVISIBLE  */
  YYSYMBOL_B256PAUSE = 333,                /* B256PAUSE  */
  YYSYMBOL_B256PENWIDTH = 334,             /* B256PENWIDTH  */
  YYSYMBOL_B256PI = 335,                   /* B256PI  */
  YYSYMBOL_B256PIE = 336,                  /* B256PIE  */
  YYSYMBOL_B256PIXEL = 337,                /* B256PIXEL  */
  YYSYMBOL_B256PLOT = 338,                 /* B256PLOT  */
  YYSYMBOL_B256POLY = 339,                 /* B256POLY  */
  YYSYMBOL_B256PORTIN = 340,               /* B256PORTIN  */
  YYSYMBOL_B256PORTOUT = 341,              /* B256PORTOUT  */
  YYSYMBOL_B256PRINT = 342,                /* B256PRINT  */
  YYSYMBOL_B256PRINTERCANCEL = 343,        /* B256PRINTERCANCEL  */
  YYSYMBOL_B256PRINTEROFF = 344,           /* B256PRINTEROFF  */
  YYSYMBOL_B256PRINTERON = 345,            /* B256PRINTERON  */
  YYSYMBOL_B256PRINTERPAGE = 346,          /* B256PRINTERPAGE  */
  YYSYMBOL_B256PROMPT = 347,               /* B256PROMPT  */
  YYSYMBOL_B256PURPLE = 348,               /* B256PURPLE  */
  YYSYMBOL_B256PUTSLICE = 349,             /* B256PUTSLICE  */
  YYSYMBOL_B256RADIANS = 350,              /* B256RADIANS  */
  YYSYMBOL_B256RAND = 351,                 /* B256RAND  */
  YYSYMBOL_B256READ = 352,                 /* B256READ  */
  YYSYMBOL_B256READBYTE = 353,             /* B256READBYTE  */
  YYSYMBOL_B256READLINE = 354,             /* B256READLINE  */
  YYSYMBOL_B256RECT = 355,                 /* B256RECT  */
  YYSYMBOL_B256RED = 356,                  /* B256RED  */
  YYSYMBOL_B256REDIM = 357,                /* B256REDIM  */
  YYSYMBOL_B256REF = 358,                  /* B256REF  */
  YYSYMBOL_B256REFRESH = 359,              /* B256REFRESH  */
  YYSYMBOL_B256REGEXMINIMAL = 360,         /* B256REGEXMINIMAL  */
  YYSYMBOL_B256REM = 361,                  /* B256REM  */
  YYSYMBOL_B256REPLACE = 362,              /* B256REPLACE  */
  YYSYMBOL_B256REPLACEX = 363,             /* B256REPLACEX  */
  YYSYMBOL_B256SAVEFILEDIALOG = 364,       /* B256SAVEFILEDIALOG  */
  YYSYMBOL_B256RESET = 365,                /* B256RESET  */
  YYSYMBOL_B256RETURN = 366,               /* B256RETURN  */
  YYSYMBOL_B256RGB = 367,                  /* B256RGB  */
  YYSYMBOL_B256RIGHT = 368,                /* B256RIGHT  */
  YYSYMBOL_B256RJUST = 369,                /* B256RJUST  */
  YYSYMBOL_B256ROUND = 370,                /* B256ROUND  */
  YYSYMBOL_B256RTRIM = 371,                /* B256RTRIM  */
  YYSYMBOL_B256SAY = 372,                  /* B256SAY  */
  YYSYMBOL_B256SECOND = 373,               /* B256SECOND  */
  YYSYMBOL_B256SEED = 374,                 /* B256SEED  */
  YYSYMBOL_B256SEEK = 375,                 /* B256SEEK  */
  YYSYMBOL_B256SEMICOLON = 376,            /* B256SEMICOLON  */
  YYSYMBOL_B256SEMICOLONEQUAL = 377,       /* B256SEMICOLONEQUAL  */
  YYSYMBOL_B256SERIALIZE = 378,            /* B256SERIALIZE  */
  YYSYMBOL_B256SETCLIPBOARDIMAGE = 379,    /* B256SETCLIPBOARDIMAGE  */
  YYSYMBOL_B256SETCLIPBOARDSTRING = 380,   /* B256SETCLIPBOARDSTRING  */
  YYSYMBOL_B256SETCOLOR = 381,             /* B256SETCOLOR  */
  YYSYMBOL_B256SETGRAPH = 382,             /* B256SETGRAPH  */
  YYSYMBOL_B256SETSETTING = 383,           /* B256SETSETTING  */
  YYSYMBOL_B256SIN = 384,                  /* B256SIN  */
  YYSYMBOL_B256SIZE = 385,                 /* B256SIZE  */
  YYSYMBOL_B256SLICE_ALL = 386,            /* B256SLICE_ALL  */
  YYSYMBOL_B256SLICE_PAINT = 387,          /* B256SLICE_PAINT  */
  YYSYMBOL_B256SLICE_SPRITE = 388,         /* B256SLICE_SPRITE  */
  YYSYMBOL_B256SOUND = 389,                /* B256SOUND  */
  YYSYMBOL_B256SOUNDENVELOPE = 390,        /* B256SOUNDENVELOPE  */
  YYSYMBOL_B256SOUNDFADE = 391,            /* B256SOUNDFADE  */
  YYSYMBOL_B256SOUNDHARMONICS = 392,       /* B256SOUNDHARMONICS  */
  YYSYMBOL_B256SOUNDID = 393,              /* B256SOUNDID  */
  YYSYMBOL_B256SOUNDLENGTH = 394,          /* B256SOUNDLENGTH  */
  YYSYMBOL_B256SOUNDLOAD = 395,            /* B256SOUNDLOAD  */
  YYSYMBOL_B256SOUNDLOADRAW = 396,         /* B256SOUNDLOADRAW  */
  YYSYMBOL_B256SOUNDLOOP = 397,            /* B256SOUNDLOOP  */
  YYSYMBOL_B256SOUNDPAUSE = 398,           /* B256SOUNDPAUSE  */
  YYSYMBOL_B256SOUNDPLAY = 399,            /* B256SOUNDPLAY  */
  YYSYMBOL_B256SOUNDPLAYER = 400,          /* B256SOUNDPLAYER  */
  YYSYMBOL_B256SOUNDPLAYEROFF = 401,       /* B256SOUNDPLAYEROFF  */
  YYSYMBOL_B256SOUNDPOSITION = 402,        /* B256SOUNDPOSITION  */
  YYSYMBOL_B256SOUNDSAMPLERATE = 403,      /* B256SOUNDSAMPLERATE  */
  YYSYMBOL_B256SOUNDSEEK = 404,            /* B256SOUNDSEEK  */
  YYSYMBOL_B256SOUNDSTATE = 405,           /* B256SOUNDSTATE  */
  YYSYMBOL_B256SOUNDSTOP = 406,            /* B256SOUNDSTOP  */
  YYSYMBOL_B256SOUNDSYSTEM = 407,          /* B256SOUNDSYSTEM  */
  YYSYMBOL_B256SOUNDVOLUME = 408,          /* B256SOUNDVOLUME  */
  YYSYMBOL_B256SOUNDWAIT = 409,            /* B256SOUNDWAIT  */
  YYSYMBOL_B256SOUNDWAVEFORM = 410,        /* B256SOUNDWAVEFORM  */
  YYSYMBOL_B256SPRITECOLLIDE = 411,        /* B256SPRITECOLLIDE  */
  YYSYMBOL_B256SPRITEDIM = 412,            /* B256SPRITEDIM  */
  YYSYMBOL_B256SPRITEH = 413,              /* B256SPRITEH  */
  YYSYMBOL_B256SPRITEHIDE = 414,           /* B256SPRITEHIDE  */
  YYSYMBOL_B256SPRITELOAD = 415,           /* B256SPRITELOAD  */
  YYSYMBOL_B256SPRITEMOVE = 416,           /* B256SPRITEMOVE  */
  YYSYMBOL_B256SPRITEO = 417,              /* B256SPRITEO  */
  YYSYMBOL_B256SPRITEPLACE = 418,          /* B256SPRITEPLACE  */
  YYSYMBOL_B256SPRITEPOLY = 419,           /* B256SPRITEPOLY  */
  YYSYMBOL_B256SPRITER = 420,              /* B256SPRITER  */
  YYSYMBOL_B256SPRITES = 421,              /* B256SPRITES  */
  YYSYMBOL_B256SPRITESHOW = 422,           /* B256SPRITESHOW  */
  YYSYMBOL_B256SPRITESLICE = 423,          /* B256SPRITESLICE  */
  YYSYMBOL_B256SPRITEV = 424,              /* B256SPRITEV  */
  YYSYMBOL_B256SPRITEW = 425,              /* B256SPRITEW  */
  YYSYMBOL_B256SPRITEX = 426,              /* B256SPRITEX  */
  YYSYMBOL_B256SPRITEY = 427,              /* B256SPRITEY  */
  YYSYMBOL_B256SQR = 428,                  /* B256SQR  */
  YYSYMBOL_B256STAMP = 429,                /* B256STAMP  */
  YYSYMBOL_B256STEP = 430,                 /* B256STEP  */
  YYSYMBOL_B256SUB1 = 431,                 /* B256SUB1  */
  YYSYMBOL_B256SUBEQUAL = 432,             /* B256SUBEQUAL  */
  YYSYMBOL_B256SUBROUTINE = 433,           /* B256SUBROUTINE  */
  YYSYMBOL_B256SYSTEM = 434,               /* B256SYSTEM  */
  YYSYMBOL_B256TAN = 435,                  /* B256TAN  */
  YYSYMBOL_B256TEXT = 436,                 /* B256TEXT  */
  YYSYMBOL_B256TEXTHEIGHT = 437,           /* B256TEXTHEIGHT  */
  YYSYMBOL_B256TEXTWIDTH = 438,            /* B256TEXTWIDTH  */
  YYSYMBOL_B256THEN = 439,                 /* B256THEN  */
  YYSYMBOL_B256THROWERROR = 440,           /* B256THROWERROR  */
  YYSYMBOL_B256TO = 441,                   /* B256TO  */
  YYSYMBOL_B256TOBINARY = 442,             /* B256TOBINARY  */
  YYSYMBOL_B256TOFLOAT = 443,              /* B256TOFLOAT  */
  YYSYMBOL_B256TOHEX = 444,                /* B256TOHEX  */
  YYSYMBOL_B256TOINT = 445,                /* B256TOINT  */
  YYSYMBOL_B256TOOCTAL = 446,              /* B256TOOCTAL  */
  YYSYMBOL_B256TORADIX = 447,              /* B256TORADIX  */
  YYSYMBOL_B256TOSTRING = 448,             /* B256TOSTRING  */
  YYSYMBOL_B256TRIM = 449,                 /* B256TRIM  */
  YYSYMBOL_B256TRY = 450,                  /* B256TRY  */
  YYSYMBOL_B256TYPEOF = 451,               /* B256TYPEOF  */
  YYSYMBOL_B256TYPE_ARRAY = 452,           /* B256TYPE_ARRAY  */
  YYSYMBOL_B256TYPE_FLOAT = 453,           /* B256TYPE_FLOAT  */
  YYSYMBOL_B256TYPE_INT = 454,             /* B256TYPE_INT  */
  YYSYMBOL_B256TYPE_MAP = 455,             /* B256TYPE_MAP  */
  YYSYMBOL_B256TYPE_REF = 456,             /* B256TYPE_REF  */
  YYSYMBOL_B256TYPE_STRING = 457,          /* B256TYPE_STRING  */
  YYSYMBOL_B256TYPE_UNASSIGNED = 458,      /* B256TYPE_UNASSIGNED  */
  YYSYMBOL_B256UNASSIGN = 459,             /* B256UNASSIGN  */
  YYSYMBOL_B256UNLOAD = 460,               /* B256UNLOAD  */
  YYSYMBOL_B256UNSERIALIZE = 461,          /* B256UNSERIALIZE  */
  YYSYMBOL_B256UNTIL = 462,                /* B256UNTIL  */
  YYSYMBOL_B256UPPER = 463,                /* B256UPPER  */
  YYSYMBOL_B256VARIABLEWATCH = 464,        /* B256VARIABLEWATCH  */
  YYSYMBOL_B256VERSION = 465,              /* B256VERSION  */
  YYSYMBOL_B256VOLUME = 466,               /* B256VOLUME  */
  YYSYMBOL_B256WARNING_ARRAYELEMENT = 467, /* B256WARNING_ARRAYELEMENT  */
  YYSYMBOL_B256WARNING_BOOLEANCONV = 468,  /* B256WARNING_BOOLEANCONV  */
  YYSYMBOL_B256WARNING_INTEGERRANGE = 469, /* B256WARNING_INTEGERRANGE  */
  YYSYMBOL_B256WARNING_LONGRANGE = 470,    /* B256WARNING_LONGRANGE  */
  YYSYMBOL_B256WARNING_NUMBERCONV = 471,   /* B256WARNING_NUMBERCONV  */
  YYSYMBOL_B256WARNING_REFNOTASSIGNED = 472, /* B256WARNING_REFNOTASSIGNED  */
  YYSYMBOL_B256WARNING_SOUNDERROR = 473,   /* B256WARNING_SOUNDERROR  */
  YYSYMBOL_B256WARNING_SOUNDFILEFORMAT = 474, /* B256WARNING_SOUNDFILEFORMAT  */
  YYSYMBOL_B256WARNING_SOUNDLENGTH = 475,  /* B256WARNING_SOUNDLENGTH  */
  YYSYMBOL_B256WARNING_SOUNDNOTSEEKABLE = 476, /* B256WARNING_SOUNDNOTSEEKABLE  */
  YYSYMBOL_B256WARNING_START = 477,        /* B256WARNING_START  */
  YYSYMBOL_B256WARNING_STRING2NOTE = 478,  /* B256WARNING_STRING2NOTE  */
  YYSYMBOL_B256WARNING_STRINGCONV = 479,   /* B256WARNING_STRINGCONV  */
  YYSYMBOL_B256WARNING_VARNOTASSIGNED = 480, /* B256WARNING_VARNOTASSIGNED  */
  YYSYMBOL_B256WARNING_WAVOBSOLETE = 481,  /* B256WARNING_WAVOBSOLETE  */
  YYSYMBOL_B256WAVLENGTH = 482,            /* B256WAVLENGTH  */
  YYSYMBOL_B256WAVPAUSE = 483,             /* B256WAVPAUSE  */
  YYSYMBOL_B256WAVPLAY = 484,              /* B256WAVPLAY  */
  YYSYMBOL_B256WAVPOS = 485,               /* B256WAVPOS  */
  YYSYMBOL_B256WAVSEEK = 486,              /* B256WAVSEEK  */
  YYSYMBOL_B256WAVSTATE = 487,             /* B256WAVSTATE  */
  YYSYMBOL_B256WAVSTOP = 488,              /* B256WAVSTOP  */
  YYSYMBOL_B256WAVWAIT = 489,              /* B256WAVWAIT  */
  YYSYMBOL_B256WHILE = 490,                /* B256WHILE  */
  YYSYMBOL_B256WHITE = 491,                /* B256WHITE  */
  YYSYMBOL_B256WRITE = 492,                /* B256WRITE  */
  YYSYMBOL_B256WRITEBYTE = 493,            /* B256WRITEBYTE  */
  YYSYMBOL_B256WRITELINE = 494,            /* B256WRITELINE  */
  YYSYMBOL_B256XOR = 495,                  /* B256XOR  */
  YYSYMBOL_B256YEAR = 496,                 /* B256YEAR  */
  YYSYMBOL_B256YELLOW = 497,               /* B256YELLOW  */
  YYSYMBOL_B256ZFILL = 498,                /* B256ZFILL  */
  YYSYMBOL_B256INTEGER = 499,              /* B256INTEGER  */
  YYSYMBOL_B256FLOAT = 500,                /* B256FLOAT  */
  YYSYMBOL_B256STRING = 501,               /* B256STRING  */
  YYSYMBOL_B256HEXCONST = 502,             /* B256HEXCONST  */
  YYSYMBOL_B256BINCONST = 503,             /* B256BINCONST  */
  YYSYMBOL_B256OCTCONST = 504,             /* B256OCTCONST  */
  YYSYMBOL_B256VARIABLE = 505,             /* B256VARIABLE  */
  YYSYMBOL_B256LABEL = 506,                /* B256LABEL  */
  YYSYMBOL_507_ = 507,                     /* ','  */
  YYSYMBOL_508_ = 508,                     /* '<'  */
  YYSYMBOL_509_ = 509,                     /* '>'  */
  YYSYMBOL_510_ = 510,                     /* '='  */
  YYSYMBOL_511_ = 511,                     /* '-'  */
  YYSYMBOL_512_ = 512,                     /* '+'  */
  YYSYMBOL_513_ = 513,                     /* '*'  */
  YYSYMBOL_514_ = 514,                     /* '/'  */
  YYSYMBOL_B256UNARY = 515,                /* B256UNARY  */
  YYSYMBOL_516_ = 516,                     /* '^'  */
  YYSYMBOL_517_ = 517,                     /* '['  */
  YYSYMBOL_518_ = 518,                     /* ']'  */
  YYSYMBOL_519_ = 519,                     /* '{'  */
  YYSYMBOL_520_ = 520,                     /* '}'  */
  YYSYMBOL_521_ = 521,                     /* '('  */
  YYSYMBOL_522_ = 522,                     /* ')'  */
  YYSYMBOL_523_n_ = 523,                   /* '\n'  */
  YYSYMBOL_524_ = 524,                     /* ':'  */
  YYSYMBOL_525_ = 525,                     /* '?'  */
  YYSYMBOL_526_ = 526,                     /* '%'  */
  YYSYMBOL_YYACCEPT = 527,                 /* $accept  */
  YYSYMBOL_program = 528,                  /* program  */
  YYSYMBOL_programnewline = 529,           /* programnewline  */
  YYSYMBOL_programline = 530,              /* programline  */
  YYSYMBOL_label = 531,                    /* label  */
  YYSYMBOL_compoundstmt = 532,             /* compoundstmt  */
  YYSYMBOL_array_none = 533,               /* array_none  */
  YYSYMBOL_array_size = 534,               /* array_size  */
  YYSYMBOL_array_size_rows = 535,          /* array_size_rows  */
  YYSYMBOL_array_size_cols = 536,          /* array_size_cols  */
  YYSYMBOL_array_indexing = 537,           /* array_indexing  */
  YYSYMBOL_variable = 538,                 /* variable  */
  YYSYMBOL_variable_a = 539,               /* variable_a  */
  YYSYMBOL_array_element = 540,            /* array_element  */
  YYSYMBOL_functionvariable = 541,         /* functionvariable  */
  YYSYMBOL_functionvariablelist = 542,     /* functionvariablelist  */
  YYSYMBOL_functionvariables = 543,        /* functionvariables  */
  YYSYMBOL_listoflists = 544,              /* listoflists  */
  YYSYMBOL_listinlist = 545,               /* listinlist  */
  YYSYMBOL_listofitems = 546,              /* listofitems  */
  YYSYMBOL_listitems = 547,                /* listitems  */
  YYSYMBOL_listofmapitems = 548,           /* listofmapitems  */
  YYSYMBOL_mapitems = 549,                 /* mapitems  */
  YYSYMBOL_callexprlist = 550,             /* callexprlist  */
  YYSYMBOL_callexpr = 551,                 /* callexpr  */
  YYSYMBOL_args_none = 552,                /* args_none  */
  YYSYMBOL_args_ee = 553,                  /* args_ee  */
  YYSYMBOL_args_ea = 554,                  /* args_ea  */
  YYSYMBOL_args_ev = 555,                  /* args_ev  */
  YYSYMBOL_args_eee = 556,                 /* args_eee  */
  YYSYMBOL_args_eeee = 557,                /* args_eeee  */
  YYSYMBOL_args_eeeee = 558,               /* args_eeeee  */
  YYSYMBOL_args_eeeeee = 559,              /* args_eeeeee  */
  YYSYMBOL_args_eeeeeee = 560,             /* args_eeeeeee  */
  YYSYMBOL_args_eeeeeeeee = 561,           /* args_eeeeeeeee  */
  YYSYMBOL_args_eeeeeeeeee = 562,          /* args_eeeeeeeeee  */
  YYSYMBOL_expr = 563,                     /* expr  */
  YYSYMBOL_expr_multi = 564,               /* expr_multi  */
  YYSYMBOL_expr_function = 565,            /* expr_function  */
  YYSYMBOL_expr_constants = 566,           /* expr_constants  */
  YYSYMBOL_expr_errors = 567,              /* expr_errors  */
  YYSYMBOL_expr_numeric = 568,             /* expr_numeric  */
  YYSYMBOL_expr_string = 569,              /* expr_string  */
  YYSYMBOL_expr_dataelement = 570,         /* expr_dataelement  */
  YYSYMBOL_statement = 571,                /* statement  */
  YYSYMBOL_begincasestmt = 572,            /* begincasestmt  */
  YYSYMBOL_casestmt = 573,                 /* casestmt  */
  YYSYMBOL_574_1 = 574,                    /* $@1  */
  YYSYMBOL_catchstmt = 575,                /* catchstmt  */
  YYSYMBOL_dostmt = 576,                   /* dostmt  */
  YYSYMBOL_elsestmt = 577,                 /* elsestmt  */
  YYSYMBOL_endcasestmt = 578,              /* endcasestmt  */
  YYSYMBOL_endifstmt = 579,                /* endifstmt  */
  YYSYMBOL_endtrystmt = 580,               /* endtrystmt  */
  YYSYMBOL_endwhilestmt = 581,             /* endwhilestmt  */
  YYSYMBOL_ifstmt = 582,                   /* ifstmt  */
  YYSYMBOL_ifthenstmt = 583,               /* ifthenstmt  */
  YYSYMBOL_ifthenelsestmt = 584,           /* ifthenelsestmt  */
  YYSYMBOL_ifthenelse = 585,               /* ifthenelse  */
  YYSYMBOL_trystmt = 586,                  /* trystmt  */
  YYSYMBOL_untilstmt = 587,                /* untilstmt  */
  YYSYMBOL_588_2 = 588,                    /* $@2  */
  YYSYMBOL_whilestmt = 589,                /* whilestmt  */
  YYSYMBOL_590_3 = 590,                    /* $@3  */
  YYSYMBOL_letstmt = 591,                  /* letstmt  */
  YYSYMBOL_mapstmt = 592,                  /* mapstmt  */
  YYSYMBOL_dimstmt = 593,                  /* dimstmt  */
  YYSYMBOL_redimstmt = 594,                /* redimstmt  */
  YYSYMBOL_pausestmt = 595,                /* pausestmt  */
  YYSYMBOL_throwerrorstmt = 596,           /* throwerrorstmt  */
  YYSYMBOL_clearstmt = 597,                /* clearstmt  */
  YYSYMBOL_fastgraphicsstmt = 598,         /* fastgraphicsstmt  */
  YYSYMBOL_graphsizestmt = 599,            /* graphsizestmt  */
  YYSYMBOL_refreshstmt = 600,              /* refreshstmt  */
  YYSYMBOL_endstmt = 601,                  /* endstmt  */
  YYSYMBOL_arrayelementassign = 602,       /* arrayelementassign  */
  YYSYMBOL_arrayassign = 603,              /* arrayassign  */
  YYSYMBOL_assign = 604,                   /* assign  */
  YYSYMBOL_forstmt = 605,                  /* forstmt  */
  YYSYMBOL_foreachstmt = 606,              /* foreachstmt  */
  YYSYMBOL_nextstmt = 607,                 /* nextstmt  */
  YYSYMBOL_gotostmt = 608,                 /* gotostmt  */
  YYSYMBOL_gosubstmt = 609,                /* gosubstmt  */
  YYSYMBOL_callstmt = 610,                 /* callstmt  */
  YYSYMBOL_offerrorstmt = 611,             /* offerrorstmt  */
  YYSYMBOL_onerrorstmt = 612,              /* onerrorstmt  */
  YYSYMBOL_returnstmt = 613,               /* returnstmt  */
  YYSYMBOL_colorstmt = 614,                /* colorstmt  */
  YYSYMBOL_soundstmt = 615,                /* soundstmt  */
  YYSYMBOL_soundplaystmt = 616,            /* soundplaystmt  */
  YYSYMBOL_soundpausestmt = 617,           /* soundpausestmt  */
  YYSYMBOL_soundplayeroffstmt = 618,       /* soundplayeroffstmt  */
  YYSYMBOL_soundstopstmt = 619,            /* soundstopstmt  */
  YYSYMBOL_soundwaitstmt = 620,            /* soundwaitstmt  */
  YYSYMBOL_soundwaveformstmt = 621,        /* soundwaveformstmt  */
  YYSYMBOL_soundsystemstmt = 622,          /* soundsystemstmt  */
  YYSYMBOL_soundenvelopestmt = 623,        /* soundenvelopestmt  */
  YYSYMBOL_soundharmonicsstmt = 624,       /* soundharmonicsstmt  */
  YYSYMBOL_soundfadestmt = 625,            /* soundfadestmt  */
  YYSYMBOL_soundseekstmt = 626,            /* soundseekstmt  */
  YYSYMBOL_soundvolumestmt = 627,          /* soundvolumestmt  */
  YYSYMBOL_soundloopstmt = 628,            /* soundloopstmt  */
  YYSYMBOL_plotstmt = 629,                 /* plotstmt  */
  YYSYMBOL_linestmt = 630,                 /* linestmt  */
  YYSYMBOL_circlestmt = 631,               /* circlestmt  */
  YYSYMBOL_ellipsestmt = 632,              /* ellipsestmt  */
  YYSYMBOL_arcstmt = 633,                  /* arcstmt  */
  YYSYMBOL_chordstmt = 634,                /* chordstmt  */
  YYSYMBOL_piestmt = 635,                  /* piestmt  */
  YYSYMBOL_rectstmt = 636,                 /* rectstmt  */
  YYSYMBOL_textstmt = 637,                 /* textstmt  */
  YYSYMBOL_fontstmt = 638,                 /* fontstmt  */
  YYSYMBOL_saystmt = 639,                  /* saystmt  */
  YYSYMBOL_systemstmt = 640,               /* systemstmt  */
  YYSYMBOL_volumestmt = 641,               /* volumestmt  */
  YYSYMBOL_polystmt = 642,                 /* polystmt  */
  YYSYMBOL_stampstmt = 643,                /* stampstmt  */
  YYSYMBOL_openstmt = 644,                 /* openstmt  */
  YYSYMBOL_writestmt = 645,                /* writestmt  */
  YYSYMBOL_writelinestmt = 646,            /* writelinestmt  */
  YYSYMBOL_writebytestmt = 647,            /* writebytestmt  */
  YYSYMBOL_closestmt = 648,                /* closestmt  */
  YYSYMBOL_resetstmt = 649,                /* resetstmt  */
  YYSYMBOL_seedstmt = 650,                 /* seedstmt  */
  YYSYMBOL_seekstmt = 651,                 /* seekstmt  */
  YYSYMBOL_inputstmt = 652,                /* inputstmt  */
  YYSYMBOL_printstmt = 653,                /* printstmt  */
  YYSYMBOL_wavpausestmt = 654,             /* wavpausestmt  */
  YYSYMBOL_wavplaystmt = 655,              /* wavplaystmt  */
  YYSYMBOL_wavseekstmt = 656,              /* wavseekstmt  */
  YYSYMBOL_wavstopstmt = 657,              /* wavstopstmt  */
  YYSYMBOL_wavwaitstmt = 658,              /* wavwaitstmt  */
  YYSYMBOL_putslicestmt = 659,             /* putslicestmt  */
  YYSYMBOL_imgloadstmt = 660,              /* imgloadstmt  */
  YYSYMBOL_spritedimstmt = 661,            /* spritedimstmt  */
  YYSYMBOL_spriteloadstmt = 662,           /* spriteloadstmt  */
  YYSYMBOL_spriteslicestmt = 663,          /* spriteslicestmt  */
  YYSYMBOL_spritepolystmt = 664,           /* spritepolystmt  */
  YYSYMBOL_spriteplacestmt = 665,          /* spriteplacestmt  */
  YYSYMBOL_spritemovestmt = 666,           /* spritemovestmt  */
  YYSYMBOL_spritehidestmt = 667,           /* spritehidestmt  */
  YYSYMBOL_spriteshowstmt = 668,           /* spriteshowstmt  */
  YYSYMBOL_clickclearstmt = 669,           /* clickclearstmt  */
  YYSYMBOL_changedirstmt = 670,            /* changedirstmt  */
  YYSYMBOL_dbopenstmt = 671,               /* dbopenstmt  */
  YYSYMBOL_dbclosestmt = 672,              /* dbclosestmt  */
  YYSYMBOL_dbexecutestmt = 673,            /* dbexecutestmt  */
  YYSYMBOL_dbopensetstmt = 674,            /* dbopensetstmt  */
  YYSYMBOL_dbclosesetstmt = 675,           /* dbclosesetstmt  */
  YYSYMBOL_netlistenstmt = 676,            /* netlistenstmt  */
  YYSYMBOL_netconnectstmt = 677,           /* netconnectstmt  */
  YYSYMBOL_netwritestmt = 678,             /* netwritestmt  */
  YYSYMBOL_netclosestmt = 679,             /* netclosestmt  */
  YYSYMBOL_killstmt = 680,                 /* killstmt  */
  YYSYMBOL_setclipboardimagestmt = 681,    /* setclipboardimagestmt  */
  YYSYMBOL_setclipboardstringstmt = 682,   /* setclipboardstringstmt  */
  YYSYMBOL_setsettingstmt = 683,           /* setsettingstmt  */
  YYSYMBOL_portoutstmt = 684,              /* portoutstmt  */
  YYSYMBOL_imgsavestmt = 685,              /* imgsavestmt  */
  YYSYMBOL_editvisiblestmt = 686,          /* editvisiblestmt  */
  YYSYMBOL_graphvisiblestmt = 687,         /* graphvisiblestmt  */
  YYSYMBOL_outputvisiblestmt = 688,        /* outputvisiblestmt  */
  YYSYMBOL_maintoolbarvisiblestmt = 689,   /* maintoolbarvisiblestmt  */
  YYSYMBOL_graphtoolbarvisiblestmt = 690,  /* graphtoolbarvisiblestmt  */
  YYSYMBOL_outputtoolbarvisiblestmt = 691, /* outputtoolbarvisiblestmt  */
  YYSYMBOL_globalstmt = 692,               /* globalstmt  */
  YYSYMBOL_penwidthstmt = 693,             /* penwidthstmt  */
  YYSYMBOL_alertstmt = 694,                /* alertstmt  */
  YYSYMBOL_continuedostmt = 695,           /* continuedostmt  */
  YYSYMBOL_continueforstmt = 696,          /* continueforstmt  */
  YYSYMBOL_continuewhilestmt = 697,        /* continuewhilestmt  */
  YYSYMBOL_exitdostmt = 698,               /* exitdostmt  */
  YYSYMBOL_exitforstmt = 699,              /* exitforstmt  */
  YYSYMBOL_exitwhilestmt = 700,            /* exitwhilestmt  */
  YYSYMBOL_printercancelstmt = 701,        /* printercancelstmt  */
  YYSYMBOL_printeroffstmt = 702,           /* printeroffstmt  */
  YYSYMBOL_printeronstmt = 703,            /* printeronstmt  */
  YYSYMBOL_printerpagestmt = 704,          /* printerpagestmt  */
  YYSYMBOL_functionstmt = 705,             /* functionstmt  */
  YYSYMBOL_subroutinestmt = 706,           /* subroutinestmt  */
  YYSYMBOL_endfunctionstmt = 707,          /* endfunctionstmt  */
  YYSYMBOL_endsubroutinestmt = 708,        /* endsubroutinestmt  */
  YYSYMBOL_regexminimalstmt = 709,         /* regexminimalstmt  */
  YYSYMBOL_unassignstmt = 710,             /* unassignstmt  */
  YYSYMBOL_variablewatchstmt = 711,        /* variablewatchstmt  */
  YYSYMBOL_imagecropstmt = 712,            /* imagecropstmt  */
  YYSYMBOL_imageautocropstmt = 713,        /* imageautocropstmt  */
  YYSYMBOL_imageresizestmt = 714,          /* imageresizestmt  */
  YYSYMBOL_imagesetpixelstmt = 715,        /* imagesetpixelstmt  */
  YYSYMBOL_imagedrawstmt = 716,            /* imagedrawstmt  */
  YYSYMBOL_imagecenteredstmt = 717,        /* imagecenteredstmt  */
  YYSYMBOL_imagetransformedstmt = 718,     /* imagetransformedstmt  */
  YYSYMBOL_imagerotatestmt = 719,          /* imagerotatestmt  */
  YYSYMBOL_imageflipstmt = 720,            /* imageflipstmt  */
  YYSYMBOL_imagesmoothstmt = 721,          /* imagesmoothstmt  */
  YYSYMBOL_unloadstmt = 722,               /* unloadstmt  */
  YYSYMBOL_setgraphstmt = 723,             /* setgraphstmt  */
  YYSYMBOL_arraybasestmt = 724             /* arraybasestmt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  934
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   37167

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  527
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  198
/* YYNRULES -- Number of rules.  */
#define YYNRULES  941
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1985

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   762


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     523,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   526,     2,     2,
     521,   522,   513,   512,   507,   511,     2,   514,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   524,     2,
     508,   510,   509,   525,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   517,     2,   518,   516,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   519,     2,   520,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   515
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   896,   896,   897,   901,   909,   910,   911,   912,   913,
     914,   915,   916,   920,   938,   939,   952,   956,   960,   961,
     965,   966,   971,   972,   973,   980,   983,   987,   988,   989,
     993,   994,  1004,  1011,  1012,  1017,  1018,  1031,  1043,  1049,
    1050,  1056,  1065,  1066,  1072,  1083,  1084,  1090,  1091,  1097,
    1098,  1112,  1113,  1120,  1121,  1125,  1126,  1130,  1131,  1136,
    1137,  1142,  1143,  1148,  1149,  1154,  1155,  1160,  1161,  1166,
    1167,  1172,  1173,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1195,  1196,  1199,  1202,  1205,  1213,  1219,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1281,  1284,
    1287,  1290,  1293,  1296,  1299,  1302,  1305,  1308,  1311,  1314,
    1317,  1320,  1323,  1326,  1329,  1332,  1335,  1338,  1341,  1344,
    1347,  1350,  1353,  1356,  1359,  1362,  1365,  1368,  1371,  1374,
    1377,  1380,  1383,  1386,  1389,  1392,  1395,  1398,  1401,  1404,
    1407,  1410,  1413,  1416,  1419,  1422,  1425,  1428,  1431,  1434,
    1437,  1440,  1443,  1446,  1449,  1452,  1455,  1458,  1461,  1464,
    1467,  1470,  1473,  1476,  1479,  1482,  1485,  1488,  1491,  1494,
    1497,  1500,  1503,  1506,  1509,  1512,  1515,  1518,  1521,  1524,
    1527,  1530,  1533,  1536,  1539,  1542,  1545,  1548,  1551,  1554,
    1557,  1560,  1563,  1566,  1569,  1572,  1575,  1578,  1581,  1584,
    1587,  1590,  1593,  1596,  1599,  1602,  1605,  1608,  1611,  1614,
    1617,  1620,  1623,  1626,  1629,  1632,  1635,  1638,  1641,  1644,
    1647,  1650,  1653,  1656,  1659,  1669,  1670,  1679,  1684,  1693,
    1697,  1700,  1703,  1706,  1711,  1714,  1717,  1718,  1719,  1720,
    1721,  1722,  1725,  1728,  1729,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1740,  1752,  1764,  1776,  1788,  1795,  1802,  1809,
    1816,  1817,  1818,  1819,  1820,  1825,  1829,  1830,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1856,  1857,  1858,
    1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1870,  1871,
    1875,  1876,  1880,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1894,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,
    1905,  1906,  1907,  1908,  1909,  1910,  1915,  1919,  1922,  1928,
    1932,  1934,  1940,  1944,  1946,  1952,  1956,  1958,  1959,  1960,
    1961,  1962,  1963,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1982,  1983,  1984,  1985,  1986,
    1990,  1993,  1997,  2001,  2005,  2008,  2018,  2028,  2038,  2039,
    2040,  2042,  2046,  2049,  2055,  2058,  2061,  2065,  2068,  2072,
    2075,  2079,  2082,  2085,  2088,  2091,  2095,  2098,  2101,  2104,
    2107,  2110,  2113,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2142,
    2146,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,  2163,  2164,  2165,  2168,  2173,  2177,  2180,
    2183,  2185,  2189,  2193,  2197,  2200,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2213,  2219,  2222,  2225,  2229,  2232,
    2236,  2240,  2244,  2248,  2252,  2255,  2259,  2262,  2266,  2269,
    2283,  2286,  2289,  2292,  2296,  2300,  2303,  2307,  2311,  2322,
    2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,
    2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,
    2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,  2365,  2366,  2367,  2368,  2369,  2370,  2371,  2372,
    2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,
    2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,  2392,
    2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,  2402,
    2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,
    2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2472,  2479,  2479,  2510,  2537,
    2547,  2593,  2624,  2646,  2669,  2693,  2704,  2715,  2724,  2738,
    2749,  2749,  2776,  2776,  2787,  2788,  2789,  2790,  2791,  2792,
    2795,  2802,  2805,  2811,  2816,  2824,  2827,  2833,  2836,  2842,
    2845,  2851,  2856,  2864,  2867,  2875,  2881,  2886,  2889,  2899,
    2905,  2911,  2915,  2921,  2926,  2933,  2936,  2945,  2954,  2964,
    2975,  2985,  2996,  3007,  3022,  3030,  3033,  3039,  3045,  3051,
    3057,  3062,  3068,  3074,  3083,  3094,  3106,  3115,  3127,  3149,
    3169,  3178,  3188,  3193,  3201,  3207,  3210,  3213,  3219,  3231,
    3243,  3247,  3250,  3259,  3266,  3271,  3275,  3281,  3289,  3292,
    3298,  3301,  3307,  3310,  3317,  3320,  3327,  3331,  3336,  3341,
    3344,  3347,  3352,  3355,  3358,  3364,  3367,  3377,  3380,  3387,
    3390,  3397,  3400,  3407,  3412,  3419,  3425,  3431,  3435,  3442,
    3446,  3453,  3457,  3464,  3467,  3471,  3477,  3480,  3484,  3490,
    3493,  3497,  3502,  3510,  3516,  3522,  3528,  3533,  3536,  3541,
    3550,  3556,  3560,  3566,  3570,  3578,  3585,  3591,  3596,  3600,
    3605,  3610,  3616,  3621,  3627,  3632,  3637,  3641,  3646,  3650,
    3655,  3660,  3665,  3670,  3675,  3681,  3687,  3693,  3698,  3704,
    3710,  3716,  3721,  3727,  3733,  3739,  3744,  3750,  3756,  3765,
    3770,  3775,  3780,  3785,  3790,  3795,  3800,  3807,  3813,  3817,
    3822,  3828,  3834,  3840,  3846,  3854,  3860,  3867,  3873,  3879,
    3885,  3891,  3896,  3901,  3906,  3914,  3919,  3923,  3927,  3934,
    3940,  3946,  3952,  3958,  3963,  3969,  3973,  3979,  3984,  3990,
    3997,  4002,  4008,  4013,  4017,  4023,  4028,  4034,  4039,  4045,
    4050,  4056,  4060,  4065,  4071,  4077,  4083,  4089,  4095,  4099,
    4105,  4111,  4117,  4123,  4129,  4135,  4141,  4156,  4162,  4168,
    4184,  4200,  4216,  4232,  4248,  4264,  4270,  4276,  4282,  4288,
    4332,  4371,  4399,  4423,  4429,  4432,  4439,  4445,  4451,  4455,
    4462,  4466,  4473,  4476,  4483,  4487,  4491,  4495,  4502,  4507,
    4511,  4515,  4522,  4525,  4532,  4539,  4542,  4549,  4555,  4561,
    4564,  4571
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "B256ABS", "B256ACOS",
  "B256ADD1", "B256ADDEQUAL", "B256ALERT", "B256AMP", "B256AMPEQUAL",
  "B256AND", "B256ARC", "B256ARRAYBASE", "B256ASC", "B256ASIN",
  "B256ASSIGNED", "B256ATAN", "B256BEGINCASE", "B256BINARYNOT",
  "B256BINARYOR", "B256BITSHIFTL", "B256BITSHIFTR", "B256BLACK",
  "B256BLUE", "B256BOOLEOF", "B256BOOLFALSE", "B256BOOLTRUE", "B256CALL",
  "B256CASE", "B256CATCH", "B256CEIL", "B256CHANGEDIR", "B256CHORD",
  "B256CHR", "B256CIRCLE", "B256CLEAR", "B256CLG", "B256CLICKB",
  "B256CLICKCLEAR", "B256CLICKX", "B256CLICKY", "B256CLOSE", "B256CLS",
  "B256CONFIRM", "B256CONTINUEDO", "B256CONTINUEFOR", "B256CONTINUEWHILE",
  "B256COS", "B256COUNT", "B256COUNTX", "B256CURRENTDIR", "B256CYAN",
  "B256DARKBLUE", "B256DARKCYAN", "B256DARKGREEN", "B256DARKGREY",
  "B256DARKORANGE", "B256DARKPURPLE", "B256DARKRED", "B256DARKYELLOW",
  "B256DAY", "B256DBCLOSE", "B256DBCLOSESET", "B256DBEXECUTE",
  "B256DBFLOAT", "B256DBINT", "B256DBNULL", "B256DBOPEN", "B256DBOPENSET",
  "B256DBROW", "B256DBSTRING", "B256DEBUGINFO", "B256DEGREES", "B256DIM",
  "B256DIR", "B256DIVEQUAL", "B256DO", "B256EDITVISIBLE", "B256ELLIPSE",
  "B256ELSE", "B256END", "B256ENDCASE", "B256ENDFUNCTION", "B256ENDIF",
  "B256ENDSUBROUTINE", "B256ENDTRY", "B256ENDWHILE",
  "B256ERROR_ARGUMENTCOUNT", "B256ERROR_ARRAYELEMENT",
  "B256ERROR_ARRAYEVEN", "B256ERROR_ARRAYEXPR", "B256ERROR_ARRAYINDEX",
  "B256ERROR_ARRAYINDEXMISSING", "B256ERROR_ARRAYLENGTH2D",
  "B256ERROR_ARRAYNITEMS", "B256ERROR_ARRAYSIZELARGE",
  "B256ERROR_ARRAYSIZESMALL", "B256ERROR_ASINACOSRANGE",
  "B256ERROR_BOOLEANCONV", "B256ERROR_DBCOLNO", "B256ERROR_DBCONNNUMBER",
  "B256ERROR_DBNOTOPEN", "B256ERROR_DBNOTSET", "B256ERROR_DBNOTSETROW",
  "B256ERROR_DBOPEN", "B256ERROR_DBQUERY", "B256ERROR_DBSETNUMBER",
  "B256ERROR_DIVZERO", "B256ERROR_DOWNLOAD", "B256ERROR_ENVELOPEMAX",
  "B256ERROR_ENVELOPEODD", "B256ERROR_EXPECTEDARRAY",
  "B256ERROR_EXPECTEDSOUND", "B256ERROR_FILENOTOPEN",
  "B256ERROR_FILENUMBER", "B256ERROR_FILEOPEN", "B256ERROR_FILEOPERATION",
  "B256ERROR_FILERESET", "B256ERROR_FILEWRITE", "B256ERROR_FOLDER",
  "B256ERROR_FREEDB", "B256ERROR_FREEDBSET", "B256ERROR_FREEFILE",
  "B256ERROR_FREENET", "B256ERROR_HARMONICLIST",
  "B256ERROR_HARMONICNUMBER", "B256ERROR_IMAGEFILE",
  "B256ERROR_IMAGERESOURCE", "B256ERROR_IMAGESAVETYPE",
  "B256ERROR_IMAGESCALE", "B256ERROR_INFINITY", "B256ERROR_INTEGERRANGE",
  "B256ERROR_INVALIDKEYNAME", "B256ERROR_INVALIDPROGNAME",
  "B256ERROR_INVALIDRESOURCE", "B256ERROR_LOGRANGE", "B256ERROR_LONGRANGE",
  "B256ERROR_MAXRECURSE", "B256ERROR_NETACCEPT", "B256ERROR_NETBIND",
  "B256ERROR_NETCONN", "B256ERROR_NETHOST", "B256ERROR_NETNONE",
  "B256ERROR_NETREAD", "B256ERROR_NETSOCK", "B256ERROR_NETSOCKNUMBER",
  "B256ERROR_NETSOCKOPT", "B256ERROR_NETWRITE", "B256ERROR_NEXTNOFOR",
  "B256ERROR_NONE", "B256ERROR_NOSUCHFUNCTION", "B256ERROR_NOSUCHLABEL",
  "B256ERROR_NOSUCHSUBROUTINE", "B256ERROR_NOTARRAY",
  "B256ERROR_NOTIMPLEMENTED", "B256ERROR_NUMBERCONV",
  "B256ERROR_NUMBEREXPR", "B256ERROR_ONEDIMENSIONAL",
  "B256ERROR_ONERRORSUB", "B256ERROR_PENWIDTH", "B256ERROR_PERMISSION",
  "B256ERROR_POLYPOINTS", "B256ERROR_PRINTERNOTOFF",
  "B256ERROR_PRINTERNOTON", "B256ERROR_PRINTEROPEN", "B256ERROR_RADIX",
  "B256ERROR_RADIXSTRING", "B256ERROR_REFNOTASSIGNED", "B256ERROR_RGB",
  "B256ERROR_SERIALPARAMETER", "B256ERROR_SETTINGMAXKEYS",
  "B256ERROR_SETTINGMAXLEN", "B256ERROR_SETTINGSGETACCESS",
  "B256ERROR_SETTINGSSETACCESS", "B256ERROR_SLICESIZE",
  "B256ERROR_SOUNDERROR", "B256ERROR_SOUNDFILE",
  "B256ERROR_SOUNDFILEFORMAT", "B256ERROR_SOUNDLENGTH",
  "B256ERROR_SOUNDNOTSEEKABLE", "B256ERROR_SOUNDRESOURCE",
  "B256ERROR_SPRITENA", "B256ERROR_SPRITENUMBER", "B256ERROR_SPRITESLICE",
  "B256ERROR_SQRRANGE", "B256ERROR_STACKUNDERFLOW",
  "B256ERROR_STRING2NOTE", "B256ERROR_STRINGCONV", "B256ERROR_STRINGEXPR",
  "B256ERROR_STRINGMAXLEN", "B256ERROR_STRSTART",
  "B256ERROR_TOOMANYSOUNDS", "B256ERROR_UNEXPECTEDRETURN",
  "B256ERROR_UNSERIALIZEFORMAT", "B256ERROR_VARCIRCULAR",
  "B256ERROR_VARNOTASSIGNED", "B256ERROR_VARNULL",
  "B256ERROR_WAVEFORMLOGICAL", "B256ERROR_WAVOBSOLETE", "B256EXISTS",
  "B256EXITDO", "B256EXITFOR", "B256EXITWHILE", "B256EXP", "B256EXPLODE",
  "B256EXPLODEX", "B256FASTGRAPHICS", "B256FILL", "B256FLOOR", "B256FONT",
  "B256FOR", "B256FOREACH", "B256FREEDB", "B256FREEDBSET", "B256FREEFILE",
  "B256FREENET", "B256FROMBINARY", "B256FROMHEX", "B256FROMOCTAL",
  "B256FROMRADIX", "B256FUNCTION", "B256GETARRAYBASE", "B256GETBRUSHCOLOR",
  "B256GETCLIPBOARDIMAGE", "B256GETCLIPBOARDSTRING", "B256GETCOLOR",
  "B256GETPENWIDTH", "B256GETSETTING", "B256GETSLICE", "B256GLOBAL",
  "B256GOSUB", "B256GOTO", "B256GRAPHHEIGHT", "B256GRAPHSIZE",
  "B256GRAPHVISIBLE", "B256GRAPHTOOLBARVISIBLE", "B256GRAPHWIDTH",
  "B256GREEN", "B256GREY", "B256GTE", "B256HOUR", "B256IF", "B256IN",
  "B256IMAGEAUTOCROP", "B256IMAGECENTERED", "B256IMAGECOPY",
  "B256IMAGECROP", "B256IMAGEDRAW", "B256IMAGEFLIP", "B256IMAGEHEIGHT",
  "B256IMAGELOAD", "B256IMAGENEW", "B256IMAGEPIXEL", "B256IMAGERESIZE",
  "B256IMAGEROTATE", "B256IMAGESETPIXEL", "B256IMAGESMOOTH",
  "B256IMAGETRANSFORMED", "B256IMAGETYPE_BMP", "B256IMAGETYPE_JPG",
  "B256IMAGETYPE_PNG", "B256IMAGEWIDTH", "B256IMGLOAD", "B256IMGSAVE",
  "B256IMPLODE", "B256INPUT", "B256INPUTFLOAT", "B256INPUTINT",
  "B256INPUTSTRING", "B256INSTR", "B256INSTRX", "B256INTDIV",
  "B256ISNUMERIC", "B256KEY", "B256KEYPRESSED", "B256KILL",
  "B256LASTERROR", "B256LASTERROREXTRA", "B256LASTERRORLINE",
  "B256LASTERRORMESSAGE", "B256LEFT", "B256LENGTH", "B256LET", "B256LINE",
  "B256LJUST", "B256LOG", "B256LOGTEN", "B256LOWER", "B256LTE",
  "B256LTRIM", "B256MAINTOOLBARVISIBLE", "B256MAP", "B256MD5", "B256MID",
  "B256MIDX", "B256MINUTE", "B256MOD", "B256MONTH", "B256MOUSEB",
  "B256MOUSEBUTTON_CENTER", "B256MOUSEBUTTON_DOUBLECLICK",
  "B256MOUSEBUTTON_LEFT", "B256MOUSEBUTTON_NONE", "B256MOUSEBUTTON_RIGHT",
  "B256MOUSEX", "B256MOUSEY", "B256MSEC", "B256MULEQUAL", "B256NE",
  "B256NETADDRESS", "B256NETCLOSE", "B256NETCONNECT", "B256NETDATA",
  "B256NETLISTEN", "B256NETREAD", "B256NETWRITE", "B256NEXT", "B256NOT",
  "B256OFFERROR", "B256ONERROR", "B256OPEN", "B256OPENB",
  "B256OPENFILEDIALOG", "B256OPENSERIAL", "B256OR", "B256ORANGE",
  "B256OSTYPE", "B256OSTYPE_ANDROID", "B256OSTYPE_LINUX",
  "B256OSTYPE_MACINTOSH", "B256OSTYPE_WINDOWS", "B256OUTPUTVISIBLE",
  "B256OUTPUTTOOLBARVISIBLE", "B256PAUSE", "B256PENWIDTH", "B256PI",
  "B256PIE", "B256PIXEL", "B256PLOT", "B256POLY", "B256PORTIN",
  "B256PORTOUT", "B256PRINT", "B256PRINTERCANCEL", "B256PRINTEROFF",
  "B256PRINTERON", "B256PRINTERPAGE", "B256PROMPT", "B256PURPLE",
  "B256PUTSLICE", "B256RADIANS", "B256RAND", "B256READ", "B256READBYTE",
  "B256READLINE", "B256RECT", "B256RED", "B256REDIM", "B256REF",
  "B256REFRESH", "B256REGEXMINIMAL", "B256REM", "B256REPLACE",
  "B256REPLACEX", "B256SAVEFILEDIALOG", "B256RESET", "B256RETURN",
  "B256RGB", "B256RIGHT", "B256RJUST", "B256ROUND", "B256RTRIM", "B256SAY",
  "B256SECOND", "B256SEED", "B256SEEK", "B256SEMICOLON",
  "B256SEMICOLONEQUAL", "B256SERIALIZE", "B256SETCLIPBOARDIMAGE",
  "B256SETCLIPBOARDSTRING", "B256SETCOLOR", "B256SETGRAPH",
  "B256SETSETTING", "B256SIN", "B256SIZE", "B256SLICE_ALL",
  "B256SLICE_PAINT", "B256SLICE_SPRITE", "B256SOUND", "B256SOUNDENVELOPE",
  "B256SOUNDFADE", "B256SOUNDHARMONICS", "B256SOUNDID", "B256SOUNDLENGTH",
  "B256SOUNDLOAD", "B256SOUNDLOADRAW", "B256SOUNDLOOP", "B256SOUNDPAUSE",
  "B256SOUNDPLAY", "B256SOUNDPLAYER", "B256SOUNDPLAYEROFF",
  "B256SOUNDPOSITION", "B256SOUNDSAMPLERATE", "B256SOUNDSEEK",
  "B256SOUNDSTATE", "B256SOUNDSTOP", "B256SOUNDSYSTEM", "B256SOUNDVOLUME",
  "B256SOUNDWAIT", "B256SOUNDWAVEFORM", "B256SPRITECOLLIDE",
  "B256SPRITEDIM", "B256SPRITEH", "B256SPRITEHIDE", "B256SPRITELOAD",
  "B256SPRITEMOVE", "B256SPRITEO", "B256SPRITEPLACE", "B256SPRITEPOLY",
  "B256SPRITER", "B256SPRITES", "B256SPRITESHOW", "B256SPRITESLICE",
  "B256SPRITEV", "B256SPRITEW", "B256SPRITEX", "B256SPRITEY", "B256SQR",
  "B256STAMP", "B256STEP", "B256SUB1", "B256SUBEQUAL", "B256SUBROUTINE",
  "B256SYSTEM", "B256TAN", "B256TEXT", "B256TEXTHEIGHT", "B256TEXTWIDTH",
  "B256THEN", "B256THROWERROR", "B256TO", "B256TOBINARY", "B256TOFLOAT",
  "B256TOHEX", "B256TOINT", "B256TOOCTAL", "B256TORADIX", "B256TOSTRING",
  "B256TRIM", "B256TRY", "B256TYPEOF", "B256TYPE_ARRAY", "B256TYPE_FLOAT",
  "B256TYPE_INT", "B256TYPE_MAP", "B256TYPE_REF", "B256TYPE_STRING",
  "B256TYPE_UNASSIGNED", "B256UNASSIGN", "B256UNLOAD", "B256UNSERIALIZE",
  "B256UNTIL", "B256UPPER", "B256VARIABLEWATCH", "B256VERSION",
  "B256VOLUME", "B256WARNING_ARRAYELEMENT", "B256WARNING_BOOLEANCONV",
  "B256WARNING_INTEGERRANGE", "B256WARNING_LONGRANGE",
  "B256WARNING_NUMBERCONV", "B256WARNING_REFNOTASSIGNED",
  "B256WARNING_SOUNDERROR", "B256WARNING_SOUNDFILEFORMAT",
  "B256WARNING_SOUNDLENGTH", "B256WARNING_SOUNDNOTSEEKABLE",
  "B256WARNING_START", "B256WARNING_STRING2NOTE", "B256WARNING_STRINGCONV",
  "B256WARNING_VARNOTASSIGNED", "B256WARNING_WAVOBSOLETE", "B256WAVLENGTH",
  "B256WAVPAUSE", "B256WAVPLAY", "B256WAVPOS", "B256WAVSEEK",
  "B256WAVSTATE", "B256WAVSTOP", "B256WAVWAIT", "B256WHILE", "B256WHITE",
  "B256WRITE", "B256WRITEBYTE", "B256WRITELINE", "B256XOR", "B256YEAR",
  "B256YELLOW", "B256ZFILL", "B256INTEGER", "B256FLOAT", "B256STRING",
  "B256HEXCONST", "B256BINCONST", "B256OCTCONST", "B256VARIABLE",
  "B256LABEL", "','", "'<'", "'>'", "'='", "'-'", "'+'", "'*'", "'/'",
  "B256UNARY", "'^'", "'['", "']'", "'{'", "'}'", "'('", "')'", "'\\n'",
  "':'", "'?'", "'%'", "$accept", "program", "programnewline",
  "programline", "label", "compoundstmt", "array_none", "array_size",
  "array_size_rows", "array_size_cols", "array_indexing", "variable",
  "variable_a", "array_element", "functionvariable",
  "functionvariablelist", "functionvariables", "listoflists", "listinlist",
  "listofitems", "listitems", "listofmapitems", "mapitems", "callexprlist",
  "callexpr", "args_none", "args_ee", "args_ea", "args_ev", "args_eee",
  "args_eeee", "args_eeeee", "args_eeeeee", "args_eeeeeee",
  "args_eeeeeeeee", "args_eeeeeeeeee", "expr", "expr_multi",
  "expr_function", "expr_constants", "expr_errors", "expr_numeric",
  "expr_string", "expr_dataelement", "statement", "begincasestmt",
  "casestmt", "$@1", "catchstmt", "dostmt", "elsestmt", "endcasestmt",
  "endifstmt", "endtrystmt", "endwhilestmt", "ifstmt", "ifthenstmt",
  "ifthenelsestmt", "ifthenelse", "trystmt", "untilstmt", "$@2",
  "whilestmt", "$@3", "letstmt", "mapstmt", "dimstmt", "redimstmt",
  "pausestmt", "throwerrorstmt", "clearstmt", "fastgraphicsstmt",
  "graphsizestmt", "refreshstmt", "endstmt", "arrayelementassign",
  "arrayassign", "assign", "forstmt", "foreachstmt", "nextstmt",
  "gotostmt", "gosubstmt", "callstmt", "offerrorstmt", "onerrorstmt",
  "returnstmt", "colorstmt", "soundstmt", "soundplaystmt",
  "soundpausestmt", "soundplayeroffstmt", "soundstopstmt", "soundwaitstmt",
  "soundwaveformstmt", "soundsystemstmt", "soundenvelopestmt",
  "soundharmonicsstmt", "soundfadestmt", "soundseekstmt",
  "soundvolumestmt", "soundloopstmt", "plotstmt", "linestmt", "circlestmt",
  "ellipsestmt", "arcstmt", "chordstmt", "piestmt", "rectstmt", "textstmt",
  "fontstmt", "saystmt", "systemstmt", "volumestmt", "polystmt",
  "stampstmt", "openstmt", "writestmt", "writelinestmt", "writebytestmt",
  "closestmt", "resetstmt", "seedstmt", "seekstmt", "inputstmt",
  "printstmt", "wavpausestmt", "wavplaystmt", "wavseekstmt", "wavstopstmt",
  "wavwaitstmt", "putslicestmt", "imgloadstmt", "spritedimstmt",
  "spriteloadstmt", "spriteslicestmt", "spritepolystmt", "spriteplacestmt",
  "spritemovestmt", "spritehidestmt", "spriteshowstmt", "clickclearstmt",
  "changedirstmt", "dbopenstmt", "dbclosestmt", "dbexecutestmt",
  "dbopensetstmt", "dbclosesetstmt", "netlistenstmt", "netconnectstmt",
  "netwritestmt", "netclosestmt", "killstmt", "setclipboardimagestmt",
  "setclipboardstringstmt", "setsettingstmt", "portoutstmt", "imgsavestmt",
  "editvisiblestmt", "graphvisiblestmt", "outputvisiblestmt",
  "maintoolbarvisiblestmt", "graphtoolbarvisiblestmt",
  "outputtoolbarvisiblestmt", "globalstmt", "penwidthstmt", "alertstmt",
  "continuedostmt", "continueforstmt", "continuewhilestmt", "exitdostmt",
  "exitforstmt", "exitwhilestmt", "printercancelstmt", "printeroffstmt",
  "printeronstmt", "printerpagestmt", "functionstmt", "subroutinestmt",
  "endfunctionstmt", "endsubroutinestmt", "regexminimalstmt",
  "unassignstmt", "variablewatchstmt", "imagecropstmt",
  "imageautocropstmt", "imageresizestmt", "imagesetpixelstmt",
  "imagedrawstmt", "imagecenteredstmt", "imagetransformedstmt",
  "imagerotatestmt", "imageflipstmt", "imagesmoothstmt", "unloadstmt",
  "setgraphstmt", "arraybasestmt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1467)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-829)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   20991,  8762,  9272,  8762, -1467,  -430, -1467, -1467,  8762,  9272,
    9782, 10292,  -485, 10292,  -485, -1467, -1467, -1467, 10292, 10802,
   11312, 11312, 11822,  -429, -1467,  8762, 12332, -1467,  -485, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,  -485, 12842,
    -430,  -430,  -430,  -360,  -430,  -430, 11822,  8762,  8762,  8762,
   11312, 13352, 13862, 13352, 11822, 11822, 11312, 14372,  8762, 14882,
   15392, 11312, 15902, 15902, 15902, 15902,  8762,  -429, 12332,  8762,
    -360, 10292, 11822, 11312, 11312,  -430,  -485,  -430, 11312, 11312,
   16412,  8762,  8762,  8762,  8762,  9272, 11312,  8762, 11312, 16922,
    -485,  -485,  -485,  -485,  9782, 17432,  -429,  -485,  8762, -1467,
   10292, 10292,  8762,  8762, 11312,  8762,  8762, 11822, 10292,  9782,
   11312, 17942, 14372, 10802, 11312, 10292, 10802, 10292, 11312, 10292,
    8762, 11312, 10292, 11312,  8762,  8762, 11312, 13352, 13352, 11312,
    8762, 13862, 15392,  -430,  8762, 18452,  8762, -1467,  -429,  8762,
   -1467,  -360,  8762,  -485, 10292,  8762,  -485,  -485, -1467, 11312,
   11312, 11312, -1467, -1467,  -429, 18962,    40,  -452, 21491,  -265,
     187,  -180,   169,  -426, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, 21959, -1467, -1467, 21959, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467,  -382,  -381,  -359,  -361,  -356,  -355,
    -351,  8762,  -485,  -485,  -350,  -485,  -485,  -348,  -345,  -485,
    -485,  -485,  -485,  -342,  -341,  -340,  -338,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -335,  -334,
    -333,  -330,  -326,  -324,  -323,  -322,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -321,  -320,
   11822, 11312,  -319,  -485,  -318,  -485,  -485,  -317,  -316,  -315,
    -314,  -485,  -485,  -485,  -485,  -485,  -485,  -312, 19472,  -485,
    -485,  -485,  -485,  -485,  -310,  -308,  -307,  -306,  -304,  -485,
    -485,  -485,  -303,  -302,  -301,  -299,  -295,  -294,  -292,  -485,
    -485,  -485,  -485,  -290,  -288,  -286,  -285,  -282,  -281,  -280,
    -278,  -276,  -273,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -272,  -271,  8762,  -269,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -268,  -267,  -266,  -485,
    -264,  -485,  -263,  -262,  -261,  -485,  -260,  -257,  -256,  -255,
    -254,  -252,  -248,  -246,  -485,  -245,  -244,  -243,  -485,  -485,
    -485,  -485,  -241,  -236,  -234,  -233,  -232,  -485,  -231,  -229,
    -228,  -227,  -226,  -224,  -223,  -221,  -220,  -219,  -218,  -359,
    -215,  -214,  -212,  -211,  -210,  -209,  -208,  -206,  -205,  -204,
    -203,  -202,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -199,
    -198,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -197, -1467, -1467, -1467, -1467, -1467, -1467,
    8762,  -457, 19982,  8762,    11, -1467,    18, -1467, -1467, 36382,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467,  9272, -1467, -1467,
   24828, 36382,  -430,  -195,  8762, 36382, -1467, -1467,  9782, -1467,
   24861,  5192, -1467, 36382,  -194, -1467, -1467, 36382, -1467, -1467,
   36382,  5702, -1467, -1467, 24911, 11312, -1467, 24911, -1467, 24911,
   11822, -1467, -1467, 24974,  -190,  6722,    49, 36382, 12332, -1467,
   25120, -1467, -1467, 12842, -1467, -1467, -1467, 25146,  -181,  -237,
    -189,  -360,  -186, -1467,  -216, -1467, -1467, -1467, -1467, -1467,
   24974, 36382, 36382, 25168, -1467, 24911, 13352, -1467, -1467, -1467,
   -1467, 25201, 13862, -1467, 25264, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, 24911, 14372, -1467, -1467, 25428, 36382,
   14882, -1467, -1467, 25458, 15392, -1467, -1467, -1467, 25491, -1467,
   24911, 15902,    90,   153, -1467, -1467, 25518,   137,   159, -1467,
   -1467,   151,   163, -1467, -1467,   189,   172, -1467, -1467, 36382,
   -1467, -1467, -1467, -1467, 36382, -1467, -1467, 36382, -1467, -1467,
   -1467, 24911, -1467, 24911, -1467, -1467,  -188, -1467, 24911, -1467,
   24911, 16412, -1467, -1467, -1467, -1467, -1467, -1467, 25574, 36382,
   36382, 36382, 36382, -1467, -1467, -1467, 36382, -1467,  5192, -1467,
   -1467, 25601, -1467, -1467, -1467, -1467, -1467, 17432, -1467, -1467,
   -1467, 25685, 11312,   127, -1467, 36382, -1467, 36382, -1467, 36382,
   36382, 36382, -1467, 24911, 36382, 36382, -1467, -1467, 24974, -1467,
   36382, -1467, -1467, 24911,  6212, -1467, -1467, 25120, -1467, -1467,
   -1467, -1467, 24911, -1467, 24911, -1467, 36382, -1467, -1467, 24911,
   -1467, 36382, -1467, 24911, -1467, 36382, 36382, -1467, 24911, -1467,
   36382, -1467, 24911, 36382, 36382, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, 36382, -1467, -1467, -1467, -1467,
    -189, 36382, 18452, -1467, -1467, -1467, 25828, 36382, -1467, -1467,
   36382,  8762, -1467, 36382, -1467, -1467, 36382, 36382, -1467, -1467,
    8762, -1467, 24911, -1467, 24911, -1467, 24911,  -483,  -187,  -178,
    5192, -1467, -1467, 25855, -1467, -1467, 20991, -1467,   -19, -1467,
   -1467,  8762,  8762,  8762,  8762,  8762, -1467,  8762,  7232, -1467,
   -1467,  8762,  8762, -1467,  8762,  8762,  8762,  8762,  8762, -1467,
    8762,  8762, 21959,   262, -1467,  8762,  8762,  -359,  -172, -1467,
    8762,  8762,  -429,  8762,  -481, -1467, -1467,  5192, -1467, -1467,
   -1467,  8762,  8762, -1467, -1467, -1467, -1467,  8762,  8762,  8762,
    8762, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467,  8762,  8762,  8762,  5192, -1467,  8762,  8762,  8762,
    5192, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467,  8762,  8762, -1467, -1467, -1467,  8762,
   -1467,  5192, -1467, -1467, -1467,  8762,  8762,  8762,  8762, -1467,
   -1467, -1467, -1467, -1467, -1467,  8762, 19472, -1467, -1467, 25895,
   -1467, -1467, -1467, -1467, -1467,  5192, -1467,  8762,  8762,  8762,
    9782, -1467, -1467, -1467,  8762, 11822,  8762,  8762,  8762,  5192,
   -1467,  5192, -1467, -1467, -1467, -1467, -1467,  8762,  8762, 11822,
    8762,  8762,  8762,  8762,  8762,  8762,  8762, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,  5192,
   -1467,  5192, -1467,  1792,  9782, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467,  8762,  8762,  8762, -1467,  8762, -1467,  5192, -1467,
    5192, -1467,  5192, -1467, -1467,  8762,  8762,  9782,  8762,  8762,
   11822, 11312,  8762, -1467,  8762,  8762,  5192, -1467, -1467, -1467,
   -1467, -1467,  5192, -1467, 11312,  8762, 11312,  5192, -1467, -1467,
    5192, -1467,  8762,  8762,  8762,  8762,  8762,  8762,  8762,  8762,
    8762,  8762,  -172, -1467,  8762,  5192, -1467,  8762,  8762,  8762,
    8762,  8762,  8762,  8762,  8762,  8762,  8762, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467,  8762,  8762, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, 11312,  -481,
   -1467, -1467, 19982,  -171,  -159, -1467,  -168, 25939,    17,  -187,
      23, 26002, -1467, -1467,  3143,  3662,  -164,  -186, -1467, -1467,
   -1467, -1467,  8762,  8762,  8762,  8762,  8762,  8762,  8762,  8762,
    8762,  8762,  8762,  8762,  8762,  8762,  8762,  8762,  8762,  8762,
    8762,  8762,  8762,  8762, 20492,  -167,  -165,   784,  8762,  -163,
    4172, 36382,  -162,  1814,  8762, -1467,  -161,  1898,  8762,  1921,
    8762,  8762,  8762,   155,  1971,  8762,  -158,  2049,  8762,  2230,
    8762,  8762,   -20,  -151,  -468, -1467,  -448,  -153,  -360, -1467,
   21152,  8762, 22120,  8762, 22227,  8762,  -156,  -152, 22301,  8762,
   22462,  8762,  -146,  -143, 22534,  -359,  4682,  -142, 22558,  8762,
    -141, 22592,  8762,  8762, 22630,  8762,   161, 22706,  8762, -1467,
   22884,  8762, 36382, 36382, -1467, -1467, -1467,  -140,  8762, -1467,
   -1467, 36382, 36382, 36382, 36382, 36382, 36382, -1467, 22939, 36382,
   36382, 36382, 36382, 36382, 36382, 36382, 36382, 36382, -1467, -1467,
   26037, 26149,  -370,  8762, 26197, 26248,  -138,  -137, 26376, 26406,
   26550, 26572, 22997, 26633, 26666, 26714, 23111, 23166, 23256, 23278,
   23320, 26807, 26829, 26923, 26958, 27089, 27119, 27240, 27264, 27354,
   27384, 27497, 27644, 23401,  8762, 23423, 27666, 27692, 27787,  -136,
   27809,  -134,  -130, 23568, 27835, 27951, 28044, 28068, 28094, 28116,
   28209,  -129,  -128, 28375, 28418, 28466, 28488, 28522, 28629, 28781,
   28803, 28928,  -124, 28950, 29039, 23683, 29094, 29207, 29249, 29330,
   29352, 29375,  -123, 29497, 29654,  -122,  -121,  -120, 23713, 29676,
   29776, 29798, 29887, 30034,  -118, 23803, 30057,  -116, 23858, 30097,
   30120, 30196, 30356, 30429, 30455, 30479, 30503, 30736, 30794, 30820,
   30842, 30865, 30887, 23880, 30909, 31144, 31166, 31200, 31245, 31267,
   31494, 31524, 31558, 31580, 31603,  -115,  -112, -1467, 19982, -1467,
    7742, -1467,  -114,  -474,  -111, -1467,  -113,   -95, 36382,  -110,
   -1467, -1467,   226,  1792,   226,  -230,  -230,   204, 36641,  -481,
     204,  -481,   204, 23230, 21108, 23230,   204,   204,   204,  -139,
    -139,  -481,  -481,  -157,  -481, -1467, -1467, 31625, -1467,  -109,
   -1467, 31882, -1467, 36382, 31882, 36382, 36382,  8762,  8762, 36382,
   -1467, 31904, 31927, 31965, -1467,  -430, -1467,  -108, -1467, 32003,
   32212, 31927, -1467, -1467, 32247, 32285, -1467, -1467,  -172, -1467,
   -1467,  -106, -1467, 32309, -1467, -1467, 32336, 32594,  8762,  8762,
   36382, 32617, -1467,  8762,  -100, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467,  8762, -1467, -1467,  8762,  8762,
    8762, -1467,  8762, -1467,  8762, -1467,  8762, -1467,  8762, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
    8762,  8762, 32644,  8762, -1467, -1467, -1467,  8762, -1467, -1467,
   -1467, -1467, -1467,  8762,  8762, -1467, -1467, -1467,  8762, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467,  8762,  8762, -1467,
   -1467, -1467,  8762, -1467,  8762, -1467, -1467, -1467, -1467, -1467,
    8762,  8762, -1467,  8762,  8762, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467,  8762, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467,  8762,  8762, -1467, -1467, -1467, -1467, -1467, -1467,
    8762, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,  8762,
    -135,   -99, -1467,  -430, -1467,  8252,   -98,  8762, -1467,  8762,
   36382, 36382,  8762,  8762,  8762,   176, -1467,  8762,  8762,  8762,
    8762, -1467,  8762,  8762, 36382, 36382,  8762, 32667,  8762, 32689,
   23973, 32756, 24036, 24115, 24137, 32925, 24230, 33002, 33037,  8762,
   33067, 24263, 24285, 24427, 33294, 33327, 24457, 33349, 33375, 33397,
   33436, 33469, 33696, 24520, 33718, 33751, 33777, 33807, -1467, -1467,
     -97, -1467, 34042, 36382, 34069, 34069, 34092,   -20, 34114, 34136,
   34159, 34235, 34444, 34114, 34042, -1467, 34468, -1467,  8762, -1467,
   -1467,  8762, -1467,  8762, -1467,  8762, -1467, -1467,  8762, -1467,
   -1467, -1467, 34235,  8762,  8762, -1467,  8762, -1467,  8762, -1467,
   -1467,  8762,  8762, -1467, -1467, -1467,  8762,  8762,  8762, -1467,
    8762, -1467, -1467, -1467, -1467,  8762, -1467,  8762,  8762,  8762,
   -1467,  8762,  8762,  8762,  8762,  8762, -1467, 34494, 34552, 34703,
   34779, 34809, 34842, 34865, 24570, 34900, 35127, 35157, 24684, 35213,
   24747, 35235, -1467, 36618, 35258, 36382, 36382, 35258, 35322, 35520,
   35322, 35555, -1467, -1467, -1467, -1467, -1467,  8762, -1467,  8762,
   -1467, -1467, -1467, -1467,  8762, -1467, -1467,  8762, -1467, -1467,
    8762,  8762,  8762,  8762, 24805, 35582, 35666, 35696, 35847, 36382,
   35931, 35958,  8762, -1467, -1467, -1467, -1467,  8762,  8762,  8762,
   35991, 36382, 36101, 36240, -1467,  8762,  8762, 36270, 36382,  8762,
   36310,  8762, 36360,  8762, 36382
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
      12,     0,     0,     0,   645,     0,   646,   648,     0,     0,
       0,    52,    52,    52,    52,   899,   900,   901,    52,    52,
       0,     0,     0,     0,   649,     0,     0,   650,    52,   651,
     911,   652,   912,   653,   654,   902,   903,   904,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    52,     0,     0,     0,   719,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    52,
      52,    52,    52,    52,     0,     0,     0,    52,     0,    11,
      52,    52,     0,     0,     0,     0,     0,     0,    52,     0,
       0,    52,     0,    52,     0,    52,    52,    52,     0,    52,
       0,     0,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   659,     0,     0,
     660,     0,     0,    52,    52,     0,    52,    52,   662,     0,
       0,     0,    25,    13,     0,    52,     0,     3,     9,     7,
      27,     0,     0,    15,   502,   504,   505,   522,   526,   527,
     529,   532,   533,   548,   549,   550,     0,   630,   633,   641,
     565,   568,   521,   592,   579,   629,   509,   537,   545,   593,
     530,   669,   668,   667,   539,   540,   573,   544,   543,   503,
     574,   575,   596,   512,   603,   606,   604,   605,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   582,   566,
     508,   525,   500,   507,   581,   591,   628,   538,   597,   627,
     635,   583,   625,   576,   644,   643,   642,   511,   595,   598,
     599,   563,   589,   636,   637,   638,   639,   640,   590,   561,
     617,   619,   624,   622,   621,   620,   618,   623,   510,   506,
     520,   517,   518,   519,   516,   571,   570,   572,   569,   564,
     600,   601,   602,   584,   562,   524,   546,   577,   567,   547,
     578,   542,   580,   499,   513,   514,   515,   534,   535,   536,
     585,   586,   587,   588,   541,   626,   528,   531,   594,   631,
     634,   553,   551,   557,   556,   554,   552,   560,   558,   555,
     559,   632,   523,   501,     0,     0,     0,     0,     0,     0,
       0,     0,    52,    52,    52,    52,    52,     0,     0,    52,
      52,    52,    52,     0,     0,     0,     0,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,     0,     0,
       0,    52,     0,     0,     0,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,     0,     0,
       0,     0,     0,    52,    52,    52,    52,     0,     0,     0,
       0,    52,    52,    52,    52,    52,    52,     0,     0,    52,
      52,    52,    52,    52,    52,     0,     0,     0,     0,    52,
      52,    52,     0,     0,     0,     0,     0,    52,    52,    52,
      52,    52,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,     0,     0,    52,
      52,    52,    52,    52,    52,    52,     0,     0,     0,    52,
       0,    52,    52,    52,    52,    52,     0,     0,     0,     0,
       0,     0,     0,     0,    52,     0,     0,    52,    52,    52,
      52,    52,    52,     0,     0,     0,    52,    52,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    52,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    52,    52,    52,    52,    52,    52,    52,     0,
       0,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,     0,   255,   256,   423,   396,   395,   397,
       0,     0,     0,     0,    27,   490,    80,   491,   492,   898,
      73,    74,    75,    76,    77,    78,    79,     0,   767,   768,
       0,   941,     0,     0,     0,   862,   769,   770,     0,   765,
       0,     0,   688,   689,     0,   861,   806,   807,   687,   865,
     866,     0,   872,   874,   873,     0,   868,   867,   864,   863,
       0,   870,   871,   869,    27,     0,   671,   890,     0,   766,
       0,   694,   690,     0,   781,   780,   779,   782,     0,     0,
       0,     0,    27,    32,    35,   896,   721,   720,   691,   692,
       0,   891,   894,     0,   919,   918,     0,   931,   930,   929,
     928,     0,     0,   917,     0,   927,   926,   925,   924,   936,
     935,   921,   920,   934,     0,     0,   923,   922,     0,   937,
       0,   933,   932,     0,     0,   844,   845,   846,     0,   889,
     888,     0,    27,    80,   815,   813,     0,    27,    80,   827,
     825,    27,    80,   823,   821,    27,    80,   819,   817,   883,
     666,   665,   664,   764,   893,   670,   881,   882,   877,   878,
     876,   875,   880,   879,   718,   724,   725,   791,   790,   793,
     792,     0,   794,   795,   796,   797,   798,   799,     0,   892,
     895,   685,   897,   771,   772,   763,   786,   887,     0,   831,
     829,    42,   905,   906,   907,   908,   843,     0,   773,   774,
     775,     0,     0,   679,   693,   913,   808,   809,   728,   729,
     783,   810,   812,   811,   884,   885,   731,   732,   730,   940,
     939,   886,   733,   734,     0,   749,   750,   751,   756,   755,
     752,   753,   754,   761,   762,   739,   738,   735,   736,   737,
     741,   740,   757,   758,   743,   742,   748,   759,   760,   745,
     744,   747,   746,   847,   859,   848,   855,   856,   857,   858,
     851,   852,   853,   854,   850,   860,   849,   789,   788,   787,
       0,   784,     0,   776,   777,   778,     0,   686,   914,   915,
     938,     0,   916,   785,   837,   838,   839,   840,   841,   842,
       0,   801,   800,   805,   804,   803,   802,     0,     0,     0,
       0,   835,   833,    42,     1,     4,    12,    10,     5,     8,
     706,     0,     0,     0,     0,     0,   707,     0,     0,    28,
      30,     0,     0,   696,     0,     0,     0,     0,     0,   697,
       0,     0,     0,   656,   657,     0,     0,     0,   288,   284,
       0,     0,     0,     0,   270,    88,    89,     0,   316,    90,
      91,     0,     0,    92,   338,   336,   337,     0,     0,     0,
       0,   437,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   321,     0,     0,     0,     0,   355,     0,     0,     0,
       0,   451,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,     0,     0,   494,   495,   496,     0,
     383,     0,   384,   386,   387,     0,     0,     0,     0,   422,
     343,   447,   448,   342,   344,     0,     0,   497,   498,     0,
     326,   325,   102,   103,   322,     0,   482,     0,     0,     0,
       0,   470,   471,   472,     0,     0,     0,     0,     0,     0,
     331,     0,   329,   367,   442,   368,   441,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   323,   320,   335,
     104,   105,   106,   107,   108,   333,   334,   376,   445,     0,
     369,     0,   443,   274,     0,   109,   375,   110,   111,   112,
     113,   315,     0,     0,     0,   114,     0,   314,     0,   433,
       0,   381,     0,   435,   115,     0,     0,     0,     0,     0,
       0,     0,     0,   324,     0,     0,     0,   327,   116,   117,
     118,   404,     0,   410,     0,     0,     0,     0,   406,   411,
       0,   408,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   289,   285,     0,     0,   379,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   121,
     122,   123,   124,   125,     0,     0,   388,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   398,   399,   400,   126,   319,   127,     0,   259,
     257,   258,     0,     0,    39,    38,     0,    42,    27,   490,
      80,     0,   286,   287,     0,     0,    28,   419,   420,   421,
     282,   283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   263,     0,     0,     0,     0,     0,
       0,   647,     0,     0,     0,    51,     0,     0,     0,     0,
       0,     0,     0,   675,   673,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   909,     0,     0,     0,   655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,     0,     0,     0,   683,   681,     0,   910,
       0,     0,   661,   663,    26,    29,    31,     0,   834,     2,
       6,   708,   712,   711,   710,   713,   709,    16,     0,   704,
     705,   698,   702,   701,   700,   703,   699,   695,    14,   658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,    44,
       0,    81,     0,     0,     0,    87,     0,    47,    49,     0,
      21,    19,    84,   271,   267,   268,   269,   279,   281,   264,
     280,   261,   276,   272,    83,   273,   277,   278,   275,   260,
      82,    85,   265,   266,   262,    64,    66,     0,   722,     0,
      60,     0,    54,    53,    53,   678,   677,     0,     0,   672,
      62,     0,    53,     0,   716,     0,    33,     0,    36,     0,
       0,     0,    70,    72,     0,     0,    56,    58,    57,    55,
     726,     0,    68,    53,   832,    43,    42,     0,     0,     0,
     680,     0,   836,     0,    24,   313,   305,   293,   304,   417,
     418,   306,   317,   299,   424,     0,   389,   302,     0,     0,
       0,   361,     0,   358,     0,   364,     0,   356,     0,   438,
     465,   307,   450,   318,   312,   300,   385,   391,   392,   393,
       0,     0,     0,     0,   481,   413,   478,     0,   414,   412,
     457,   458,   456,     0,     0,   466,   332,   330,     0,   292,
     483,   484,   309,   310,   427,   467,   446,     0,     0,   370,
     444,   488,     0,   371,     0,   459,   308,   434,   382,   436,
       0,     0,   489,     0,     0,   485,   486,   416,   415,   468,
     455,   301,   328,   409,   474,   473,   475,   403,   402,   405,
     407,     0,   349,   354,   352,   353,   351,   350,   347,   348,
     311,   303,     0,     0,   377,   461,   291,   462,   290,   463,
       0,   425,   469,   401,   493,   426,   487,    41,    40,     0,
       0,     0,    17,     0,    86,     0,     0,     0,   723,     0,
     676,   674,     0,     0,     0,     0,    34,     0,     0,     0,
       0,   727,     0,     0,   684,   682,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    20,    18,
       0,    48,     0,    59,     0,    59,   714,     0,    59,     0,
       0,    59,    59,     0,    59,    22,     0,   390,     0,   372,
     374,     0,   362,     0,   359,     0,   365,   357,     0,   439,
     394,   449,     0,     0,     0,   477,     0,   294,     0,   297,
     431,     0,     0,   429,   339,   460,     0,     0,     0,   432,
       0,   346,   380,   378,   464,     0,    50,     0,     0,     0,
     717,     0,     0,     0,     0,     0,    23,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,     0,     0,    61,   715,    61,     0,     0,
      61,    61,   373,   363,   360,   366,   440,     0,   476,     0,
     295,   298,   428,   430,     0,   452,   454,     0,   340,   345,
       0,     0,     0,     0,     0,     0,     0,     0,    63,    63,
       0,    63,     0,   480,   296,   453,   341,     0,     0,     0,
       0,    65,     0,    65,   479,     0,     0,     0,    67,     0,
       0,     0,    69,     0,    71
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1467,  -514, -1467, -1467, -1467,  -147,  -154,  -903, -1467, -1467,
   -1467,  1381,   167,  1430, -1467,  -472,   -67, -1467, -1142, -1467,
       0, -1467, -1466, -1224, -1467,  2501,   317,   -50,   -33,   435,
     717,   219,   500,  -369,  -313,  -311,    -1, -1467, -1467, -1467,
   -1467, -1467, -1467, -1378, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467,   367,   369,   377, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467,
   -1467, -1467, -1467, -1467, -1467, -1467, -1467, -1467
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   156,   936,   157,   158,   159,  1326,  1327,  1328,  1329,
     950,   644,   645,   646,   714,  1385,   715,   647,  1313,  1314,
    1315,   648,  1316,  1576,  1577,   672,  1366,   764,   765,  1362,
    1376,  1355,  1356,   807,   751,   752,   720,   650,   651,   652,
     653,   654,   655,   656,   163,   164,   165,   664,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   911,   179,   920,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     649,   660,   661,   785,  1624,  1382,   949,   665,   660,   670,
     673,   938,   677,   769,   773,   777,  1322,   680,   684,   687,
     689,   693,  1322,  1330,   697,   700,   963,   951,  1330,   964,
     770,   774,   778,  1781,   948,  1353,   674,   152,   707,  1424,
     934,  1339,  1310,  1311,  1782,  1354,   721,   722,   723,   725,
     731,   734,   731,   711,  1626,   744,   748,   749,   753,   758,
     760,   766,   766,   766,   766,   779,  1341,   700,   784,  1387,
     787,   935,   791,   793,  1424,   152,   152,   798,   800,   808,
     809,   810,   811,   812,   660,   744,   816,   744,   821,   819,
    -814,   662,   154,   670,   831,  1322,   939,   835,   962,   837,
     839,   840,   841,   843,   844,   845,   848,   850,   670,   853,
     857,   748,   862,   864,   866,   869,   871,   873,   875,   876,
     878,   880,   882,   883,   884,   744,   731,   731,   744,   895,
     734,   758,  1339,   901,   906,   907,  1609,  -826,   910,   965,
     966,   913,  1322,   916,   917,   152,   152,  1453,   922,   924,
     926,  -822,  1424,  -816,   933,   931,  1322,  1341,  1330,  -828,
     970,   711,   967,  -824,  1330,   971,   972,   161,  1330,  -814,
     973,   977,  -820,   981,   953,   954,   982,  1330,   955,   987,
     988,   989,  1641,   990,   470,   471,  1002,  1003,  1004,  -818,
     695,  1005,   940,   941,  1322,  1007,   942,  1008,  1009,  1010,
    1124,  1125,  1129,  1131,  1135,  1136,  1137,  1138,   488,  1145,
     713,  1155,  1332,  1157,  1158,  1159,  -826,  1160,  1164,  1165,
    1166,   658,  1167,  1334,  1335,  1336,  1168,  1169,   666,  1171,
    -822,  1177,  -816,  1178,   161,  1179,  1180,   713,  -828,  1181,
    1182,  1183,  -824,  1184,   956,  1185,  1335,  1336,  1186,  1199,
    1201,  -820,  1204,  1212,  1213,  1214,  1375,  1216,  1218,  1220,
    1222,  1225,   943,   832,  1226,  1227,  1228,  1229,  -818,  1230,
     729,   733,   737,  1231,  1383,  1232,  1234,  1235,  1236,   757,
    1242,  1349,  1350,  1351,  1352,  1244,  1353,  1245,  1246,  1247,
    1250,  1388,  1252,  1253,  1254,  1255,  1354,  1256,  1257,   805,
    1258,  1259,  1260,  1261,   813,   908,  1264,  1265,   912,  1267,
    1268,  1269,  1270,  1271,   829,  1272,  1273,  1274,  1275,  1276,
     974,   928,  1284,  1285,  1308,   161,  1360,   948,  1365,  1381,
     952,  1387,  1384,  1406,  1418,  1425,   683,   686,   688,   691,
     161,  1449,  1430,   161,  1426,  1453,   888,   892,  1568,  1567,
     896,   899,  1569,  1579,   904,  1605,   704,  1606,  1625,  1424,
    1610,  1612,  1617,   718,  1620,  1437,  1632,   724,  1648,  1354,
    1633,   739,   741,   743,  1351,  1352,  1636,  1353,   759,  1637,
    1642,  1644,  1652,  1838,  1659,  1660,  1698,  1354,  1700,   788,
     790,   792,  1701,  1710,  1711,   797,   799,   802,  1721,  1732,
    1735,  1736,  1737,   815,  1744,   817,  1747,  1776,  1777,  1784,
    1783,  1780,  1785,  1788,  1796,  1786,  1801,  1808,  1847,  1839,
    1782,   842,  1429,  1580,   846,  1896,  1778,   852,  1419,  1922,
     861,   863,  1407,   868,   780,   872,   781,  1396,   877,  1397,
     881,   609,  1323,   885,   782,   669,   894,     0,  1323,  1331,
       0,  -814,     0,     0,  1331,     0,     0,   692,     0,     0,
       0,     0,     0,     0,     0,     0,   921,   923,   925,  1900,
     744,     0,     0,     0,   705,  1339,   957,     0,     0,     0,
       0,   719,     0,     0,     0,   152,   727,  1149,   735,   740,
     742,     0,   746,     0,   944,   755,     0,  1339,  -826,   642,
    1341,   711,   659,     0,     0,     0,     0,   789,     0,   667,
       0,     0,  -822,     0,  -816,   803,     0,     0,     0,     0,
    -828,  1323,  1341,     0,  -824,     0,     0,     0,  1324,   826,
       0,     0,  1325,  -820,  1324,     0,  1203,     0,  1325,  1424,
     949,     0,   847,     0,   851,  1426,   958,   858,     0,     0,
    -818,   730,     0,   738,     0,     0,     0,     0,   949,     0,
       0,  1841,   886,   890,   945,     0,     0,   897,  1323,     0,
     903,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     806,     0,  1323,     0,  1331,   814,     0,     0,     0,     0,
    1331,     0,     0,     0,  1331,   830,     0,     0,     0,     0,
     959,   960,     0,  1331,     0,     0,     0,  1324,     0,     0,
       0,  1325,     0,  -814,  -814,     0,     0,     0,   946,   947,
    1323,     0,     0,     0,     0,     0,     0,   889,   893,     0,
       0,     0,     0,     0,     0,   905,     0,     0,     0,  1309,
       0,  1317,  1321,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1324,     0,  1357,     0,  1325,     0,
    -826,  -826,     0,  1361,     0,     0,     0,  1363,  1324,     0,
    1321,     0,  1325,     0,  -822,  -822,  -816,  -816,     0,   961,
    1367,     0,  -828,  -828,  1367,     0,  -824,  -824,     0,  1369,
       0,     0,     0,     0,  1374,  -820,  -820,  1377,     0,     0,
       0,     0,  1379,     0,   948,     0,  1324,  1148,     0,     0,
    1325,  1402,  -818,  -818,     0,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,  1390,     0,     0,  1403,     0,
    1354,  1392,     0,     0,     0,     0,     0,  1349,  1350,  1351,
    1352,     0,  1353,   699,  1394,     0,     0,     0,     0,  1398,
       0,     0,  1354,  1400,     0,     0,   706,     0,     0,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,   728,     0,
     736,     0,     0,   949,   747,     0,     0,   756,     0,     0,
       0,     0,     0,     0,     0,   783,     0,  1126,  1128,     0,
       0,     0,  1332,     0,  1333,     0,     0,   804,     0,     0,
    1408,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
    1319,     0,   828,     0,     0,  1448,     0,  1411,  1410,     0,
       0,     0,     0,     0,  1319,     0,  1414,     0,   856,   859,
       0,  1417,     0,     0,     0,  1319,     0,     0,  1319,     0,
       0,     0,     0,     0,   887,   891,     0,     0,  1319,   898,
       0,     0,  1319,  1377,     0,     0,     0,  1319,     0,     0,
       0,     0,     0,     0,     0,  1319,     0,     0,     0,     0,
    1319,     0,     0,     0,     0,     0,     0,     0,   928,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1319,     0,     0,     0,     0,     0,  1319,
       0,  1420,     0,     0,     0,  1127,     0,     0,     0,     0,
    1422,     0,  1319,     0,     0,     0,     0,  1319,     0,  1423,
       0,  1319,     0,     0,     0,     0,     0,     0,  1319,  1411,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1431,  1432,  1433,  1434,  1435,     0,  1436,  1438,     0,     0,
    1439,  1440,     0,  1441,  1442,  1443,  1444,  1445,     0,  1446,
    1447,     0,     0,     0,  1450,  1451,     0,     0,  1319,  1454,
    1455,     0,  1458,     0,     0,     0,  1459,     0,     0,     0,
    1460,  1461,     0,     0,     0,  1319,  1462,  1463,  1464,  1465,
       0,     0,     0,     0,  1319,     0,     0,     0,     0,     0,
       0,  1466,  1467,  1468,  1469,     0,  1470,  1471,  1472,  1473,
       0,     0,  1373,     0,     0,     0,     0,     0,     0,     0,
       0,  1319,     0,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1319,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,  1319,     0,     0,
       0,     0,     0,   161,     0,     0,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1474,  1475,     0,     0,     0,  1476,   161,
    1477,     0,     0,     0,  1478,  1479,  1480,  1481,     0,  1456,
       0,     0,     0,     0,  1482,  1483,     0,     0,     0,  1416,
       0,     0,     0,     0,  1485,     0,  1486,  1487,  1488,   670,
    1344,     0,     0,  1490,  1493,  1494,  1495,  1496,  1497,     0,
    1498,     0,     0,  1581,     0,     0,  1499,  1500,     0,  1503,
    1504,  1505,  1506,  1507,  1508,  1509,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1510,     0,
    1511,     0,     0,   670,     0,  1147,     0,     0,     0,     0,
       0,  1513,  1514,  1515,     0,  1516,     0,  1517,     0,  1518,
       0,  1519,     0,     0,  1520,  1521,   670,  1523,  1524,     0,
    1528,  1529,   949,  1530,  1531,  1532,     0,     0,     0,     0,
       0,  1533,     0,  1535,  1536,  1538,  1539,     0,     0,  1540,
       0,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,     0,     0,  1551,  1552,     0,  1553,  1554,  1555,  1556,
    1557,  1558,  1559,  1560,  1561,  1562,     0,     0,     0,  1345,
       0,     0,     0,  1563,  1564,     0,     0,     0,     0,     0,
       0,  1358,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,     0,  1571,   744,     0,     0,
    1354,  1317,  1566,  1319,     0,     0,     0,  1627,     0,     0,
       0,  1628,     0,  1438,  1578,     0,     0,     0,     0,     0,
       0,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,
    1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,
    1601,  1602,  1603,  1604,     0,     0,     0,  1607,     0,  1578,
       0,     0,     0,  1611,     0,     0,     0,  1613,     0,  1614,
    1615,  1616,     0,     0,  1619,     0,     0,  1621,     0,  1622,
    1623,   160,     0,     0,     0,     0,   663,     0,     0,     0,
    1629,     0,  1630,     0,  1631,     0,     0,     0,  1634,     0,
    1635,     0,     0,     0,   694,  1578,     0,     0,  1643,     0,
       0,  1594,  1646,  1645,  1647,     0,     0,  1650,     0,     0,
    1651,   708,   709,   710,   712,   716,   717,  1594,     0,     0,
     162,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   762,   767,   771,   775,     0,   160,     0,
       0,   712,  1438,   696,     0,     0,   794,     0,   796,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   694,     0,     0,
       0,     0,  1491,  1692,     0,     0,     0,     0,     0,     0,
       0,     0,   763,   768,   772,   776,  1501,   162,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   900,     0,     0,     0,     0,   694,
       0,     0,   712,     0,     0,     0,   833,     0,     0,     0,
       0,     0,     0,     0,     0,   927,     0,     0,     0,   160,
       0,     0,     0,     0,     0,     0,     0,  1525,  1527,     0,
       0,   713,     0,     0,   160,   713,     0,   160,     0,     0,
       0,  1534,     0,  1537,     0,     0,     0,  1646,   909,  1599,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   929,     0,     0,     0,   162,     0,
       0,     0,     0,     0,     0,  1489,     0,     0,     0,     0,
    1492,     0,     0,   162,     0,     0,   162,     0,     0,     0,
       0,     0,     0,     0,  1502,     0,  1790,  1791,     0,     0,
       0,     0,     0,     0,     0,  1565,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1512,
       0,     0,     0,     0,     0,     0,     0,  1804,  1805,     0,
       0,     0,  1807,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1522,     0,  1809,  1526,     0,  1810,  1811,  1812,
       0,  1813,     0,  1814,     0,  1815,     0,  1816,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1817,
    1818,     0,  1820,     0,     0,     0,  1821,   968,     0,     0,
       0,     0,  1822,  1823,     0,     0,     0,  1824,     0,     0,
       0,     0,     0,     0,     0,     0,  1825,  1826,     0,     0,
       0,  1827,     0,  1828,     0,     0,     0,     0,     0,  1829,
    1830,     0,  1831,  1832,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   969,     0,     0,     0,
    1833,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1834,  1835,     0,     0,     0,     0,     0,     0,  1836,
       0,     0,     0,     0,     0,     0,     0,     0,  1837,     0,
       0,     0,     0,     0,  1578,     0,  1842,     0,  1843,     0,
       0,  1844,  1845,  1846,     0,     0,  1848,  1849,  1850,  1851,
    1332,  1852,  1853,     0,     0,  1854,     0,  1856,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,  1872,     0,
       0,     0,  1332,     0,  1333,     0,     0,     0,     0,     0,
       0,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1907,     0,     0,
    1908,     0,  1909,     0,  1910,     0,     0,  1911,     0,     0,
       0,     0,  1912,  1913,     0,  1914,     0,  1915,     0,     0,
    1916,  1917,     0,     0,     0,  1918,  1919,  1920,     0,  1921,
       0,     0,     0,     0,  1923,     0,  1924,  1925,  1926,     0,
    1927,  1928,  1929,  1930,  1931,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1332,
       0,  1333,     0,     0,     0,     0,  1954,     0,  1955,     0,
    1334,  1335,  1336,  1956,     0,     0,  1957,     0,     0,  1958,
    1959,  1960,  1961,     0,     0,     0,     0,     0,     0,     0,
       0,  1970,     0,     0,     0,     0,  1971,  1972,  1973,     0,
    1262,     0,     0,     0,  1977,  1978,     0,     0,  1980,  1332,
    1982,  1333,  1984,     0,     0,     0,     0,     0,     0,     0,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1263,
       0,     0,     0,     0,  1318,     0,     0,     0,     0,     0,
       0,  1337,     0,     0,     0,     0,     0,     0,  1318,     0,
       0,     0,     0,  1359,     0,     0,     0,     0,     0,  1318,
       0,     0,  1318,  1337,     0,     0,  1338,  1332,     0,  1333,
       0,     0,  1318,  1339,     0,     0,  1318,     0,  1334,  1335,
    1336,  1318,     0,  1320,     0,     0,     0,     0,     0,  1318,
    1340,     0,     0,     0,  1318,  1339,     0,  1320,  1341,     0,
       0,     0,  1386,     0,     0,     0,     0,     0,  1320,     0,
    1342,  1320,  1340,     0,     0,     0,     0,  1318,     0,     0,
    1341,  1320,     0,  1318,     0,  1320,     0,     0,     0,     0,
    1320,     0,  1342,     0,     0,     0,  1318,     0,  1320,     0,
       0,  1318,     0,  1320,     0,  1318,     0,  1337,  1343,     0,
    1338,     0,  1318,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1320,     0,     0,     0,
    1337,     0,  1320,  1338,     0,     0,     0,     0,     0,  1339,
       0,     0,     0,     0,     0,  1320,     0,     0,  1618,     0,
    1320,     0,  1318,     0,  1320,     0,  1340,     0,     0,     0,
    1344,  1320,  1339,     0,  1341,     0,     0,     0,     0,  1318,
       0,     0,     0,     0,     0,     0,  1342,     0,  1318,  1340,
    1337,     0,     0,  1338,     0,     0,     0,  1341,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,     0,     0,  1342,
       0,  1320,     0,     0,     0,  1318,     0,     0,  1332,     0,
    1333,     0,  1339,     0,     0,  1343,     0,     0,  1320,  1334,
    1335,  1336,     0,     0,     0,     0,     0,  1320,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,     0,  1342,
       0,     0,     0,  1318,  1320,     0,     0,     0,  1337,     0,
       0,  1338,     0,     0,     0,  1343,     0,  1344,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,
       0,  1318,     0,     0,     0,     0,     0,   160,  1354,     0,
    1339,  1364,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1320,     0,     0,     0,  1571,  1340,     0,     0,
    1354,     0,     0,   160,     0,  1341,     0,  1344,  1452,     0,
       0,     0,     0,   694,     0,     0,     0,  1342,     0,     0,
    1320,     0,     0,     0,     0,     0,   162,     0,     0,     0,
       0,     0,     0,  1343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,  1345,     0,     0,     0,   929,     0,     0,
       0,     0,  1457,     0,     0,  1368,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,  1345,     0,     0,     0,
    1571,     0,     0,     0,  1354,  1344,     0,     0,  1370,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,     0,  1571,     0,     0,     0,  1354,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1345,     0,     0,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,  1368,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1354,     0,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   675,   676,   678,     0,     0,  1340,   679,
     682,     0,     0,     0,     0,     0,  1341,  1318,     0,   701,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,   702,
       0,     0,     0,     0,  1345,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,     0,  1378,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1571,   786,     0,     0,  1354,  1320,   795,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     820,   822,   823,   824,   825,     0,     0,     0,   834,     0,
       0,   836,   838,     0,     0,     0,  1344,     0,     0,   849,
       0,     0,   855,     0,   860,     0,   865,   867,   870,     0,
     874,     0,     0,   879,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   914,   915,     0,   918,   919,     0,
       0,     0,     0,     0,     0,     0,   932,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1380,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1571,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,   712,     0,   712,     0,     0,     0,   712,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1638,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   975,   976,   978,   979,   980,     0,     0,
     983,   984,   985,   986,     0,  1639,     0,     0,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,     0,
       0,     0,  1006,     0,     0,     0,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,     0,
       0,     0,     0,     0,  1130,  1132,  1133,  1134,     0,     0,
       0,     0,  1139,  1140,  1141,  1142,  1143,  1144,     0,     0,
    1150,  1151,  1152,  1153,  1154,  1156,     0,     0,     0,     0,
    1161,  1162,  1163,     0,     0,     0,  1795,     0,  1170,  1172,
    1173,  1174,  1175,  1176,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,  1198,  1200,  1202,     0,     0,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,     0,     0,     0,
    1215,     0,  1217,  1219,  1221,  1223,  1224,     0,     0,     0,
       0,     0,     0,     0,     0,  1233,     0,     0,  1237,  1238,
    1239,  1240,  1241,  1243,     0,     0,     0,  1248,  1249,  1251,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1266,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1277,  1278,  1279,  1280,  1281,  1282,  1283,
       0,     0,  1286,  1287,  1288,  1289,  1290,  1291,  1292,  1293,
    1294,  1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1306,  1307,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   314,   315,   316,     0,
       0,     0,     0,     0,     0,     0,   317,   318,   319,   320,
       0,   321,     0,     0,  1840,   322,   323,   324,   325,   326,
       0,     0,     0,   327,     0,     0,   328,     0,   329,     0,
     330,     0,   331,   332,     0,     0,   333,     0,     0,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,     0,     0,   348,   349,   350,
       0,     0,   351,   352,   353,   354,     0,   355,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   712,     0,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,     0,     0,     0,   469,   470,   471,     0,
       0,   472,     0,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,   483,   484,   485,   486,
     487,   488,     0,     0,     0,   489,     0,     0,     0,   490,
     491,   492,     0,   493,     0,     0,     0,     0,   494,     0,
       0,     0,   495,   496,   497,   498,     0,     0,     0,     0,
       0,   499,   500,   501,   502,     0,     0,   503,     0,     0,
       0,     0,   504,   505,     0,   506,   507,   508,     0,   509,
     510,   511,   512,   513,   514,     0,     0,   515,   516,   517,
     518,     0,   519,     0,     0,   520,   521,   522,   523,     0,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,     0,   534,     0,     0,   535,     0,   536,     0,     0,
     537,     0,     0,     0,     0,   538,     0,     0,   539,   540,
     541,   542,   543,   544,     0,     0,     0,     0,   545,     0,
     546,     0,     0,   547,     0,     0,     0,     0,     0,     0,
     548,   549,     0,   550,   551,   552,   553,   554,     0,   555,
       0,     0,     0,     0,     0,   556,   557,   558,     0,     0,
     559,   560,   561,   562,   563,     0,   564,     0,     0,     0,
       0,   565,     0,     0,     0,     0,     0,   566,   567,   568,
     569,   570,     0,     0,     0,     0,   571,   572,   573,   574,
       0,     0,     0,   575,     0,   576,   577,     0,   578,     0,
       0,     0,     0,     0,   579,     0,   580,     0,     0,     0,
     581,     0,     0,   582,   583,     0,     0,   584,   585,   586,
     587,   588,     0,     0,   589,     0,     0,     0,   590,     0,
     591,   592,     0,     0,     0,   593,   594,   595,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,   610,     0,   611,     0,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
     629,     0,     0,     0,   630,     0,     0,     0,     0,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   152,     0,
    1572,     0,     0,     0,   640,   641,     0,     0,     0,     0,
       0,  1437,   642,     0,   643,   314,   315,   316,  1573,     0,
       0,     0,     0,     0,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
    1574,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,  1575,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
    1574,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,  1608,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
    1574,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,  1640,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,  1365,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   685,  1365,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   698,  1365,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,  1371,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,  1372,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   685,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
    1437,   642,     0,   643,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,  1779,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
    1574,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   643,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   657,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   668,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   671,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   681,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   685,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   690,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   698,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   703,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   726,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   732,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   745,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   750,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   754,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   761,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   801,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   818,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   827,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   854,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   902,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,   930,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,   642,     0,  1146,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     0,     0,
       0,     0,     0,   640,   641,   314,   315,   316,     0,     0,
       0,  1312,     0,   643,     0,   317,   318,   319,   320,     0,
     321,     0,     0,     0,   322,   323,   324,   325,   326,     0,
       0,     0,   327,     0,     0,   328,     0,   329,     0,   330,
       0,   331,   332,     0,     0,   333,     0,     0,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,     0,     0,   348,   349,   350,     0,
       0,   351,   352,   353,   354,     0,   355,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,     0,     0,     0,   469,   470,   471,     0,     0,
     472,     0,     0,     0,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,   489,     0,     0,     0,   490,   491,
     492,     0,   493,     0,     0,     0,     0,   494,     0,     0,
       0,   495,   496,   497,   498,     0,     0,     0,     0,     0,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,   504,   505,     0,   506,   507,   508,     0,   509,   510,
     511,   512,   513,   514,     0,     0,   515,   516,   517,   518,
       0,   519,     0,     0,   520,   521,   522,   523,     0,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
       0,   534,     0,     0,   535,     0,   536,     0,     0,   537,
       0,     0,     0,     0,   538,     0,     0,   539,   540,   541,
     542,   543,   544,     0,     0,     0,     0,   545,     0,   546,
       0,     0,   547,     0,     0,     0,     0,     0,     0,   548,
     549,     0,   550,   551,   552,   553,   554,     0,   555,     0,
       0,     0,     0,     0,   556,   557,   558,     0,     0,   559,
     560,   561,   562,   563,     0,   564,     0,     0,     0,     0,
     565,     0,     0,     0,     0,     0,   566,   567,   568,   569,
     570,     0,     0,     0,     0,   571,   572,   573,   574,     0,
       0,     0,   575,     0,   576,   577,     0,   578,     0,     0,
       0,     0,     0,   579,     0,   580,     0,     0,     0,   581,
       0,     0,   582,   583,     0,     0,   584,   585,   586,   587,
     588,     0,     0,   589,     0,     0,     0,   590,     0,   591,
     592,     0,     0,     0,   593,   594,   595,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,   610,     0,   611,     0,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,   629,
       0,     0,     0,   630,     0,     0,     0,     0,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   152,     1,     0,
       0,     0,     2,     3,     0,     0,     0,     0,     4,     0,
       0,   642,     0,   643,     0,     0,     0,     0,     5,     6,
       7,     0,     8,     9,     0,    10,     0,    11,     0,    12,
       0,     0,    13,    14,     0,    15,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,     0,     0,     0,    21,    22,
       0,     0,     0,     0,    23,     0,     0,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,     0,     0,     0,     0,     0,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    35,    36,    37,     0,     0,     0,    38,     0,     0,
      39,    40,    41,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,     0,     0,     0,
      43,    44,    45,     0,    46,    47,    48,     0,     0,     0,
       0,     0,    49,     0,    50,    51,     0,    52,    53,    54,
       0,     0,     0,     0,    55,    56,    57,    58,    59,     0,
       0,     0,     0,    60,    61,     0,    62,    63,    64,    65,
       0,     0,     0,     0,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,     0,
       0,    69,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,    72,     0,    73,     0,    74,    75,     0,    76,
      77,    78,    79,     0,    80,     0,     0,     0,     0,     0,
       0,     0,    81,    82,    83,    84,     0,    85,     0,    86,
      87,     0,    88,    89,    90,    91,    92,    93,     0,     0,
      94,     0,     0,     0,     0,     0,    95,  1337,    96,     0,
      97,    98,    99,     0,     0,     0,   100,   101,     0,     0,
       0,     0,     0,   102,     0,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,     0,     0,     0,     0,  1339,
     110,   111,   112,   113,     0,     0,     0,     0,   114,   115,
     116,  1337,   117,     0,  1338,   118,  1340,   119,   120,   121,
     122,   123,     0,   124,  1341,   125,   126,   127,     0,   128,
     129,     0,     0,   130,   131,     0,  1342,     0,     0,     0,
     132,     0,     0,  1339,   133,   134,     0,   135,     0,     0,
       0,   136,  1343,     0,     0,     0,     0,     0,     0,     0,
    1340,   137,     0,     0,     0,     0,     0,     0,  1341,     0,
     138,   139,     0,   140,     0,   141,     0,   142,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,  1343,   145,     0,   146,
     147,   148,     0,   149,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,   153,     1,     0,
       0,     0,     2,     3,     0,     0,     0,     0,     4,     0,
       0,     0,   154,     0,     0,     0,   155,     0,     5,     6,
       7,     0,     8,     9,     0,    10,     0,    11,  1344,    12,
       0,     0,    13,    14,     0,    15,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,     0,     0,     0,    21,    22,
       0,     0,     0,     0,    23,     0,     0,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1345,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1391,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,  1571,     0,     0,     0,  1354,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    35,    36,    37,     0,     0,     0,    38,     0,     0,
      39,    40,    41,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,     0,     0,     0,
      43,    44,    45,     0,    46,    47,    48,     0,     0,     0,
       0,     0,    49,     0,    50,    51,     0,    52,    53,    54,
       0,     0,     0,     0,    55,    56,    57,    58,    59,     0,
       0,     0,     0,    60,    61,     0,    62,    63,    64,    65,
       0,     0,     0,     0,     0,     0,    66,     0,     0,     0,
       0,     0,     0,    67,    68,     0,     0,     0,     0,     0,
       0,    69,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,    72,     0,    73,     0,    74,    75,     0,    76,
      77,    78,    79,     0,    80,     0,     0,     0,     0,     0,
       0,     0,    81,    82,    83,    84,     0,    85,     0,    86,
      87,     0,    88,    89,    90,    91,    92,    93,     0,     0,
      94,     0,     0,     0,     0,     0,    95,     0,    96,     0,
      97,    98,   937,     0,     0,     0,   100,   101,     0,     0,
       0,     0,     0,   102,     0,   103,   104,     0,     0,     0,
     105,   106,   107,   108,   109,     0,     0,     0,     0,     0,
     110,   111,   112,   113,     0,     0,     0,     0,   114,   115,
     116,     0,   117,     0,     0,   118,     0,   119,   120,   121,
     122,   123,     0,   124,     0,   125,   126,   127,     0,   128,
     129,     0,     0,   130,   131,     0,     0,     0,     0,     0,
     132,     0,     0,     0,   133,   134,     0,   135,     0,     0,
       0,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,     0,     0,     0,     0,     0,     0,     0,     0,
     138,   139,     0,   140,     0,   141,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       2,     3,     0,     0,   143,   144,     4,   145,     0,   146,
     147,   148,     0,   149,   150,   151,     5,     6,     7,     0,
       8,     9,     0,    10,     0,    11,   152,    12,     0,     0,
      13,    14,     0,    15,    16,    17,     0,     0,     0,     0,
       0,     0,   154,     0,     0,     0,   155,     0,     0,     0,
      18,    19,    20,     0,     0,     0,    21,    22,     0,     0,
       0,     0,    23,     0,     0,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,     0,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
      36,    37,     0,     0,     0,    38,     0,     0,    39,    40,
      41,     0,     0,     0,     0,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,    43,    44,
      45,     0,    46,    47,    48,     0,     0,     0,     0,     0,
      49,     0,    50,    51,     0,    52,    53,    54,     0,     0,
       0,     0,    55,    56,    57,    58,    59,     0,     0,     0,
       0,    60,    61,     0,    62,    63,    64,    65,     0,     0,
       0,     0,     0,     0,    66,  1332,     0,  1333,     0,     0,
       0,    67,    68,     0,     0,     0,  1334,  1335,  1336,    69,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
      72,     0,    73,     0,    74,    75,     0,    76,    77,    78,
      79,     0,    80,     0,     0,     0,     0,     0,     0,     0,
      81,    82,    83,    84,     0,    85,     0,    86,    87,     0,
      88,    89,    90,    91,    92,    93,     0,     0,    94,  1332,
       0,  1333,     0,     0,    95,     0,    96,     0,    97,    98,
    1334,  1335,  1336,     0,   100,   101,     0,     0,     0,     0,
       0,   102,     0,   103,   104,     0,     0,     0,   105,   106,
     107,   108,   109,     0,     0,     0,     0,     0,   110,   111,
     112,   113,     0,     0,     0,     0,   114,   115,   116,  1337,
     117,     0,  1338,   118,     0,   119,   120,   121,   122,   123,
       0,   124,     0,   125,   126,   127,     0,   128,   129,     0,
       0,   130,   131,     0,     0,     0,     0,     0,   132,     0,
       0,  1339,   133,   134,     0,   135,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,     0,  1340,   137,
       0,     0,     0,     0,     0,     0,  1341,     0,   138,   139,
       0,   140,     0,   141,     0,   142,     0,     0,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,  1343,   145,     0,   146,   147,   148,
       0,   149,   150,   151,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,     0,  1337,     0,     0,  1338,
    1332,     0,  1333,     0,     0,     0,     0,     0,     0,     0,
     154,  1334,  1335,  1336,   155,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1344,     0,  1339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
    1337,     0,  1332,  1338,  1333,     0,     0,     0,     0,     0,
       0,  1343,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1332,     0,  1333,     0,
       0,     0,  1339,     0,     0,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
    1332,     0,  1333,  1344,     0,     0,     0,     0,     0,  1342,
       0,  1334,  1335,  1336,     0,  1345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,  1393,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,  1332,     0,
    1333,     0,  1571,     0,     0,     0,  1354,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1344,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1337,     0,     0,  1338,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1332,     0,  1333,     0,     0,     0,
       0,     0,  1345,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,  1339,  1395,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,  1571,
    1340,     0,     0,  1354,     0,     0,     0,     0,  1341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1345,  1337,     0,     0,
    1338,     0,     0,     0,     0,  1339,     0,     0,  1399,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,  1340,  1571,     0,     0,     0,  1354,     0,  1339,
    1341,  1337,     0,     0,  1338,     0,     0,     0,  1344,     0,
       0,     0,  1342,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,  1343,     0,
       0,     0,     0,  1339,     0,     0,  1342,     0,     0,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,  1343,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,  1332,     0,  1333,     0,     0,     0,     0,     0,
    1342,  1339,     0,  1334,  1335,  1336,     0,     0,     0,     0,
    1344,     0,     0,  1649,     0,     0,  1343,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,  1342,     0,
       0,     0,     0,     0,     0,  1337,     0,  1332,  1338,  1333,
       0,     0,     0,     0,  1343,     0,     0,  1345,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,  1344,  1401,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,  1339,  1353,     0,
       0,     0,     0,     0,  1571,     0,     0,     0,  1354,     0,
       0,     0,     0,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,  1332,  1344,  1333,     0,     0,
       0,     0,     0,     0,  1342,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1345,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1405,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,  1345,     0,     0,  1571,     0,     0,     0,
    1354,     0,     0,     0,     0,  1409,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
    1571,     0,  1344,     0,  1354,     0,     0,  1345,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1413,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,  1571,     0,     0,     0,  1354,  1332,
       0,  1333,     0,  1337,     0,  1345,  1338,     0,     0,     0,
    1334,  1335,  1336,     0,     0,     0,     0,  1415,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1571,     0,     0,  1339,  1354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,  1332,     0,  1333,     0,  1337,     0,
    1341,  1338,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,     0,     0,     0,     0,     0,  1343,     0,
    1339,     0,     0,  1368,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,  1340,     0,     0,
       0,     0,  1354,     0,     0,  1341,  1337,     0,  1332,  1338,
    1333,     0,     0,     0,     0,     0,     0,  1342,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
    1344,     0,     0,  1343,  1332,     0,  1333,     0,  1339,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,  1340,  1332,     0,  1333,     0,
       0,     0,     0,  1341,     0,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,     0,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,     0,  1332,     0,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
    1337,     0,     0,  1338,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1344,     0,     0,     0,     0,     0,  1345,
       0,     0,  1339,     0,     0,     0,     0,     0,     0,     0,
       0,  1421,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1340,
    1353,     0,     0,     0,     0,  1337,  1571,  1341,  1338,  1332,
    1354,  1333,     0,     0,     0,     0,     0,     0,     0,  1342,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,  1332,     0,  1333,  1345,  1343,     0,  1339,     0,     0,
       0,     0,  1334,  1335,  1336,     0,  1653,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,  1340,  1353,     0,  1654,     0,     0,
       0,     0,  1341,     0,     0,  1354,     0,     0,     0,  1337,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1344,     0,     0,
    1343,     0,  1345,     0,     0,  1337,     0,     0,  1338,     0,
       0,  1339,     0,     0,  1665,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,  1337,  1340,  1666,
    1338,     0,     0,  1354,     0,     0,  1341,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,     0,  1344,     0,  1340,     0,     0,     0,     0,  1339,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,  1338,     0,  1342,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,  1332,     0,  1333,     0,
    1343,     0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1343,     0,     0,     0,  1345,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,  1670,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1342,     0,
       0,     0,  1344,  1671,     0,     0,     0,  1354,     0,     0,
    1337,     0,     0,  1338,  1343,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,     0,     0,
       0,  1345,  1337,     0,     0,  1338,     0,     0,     0,     0,
       0,     0,  1339,  1672,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,     0,  1673,  1340,
       0,  1332,  1354,  1333,  1339,     0,  1344,  1341,     0,     0,
       0,     0,  1334,  1335,  1336,     0,     0,     0,     0,  1342,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,  1332,     0,  1333,     0,  1343,     0,     0,     0,     0,
       0,  1342,  1334,  1335,  1336,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,  1343,     0,     0,
       0,  1345,     0,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,  1674,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1345,     0,     0,     0,  1344,  1675,     0,
       0,     0,  1354,     0,     0,  1676,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,  1344,
    1677,     0,     0,     0,  1354,     0,     0,  1337,     0,     0,
    1338,  1332,     0,  1333,     0,  1345,     0,     0,     0,     0,
       0,     0,  1334,  1335,  1336,     0,     0,  1678,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,  1339,
       0,     0,  1679,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,     0,
    1333,     0,  1343,     0,     0,     0,  1345,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,  1484,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,     0,
       0,     0,  1337,  1571,     0,  1338,     0,  1354,     0,     0,
    1693,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,  1344,  1694,     0,     0,     0,  1354,
       0,     0,  1337,     0,  1339,  1338,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,  1332,     0,  1333,  1339,     0,     0,     0,     0,     0,
       0,  1342,  1334,  1335,  1336,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,  1343,     0,  1341,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1343,     0,     0,
       0,     0,  1337,     0,  1332,  1338,  1333,     0,     0,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,  1344,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1339,  1370,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,  1344,
    1702,  1340,     0,     0,  1354,     0,     0,  1337,     0,  1341,
    1338,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,  1338,  1332,     0,  1333,     0,  1343,     0,  1339,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,  1340,  1333,     0,     0,
       0,  1339,     0,     0,  1341,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,  1345,  1344,
       0,     0,  1343,     0,     0,     0,     0,     0,  1342,     0,
    1724,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,  1343,  1725,     0,     0,  1345,  1354,
       0,     0,  1337,     0,     0,  1338,     0,     0,     0,     0,
    1368,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,  1344,  1738,     0,     0,  1332,  1354,
    1333,     0,     0,     0,  1339,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,  1344,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,  1332,     0,  1333,     0,  1337,     0,     0,  1338,     0,
       0,  1342,  1334,  1335,  1336,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  1333,     0,  1343,  1345,     0,
       0,     0,     0,     0,  1334,  1335,  1336,  1339,     0,     0,
    1368,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,  1340,  1745,     0,     0,     0,  1354,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,  1344,
       0,     0,     0,  1345,  1337,     0,     0,  1338,     0,     0,
    1343,     0,     0,     0,     0,  1368,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1345,  1337,     0,     0,  1338,
    1748,     0,     0,     0,  1354,     0,  1339,  1763,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1764,  1340,     0,     0,  1354,     0,  1339,     0,
       0,  1341,  1344,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,  1332,     0,  1333,     0,  1343,
       0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,     0,     0,     0,  1332,     0,  1333,  1345,  1337,
       0,     0,  1338,     0,     0,     0,  1334,  1335,  1336,     0,
    1858,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,  1344,     0,     0,     0,  1859,     0,     0,     0,  1354,
       0,  1339,  1337,     0,     0,  1338,     0,     0,     0,     0,
       0,     0,     0,  1344,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,  1337,     0,  1341,  1338,  1332,     0,
    1333,  1345,     0,     0,  1339,     0,     0,     0,  1342,  1334,
    1335,  1336,     0,  1861,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,  1340,  1353,     0,  1343,     0,  1339,     0,  1862,  1341,
       0,     0,  1354,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,  1340,     0,     0,     0,     0,  1332,     0,
    1333,  1341,     0,     0,     0,     0,     0,  1343,     0,  1334,
    1335,  1336,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1344,     0,     0,  1343,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1863,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1345,     0,     0,     0,     0,  1864,     0,  1344,
       0,  1354,     0,     0,  1865,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,  1866,
       0,  1344,     0,  1354,     0,     0,  1337,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,  1337,     0,  1339,  1338,
       0,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,  1345,     0,     0,  1339,     0,
       0,     0,     0,     0,     0,  1342,     0,  1868,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,     0,     0,
       0,  1343,  1869,  1341,     0,  1332,  1354,  1333,  1345,  1337,
       0,     0,  1338,     0,     0,  1342,  1334,  1335,  1336,     0,
    1874,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
    1345,  1343,     0,     0,     0,  1875,     0,     0,     0,  1354,
       0,  1339,  1876,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1344,     0,     0,     0,  1877,  1340,  1337,
       0,  1354,  1338,  1332,     0,  1333,  1341,     0,     0,     0,
       0,     0,     0,     0,  1334,  1335,  1336,     0,  1342,     0,
       0,     0,     0,  1344,     0,     0,  1332,     0,  1333,     0,
       0,  1339,     0,     0,  1343,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,     0,  1332,
       0,  1333,     0,     0,     0,     0,     0,     0,  1342,     0,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1332,
       0,  1333,  1345,  1337,     0,     0,  1338,     0,     0,     0,
    1334,  1335,  1336,     0,  1878,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,  1344,     0,     0,  1879,
       0,     0,  1345,  1354,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,  1882,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1340,  1353,     0,     0,     0,     0,     0,  1883,
    1341,     0,  1332,  1354,  1333,     0,  1337,     0,     0,  1338,
       0,     0,  1342,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,  1345,     0,     0,  1339,     0,
       0,     0,     0,     0,     0,     0,     0,  1890,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,     0,     0,
       0,     0,  1891,  1341,  1337,     0,  1354,  1338,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
    1344,     0,     0,     0,     0,  1345,     0,  1337,     0,     0,
    1338,  1343,     0,     0,     0,     0,  1339,  1939,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1940,  1340,     0,     0,  1354,     0,     0,  1339,
    1337,  1341,     0,  1338,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,  1344,  1341,     0,     0,     0,  1332,  1343,
    1333,     0,  1339,     0,     0,     0,  1342,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,  1340,
    1337,     0,  1343,  1338,  1332,     0,  1333,  1341,     0,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,  1342,
       0,     0,     0,     0,     0,     0,  1332,     0,  1333,  1345,
       0,  1344,  1339,     0,     0,  1343,     0,  1334,  1335,  1336,
       0,  1944,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1340,
    1353,     0,     0,     0,  1344,     0,  1945,  1341,     0,  1332,
    1354,  1333,     0,  1337,     0,     0,  1338,     0,     0,  1342,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,  1344,     0,     0,
       0,     0,  1345,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,  1947,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1340,  1353,     0,     0,     0,     0,     0,  1948,
    1341,     0,  1332,  1354,  1333,     0,     0,     0,     0,     0,
       0,     0,  1342,  1334,  1335,  1336,     0,  1344,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1962,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1345,     0,     0,     0,  1963,     0,     0,
       0,  1354,     0,     0,     0,  1358,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
    1344,     0,     0,     0,  1354,     0,  1345,     0,     0,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,  1364,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,     0,     0,     0,  1337,     0,  1354,  1338,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1345,  1337,  1340,     0,
    1338,     0,     0,     0,     0,     0,  1341,  1339,  1368,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1342,     0,
       0,     0,     0,     0,  1340,     0,  1332,  1354,  1333,  1339,
    1337,     0,  1341,  1338,  1343,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,  1342,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,  1332,     0,  1333,  1345,
    1343,     0,  1339,     0,     0,     0,  1342,  1334,  1335,  1336,
       0,  1370,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1340,
    1353,     0,  1343,     0,     0,     0,  1344,  1341,     0,  1332,
    1354,  1333,     0,  1337,     0,     0,  1338,     0,     0,  1342,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1344,     0,     0,  1343,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,  1339,     0,  1334,  1335,  1336,
       0,     0,     0,     0,  1344,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,  1344,     0,     0,
       0,     0,  1332,     0,  1333,     0,     0,     0,  1343,     0,
       0,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1389,     0,  1332,
       0,  1333,     0,     0,     0,  1345,     0,     0,     0,     0,
    1334,  1335,  1336,     0,     0,     0,     0,  1378,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
    1344,  1345,     0,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,  1380,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1345,     0,     0,     0,  1337,     0,     0,
    1338,     0,  1354,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,  1354,  1333,  1345,  1337,     0,  1339,
    1338,     0,     0,     0,  1334,  1335,  1336,     0,  1391,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,  1354,     0,  1339,
    1337,     0,     0,  1338,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,  1343,     0,  1341,     0,     0,  1337,     0,  1345,
    1338,     0,  1339,     0,     0,     0,  1342,     0,     0,     0,
       0,  1393,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1340,
    1353,     0,  1343,     0,     0,     0,     0,  1341,     0,  1339,
    1354,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,  1344,     0,  1340,     0,     0,     0,
       0,     0,     0,  1337,  1341,  1343,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,  1344,     0,  1332,     0,  1333,     0,
    1337,     0,  1343,  1338,     0,  1339,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,  1332,     0,  1333,     0,  1344,     0,     0,
    1341,     0,  1339,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,  1344,     0,     0,  1341,  1343,     0,
       0,     0,     0,  1332,     0,  1333,     0,     0,     0,  1342,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,  1345,  1337,  1343,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,  1395,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,  1332,     0,  1333,
    1344,     0,     0,  1345,  1354,     0,  1339,     0,  1334,  1335,
    1336,     0,     0,     0,     0,  1399,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,  1340,  1353,     0,     0,  1412,     0,     0,
       0,  1341,     0,     0,  1354,     0,  1345,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,  1401,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,  1343,
    1332,     0,  1333,  1345,     0,     0,     0,  1354,     0,     0,
       0,  1334,  1335,  1336,     0,  1405,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1354,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,  1344,     0,     0,     0,     0,     0,  1337,     0,  1345,
    1338,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1409,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,  1337,     0,  1345,  1338,     0,  1339,
    1354,     0,     0,     0,     0,     0,     0,     0,  1413,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,     0,
       0,     0,     0,     0,  1341,     0,  1339,  1354,     0,     0,
       0,     0,     0,     0,  1337,     0,  1342,  1338,     0,     0,
       0,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,  1341,  1343,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,  1342,     0,     0,  1339,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,  1337,  1343,
    1345,  1338,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,  1341,  1415,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1342,  1344,  1332,     0,  1333,     0,     0,
    1339,  1354,     0,     0,     0,     0,  1334,  1335,  1336,  1343,
       0,     0,     0,     0,     0,     0,     0,  1340,     0,     0,
       0,  1428,     0,     0,     0,  1341,     0,     0,     0,     0,
       0,  1337,     0,     0,  1338,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,  1332,     0,  1333,     0,
       0,     0,     0,  1343,     0,     0,     0,  1334,  1335,  1336,
       0,  1344,     0,  1339,     0,     0,  1337,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1339,     0,
    1342,     0,     0,     0,     0,  1344,     0,     0,     0,     0,
       0,     0,     0,  1345,     0,  1340,  1343,     0,     0,     0,
       0,     0,     0,  1341,     0,  1421,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1342,     0,     0,     0,     0,
    1345,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,  1343,  1413,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,     0,     0,     0,     0,     0,  1344,     0,
       0,  1354,     0,     0,  1332,     0,  1333,     0,  1337,     0,
    1345,  1338,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,  1484,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1344,  1332,     0,  1333,     0,     0,     0,
    1339,  1354,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,  1345,     0,  1337,  1340,     0,  1338,
       0,     0,     0,     0,     0,  1341,  1413,  1346,  1347,  1348,
    1570,  1350,  1351,  1352,     0,  1353,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,  1354,     0,     0,  1339,     0,
       0,     0,     0,  1343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,     0,  1337,     0,     0,
    1338,     0,     0,  1341,     0,     0,     0,  1345,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1339,
       0,  1343,     0,     0,  1571,  1344,     0,     0,  1354,     0,
       0,     0,  1345,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,  1342,     0,  1332,  1655,
    1333,     0,     0,  1354,     0,     0,     0,     0,     0,  1334,
    1335,  1336,  1343,  1344,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,     0,     0,     0,     0,     0,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1332,     0,  1333,  1345,  1337,     0,  1339,  1338,     0,
       0,     0,  1334,  1335,  1336,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,  1340,  1353,     0,     0,     0,     0,
       0,  1656,  1341,     0,  1332,  1354,  1333,  1339,     0,     0,
       0,     0,     0,     0,  1342,  1334,  1335,  1336,     0,     0,
       0,     0,  1345,     0,  1340,     0,     0,     0,     0,     0,
    1343,     0,  1341,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1342,     0,     0,     0,     0,  1657,
       0,     0,  1332,  1354,  1333,     0,     0,     0,     0,     0,
    1343,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
    1658,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1337,     0,     0,  1338,  1332,     0,  1333,     0,     0,
       0,  1339,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,  1340,  1333,
       0,     0,     0,  1339,     0,     0,  1341,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,  1345,  1337,     0,  1343,  1338,     0,     0,     0,     0,
    1342,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,  1343,     0,  1661,     0,
       0,  1345,  1354,     0,  1339,  1337,     0,     0,  1338,     0,
       0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,  1340,  1353,     0,     0,     0,  1344,     0,  1662,  1341,
       0,  1332,  1354,  1333,     0,     0,     0,  1339,     0,     0,
       0,  1342,  1334,  1335,  1336,     0,     0,     0,  1344,     0,
       0,     0,     0,  1337,  1340,     0,  1338,  1343,     0,     0,
       0,     0,  1341,     0,     0,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,  1342,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,  1339,     0,     0,     0,     0,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,  1344,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,     0,
       0,     0,  1344,     0,     0,  1345,  1337,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,  1337,     0,
       0,  1338,  1663,     0,     0,     0,  1354,     0,  1339,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
    1344,     0,     0,     0,  1664,  1340,     0,  1332,  1354,  1333,
    1339,     0,     0,  1341,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,  1342,     0,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,  1332,  1345,  1333,
       0,  1343,     0,     0,     0,     0,     0,  1342,  1334,  1335,
    1336,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,  1343,     0,  1667,     0,     0,     0,  1354,
       0,  1345,  1337,     0,     0,  1338,     0,     0,     0,     0,
       0,     0,     0,  1668,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1344,     0,     0,     0,     0,     0,     0,
       0,     0,  1354,     0,  1339,     0,     0,  1337,     0,     0,
    1338,     0,     0,     0,     0,  1344,     0,     0,     0,  1345,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,  1669,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1339,
    1353,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,     0,     0,  1340,  1343,  1332,     0,
    1333,     0,     0,     0,  1341,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,     0,     0,     0,     0,
       0,     0,  1343,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1344,
       0,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1345,     0,     0,     0,  1337,  1680,
       0,  1338,     0,  1354,  1344,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1681,     0,     0,     0,  1354,     0,     0,  1337,     0,
    1339,  1338,  1332,     0,  1333,     0,     0,     0,     0,     0,
       0,     0,     0,  1334,  1335,  1336,     0,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,     0,     0,
    1339,     0,  1332,     0,  1333,     0,     0,  1342,     0,     0,
       0,     0,     0,  1334,  1335,  1336,     0,  1340,     0,     0,
       0,     0,     0,  1343,     0,  1341,     0,     0,  1345,     0,
       0,     0,     0,     0,     0,     0,     0,  1342,     0,     0,
       0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,  1343,     0,  1682,     0,     0,     0,  1354,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,  1337,
    1683,     0,  1338,     0,  1354,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,     0,     0,     0,     0,
       0,     0,     0,  1337,     0,  1332,  1338,  1333,     0,     0,
       0,  1339,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,     0,  1339,  1341,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,     0,
    1341,     0,     0,     0,  1343,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1345,     0,     0,     0,  1343,     0,
       0,     0,     0,  1337,     0,     0,  1338,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1684,     0,     0,  1345,  1354,  1344,     0,     0,     0,
       0,     0,     0,  1337,     0,  1339,  1338,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
    1344,  1685,  1340,     0,     0,  1354,     0,     0,     0,     0,
    1341,     0,  1332,     0,  1333,  1339,     0,     0,     0,     0,
       0,     0,  1342,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,  1340,     0,  1332,     0,  1333,     0,  1343,     0,
    1341,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,     0,     0,     0,     0,     0,  1343,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1344,     0,     0,     0,     0,  1345,  1337,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,  1345,
    1344,     0,  1686,     0,     0,     0,  1354,     0,  1339,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,  1340,  1687,     0,     0,     0,
    1354,     0,     0,  1341,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,  1343,     0,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  1333,     0,     0,     0,  1345,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,  1344,     0,     0,  1688,     0,     0,  1345,
    1354,     0,     0,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,  1337,  1689,     0,  1338,     0,
    1354,     0,     0,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1337,  1340,     0,  1338,     0,     0,  1339,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  1340,     0,     0,     0,     0,  1332,
       0,  1333,  1341,  1339,     0,     0,     0,     0,  1343,     0,
    1334,  1335,  1336,     0,  1342,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
    1343,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,  1690,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,  1343,     0,     0,     0,
    1344,     0,     0,  1354,     0,     0,  1337,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,     0,     0,  1337,     0,
       0,  1338,  1332,     0,  1333,     0,     0,     0,  1339,     0,
       0,     0,     0,  1334,  1335,  1336,     0,     0,  1344,     0,
       0,     0,     0,     0,  1337,  1340,  1332,  1338,  1333,     0,
    1339,     0,     0,  1341,     0,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,  1342,     0,  1340,     0,     0,
       0,     0,  1332,     0,  1333,  1341,  1339,     0,     0,     0,
       0,  1343,     0,  1334,  1335,  1336,     0,  1342,     0,     0,
       0,     0,     0,  1340,  1332,     0,  1333,     0,     0,     0,
       0,  1341,     0,  1343,     0,  1334,  1335,  1336,     0,  1345,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,  1691,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1343,
    1353,  1345,     0,  1344,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,  1344,     0,  1345,  1695,     0,
    1337,     0,  1354,  1338,     0,     0,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,  1344,     0,     0,  1696,     0,     0,  1332,  1354,  1333,
       0,     0,  1339,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,     0,     0,     0,
       0,     0,  1345,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,  1697,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1345,     0,     0,  1337,     0,     0,
    1338,     0,     0,  1354,     0,  1339,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,  1344,     0,     0,
    1345,  1699,  1340,  1337,     0,  1354,  1338,     0,     0,  1339,
    1341,     0,  1703,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1342,     0,     0,  1337,  1340,     0,  1338,     0,
       0,  1354,     0,     0,  1341,  1339,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,  1340,  1332,     0,  1333,     0,  1339,     0,     0,
    1341,     0,  1343,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1342,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,  1343,     0,
    1344,     0,     0,     0,  1342,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,     0,  1334,  1335,  1336,
    1343,     0,     0,     0,  1344,     0,  1345,     0,  1337,     0,
       0,  1338,     0,     0,     0,     0,     0,     0,  1704,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
    1344,     0,     0,     0,  1332,     0,  1333,  1354,     0,     0,
    1339,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,  1344,     0,     0,     0,  1332,  1340,  1333,     0,
       0,     0,     0,     0,     0,  1341,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,  1343,     0,     0,     0,     0,     0,  1345,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,  1345,     0,     0,  1705,     0,     0,     0,
    1354,     0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1344,     0,     0,     0,  1345,
    1706,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1345,     0,     0,  1337,     0,  1707,  1338,     0,     0,
    1354,     0,     0,  1708,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,  1354,     0,     0,     0,  1339,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
    1338,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,  1339,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
       0,     0,     0,     0,  1345,  1337,  1340,     0,  1338,     0,
       0,     0,     0,     0,  1341,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,  1342,  1337,     0,     0,
    1338,  1709,     0,     0,     0,  1354,     0,  1339,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,  1340,     0,     0,     0,     0,  1339,
       0,  1337,  1341,     0,  1338,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,  1332,
    1343,  1333,     0,  1339,  1344,     0,  1342,     0,     0,     0,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
    1340,  1332,  1343,  1333,     0,     0,     0,     0,  1341,     0,
       0,     0,  1334,  1335,  1336,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,  1337,     0,
    1345,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,     0,     0,     0,     0,  1712,  1344,     0,
    1339,  1354,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1345,     0,     0,     0,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,  1332,  1342,  1333,     0,
    1713,     0,     0,     0,  1354,     0,     0,  1334,  1335,  1336,
       0,     0,     0,  1343,     0,     0,     0,     0,  1332,     0,
    1333,  1345,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1345,     0,     0,     0,     0,  1714,     0,
       0,     0,  1354,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1344,     0,     0,     0,     0,
    1715,     0,     0,     0,  1354,     0,     0,  1345,     0,     0,
    1337,     0,     0,  1338,     0,     0,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,  1337,     0,  1716,  1338,     0,  1332,  1354,  1333,
       0,     0,  1339,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,  1339,     0,     0,  1341,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,     0,  1332,     0,  1333,  1343,     0,     0,     0,     0,
       0,  1342,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,  1345,     0,     0,  1343,     0,     0,
       0,     0,     0,     0,     0,     0,  1717,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1354,     0,  1344,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
    1338,     0,     0,     0,     0,     0,     0,     0,     0,  1344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,     0,  1339,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,  1340,  1333,     0,     0,
       0,  1339,     0,     0,  1341,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,  1332,  1342,  1333,
       0,     0,     0,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,  1343,     0,  1345,     0,  1337,     0,
       0,  1338,     0,     0,     0,     0,     0,     0,  1718,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,     0,
       0,     0,     0,     0,  1344,     0,     0,  1354,     0,     0,
    1339,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,     0,  1719,  1344,  1340,     0,  1354,
       0,     0,     0,  1337,     0,  1341,  1338,     0,  1332,     0,
    1333,     0,     0,     0,     0,     0,     0,  1342,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,  1343,     0,  1339,     0,     0,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,  1332,     0,  1333,     0,     0,     0,     0,
    1341,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,     0,     0,  1343,     0,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1345,  1337,     0,     0,  1338,
    1720,     0,     0,     0,  1354,     0,     0,  1722,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
    1344,     0,     0,     0,     0,     0,  1354,     0,  1339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1337,     0,
       0,  1338,     0,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,     0,
    1339,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,     0,     0,  1345,     0,     0,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,  1342,     0,     0,
       0,  1723,     0,     0,     0,  1354,     0,     0,     0,  1337,
       0,     0,  1338,  1343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1344,     0,     0,     0,     0,     0,  1345,
       0,  1337,     0,     0,  1338,     0,     0,     0,     0,     0,
       0,  1339,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,  1337,     0,  1726,  1338,  1340,     0,
    1354,     0,     0,  1339,     0,  1344,  1341,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
    1340,     0,     0,     0,     0,     0,  1339,     0,  1341,     0,
       0,     0,     0,     0,  1343,     0,     0,     0,     0,     0,
    1342,     0,  1332,  1340,  1333,     0,     0,     0,     0,     0,
       0,  1341,     0,  1334,  1335,  1336,  1343,     0,     0,     0,
       0,     0,     0,  1342,  1332,     0,  1333,     0,     0,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,  1343,
       0,     0,  1345,     0,     0,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,  1344,  1727,
       0,     0,     0,  1354,     0,     0,  1337,     0,     0,  1338,
       0,     0,     0,     0,  1345,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,  1339,     0,
       0,  1728,     0,     0,     0,  1354,     0,     0,     0,     0,
       0,     0,     0,     0,  1332,  1340,  1333,     0,     0,     0,
       0,     0,     0,  1341,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,  1342,  1332,     0,  1333,     0,
       0,     0,     0,     0,     0,     0,     0,  1334,  1335,  1336,
       0,  1343,     0,     0,     0,  1345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,     0,     0,
       0,     0,  1729,     0,     0,     0,  1354,     0,     0,  1730,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
    1345,     0,     0,  1344,     0,     0,     0,     0,  1354,     0,
       0,     0,  1731,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1337,     0,  1332,  1338,  1333,     0,     0,
       0,  1354,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,  1339,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,  1343,     0,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
    1343,     0,     0,     0,  1733,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,  1354,     0,     0,     0,     0,     0,     0,
    1344,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
    1338,     0,  1332,     0,  1333,     0,     0,  1339,     0,     0,
       0,     0,  1344,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,  1340,  1332,     0,  1333,     0,  1339,
       0,     0,  1341,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,  1342,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,     0,
    1343,     0,     0,     0,     0,  1332,  1342,  1333,     0,     0,
       0,     0,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,  1343,     0,     0,     0,  1337,     0,  1332,  1338,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,  1345,
       0,     0,  1344,     0,     0,     0,     0,     0,  1339,     0,
       0,  1734,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1345,     0,     0,  1344,  1340,     0,     0,     0,     0,
    1354,     0,     0,  1341,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,  1342,     0,     0,  1739,     0,
       0,     0,  1354,     0,  1332,     0,  1333,     0,     0,     0,
       0,  1343,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1344,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1345,     0,     0,  1337,     0,  1740,  1338,
       0,     0,  1354,     0,     0,  1339,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
    1741,     0,  1340,     0,  1354,     0,     0,     0,  1339,     0,
    1341,     0,     0,     0,     0,     0,  1337,     0,     0,  1338,
       0,     0,  1342,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,  1343,  1337,
       0,     0,  1338,     0,  1332,  1342,  1333,     0,  1339,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,  1343,  1345,     0,     0,  1340,     0,     0,     0,     0,
       0,  1339,     0,  1341,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,  1342,     0,     0,  1340,  1742,
    1344,     0,     0,  1354,     0,     0,  1341,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,     0,     0,  1344,     0,  1337,     0,  1332,  1338,  1333,
       0,     0,     0,     0,  1343,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  1333,     0,  1339,     0,     0,
       0,     0,     0,  1344,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,  1340,     0,     0,  1332,     0,  1333,
       0,     0,  1341,     0,     0,     0,  1344,     0,  1334,  1335,
    1336,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,  1332,     0,  1333,     0,     0,     0,     0,     0,     0,
    1343,     0,  1334,  1335,  1336,     0,     0,     0,     0,  1345,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1345,     0,     0,     0,  1743,     0,     0,     0,
    1354,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1344,  1353,     0,     0,     0,     0,     0,  1746,
       0,     0,     0,  1354,     0,     0,     0,     0,     0,     0,
       0,     0,  1345,     0,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,  1345,     0,     0,     0,  1749,
       0,     0,     0,  1354,     0,     0,     0,  1339,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1750,     0,  1340,     0,  1354,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,     0,     0,  1337,     0,
       0,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,     0,  1337,     0,     0,  1338,     0,     0,
    1339,     0,     0,  1751,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,  1340,  1337,     0,
       0,  1338,  1354,     0,     0,  1341,  1339,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,     0,  1342,     0,     0,
       0,     0,  1337,  1340,  1332,  1338,  1333,     0,     0,     0,
    1339,  1341,     0,  1343,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,  1340,     0,     0,
       0,     0,     0,     0,  1339,  1341,     0,     0,     0,  1343,
       0,     0,     0,     0,     0,     0,     0,  1342,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,     0,  1332,  1343,  1333,  1344,     0,     0,     0,     0,
       0,  1342,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1343,  1332,     0,
    1333,  1344,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
    1332,  1345,  1333,     0,     0,  1344,     0,     0,     0,     0,
       0,  1334,  1335,  1336,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1332,     0,  1333,     0,     0,  1752,  1344,
       0,     0,  1354,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,     0,  1345,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
    1345,  1753,     0,     0,     0,  1354,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,     0,  1345,  1337,     0,  1754,  1338,     0,
       0,  1354,     0,     0,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,  1345,     0,
       0,  1755,     0,     0,     0,  1354,     0,  1339,     0,     0,
       0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
       0,     0,     0,     0,  1340,  1756,     0,     0,     0,  1354,
       0,     0,  1341,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1337,
    1343,     0,  1338,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1337,  1340,     0,  1338,     0,     0,     0,     0,     0,
    1341,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  1337,     0,     0,  1338,  1340,     0,
       0,     0,  1344,  1339,     0,     0,  1341,     0,  1343,     0,
       0,     0,     0,     0,     0,     0,  1337,     0,  1342,  1338,
    1340,     0,     0,     0,     0,     0,  1339,     0,  1341,     0,
       0,     0,     0,     0,  1343,     0,     0,     0,  1337,     0,
    1342,  1338,  1332,  1340,  1333,     0,     0,     0,  1339,     0,
       0,  1341,     0,  1334,  1335,  1336,  1343,     0,     0,     0,
    1344,     0,     0,  1342,  1332,  1340,  1333,     0,     0,     0,
    1339,     0,     0,  1341,     0,  1334,  1335,  1336,     0,  1343,
       0,     0,     0,     0,     0,  1342,  1344,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,  1332,     0,
    1333,  1343,     0,     0,     0,     0,     0,  1342,  1344,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,  1343,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1332,     0,  1333,     0,     0,  1757,     0,
       0,     0,  1354,  1344,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,  1344,  1334,  1335,  1336,  1345,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,  1345,  1758,     0,     0,     0,
    1354,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,     0,     0,
       0,     0,  1759,     0,     0,     0,  1354,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
    1345,     0,     0,     0,  1760,     0,     0,     0,  1354,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1345,  1337,     0,     0,  1338,  1761,     0,     0,
       0,  1354,     0,     0,  1762,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1345,  1337,     0,     0,  1338,     0,
       0,     0,     0,  1354,     0,  1339,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1765,  1340,     0,     0,  1354,     0,  1339,     0,  1337,
    1341,     0,  1338,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,  1343,     0,
       0,  1339,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1337,     0,     0,  1338,  1340,     0,
    1343,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,  1337,     0,  1342,  1338,
       0,     0,     0,  1334,  1335,  1336,  1339,     0,     0,     0,
    1344,     0,     0,     0,  1343,     0,     0,     0,     0,     0,
       0,     0,  1332,  1340,  1333,     0,     0,     0,  1339,     0,
       0,  1341,  1344,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,  1332,     0,  1333,  1343,
       0,     0,     0,     0,     0,  1342,  1344,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,     0,
    1333,  1343,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1332,     0,  1333,     0,     0,     0,     0,     0,     0,
       0,  1344,  1334,  1335,  1336,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  1333,     0,     0,     0,  1345,
       0,     0,     0,  1344,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1345,     0,     0,     0,     0,  1766,     0,     0,     0,
    1354,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,     0,  1767,     0,
       0,     0,  1354,     0,     0,  1345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1768,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,  1337,     0,     0,  1338,     0,     0,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1345,  1337,     0,  1339,  1338,  1769,     0,     0,
       0,  1354,     0,     0,  1770,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1340,  1353,     0,     0,     0,     0,     0,     0,
    1341,     0,     0,  1354,     0,  1339,     0,  1337,     0,     0,
    1338,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,  1343,  1337,
    1341,     0,  1338,     0,     0,     0,     0,     0,     0,  1339,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1337,     0,     0,  1338,  1340,     0,  1343,     0,
       0,  1339,     0,     0,  1341,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1337,     0,  1342,  1338,  1340,     0,
    1344,     0,     0,     0,  1339,     0,  1341,     0,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,     0,  1342,     0,
    1332,  1340,  1333,     0,     0,     0,  1339,     0,     0,  1341,
    1344,  1334,  1335,  1336,  1343,     0,     0,     0,     0,     0,
       0,  1342,  1332,  1340,  1333,     0,     0,     0,     0,     0,
       0,  1341,     0,  1334,  1335,  1336,     0,  1343,     0,     0,
       0,     0,     0,  1342,  1344,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,     0,  1334,  1335,  1336,  1343,
       0,     0,     0,     0,     0,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1332,     0,  1333,     0,     0,     0,  1344,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,  1345,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1332,     0,  1333,     0,     0,  1771,     0,     0,  1345,
    1354,     0,  1334,  1335,  1336,     0,     0,     0,     0,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,     0,     0,     0,  1772,     0,     0,     0,
    1354,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,  1345,     0,     0,     0,     0,
    1773,     0,     0,     0,  1354,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,  1345,     0,
       0,     0,  1774,     0,     0,     0,  1354,     0,     0,     0,
       0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
    1345,  1337,     0,     0,  1338,  1775,     0,     0,     0,  1354,
       0,     0,  1787,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1337,     0,     0,  1338,     0,     0,     0,
       0,  1354,     0,  1339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1337,     0,     0,  1338,
    1340,     0,     0,     0,     0,  1339,     0,     0,  1341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,  1340,     0,     0,     0,     0,     0,  1339,     0,
    1341,     0,     0,     0,  1337,     0,  1343,  1338,     0,     0,
       0,     0,  1342,     0,     0,  1340,     0,     0,     0,     0,
    1332,     0,  1333,  1341,     0,     0,     0,     0,  1343,     0,
       0,  1334,  1335,  1336,     0,  1342,  1339,     0,     0,     0,
       0,     0,  1337,     0,     0,  1338,     0,     0,     0,     0,
       0,  1343,     0,  1340,     0,  1332,     0,  1333,  1344,     0,
       0,  1341,     0,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,  1342,  1339,     0,     0,     0,     0,     0,
    1344,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
       0,  1340,     0,  1332,     0,  1333,     0,     0,     0,  1341,
       0,     0,     0,  1344,  1334,  1335,  1336,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,     0,     0,     0,     0,  1343,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,  1332,     0,  1333,     0,     0,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1345,     0,  1344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1789,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,
       0,     0,     0,     0,     0,     0,  1794,     0,  1354,     0,
       0,  1792,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,  1793,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,     0,
       0,  1337,     0,  1354,  1338,     0,     0,     0,     0,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1339,     0,     0,  1337,     0,     0,  1338,
       0,  1354,     0,     0,     0,     0,     0,     0,  1345,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
    1797,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1339,  1353,
    1342,     0,     0,     0,  1337,     0,     0,  1338,     0,  1354,
       0,     0,     0,     0,     0,  1340,  1343,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,  1337,     0,
       0,  1338,     0,     0,     0,  1342,  1339,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1343,     0,  1340,     0,  1337,     0,     0,  1338,     0,
    1339,  1341,     0,     0,     0,     0,     0,     0,  1344,     0,
       0,     0,     0,  1342,     0,     0,     0,  1340,     0,     0,
       0,     0,  1332,     0,  1333,  1341,     0,  1339,     0,  1343,
       0,     0,     0,  1334,  1335,  1336,     0,  1342,     0,     0,
       0,     0,     0,  1344,  1340,  1332,     0,  1333,     0,     0,
       0,     0,  1341,  1343,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,     0,     0,     0,     0,
    1343,  1344,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,     0,     0,  1344,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,     0,     0,     0,     0,  1345,  1334,  1335,
    1336,     0,  1344,     0,     0,     0,     0,     0,     0,  1798,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1354,     0,
       0,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1799,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1332,     0,  1333,     0,     0,     0,
       0,     0,     0,  1354,     0,  1334,  1335,  1336,     0,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1800,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,     0,  1345,     0,     0,     0,     0,     0,
       0,  1354,     0,     0,     0,     0,  1802,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1345,     0,  1337,     0,  1354,  1338,     0,     0,     0,
       0,     0,     0,  1413,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,  1337,     0,     0,  1338,
       0,     0,  1354,     0,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,  1337,     0,     0,  1338,     0,  1339,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,  1340,  1337,     0,     0,  1338,
       0,     0,     0,  1341,     0,  1339,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,  1337,     0,
       0,  1338,  1340,  1332,     0,  1333,     0,     0,  1339,     0,
    1341,  1343,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1342,     0,     0,  1340,     0,     0,     0,     0,
    1339,     0,     0,  1341,     0,     0,     0,     0,  1343,     0,
    1344,     0,     0,     0,     0,  1342,     0,  1340,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,     0,     0,
       0,  1343,     0,  1344,     0,  1337,     0,  1342,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1332,     0,  1333,  1343,     0,     0,     0,     0,     0,     0,
    1344,  1334,  1335,  1336,     0,     0,     0,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1344,  1340,  1332,     0,  1333,     0,     0,
       0,     0,  1341,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,  1342,  1344,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,     0,
    1343,     0,     0,     0,     0,     0,  1334,  1335,  1336,  1345,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1803,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,  1806,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1344,  1353,     0,     0,     0,     0,     0,  1345,
       0,     0,     0,  1354,     0,     0,     0,     0,     0,     0,
       0,  1819,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1345,     0,  1337,     0,     0,  1338,     0,     0,
    1354,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1345,  1855,     0,     0,     0,     0,
       0,     0,     0,  1354,     0,     0,  1339,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1857,     0,  1340,     0,  1354,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,  1337,     0,     0,  1338,     0,     0,     0,     0,  1343,
       0,  1345,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1339,     0,     0,  1337,     0,  1860,  1338,
       0,     0,  1354,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,  1344,  1332,     0,  1333,     0,  1337,     0,  1339,  1338,
    1342,     0,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,  1343,     0,     0,     0,
       0,     0,     0,  1341,     0,  1332,     0,  1333,  1339,     0,
       0,     0,     0,     0,     0,  1342,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,  1340,     0,  1332,     0,  1333,
       0,  1343,     0,  1341,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,  1342,     0,     0,  1344,     0,
       0,     0,     0,  1332,     0,  1333,     0,     0,     0,     0,
       0,  1343,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,  1344,     0,     0,  1334,  1335,  1336,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1344,  1332,     0,  1333,  1867,     0,     0,
       0,  1354,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,  1345,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,  1870,     0,     0,     0,  1354,     0,
       0,     0,  1345,  1337,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,  1871,
       0,     0,  1345,  1354,     0,  1339,  1337,     0,     0,  1338,
       0,     0,     0,     0,  1873,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1340,  1353,     0,     0,     0,     0,  1337,     0,
    1341,  1338,     0,  1354,     0,     0,     0,     0,  1339,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1337,  1340,     0,  1338,  1343,     0,
    1339,     0,     0,  1341,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,  1337,  1340,     0,  1338,
       0,     0,     0,     0,     0,  1341,  1339,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,  1342,     0,     0,
       0,     0,     0,  1340,     0,     0,     0,     0,  1339,     0,
    1344,  1341,     0,  1343,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,  1342,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,     0,  1343,
       0,     0,     0,  1344,  1332,  1342,  1333,  1339,  1337,     0,
       0,  1338,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,  1343,     0,     0,  1340,  1344,  1332,     0,  1333,     0,
       0,     0,  1341,     0,     0,     0,     0,  1334,  1335,  1336,
    1339,     0,     0,     0,  1342,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,     0,     0,  1340,     0,  1332,
    1343,  1333,     0,     0,     0,  1341,     0,     0,     0,     0,
    1334,  1335,  1336,  1344,     0,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,  1332,     0,  1333,     0,  1345,
       0,     0,     0,  1343,     0,     0,  1334,  1335,  1336,     0,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,  1344,     0,     0,  1332,  1880,  1333,     0,     0,
    1354,     0,  1345,     0,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,  1881,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1345,  1344,     0,     0,     0,     0,
       0,     0,     0,  1354,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
    1345,  1884,     0,     0,     0,  1354,     0,     0,     0,     0,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1345,     0,     0,     0,     0,  1885,     0,     0,
       0,  1354,     0,     0,  1886,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1354,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,     0,     0,  1337,     0,     0,  1338,     0,
       0,     0,     0,  1887,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,  1337,     0,     0,
    1338,     0,  1354,     0,  1345,     0,     0,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,  1888,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,  1340,  1353,     0,     0,     0,  1339,
    1337,     0,  1341,  1338,     0,  1354,     0,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,  1337,     0,     0,  1338,
    1343,     0,  1339,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,  1343,     0,     0,     0,  1337,  1341,  1339,  1338,
    1332,     0,  1333,     0,     0,     0,     0,     0,     0,  1342,
       0,  1334,  1335,  1336,     0,  1340,     0,     0,     0,     0,
       0,     0,  1344,  1341,     0,  1343,     0,  1332,  1339,  1333,
       0,     0,     0,     0,     0,  1342,     0,     0,  1334,  1335,
    1336,     0,     0,     0,  1344,  1340,     0,     0,     0,     0,
    1332,  1343,  1333,  1341,     0,     0,     0,     0,     0,     0,
       0,  1334,  1335,  1336,     0,  1342,     0,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,     0,  1344,     0,     0,
       0,  1343,     0,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,     0,     0,  1332,     0,  1333,     0,     0,     0,
       0,     0,     0,  1344,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,     0,  1333,
       0,     0,     0,     0,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,  1344,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,  1345,     0,     0,     0,     0,  1889,     0,
       0,     0,  1354,     0,     0,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
    1892,     0,     0,  1332,  1354,  1333,  1345,     0,     0,     0,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,  1345,  1893,     0,     0,     0,  1354,     0,     0,
       0,  1337,     0,     0,  1338,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,  1894,
       0,     0,  1345,  1354,     0,     0,     0,     0,  1337,     0,
       0,  1338,     0,  1339,  1895,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,     0,     0,     0,
    1340,  1337,     0,  1354,  1338,     0,     0,     0,  1341,     0,
    1339,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,  1337,     0,     0,  1338,  1340,     0,     0,
       0,     0,     0,  1339,     0,  1341,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,  1337,     0,  1342,  1338,     0,
    1340,     0,     0,     0,     0,  1339,     0,     0,  1341,     0,
       0,     0,     0,  1343,     0,     0,     0,     0,  1337,     0,
    1342,  1338,  1340,     0,     0,     0,     0,  1339,     0,     0,
    1341,     0,     0,     0,     0,     0,  1343,     0,  1344,     0,
       0,     0,  1342,     0,  1340,     0,     0,     0,     0,     0,
    1339,     0,  1341,     0,     0,     0,     0,     0,  1343,     0,
       0,     0,     0,     0,  1342,  1344,     0,  1340,     0,     0,
       0,     0,  1332,     0,  1333,  1341,     0,     0,     0,     0,
    1343,     0,     0,  1334,  1335,  1336,     0,  1342,  1344,     0,
       0,     0,     0,     0,  1337,     0,  1332,  1338,  1333,     0,
       0,     0,     0,  1343,     0,     0,     0,  1334,  1335,  1336,
    1344,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1332,     0,  1333,     0,  1339,     0,     0,     0,
       0,     0,  1344,  1334,  1335,  1336,     0,     0,     0,     0,
       0,     0,  1899,  1340,     0,     0,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,  1344,     0,  1345,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,  1897,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1343,
    1332,     0,  1333,     0,  1345,     0,     0,     0,  1354,     0,
       0,  1334,  1335,  1336,     0,     0,  1898,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,  1345,     0,     0,
       0,     0,     0,     0,     0,  1354,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,
       0,  1344,     0,     0,     0,     0,     0,     0,  1354,     0,
       0,  1901,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1345,     0,     0,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,  1902,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,  1345,     0,     0,     0,     0,     0,
       0,     0,  1354,     0,     0,     0,  1903,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,     0,     0,  1337,     0,  1354,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
    1338,  1332,     0,  1333,     0,  1339,     0,     0,     0,     0,
       0,     0,  1334,  1335,  1336,     0,     0,     0,     0,     0,
    1345,     0,  1340,  1337,     0,     0,  1338,     0,     0,  1339,
    1341,     0,  1904,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1342,     0,     0,     0,  1340,     0,     0,     0,
       0,  1354,     0,     0,  1341,  1339,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,  1332,     0,  1333,
    1341,  1337,  1343,     0,  1338,     0,     0,     0,  1334,  1335,
    1336,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1332,  1343,  1333,
    1344,     0,     0,  1339,     0,     0,     0,     0,  1334,  1335,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,  1344,     0,     0,     0,  1341,     0,
    1332,     0,  1333,     0,     0,     0,     0,     0,     0,     0,
    1342,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
    1344,     0,     0,  1332,     0,  1333,  1343,     0,     0,     0,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,     0,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,  1344,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1345,
       0,     0,  1337,     0,     0,  1338,     0,     0,     0,     0,
       0,  1905,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
    1354,     0,     0,     0,  1339,     0,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,  1906,     0,     0,  1345,
       0,  1340,     0,     0,  1354,     0,     0,     0,     0,  1341,
       0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,
    1353,  1342,     0,     0,     0,     0,  1932,     0,  1337,     0,
    1354,  1338,     0,     0,     0,     0,     0,  1343,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1345,  1337,     0,
    1339,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,
       0,     0,     0,     0,  1933,  1341,     0,     0,  1354,  1344,
    1339,  1337,     0,     0,  1338,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1340,     0,     0,
       0,     0,     0,  1343,  1337,  1341,     0,  1338,     0,     0,
       0,     0,     0,  1339,     0,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,  1343,     0,  1332,  1339,  1333,  1341,  1337,
       0,     0,  1338,     0,     0,     0,  1334,  1335,  1336,     0,
    1342,     0,     0,  1340,     0,  1344,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,  1332,  1343,  1333,     0,     0,
       0,  1339,     0,  1342,     0,     0,  1334,  1335,  1336,     0,
       0,     0,     0,     0,     0,  1344,     0,     0,  1340,  1343,
       0,     0,     0,     0,     0,     0,  1341,     0,  1345,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1344,  1353,
       0,  1332,     0,  1333,  1343,  1934,     0,     0,     0,  1354,
       0,     0,  1334,  1335,  1336,     0,     0,     0,     0,     0,
       0,  1344,     0,  1332,     0,  1333,     0,     0,     0,     0,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1332,     0,  1333,     0,
       0,     0,     0,     0,  1345,     0,  1344,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
       0,  1935,     0,     0,  1345,  1354,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1346,  1347,  1348,
    1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,
    1332,  1936,  1333,     0,     0,  1354,     0,  1345,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,  1937,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
    1345,     0,     0,     0,     0,     0,  1337,     0,  1354,  1338,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,     0,     0,     0,     0,  1938,     0,     0,
       0,  1354,     0,     0,     0,  1345,  1337,     0,  1339,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,  1340,  1353,     0,     0,     0,
       0,     0,  1941,  1341,     0,     0,  1354,     0,  1339,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,     0,     0,     0,     0,
       0,  1343,  1337,  1341,     0,  1338,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,  1337,     0,     0,  1338,     0,     0,
       0,  1343,     0,     0,  1339,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
    1338,  1340,     0,  1344,     0,     0,  1339,     0,     0,  1341,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,  1340,     0,     0,     0,     0,  1332,  1339,
    1333,  1341,     0,  1344,     0,     0,     0,  1343,     0,  1334,
    1335,  1336,     0,  1342,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,  1343,
       0,  1337,     0,  1332,  1338,  1333,  1342,     0,     0,     0,
       0,     0,     0,     0,  1334,  1335,  1336,     0,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,     0,     0,  1344,
    1332,     0,  1333,  1339,     0,     0,     0,     0,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,     0,
    1340,  1344,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,  1345,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,  1344,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,  1343,     0,     0,  1942,
       0,     0,  1345,  1354,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,  1332,     0,  1333,     0,     0,  1943,
       0,     0,     0,  1354,     0,  1334,  1335,  1336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1344,     0,
       0,     0,     0,     0,  1332,     0,  1333,     0,  1345,     0,
       0,     0,     0,     0,     0,  1334,  1335,  1336,     0,     0,
       0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,
    1345,     0,     0,     0,     0,  1946,     0,     0,     0,  1354,
       0,     0,     0,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,     0,  1345,     0,     0,     0,  1949,     0,  1337,
       0,  1354,  1338,     0,     0,  1950,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,  1339,     0,     0,  1337,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,  1345,     0,     0,
       0,  1337,     0,     0,  1338,     0,  1339,     0,  1342,  1951,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,  1340,  1343,     0,     0,     0,  1354,     0,
       0,  1341,     0,  1339,     0,  1332,     0,  1333,     0,     0,
       0,     0,     0,  1342,     0,     0,  1334,  1335,  1336,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,  1343,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,  1337,  1343,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,  1337,     0,  1339,  1338,  1332,
       0,  1333,     0,     0,     0,     0,     0,     0,     0,     0,
    1334,  1335,  1336,     0,  1340,     0,     0,     0,  1344,     0,
       0,     0,  1341,     0,     0,     0,  1332,  1339,  1333,     0,
       0,     0,     0,     0,  1342,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,  1340,     0,     0,     0,     0,     0,
    1343,     0,  1341,     0,     0,     0,     0,     0,     0,  1332,
       0,  1333,     0,     0,  1342,     0,     0,     0,     0,     0,
    1334,  1335,  1336,     0,     0,  1345,     0,     0,     0,     0,
    1343,     0,     0,     0,     0,     0,     0,  1952,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,  1344,     0,     0,     0,  1354,     0,     0,     0,
    1345,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1953,  1346,  1347,  1348,  1349,  1350,  1351,  1352,
       0,  1353,  1344,     0,     0,     0,     0,  1345,     0,     0,
       0,  1354,     0,     0,     0,     0,  1337,     0,     0,  1338,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,  1964,     0,     0,     0,  1354,  1332,
       0,  1333,     0,     0,     0,     0,     0,     0,  1339,     0,
    1334,  1335,  1336,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1341,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,  1345,     0,     0,     0,     0,     0,     0,     0,     0,
    1337,  1343,     0,  1338,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,     0,  1965,     0,
       0,  1345,  1354,     0,     0,     0,     0,  1337,     0,     0,
    1338,     0,  1339,     0,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,     0,  1353,     0,     0,     0,     0,     0,  1966,  1340,
       0,     0,  1354,  1344,     0,     0,     0,  1341,     0,  1339,
    1337,     0,     0,  1338,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,     0,     0,  1340,     0,  1332,     0,
    1333,     0,     0,     0,  1341,  1343,     0,     0,     0,  1334,
    1335,  1336,  1339,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,  1340,
    1333,     0,  1343,     0,     0,     0,     0,  1341,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,     0,     0,     0,  1344,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,     0,  1332,     0,
    1333,     0,     0,     0,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,  1344,     0,     0,     0,     0,     0,
    1337,     0,  1345,  1338,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1967,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,     0,  1353,     0,     0,     0,  1344,  1332,     0,
    1333,     0,  1339,  1354,     0,     0,     0,     0,     0,  1334,
    1335,  1336,     0,     0,     0,     0,     0,     0,     0,  1340,
    1332,     0,  1333,     0,     0,     0,     0,  1341,     0,     0,
       0,  1334,  1335,  1336,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,  1345,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1968,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,     0,  1345,     0,     0,     0,  1354,     0,     0,
       0,     0,     0,     0,     0,  1969,  1346,  1347,  1348,  1349,
    1350,  1351,  1352,     0,  1353,     0,     0,  1344,     0,  1337,
       0,     0,  1338,     0,  1354,     0,  1345,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,  1337,
       0,  1339,  1338,  1974,     0,     0,     0,  1354,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,     0,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,  1342,  1337,
       0,     0,  1338,     0,     0,     0,     0,     0,  1340,     0,
       0,     0,     0,     0,  1343,     0,  1341,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,     0,  1345,     0,  1340,  1337,
       0,     0,  1338,     0,     0,     0,  1341,     0,  1975,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,  1344,  1353,  1342,     0,
       0,  1337,     0,     0,  1338,     0,  1332,  1354,  1333,     0,
       0,  1339,     0,     0,  1343,     0,     0,  1334,  1335,  1336,
       0,     0,     0,     0,     0,     0,  1344,     0,  1340,  1332,
       0,  1333,     0,  1339,     0,     0,  1341,     0,     0,     0,
    1334,  1335,  1336,     0,     0,     0,     0,     0,  1342,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,     0,     0,  1343,     0,  1344,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1345,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1976,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,  1344,     0,
       0,     0,     0,     0,     0,  1345,  1354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1979,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,     0,     0,  1345,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1981,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1354,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1345,     0,  1337,     0,     0,
    1338,     0,     0,     0,     0,     0,     0,  1983,  1346,  1347,
    1348,  1349,  1350,  1351,  1352,     0,  1353,  1345,     0,     0,
    1337,     0,     0,     0,     0,     0,  1354,     0,     0,  1339,
    1346,  1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,
       0,     0,     0,     0,     0,     0,  1340,     0,  1354,     0,
       0,     0,  1339,     0,  1341,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,  1341,     0,     0,
       0,     0,  1343,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1344,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1344,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,  1347,  1348,  1570,
    1350,  1351,  1352,     0,  1353,     0,  1345,     0,     0,     0,
       0,     0,     0,     0,  1354,     0,     0,     0,     0,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,     0,  1353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1354
};

static const yytype_int16 yycheck[] =
{
       1,     2,     3,    70,  1382,   242,   160,     8,     9,    10,
      11,   158,    13,    63,    64,    65,     5,    18,    19,    20,
      21,    22,     5,     5,    25,    26,   173,   207,     5,   176,
      63,    64,    65,   507,   517,   516,   521,   505,    39,   522,
       0,   271,   499,   500,   518,   526,    47,    48,    49,    50,
      51,    52,    53,   521,   522,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,   296,    68,    69,   517,
      71,   523,    73,    74,   522,   505,   505,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    89,
       0,   521,   521,    94,    95,     5,   361,    98,   524,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   271,   134,   135,   136,  1360,     0,   139,   521,
     521,   142,     5,   144,   145,   505,   505,   517,   149,   150,
     151,     0,   522,     0,   155,   155,     5,   296,     5,     0,
     521,   521,   521,     0,     5,   521,   521,     0,     5,    79,
     521,   521,     0,   521,     5,     6,   521,     5,     9,   521,
     521,   521,  1406,   521,   204,   205,   521,   521,   521,     0,
      23,   521,     5,     6,     5,   521,     9,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   521,   521,   228,   521,
      43,   521,     8,   521,   521,   521,    79,   521,   521,   521,
     521,     2,   521,    19,    20,    21,   521,   521,     9,   521,
      79,   521,    79,   521,    67,   521,   521,    70,    79,   521,
     521,   521,    79,   521,    75,   521,    20,    21,   521,   521,
     521,    79,   521,   521,   521,   521,   207,   521,   521,   521,
     521,   521,    75,    96,   521,   521,   521,   521,    79,   521,
      51,    52,    53,   521,   511,   521,   521,   521,   521,    60,
     521,   511,   512,   513,   514,   521,   516,   521,   521,   521,
     521,   507,   521,   521,   521,   521,   526,   521,   521,    80,
     521,   521,   521,   521,    85,   138,   521,   521,   141,   521,
     521,   521,   521,   521,    95,   521,   521,   521,   521,   521,
     321,   154,   521,   521,   521,   158,   521,   517,   522,   510,
     510,   517,   521,   521,   207,   522,    19,    20,    21,    22,
     173,    79,   361,   176,   522,   517,   127,   128,   507,   520,
     131,   132,   520,   517,   135,   522,    39,   522,   509,   522,
     522,   522,   207,    46,   522,   518,   522,    50,   207,   526,
     522,    54,    55,    56,   513,   514,   522,   516,    61,   522,
     522,   522,   522,   518,   522,   522,   522,   526,   522,    72,
      73,    74,   522,   522,   522,    78,    79,    80,   522,   522,
     522,   522,   522,    86,   522,    88,   522,   522,   520,   522,
     521,   525,   507,   522,   522,   525,   522,   517,   242,   518,
     518,   104,   936,  1326,   107,   522,  1568,   110,   900,  1895,
     113,   114,   801,   116,    67,   118,    67,   750,   121,   750,
     123,   461,   431,   126,    67,    10,   129,    -1,   431,   431,
      -1,   361,    -1,    -1,   431,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,   150,   151,  1847,
     471,    -1,    -1,    -1,    39,   271,   307,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,   505,    51,   488,    53,    54,
      55,    -1,    57,    -1,   307,    60,    -1,   271,   361,   519,
     296,   521,     2,    -1,    -1,    -1,    -1,    72,    -1,     9,
      -1,    -1,   361,    -1,   361,    80,    -1,    -1,    -1,    -1,
     361,   431,   296,    -1,   361,    -1,    -1,    -1,   517,    94,
      -1,    -1,   521,   361,   517,    -1,   537,    -1,   521,   522,
     694,    -1,   107,    -1,   109,   522,   377,   112,    -1,    -1,
     361,    51,    -1,    53,    -1,    -1,    -1,    -1,   712,    -1,
      -1,  1785,   127,   128,   377,    -1,    -1,   132,   431,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,   431,    -1,   431,    85,    -1,    -1,    -1,    -1,
     431,    -1,    -1,    -1,   431,    95,    -1,    -1,    -1,    -1,
     431,   432,    -1,   431,    -1,    -1,    -1,   517,    -1,    -1,
      -1,   521,    -1,   523,   524,    -1,    -1,    -1,   431,   432,
     431,    -1,    -1,    -1,    -1,    -1,    -1,   127,   128,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,   640,
      -1,   642,   643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   517,    -1,   657,    -1,   521,    -1,
     523,   524,    -1,   664,    -1,    -1,    -1,   668,   517,    -1,
     671,    -1,   521,    -1,   523,   524,   523,   524,    -1,   510,
     681,    -1,   523,   524,   685,    -1,   523,   524,    -1,   690,
      -1,    -1,    -1,    -1,   695,   523,   524,   698,    -1,    -1,
      -1,    -1,   703,    -1,   517,    -1,   517,   488,    -1,    -1,
     521,   761,   523,   524,    -1,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,   726,    -1,    -1,   761,    -1,
     526,   732,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,
     514,    -1,   516,    26,   745,    -1,    -1,    -1,    -1,   750,
      -1,    -1,   526,   754,    -1,    -1,    39,    -1,    -1,    -1,
     761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      53,    -1,    -1,   927,    57,    -1,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,   470,   471,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    80,    -1,    -1,
     801,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
     643,    -1,    95,    -1,    -1,   962,    -1,   818,   818,    -1,
      -1,    -1,    -1,    -1,   657,    -1,   827,    -1,   111,   112,
      -1,   832,    -1,    -1,    -1,   668,    -1,    -1,   671,    -1,
      -1,    -1,    -1,    -1,   127,   128,    -1,    -1,   681,   132,
      -1,    -1,   685,   854,    -1,    -1,    -1,   690,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   698,    -1,    -1,    -1,    -1,
     703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   711,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   726,    -1,    -1,    -1,    -1,    -1,   732,
      -1,   902,    -1,    -1,    -1,   470,    -1,    -1,    -1,    -1,
     911,    -1,   745,    -1,    -1,    -1,    -1,   750,    -1,   920,
      -1,   754,    -1,    -1,    -1,    -1,    -1,    -1,   761,   930,
     930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     941,   942,   943,   944,   945,    -1,   947,   948,    -1,    -1,
     951,   952,    -1,   954,   955,   956,   957,   958,    -1,   960,
     961,    -1,    -1,    -1,   965,   966,    -1,    -1,   801,   970,
     971,    -1,   973,    -1,    -1,    -1,   977,    -1,    -1,    -1,
     981,   982,    -1,    -1,    -1,   818,   987,   988,   989,   990,
      -1,    -1,    -1,    -1,   827,    -1,    -1,    -1,    -1,    -1,
      -1,  1002,  1003,  1004,  1005,    -1,  1007,  1008,  1009,  1010,
      -1,    -1,   695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   854,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   902,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,   930,    -1,    -1,
      -1,    -1,    -1,   936,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1124,  1125,    -1,    -1,    -1,  1129,   962,
    1131,    -1,    -1,    -1,  1135,  1136,  1137,  1138,    -1,   972,
      -1,    -1,    -1,    -1,  1145,  1146,    -1,    -1,    -1,   832,
      -1,    -1,    -1,    -1,  1155,    -1,  1157,  1158,  1159,  1160,
     376,    -1,    -1,  1164,  1165,  1166,  1167,  1168,  1169,    -1,
    1171,    -1,    -1,  1327,    -1,    -1,  1177,  1178,    -1,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1199,    -1,
    1201,    -1,    -1,  1204,    -1,   488,    -1,    -1,    -1,    -1,
      -1,  1212,  1213,  1214,    -1,  1216,    -1,  1218,    -1,  1220,
      -1,  1222,    -1,    -1,  1225,  1226,  1227,  1228,  1229,    -1,
    1231,  1232,  1386,  1234,  1235,  1236,    -1,    -1,    -1,    -1,
      -1,  1242,    -1,  1244,  1245,  1246,  1247,    -1,    -1,  1250,
      -1,  1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,
    1261,    -1,    -1,  1264,  1265,    -1,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,    -1,    -1,    -1,   495,
      -1,    -1,    -1,  1284,  1285,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,    -1,   522,  1308,    -1,    -1,
     526,  1312,  1312,  1146,    -1,    -1,    -1,  1384,    -1,    -1,
      -1,  1388,    -1,  1324,  1325,    -1,    -1,    -1,    -1,    -1,
      -1,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,
    1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,    -1,    -1,    -1,  1358,    -1,  1360,
      -1,    -1,    -1,  1364,    -1,    -1,    -1,  1368,    -1,  1370,
    1371,  1372,    -1,    -1,  1375,    -1,    -1,  1378,    -1,  1380,
    1381,     0,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
    1391,    -1,  1393,    -1,  1395,    -1,    -1,    -1,  1399,    -1,
    1401,    -1,    -1,    -1,    23,  1406,    -1,    -1,  1409,    -1,
      -1,  1412,  1413,  1413,  1415,    -1,    -1,  1418,    -1,    -1,
    1421,    40,    41,    42,    43,    44,    45,  1428,    -1,    -1,
       0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    65,    -1,    67,    -1,
      -1,    70,  1453,    23,    -1,    -1,    75,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,  1165,  1484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    64,    65,  1179,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,   138,
      -1,    -1,   141,    -1,    -1,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1230,  1231,    -1,
      -1,  1384,    -1,    -1,   173,  1388,    -1,   176,    -1,    -1,
      -1,  1244,    -1,  1246,    -1,    -1,    -1,  1568,   138,  1570,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,    -1,
      -1,    -1,    -1,    -1,    -1,  1160,    -1,    -1,    -1,    -1,
    1165,    -1,    -1,   173,    -1,    -1,   176,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1179,    -1,  1617,  1618,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1308,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1648,  1649,    -1,
      -1,    -1,  1653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1227,    -1,  1665,  1230,    -1,  1668,  1669,  1670,
      -1,  1672,    -1,  1674,    -1,  1676,    -1,  1678,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1690,
    1691,    -1,  1693,    -1,    -1,    -1,  1697,   316,    -1,    -1,
      -1,    -1,  1703,  1704,    -1,    -1,    -1,  1708,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1717,  1718,    -1,    -1,
      -1,  1722,    -1,  1724,    -1,    -1,    -1,    -1,    -1,  1730,
    1731,    -1,  1733,  1734,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,    -1,
    1751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1762,  1763,    -1,    -1,    -1,    -1,    -1,    -1,  1770,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1779,    -1,
      -1,    -1,    -1,    -1,  1785,    -1,  1787,    -1,  1789,    -1,
      -1,  1792,  1793,  1794,    -1,    -1,  1797,  1798,  1799,  1800,
       8,  1802,  1803,    -1,    -1,  1806,    -1,  1808,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,  1819,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1858,    -1,    -1,
    1861,    -1,  1863,    -1,  1865,    -1,    -1,  1868,    -1,    -1,
      -1,    -1,  1873,  1874,    -1,  1876,    -1,  1878,    -1,    -1,
    1881,  1882,    -1,    -1,    -1,  1886,  1887,  1888,    -1,  1890,
      -1,    -1,    -1,    -1,  1895,    -1,  1897,  1898,  1899,    -1,
    1901,  1902,  1903,  1904,  1905,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    10,    -1,    -1,    -1,    -1,  1937,    -1,  1939,    -1,
      19,    20,    21,  1944,    -1,    -1,  1947,    -1,    -1,  1950,
    1951,  1952,  1953,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1962,    -1,    -1,    -1,    -1,  1967,  1968,  1969,    -1,
     589,    -1,    -1,    -1,  1975,  1976,    -1,    -1,  1979,     8,
    1981,    10,  1983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   589,
      -1,    -1,    -1,    -1,   643,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   657,    -1,
      -1,    -1,    -1,   662,    -1,    -1,    -1,    -1,    -1,   668,
      -1,    -1,   671,   239,    -1,    -1,   242,     8,    -1,    10,
      -1,    -1,   681,   271,    -1,    -1,   685,    -1,    19,    20,
      21,   690,    -1,   643,    -1,    -1,    -1,    -1,    -1,   698,
     288,    -1,    -1,    -1,   703,   271,    -1,   657,   296,    -1,
      -1,    -1,   711,    -1,    -1,    -1,    -1,    -1,   668,    -1,
     308,   671,   288,    -1,    -1,    -1,    -1,   726,    -1,    -1,
     296,   681,    -1,   732,    -1,   685,    -1,    -1,    -1,    -1,
     690,    -1,   308,    -1,    -1,    -1,   745,    -1,   698,    -1,
      -1,   750,    -1,   703,    -1,   754,    -1,   239,   324,    -1,
     242,    -1,   761,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   726,    -1,    -1,    -1,
     239,    -1,   732,   242,    -1,    -1,    -1,    -1,    -1,   271,
      -1,    -1,    -1,    -1,    -1,   745,    -1,    -1,   207,    -1,
     750,    -1,   801,    -1,   754,    -1,   288,    -1,    -1,    -1,
     376,   761,   271,    -1,   296,    -1,    -1,    -1,    -1,   818,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,   827,   288,
     239,    -1,    -1,   242,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,   801,    -1,    -1,    -1,   854,    -1,    -1,     8,    -1,
      10,    -1,   271,    -1,    -1,   324,    -1,    -1,   818,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,   827,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,   902,   854,    -1,    -1,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,   324,    -1,   376,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,   495,
      -1,   930,    -1,    -1,    -1,    -1,    -1,   936,   526,    -1,
     271,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   902,    -1,    -1,    -1,   522,   288,    -1,    -1,
     526,    -1,    -1,   962,    -1,   296,    -1,   376,   967,    -1,
      -1,    -1,    -1,   972,    -1,    -1,    -1,   308,    -1,    -1,
     930,    -1,    -1,    -1,    -1,    -1,   936,    -1,    -1,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   962,   495,    -1,    -1,    -1,   967,    -1,    -1,
      -1,    -1,   972,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,   495,    -1,    -1,    -1,
     522,    -1,    -1,    -1,   526,   376,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,   288,    18,
      19,    -1,    -1,    -1,    -1,    -1,   296,  1146,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    38,
      -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   324,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,    71,    -1,    -1,   526,  1146,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    90,    91,    92,    93,    -1,    -1,    -1,    97,    -1,
      -1,   100,   101,    -1,    -1,    -1,   376,    -1,    -1,   108,
      -1,    -1,   111,    -1,   113,    -1,   115,   116,   117,    -1,
     119,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   143,   144,    -1,   146,   147,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,  1382,    -1,  1384,    -1,    -1,    -1,  1388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   322,   323,   324,   325,   326,    -1,    -1,
     329,   330,   331,   332,    -1,  1405,    -1,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,    -1,
      -1,    -1,    -1,    -1,   473,   474,   475,   476,    -1,    -1,
      -1,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,
     499,   500,   501,    -1,    -1,    -1,  1625,    -1,   507,   508,
     509,   510,   511,   512,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    -1,
     539,   540,   541,   542,   543,   544,   545,    -1,    -1,    -1,
     549,    -1,   551,   552,   553,   554,   555,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   564,    -1,    -1,   567,   568,
     569,   570,   571,   572,    -1,    -1,    -1,   576,   577,   578,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   602,   603,   604,   605,   606,   607,   608,
      -1,    -1,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    16,
      -1,    18,    -1,    -1,  1783,    22,    23,    24,    25,    26,
      -1,    -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,
      37,    -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1847,    -1,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,
      -1,   208,    -1,    -1,    -1,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,   222,   223,   224,   225,   226,
     227,   228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,
     237,   238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,
      -1,    -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,
      -1,   258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,
      -1,    -1,   269,   270,    -1,   272,   273,   274,    -1,   276,
     277,   278,   279,   280,   281,    -1,    -1,   284,   285,   286,
     287,    -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,
     317,    -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,
     327,   328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,
     337,    -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,    -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,
     367,   368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,
     387,   388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,
      -1,    -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,
      -1,    -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,
     417,    -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,
     427,   428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,
     437,   438,    -1,    -1,    -1,   442,   443,   444,   445,   446,
     447,   448,   449,    -1,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,    -1,   485,    -1,
     487,    -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,    -1,    -1,   511,   512,    -1,    -1,    -1,    -1,
      -1,   518,   519,    -1,   521,     3,     4,     5,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,   522,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,   207,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,   510,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
     518,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,   509,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,    -1,
      -1,    -1,    -1,   511,   512,     3,     4,     5,    -1,    -1,
      -1,   519,    -1,   521,    -1,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    24,    25,    26,    -1,
      -1,    -1,    30,    -1,    -1,    33,    -1,    35,    -1,    37,
      -1,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,    -1,    -1,    -1,   203,   204,   205,    -1,    -1,
     208,    -1,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,   232,    -1,    -1,    -1,   236,   237,
     238,    -1,   240,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,   249,   250,   251,   252,    -1,    -1,    -1,    -1,    -1,
     258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,
      -1,   269,   270,    -1,   272,   273,   274,    -1,   276,   277,
     278,   279,   280,   281,    -1,    -1,   284,   285,   286,   287,
      -1,   289,    -1,    -1,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,    -1,    -1,   312,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,   322,    -1,    -1,   325,   326,   327,
     328,   329,   330,    -1,    -1,    -1,    -1,   335,    -1,   337,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   362,   363,   364,    -1,    -1,   367,
     368,   369,   370,   371,    -1,   373,    -1,    -1,    -1,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   384,   385,   386,   387,
     388,    -1,    -1,    -1,    -1,   393,   394,   395,   396,    -1,
      -1,    -1,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,   417,
      -1,    -1,   420,   421,    -1,    -1,   424,   425,   426,   427,
     428,    -1,    -1,   431,    -1,    -1,    -1,   435,    -1,   437,
     438,    -1,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,    -1,   461,    -1,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,    -1,    -1,   485,    -1,   487,
      -1,    -1,    -1,   491,    -1,    -1,    -1,    -1,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    -1,    17,    -1,
      -1,   519,    -1,   521,    -1,    -1,    -1,    -1,    27,    28,
      29,    -1,    31,    32,    -1,    34,    -1,    36,    -1,    38,
      -1,    -1,    41,    42,    -1,    44,    45,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   200,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,    -1,    -1,    -1,   253,   254,   255,   256,   257,    -1,
      -1,    -1,    -1,   262,   263,    -1,   265,   266,   267,   268,
      -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
      -1,    -1,    -1,   282,   283,    -1,    -1,    -1,    -1,    -1,
      -1,   290,   291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,   311,    -1,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   331,   332,   333,   334,    -1,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,   355,   239,   357,    -1,
     359,   360,   361,    -1,    -1,    -1,   365,   366,    -1,    -1,
      -1,    -1,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,    -1,    -1,   271,
     389,   390,   391,   392,    -1,    -1,    -1,    -1,   397,   398,
     399,   239,   401,    -1,   242,   404,   288,   406,   407,   408,
     409,   410,    -1,   412,   296,   414,   415,   416,    -1,   418,
     419,    -1,    -1,   422,   423,    -1,   308,    -1,    -1,    -1,
     429,    -1,    -1,   271,   433,   434,    -1,   436,    -1,    -1,
      -1,   440,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   450,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
     459,   460,    -1,   462,    -1,   464,    -1,   466,    -1,    -1,
     308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   483,   484,   324,   486,    -1,   488,
     489,   490,    -1,   492,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   505,   506,     7,    -1,
      -1,    -1,    11,    12,    -1,    -1,    -1,    -1,    17,    -1,
      -1,    -1,   521,    -1,    -1,    -1,   525,    -1,    27,    28,
      29,    -1,    31,    32,    -1,    34,    -1,    36,   376,    38,
      -1,    -1,    41,    42,    -1,    44,    45,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   200,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,    -1,    -1,    -1,   253,   254,   255,   256,   257,    -1,
      -1,    -1,    -1,   262,   263,    -1,   265,   266,   267,   268,
      -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
      -1,    -1,    -1,   282,   283,    -1,    -1,    -1,    -1,    -1,
      -1,   290,   291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,   311,    -1,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   331,   332,   333,   334,    -1,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,    -1,
     349,    -1,    -1,    -1,    -1,    -1,   355,    -1,   357,    -1,
     359,   360,   361,    -1,    -1,    -1,   365,   366,    -1,    -1,
      -1,    -1,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,    -1,    -1,    -1,
     389,   390,   391,   392,    -1,    -1,    -1,    -1,   397,   398,
     399,    -1,   401,    -1,    -1,   404,    -1,   406,   407,   408,
     409,   410,    -1,   412,    -1,   414,   415,   416,    -1,   418,
     419,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,
     429,    -1,    -1,    -1,   433,   434,    -1,   436,    -1,    -1,
      -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     459,   460,    -1,   462,    -1,   464,    -1,   466,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,
      11,    12,    -1,    -1,   483,   484,    17,   486,    -1,   488,
     489,   490,    -1,   492,   493,   494,    27,    28,    29,    -1,
      31,    32,    -1,    34,    -1,    36,   505,    38,    -1,    -1,
      41,    42,    -1,    44,    45,    46,    -1,    -1,    -1,    -1,
      -1,    -1,   521,    -1,    -1,    -1,   525,    -1,    -1,    -1,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,   253,   254,   255,   256,   257,    -1,    -1,    -1,
      -1,   262,   263,    -1,   265,   266,   267,   268,    -1,    -1,
      -1,    -1,    -1,    -1,   275,     8,    -1,    10,    -1,    -1,
      -1,   282,   283,    -1,    -1,    -1,    19,    20,    21,   290,
     291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,
     311,    -1,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     331,   332,   333,   334,    -1,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,    -1,   349,     8,
      -1,    10,    -1,    -1,   355,    -1,   357,    -1,   359,   360,
      19,    20,    21,    -1,   365,   366,    -1,    -1,    -1,    -1,
      -1,   372,    -1,   374,   375,    -1,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,    -1,    -1,    -1,   389,   390,
     391,   392,    -1,    -1,    -1,    -1,   397,   398,   399,   239,
     401,    -1,   242,   404,    -1,   406,   407,   408,   409,   410,
      -1,   412,    -1,   414,   415,   416,    -1,   418,   419,    -1,
      -1,   422,   423,    -1,    -1,    -1,    -1,    -1,   429,    -1,
      -1,   271,   433,   434,    -1,   436,    -1,    -1,    -1,   440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   450,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   459,   460,
      -1,   462,    -1,   464,    -1,   466,    -1,    -1,   308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   483,   484,   324,   486,    -1,   488,   489,   490,
      -1,   492,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,    -1,   239,    -1,    -1,   242,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     521,    19,    20,    21,   525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
     239,    -1,     8,   242,    10,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
       8,    -1,    10,   376,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    19,    20,    21,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,     8,    -1,
      10,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,   495,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,   271,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,
     288,    -1,    -1,   526,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   495,   239,    -1,    -1,
     242,    -1,    -1,    -1,    -1,   271,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,   288,   522,    -1,    -1,    -1,   526,    -1,   271,
     296,   239,    -1,    -1,   242,    -1,    -1,    -1,   376,    -1,
      -1,    -1,   308,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,   271,    -1,    -1,   308,    -1,    -1,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,   324,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
     308,   271,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
     376,    -1,    -1,   207,    -1,    -1,   324,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,   308,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,     8,   242,    10,
      -1,    -1,    -1,    -1,   324,    -1,    -1,   495,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,   507,
     508,   509,   510,   511,   512,   513,   514,   271,   516,    -1,
      -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,     8,   376,    10,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,   495,    -1,    -1,   522,    -1,    -1,    -1,
     526,    -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
     522,    -1,   376,    -1,   526,    -1,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,     8,
      -1,    10,    -1,   239,    -1,   495,   242,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,    -1,    -1,   271,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,     8,    -1,    10,    -1,   239,    -1,
     296,   242,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,
     271,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,   526,    -1,    -1,   296,   239,    -1,     8,   242,
      10,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,   324,     8,    -1,    10,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,     8,    -1,    10,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,   495,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   288,
     516,    -1,    -1,    -1,    -1,   239,   522,   296,   242,     8,
     526,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    10,   495,   324,    -1,   271,    -1,    -1,
      -1,    -1,    19,    20,    21,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,   288,   516,    -1,   518,    -1,    -1,
      -1,    -1,   296,    -1,    -1,   526,    -1,    -1,    -1,   239,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,
     324,    -1,   495,    -1,    -1,   239,    -1,    -1,   242,    -1,
      -1,   271,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,   239,   288,   522,
     242,    -1,    -1,   526,    -1,    -1,   296,   271,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,    -1,   376,    -1,   288,    -1,    -1,    -1,    -1,   271,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,   242,    -1,   308,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,     8,    -1,    10,    -1,
     324,    -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,   495,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,   308,    -1,
      -1,    -1,   376,   522,    -1,    -1,    -1,   526,    -1,    -1,
     239,    -1,    -1,   242,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,   495,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,   271,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,   288,
      -1,     8,   526,    10,   271,    -1,   376,   296,    -1,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,   308,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,     8,    -1,    10,    -1,   324,    -1,    -1,    -1,    -1,
      -1,   308,    19,    20,    21,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,   324,    -1,    -1,
      -1,   495,    -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   495,    -1,    -1,    -1,   376,   522,    -1,
      -1,    -1,   526,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,   376,
     522,    -1,    -1,    -1,   526,    -1,    -1,   239,    -1,    -1,
     242,     8,    -1,    10,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,   271,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,    -1,   324,    -1,    -1,    -1,   495,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,   495,    -1,
      -1,    -1,   239,   522,    -1,   242,    -1,   526,    -1,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,   376,   522,    -1,    -1,    -1,   526,
      -1,    -1,   239,    -1,   271,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,     8,    -1,    10,   271,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,   324,    -1,   296,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,
      -1,    -1,   239,    -1,     8,   242,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,   376,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   271,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,   376,
     522,   288,    -1,    -1,   526,    -1,    -1,   239,    -1,   296,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,   242,     8,    -1,    10,    -1,   324,    -1,   271,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,   288,    10,    -1,    -1,
      -1,   271,    -1,    -1,   296,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   495,   376,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,   308,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,   324,   522,    -1,    -1,   495,   526,
      -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,   376,   522,    -1,    -1,     8,   526,
      10,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,     8,    -1,    10,    -1,   239,    -1,    -1,   242,    -1,
      -1,   308,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,   324,   495,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,   271,    -1,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,   288,   522,    -1,    -1,    -1,   526,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,   376,
      -1,    -1,    -1,   495,   239,    -1,    -1,   242,    -1,    -1,
     324,    -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   495,   239,    -1,    -1,   242,
     522,    -1,    -1,    -1,   526,    -1,   271,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,   288,    -1,    -1,   526,    -1,   271,    -1,
      -1,   296,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,     8,    -1,    10,    -1,   324,
      -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,     8,    -1,    10,   495,   239,
      -1,    -1,   242,    -1,    -1,    -1,    19,    20,    21,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,   376,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,
      -1,   271,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,   239,    -1,   296,   242,     8,    -1,
      10,   495,    -1,    -1,   271,    -1,    -1,    -1,   308,    19,
      20,    21,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,   288,   516,    -1,   324,    -1,   271,    -1,   522,   296,
      -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,   288,    -1,    -1,    -1,    -1,     8,    -1,
      10,   296,    -1,    -1,    -1,    -1,    -1,   324,    -1,    19,
      20,    21,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,   324,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   495,    -1,    -1,    -1,    -1,   522,    -1,   376,
      -1,   526,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,
      -1,   376,    -1,   526,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,   239,    -1,   271,   242,
      -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,   495,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,   288,   516,    -1,    -1,    -1,
      -1,   324,   522,   296,    -1,     8,   526,    10,   495,   239,
      -1,    -1,   242,    -1,    -1,   308,    19,    20,    21,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
     495,   324,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,
      -1,   271,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   376,    -1,    -1,    -1,   522,   288,   239,
      -1,   526,   242,     8,    -1,    10,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,   308,    -1,
      -1,    -1,    -1,   376,    -1,    -1,     8,    -1,    10,    -1,
      -1,   271,    -1,    -1,   324,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,     8,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   324,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    10,   495,   239,    -1,    -1,   242,    -1,    -1,    -1,
      19,    20,    21,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,   376,    -1,    -1,   522,
      -1,    -1,   495,   526,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   288,   516,    -1,    -1,    -1,    -1,    -1,   522,
     296,    -1,     8,   526,    10,    -1,   239,    -1,    -1,   242,
      -1,    -1,   308,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,   288,   516,    -1,    -1,    -1,
      -1,    -1,   522,   296,   239,    -1,   526,   242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,   495,    -1,   239,    -1,    -1,
     242,   324,    -1,    -1,    -1,    -1,   271,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,   288,    -1,    -1,   526,    -1,    -1,   271,
     239,   296,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,   376,   296,    -1,    -1,    -1,     8,   324,
      10,    -1,   271,    -1,    -1,    -1,   308,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
     239,    -1,   324,   242,     8,    -1,    10,   296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,   495,
      -1,   376,   271,    -1,    -1,   324,    -1,    19,    20,    21,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   288,
     516,    -1,    -1,    -1,   376,    -1,   522,   296,    -1,     8,
     526,    10,    -1,   239,    -1,    -1,   242,    -1,    -1,   308,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,   376,    -1,    -1,
      -1,    -1,   495,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   288,   516,    -1,    -1,    -1,    -1,    -1,   522,
     296,    -1,     8,   526,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    19,    20,    21,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   495,    -1,    -1,    -1,   522,    -1,    -1,
      -1,   526,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,   526,    -1,   495,    -1,    -1,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,   526,   242,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   495,   239,   288,    -1,
     242,    -1,    -1,    -1,    -1,    -1,   296,   271,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,   308,    -1,
      -1,    -1,    -1,    -1,   288,    -1,     8,   526,    10,   271,
     239,    -1,   296,   242,   324,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,     8,    -1,    10,   495,
     324,    -1,   271,    -1,    -1,    -1,   308,    19,    20,    21,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   288,
     516,    -1,   324,    -1,    -1,    -1,   376,   296,    -1,     8,
     526,    10,    -1,   239,    -1,    -1,   242,    -1,    -1,   308,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,   324,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   439,    -1,     8,
      -1,    10,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
     376,   495,    -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   495,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,   526,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,   526,    10,   495,   239,    -1,   271,
     242,    -1,    -1,    -1,    19,    20,    21,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,   288,   516,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,   526,    -1,   271,
     239,    -1,    -1,   242,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,   324,    -1,   296,    -1,    -1,   239,    -1,   495,
     242,    -1,   271,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   288,
     516,    -1,   324,    -1,    -1,    -1,    -1,   296,    -1,   271,
     526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,   376,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   296,   324,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,     8,    -1,    10,    -1,
     239,    -1,   324,   242,    -1,   271,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,     8,    -1,    10,    -1,   376,    -1,    -1,
     296,    -1,   271,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,   376,    -1,    -1,   296,   324,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,   495,   239,   324,    -1,   242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,     8,    -1,    10,
     376,    -1,    -1,   495,   526,    -1,   271,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,   288,   516,    -1,    -1,   376,    -1,    -1,
      -1,   296,    -1,    -1,   526,    -1,   495,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,   324,
       8,    -1,    10,   495,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    19,    20,    21,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,   376,    -1,    -1,    -1,    -1,    -1,   239,    -1,   495,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,   239,    -1,   495,   242,    -1,   271,
     526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,   288,   516,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,   271,   526,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,   308,   242,    -1,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,   324,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,   308,    -1,    -1,   271,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   324,
     495,   242,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   308,   376,     8,    -1,    10,    -1,    -1,
     271,   526,    -1,    -1,    -1,    -1,    19,    20,    21,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,   376,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,   239,    -1,    -1,   242,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    19,    20,    21,
      -1,   376,    -1,   271,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,    -1,
     308,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,   288,   324,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   308,    -1,    -1,    -1,    -1,
     495,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,   324,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,
      -1,   526,    -1,    -1,     8,    -1,    10,    -1,   239,    -1,
     495,   242,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   376,     8,    -1,    10,    -1,    -1,    -1,
     271,   526,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,   495,    -1,   239,   288,    -1,   242,
      -1,    -1,    -1,    -1,    -1,   296,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,   271,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,   239,    -1,    -1,
     242,    -1,    -1,   296,    -1,    -1,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,   271,
      -1,   324,    -1,    -1,   522,   376,    -1,    -1,   526,    -1,
      -1,    -1,   495,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,   308,    -1,     8,   522,
      10,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,   324,   376,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    10,   495,   239,    -1,   271,   242,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,   288,   516,    -1,    -1,    -1,    -1,
      -1,   522,   296,    -1,     8,   526,    10,   271,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    19,    20,    21,    -1,    -1,
      -1,    -1,   495,    -1,   288,    -1,    -1,    -1,    -1,    -1,
     324,    -1,   296,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   308,    -1,    -1,    -1,    -1,   522,
      -1,    -1,     8,   526,    10,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
     522,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,    -1,   242,     8,    -1,    10,    -1,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,   288,    10,
      -1,    -1,    -1,   271,    -1,    -1,   296,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,   495,   239,    -1,   324,   242,    -1,    -1,    -1,    -1,
     308,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,   324,    -1,   522,    -1,
      -1,   495,   526,    -1,   271,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,   288,   516,    -1,    -1,    -1,   376,    -1,   522,   296,
      -1,     8,   526,    10,    -1,    -1,    -1,   271,    -1,    -1,
      -1,   308,    19,    20,    21,    -1,    -1,    -1,   376,    -1,
      -1,    -1,    -1,   239,   288,    -1,   242,   324,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,   376,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    -1,   376,    -1,    -1,   495,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,   495,   239,    -1,
      -1,   242,   522,    -1,    -1,    -1,   526,    -1,   271,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
     376,    -1,    -1,    -1,   522,   288,    -1,     8,   526,    10,
     271,    -1,    -1,   296,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,     8,   495,    10,
      -1,   324,    -1,    -1,    -1,    -1,    -1,   308,    19,    20,
      21,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,   324,    -1,   522,    -1,    -1,    -1,   526,
      -1,   495,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,    -1,   271,    -1,    -1,   239,    -1,    -1,
     242,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,   495,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   271,
     516,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,    -1,    -1,    -1,   288,   324,     8,    -1,
      10,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,
      -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   495,    -1,    -1,    -1,   239,   522,
      -1,   242,    -1,   526,   376,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,    -1,    -1,    -1,   526,    -1,    -1,   239,    -1,
     271,   242,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
     271,    -1,     8,    -1,    10,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,   288,    -1,    -1,
      -1,    -1,    -1,   324,    -1,   296,    -1,    -1,   495,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,   324,    -1,   522,    -1,    -1,    -1,   526,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,   239,
     522,    -1,   242,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,     8,   242,    10,    -1,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,   271,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,   239,    -1,    -1,   242,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,    -1,    -1,   495,   526,   376,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,   271,   242,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
     376,   522,   288,    -1,    -1,   526,    -1,    -1,    -1,    -1,
     296,    -1,     8,    -1,    10,   271,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,     8,    -1,    10,    -1,   324,    -1,
     296,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,   495,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,   495,
     376,    -1,   522,    -1,    -1,    -1,   526,    -1,   271,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,   288,   522,    -1,    -1,    -1,
     526,    -1,    -1,   296,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,   495,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,   376,    -1,    -1,   522,    -1,    -1,   495,
     526,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,   239,   522,    -1,   242,    -1,
     526,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   288,    -1,   242,    -1,    -1,   271,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,     8,
      -1,    10,   296,   271,    -1,    -1,    -1,    -1,   324,    -1,
      19,    20,    21,    -1,   308,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
     324,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,   324,    -1,    -1,    -1,
     376,    -1,    -1,   526,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,   239,    -1,
      -1,   242,     8,    -1,    10,    -1,    -1,    -1,   271,    -1,
      -1,    -1,    -1,    19,    20,    21,    -1,    -1,   376,    -1,
      -1,    -1,    -1,    -1,   239,   288,     8,   242,    10,    -1,
     271,    -1,    -1,   296,    -1,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,
      -1,    -1,     8,    -1,    10,   296,   271,    -1,    -1,    -1,
      -1,   324,    -1,    19,    20,    21,    -1,   308,    -1,    -1,
      -1,    -1,    -1,   288,     8,    -1,    10,    -1,    -1,    -1,
      -1,   296,    -1,   324,    -1,    19,    20,    21,    -1,   495,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,   324,
     516,   495,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,   376,    -1,   495,   522,    -1,
     239,    -1,   526,   242,    -1,    -1,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,   376,    -1,    -1,   522,    -1,    -1,     8,   526,    10,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,
      -1,    -1,   495,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   495,    -1,    -1,   239,    -1,    -1,
     242,    -1,    -1,   526,    -1,   271,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,   376,    -1,    -1,
     495,   522,   288,   239,    -1,   526,   242,    -1,    -1,   271,
     296,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   308,    -1,    -1,   239,   288,    -1,   242,    -1,
      -1,   526,    -1,    -1,   296,   271,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,   288,     8,    -1,    10,    -1,   271,    -1,    -1,
     296,    -1,   324,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,   324,    -1,
     376,    -1,    -1,    -1,   308,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
     324,    -1,    -1,    -1,   376,    -1,   495,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
     376,    -1,    -1,    -1,     8,    -1,    10,   526,    -1,    -1,
     271,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,     8,   288,    10,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,   324,    -1,    -1,    -1,    -1,    -1,   495,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,   495,    -1,    -1,   522,    -1,    -1,    -1,
     526,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   376,    -1,    -1,    -1,   495,
     522,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,   495,    -1,    -1,   239,    -1,   522,   242,    -1,    -1,
     526,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,   526,    -1,    -1,    -1,   271,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,   271,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,
      -1,    -1,    -1,    -1,   495,   239,   288,    -1,   242,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,   308,   239,    -1,    -1,
     242,   522,    -1,    -1,    -1,   526,    -1,   271,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,   288,    -1,    -1,    -1,    -1,   271,
      -1,   239,   296,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,     8,
     324,    10,    -1,   271,   376,    -1,   308,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,     8,   324,    10,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,   239,    -1,
     495,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,    -1,    -1,    -1,    -1,   522,   376,    -1,
     271,   526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,     8,   308,    10,    -1,
     522,    -1,    -1,    -1,   526,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,     8,    -1,
      10,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   495,    -1,    -1,    -1,    -1,   522,    -1,
      -1,    -1,   526,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   376,    -1,    -1,    -1,    -1,
     522,    -1,    -1,    -1,   526,    -1,    -1,   495,    -1,    -1,
     239,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,   239,    -1,   522,   242,    -1,     8,   526,    10,
      -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,   271,    -1,    -1,   296,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,    -1,     8,    -1,    10,   324,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   495,    -1,    -1,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,   271,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,   288,    10,    -1,    -1,
      -1,   271,    -1,    -1,   296,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,     8,   308,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,   324,    -1,   495,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,   495,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,   526,    -1,    -1,
     271,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,    -1,   522,   376,   288,    -1,   526,
      -1,    -1,    -1,   239,    -1,   296,   242,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,   324,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,     8,    -1,    10,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,   324,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   495,   239,    -1,    -1,   242,
     522,    -1,    -1,    -1,   526,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,    -1,   526,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,    -1,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    -1,   495,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,   308,    -1,    -1,
      -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,   239,
      -1,    -1,   242,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,   495,
      -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,   271,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,   239,    -1,   522,   242,   288,    -1,
     526,    -1,    -1,   271,    -1,   376,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
     288,    -1,    -1,    -1,    -1,    -1,   271,    -1,   296,    -1,
      -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
     308,    -1,     8,   288,    10,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    19,    20,    21,   324,    -1,    -1,    -1,
      -1,    -1,    -1,   308,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,   324,
      -1,    -1,   495,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,   376,   522,
      -1,    -1,    -1,   526,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,   271,    -1,
      -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,   288,    10,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      -1,   324,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,   495,    -1,    -1,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
     495,    -1,    -1,   376,    -1,    -1,    -1,    -1,   526,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   239,    -1,     8,   242,    10,    -1,    -1,
      -1,   526,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,   271,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,     8,    -1,    10,    -1,    -1,   271,    -1,    -1,
      -1,    -1,   376,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,     8,    -1,    10,    -1,   271,
      -1,    -1,   296,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,     8,   308,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,   324,    -1,    -1,    -1,   239,    -1,     8,   242,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,
      -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,   271,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,   495,    -1,    -1,   376,   288,    -1,    -1,    -1,    -1,
     526,    -1,    -1,   296,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,   308,    -1,    -1,   522,    -1,
      -1,    -1,   526,    -1,     8,    -1,    10,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   495,    -1,    -1,   239,    -1,   522,   242,
      -1,    -1,   526,    -1,    -1,   271,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
     522,    -1,   288,    -1,   526,    -1,    -1,    -1,   271,    -1,
     296,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,   308,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,   324,   239,
      -1,    -1,   242,    -1,     8,   308,    10,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,   324,   495,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,   271,    -1,   296,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,   308,    -1,    -1,   288,   522,
     376,    -1,    -1,   526,    -1,    -1,   296,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,    -1,    -1,   376,    -1,   239,    -1,     8,   242,    10,
      -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,   271,    -1,    -1,
      -1,    -1,    -1,   376,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,     8,    -1,    10,
      -1,    -1,   296,    -1,    -1,    -1,   376,    -1,    19,    20,
      21,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,   495,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   495,    -1,    -1,    -1,   522,    -1,    -1,    -1,
     526,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,   376,   516,    -1,    -1,    -1,    -1,    -1,   522,
      -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   495,    -1,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,   495,    -1,    -1,    -1,   522,
      -1,    -1,    -1,   526,    -1,    -1,    -1,   271,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,    -1,   288,    -1,   526,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,
     271,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,   288,   239,    -1,
      -1,   242,   526,    -1,    -1,   296,   271,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,   239,   288,     8,   242,    10,    -1,    -1,    -1,
     271,   296,    -1,   324,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,   271,   296,    -1,    -1,    -1,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,
      -1,    -1,     8,   324,    10,   376,    -1,    -1,    -1,    -1,
      -1,   308,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,     8,    -1,
      10,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,   495,    10,    -1,    -1,   376,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,     8,    -1,    10,    -1,    -1,   522,   376,
      -1,    -1,   526,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
     495,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,    -1,   495,   239,    -1,   522,   242,    -1,
      -1,   526,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,   495,    -1,
      -1,   522,    -1,    -1,    -1,   526,    -1,   271,    -1,    -1,
      -1,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
      -1,    -1,    -1,    -1,   288,   522,    -1,    -1,    -1,   526,
      -1,    -1,   296,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
     324,    -1,   242,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   288,    -1,   242,    -1,    -1,    -1,    -1,    -1,
     296,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   239,    -1,    -1,   242,   288,    -1,
      -1,    -1,   376,   271,    -1,    -1,   296,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,   308,   242,
     288,    -1,    -1,    -1,    -1,    -1,   271,    -1,   296,    -1,
      -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,   239,    -1,
     308,   242,     8,   288,    10,    -1,    -1,    -1,   271,    -1,
      -1,   296,    -1,    19,    20,    21,   324,    -1,    -1,    -1,
     376,    -1,    -1,   308,     8,   288,    10,    -1,    -1,    -1,
     271,    -1,    -1,   296,    -1,    19,    20,    21,    -1,   324,
      -1,    -1,    -1,    -1,    -1,   308,   376,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,     8,    -1,
      10,   324,    -1,    -1,    -1,    -1,    -1,   308,   376,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,     8,    -1,    10,    -1,    -1,   522,    -1,
      -1,    -1,   526,   376,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    19,    20,    21,   495,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,   495,   522,    -1,    -1,    -1,
     526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,   495,    -1,    -1,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
     495,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   495,   239,    -1,    -1,   242,   522,    -1,    -1,
      -1,   526,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   495,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   526,    -1,   271,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,   288,    -1,    -1,   526,    -1,   271,    -1,   239,
     296,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,   271,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,    -1,   242,   288,    -1,
     324,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,   239,    -1,   308,   242,
      -1,    -1,    -1,    19,    20,    21,   271,    -1,    -1,    -1,
     376,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,   288,    10,    -1,    -1,    -1,   271,    -1,
      -1,   296,   376,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,     8,    -1,    10,   324,
      -1,    -1,    -1,    -1,    -1,   308,   376,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,   495,
      -1,    -1,    -1,   376,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,   495,    -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,
     526,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,    -1,
      -1,    -1,   526,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   495,   239,    -1,   271,   242,   522,    -1,    -1,
      -1,   526,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   288,   516,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,   526,    -1,   271,    -1,   239,    -1,    -1,
     242,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,   324,   239,
     296,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,   271,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   239,    -1,    -1,   242,   288,    -1,   324,    -1,
      -1,   271,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,   308,   242,   288,    -1,
     376,    -1,    -1,    -1,   271,    -1,   296,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,   308,    -1,
       8,   288,    10,    -1,    -1,    -1,   271,    -1,    -1,   296,
     376,    19,    20,    21,   324,    -1,    -1,    -1,    -1,    -1,
      -1,   308,     8,   288,    10,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    19,    20,    21,    -1,   324,    -1,    -1,
      -1,    -1,    -1,   308,   376,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,   324,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,   376,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,   495,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,     8,    -1,    10,    -1,    -1,   522,    -1,    -1,   495,
     526,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,
     526,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,   495,    -1,    -1,    -1,    -1,
     522,    -1,    -1,    -1,   526,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,   495,    -1,
      -1,    -1,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
     495,   239,    -1,    -1,   242,   522,    -1,    -1,    -1,   526,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,   526,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,   242,
     288,    -1,    -1,    -1,    -1,   271,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,   288,    -1,    -1,    -1,    -1,    -1,   271,    -1,
     296,    -1,    -1,    -1,   239,    -1,   324,   242,    -1,    -1,
      -1,    -1,   308,    -1,    -1,   288,    -1,    -1,    -1,    -1,
       8,    -1,    10,   296,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    19,    20,    21,    -1,   308,   271,    -1,    -1,    -1,
      -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,   324,    -1,   288,    -1,     8,    -1,    10,   376,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,   308,   271,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,
      -1,   288,    -1,     8,    -1,    10,    -1,    -1,    -1,   296,
      -1,    -1,    -1,   376,    19,    20,    21,    -1,    -1,    -1,
      -1,   308,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,   376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,   495,
      -1,    -1,    -1,    -1,    -1,    -1,   441,    -1,   526,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,   526,   242,    -1,    -1,    -1,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   271,    -1,    -1,   239,    -1,    -1,   242,
      -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,   271,   516,
     308,    -1,    -1,    -1,   239,    -1,    -1,   242,    -1,   526,
      -1,    -1,    -1,    -1,    -1,   288,   324,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,   239,    -1,
      -1,   242,    -1,    -1,    -1,   308,   271,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    -1,   288,    -1,   239,    -1,    -1,   242,    -1,
     271,   296,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,     8,    -1,    10,   296,    -1,   271,    -1,   324,
      -1,    -1,    -1,    19,    20,    21,    -1,   308,    -1,    -1,
      -1,    -1,    -1,   376,   288,     8,    -1,    10,    -1,    -1,
      -1,    -1,   296,   324,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
     324,   376,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    19,    20,
      21,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,
      -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,   526,    -1,    19,    20,    21,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,
      -1,   526,    -1,    -1,    -1,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   495,    -1,   239,    -1,   526,   242,    -1,    -1,    -1,
      -1,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,   239,    -1,    -1,   242,
      -1,    -1,   526,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   239,    -1,    -1,   242,    -1,   271,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,   288,   239,    -1,    -1,   242,
      -1,    -1,    -1,   296,    -1,   271,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,   239,    -1,
      -1,   242,   288,     8,    -1,    10,    -1,    -1,   271,    -1,
     296,   324,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   308,    -1,    -1,   288,    -1,    -1,    -1,    -1,
     271,    -1,    -1,   296,    -1,    -1,    -1,    -1,   324,    -1,
     376,    -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,   324,    -1,   376,    -1,   239,    -1,   308,   242,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    10,   324,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    19,    20,    21,    -1,    -1,    -1,   271,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   376,   288,     8,    -1,    10,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,   308,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,   495,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   376,   516,    -1,    -1,    -1,    -1,    -1,   495,
      -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   495,    -1,   239,    -1,    -1,   242,    -1,    -1,
     526,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   495,   518,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,    -1,    -1,   271,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,    -1,   288,    -1,   526,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,   324,
      -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   271,    -1,    -1,   239,    -1,   522,   242,
      -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,   376,     8,    -1,    10,    -1,   239,    -1,   271,   242,
     308,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,   324,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,     8,    -1,    10,   271,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,     8,    -1,    10,
      -1,   324,    -1,   296,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,   308,    -1,    -1,   376,    -1,
      -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    -1,    19,    20,    21,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   376,     8,    -1,    10,   522,    -1,    -1,
      -1,   526,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,    -1,
      -1,    -1,   495,   239,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,
      -1,    -1,   495,   526,    -1,   271,   239,    -1,    -1,   242,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   288,   516,    -1,    -1,    -1,    -1,   239,    -1,
     296,   242,    -1,   526,    -1,    -1,    -1,    -1,   271,    -1,
      -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,   288,    -1,   242,   324,    -1,
     271,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,   239,   288,    -1,   242,
      -1,    -1,    -1,    -1,    -1,   296,   271,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,   271,    -1,
     376,   296,    -1,   324,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,   324,
      -1,    -1,    -1,   376,     8,   308,    10,   271,   239,    -1,
      -1,   242,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,   324,    -1,    -1,   288,   376,     8,    -1,    10,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    19,    20,    21,
     271,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,    -1,    -1,    -1,   288,    -1,     8,
     324,    10,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      19,    20,    21,   376,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,   495,
      -1,    -1,    -1,   324,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,   376,    -1,    -1,     8,   522,    10,    -1,    -1,
     526,    -1,   495,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,   495,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
     495,   522,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   495,    -1,    -1,    -1,    -1,   522,    -1,    -1,
      -1,   526,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,    -1,   239,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,   526,    -1,   495,    -1,    -1,   271,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,   288,   516,    -1,    -1,    -1,   271,
     239,    -1,   296,   242,    -1,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   308,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,   239,    -1,    -1,   242,
     324,    -1,   271,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,   324,    -1,    -1,    -1,   239,   296,   271,   242,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    19,    20,    21,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,   376,   296,    -1,   324,    -1,     8,   271,    10,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,   376,   288,    -1,    -1,    -1,    -1,
       8,   324,    10,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,   308,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,   376,    -1,    -1,
      -1,   324,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,   376,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,   495,    -1,    -1,    -1,    -1,   522,    -1,
      -1,    -1,   526,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
     522,    -1,    -1,     8,   526,    10,   495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,   495,   522,    -1,    -1,    -1,   526,    -1,    -1,
      -1,   239,    -1,    -1,   242,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,
      -1,    -1,   495,   526,    -1,    -1,    -1,    -1,   239,    -1,
      -1,   242,    -1,   271,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   239,    -1,   526,   242,    -1,    -1,    -1,   296,    -1,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,   239,    -1,    -1,   242,   288,    -1,    -1,
      -1,    -1,    -1,   271,    -1,   296,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   239,    -1,   308,   242,    -1,
     288,    -1,    -1,    -1,    -1,   271,    -1,    -1,   296,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,   239,    -1,
     308,   242,   288,    -1,    -1,    -1,    -1,   271,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,   324,    -1,   376,    -1,
      -1,    -1,   308,    -1,   288,    -1,    -1,    -1,    -1,    -1,
     271,    -1,   296,    -1,    -1,    -1,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,   308,   376,    -1,   288,    -1,    -1,
      -1,    -1,     8,    -1,    10,   296,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    19,    20,    21,    -1,   308,   376,    -1,
      -1,    -1,    -1,    -1,   239,    -1,     8,   242,    10,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    19,    20,    21,
     376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,   271,    -1,    -1,    -1,
      -1,    -1,   376,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,   430,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,   376,    -1,   495,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,   324,
       8,    -1,    10,    -1,   495,    -1,    -1,    -1,   526,    -1,
      -1,    19,    20,    21,    -1,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,   495,
      -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,   507,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,   495,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,    -1,    -1,    -1,   507,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,   526,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,     8,    -1,    10,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
     495,    -1,   288,   239,    -1,    -1,   242,    -1,    -1,   271,
     296,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   308,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,   526,    -1,    -1,   296,   271,    -1,    -1,   324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,     8,    -1,    10,
     296,   239,   324,    -1,   242,    -1,    -1,    -1,    19,    20,
      21,    -1,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,   324,    10,
     376,    -1,    -1,   271,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,   376,    -1,    -1,    -1,   296,    -1,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,     8,    -1,    10,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,
      -1,    -1,   239,    -1,    -1,   242,    -1,    -1,    -1,    -1,
      -1,   507,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,    -1,    -1,   271,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,   518,    -1,    -1,   495,
      -1,   288,    -1,    -1,   526,    -1,    -1,    -1,    -1,   296,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,    -1,
     516,   308,    -1,    -1,    -1,    -1,   522,    -1,   239,    -1,
     526,   242,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,   239,    -1,
     271,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     508,   509,   510,   511,   512,   513,   514,   288,   516,    -1,
      -1,    -1,    -1,    -1,   522,   296,    -1,    -1,   526,   376,
     271,   239,    -1,    -1,   242,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,   324,   239,   296,    -1,   242,    -1,    -1,
      -1,    -1,    -1,   271,    -1,    -1,    -1,   308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,   324,    -1,     8,   271,    10,   296,   239,
      -1,    -1,   242,    -1,    -1,    -1,    19,    20,    21,    -1,
     308,    -1,    -1,   288,    -1,   376,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    -1,    -1,     8,   324,    10,    -1,    -1,
      -1,   271,    -1,   308,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,   288,   324,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   495,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,   508,   509,   510,   511,   512,   513,   514,   376,   516,
      -1,     8,    -1,    10,   324,   522,    -1,    -1,    -1,   526,
      -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    -1,
      -1,    -1,    -1,    -1,   495,    -1,   376,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
      -1,   522,    -1,    -1,   495,   526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,
     511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,
       8,   522,    10,    -1,    -1,   526,    -1,   495,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
     495,    -1,    -1,    -1,    -1,    -1,   239,    -1,   526,   242,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,    -1,    -1,    -1,    -1,   522,    -1,    -1,
      -1,   526,    -1,    -1,    -1,   495,   239,    -1,   271,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,   511,   512,   513,   514,   288,   516,    -1,    -1,    -1,
      -1,    -1,   522,   296,    -1,    -1,   526,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,   324,   239,   296,    -1,   242,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,
      -1,   324,    -1,    -1,   271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,   288,    -1,   376,    -1,    -1,   271,    -1,    -1,   296,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   308,    -1,   288,    -1,    -1,    -1,    -1,     8,   271,
      10,   296,    -1,   376,    -1,    -1,    -1,   324,    -1,    19,
      20,    21,    -1,   308,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,   324,
      -1,   239,    -1,     8,   242,    10,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,   376,
       8,    -1,    10,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
     288,   376,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,    -1,   376,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,   324,    -1,    -1,   522,
      -1,    -1,   495,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,     8,    -1,    10,    -1,    -1,   522,
      -1,    -1,    -1,   526,    -1,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    10,    -1,   495,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,    -1,
      -1,   508,   509,   510,   511,   512,   513,   514,    -1,   516,
     495,    -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,
      -1,    -1,    -1,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,    -1,   495,    -1,    -1,    -1,   522,    -1,   239,
      -1,   526,   242,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,    -1,
      -1,   271,    -1,    -1,   239,    -1,    -1,   242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,   495,    -1,    -1,
      -1,   239,    -1,    -1,   242,    -1,   271,    -1,   308,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,   288,   324,    -1,    -1,    -1,   526,    -1,
      -1,   296,    -1,   271,    -1,     8,    -1,    10,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    19,    20,    21,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     308,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   239,   324,    -1,   242,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   376,    -1,    -1,    -1,   239,    -1,   271,   242,     8,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    20,    21,    -1,   288,    -1,    -1,    -1,   376,    -1,
      -1,    -1,   296,    -1,    -1,    -1,     8,   271,    10,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
     324,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    10,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,   495,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,   376,    -1,    -1,    -1,   526,    -1,    -1,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
      -1,   516,   376,    -1,    -1,    -1,    -1,   495,    -1,    -1,
      -1,   526,    -1,    -1,    -1,    -1,   239,    -1,    -1,   242,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,   522,    -1,    -1,    -1,   526,     8,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,   271,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,
      -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,   324,    -1,   242,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,    -1,
      -1,   495,   526,    -1,    -1,    -1,    -1,   239,    -1,    -1,
     242,    -1,   271,    -1,   508,   509,   510,   511,   512,   513,
     514,    -1,   516,    -1,    -1,    -1,    -1,    -1,   522,   288,
      -1,    -1,   526,   376,    -1,    -1,    -1,   296,    -1,   271,
     239,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,     8,    -1,
      10,    -1,    -1,    -1,   296,   324,    -1,    -1,    -1,    19,
      20,    21,   271,    -1,    -1,    -1,   308,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,   288,
      10,    -1,   324,    -1,    -1,    -1,    -1,   296,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
     239,    -1,   495,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,   516,    -1,    -1,    -1,   376,     8,    -1,
      10,    -1,   271,   526,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
       8,    -1,    10,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,   495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,    -1,   376,    -1,   239,
      -1,    -1,   242,    -1,   526,    -1,   495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,   239,
      -1,   271,   242,   522,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,   308,   239,
      -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,   324,    -1,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   324,    -1,   495,    -1,   288,   239,
      -1,    -1,   242,    -1,    -1,    -1,   296,    -1,   507,   508,
     509,   510,   511,   512,   513,   514,   376,   516,   308,    -1,
      -1,   239,    -1,    -1,   242,    -1,     8,   526,    10,    -1,
      -1,   271,    -1,    -1,   324,    -1,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,   288,     8,
      -1,    10,    -1,   271,    -1,    -1,   296,    -1,    -1,    -1,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,   308,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,   324,    -1,   376,    -1,    -1,    -1,
     308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   495,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,   376,    -1,
      -1,    -1,    -1,    -1,    -1,   495,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   495,    -1,   239,    -1,    -1,
     242,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,   509,
     510,   511,   512,   513,   514,    -1,   516,   495,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,   271,
     508,   509,   510,   511,   512,   513,   514,    -1,   516,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,   526,    -1,
      -1,    -1,   271,    -1,   296,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   508,   509,   510,   511,
     512,   513,   514,    -1,   516,    -1,   495,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   526,    -1,    -1,    -1,    -1,   508,
     509,   510,   511,   512,   513,   514,    -1,   516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,    11,    12,    17,    27,    28,    29,    31,    32,
      34,    36,    38,    41,    42,    44,    45,    46,    61,    62,
      63,    67,    68,    73,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,   200,   201,   202,   206,   209,
     210,   211,   220,   229,   230,   231,   233,   234,   235,   241,
     243,   244,   246,   247,   248,   253,   254,   255,   256,   257,
     262,   263,   265,   266,   267,   268,   275,   282,   283,   290,
     291,   310,   311,   313,   315,   316,   318,   319,   320,   321,
     323,   331,   332,   333,   334,   336,   338,   339,   341,   342,
     343,   344,   345,   346,   349,   355,   357,   359,   360,   361,
     365,   366,   372,   374,   375,   379,   380,   381,   382,   383,
     389,   390,   391,   392,   397,   398,   399,   401,   404,   406,
     407,   408,   409,   410,   412,   414,   415,   416,   418,   419,
     422,   423,   429,   433,   434,   436,   440,   450,   459,   460,
     462,   464,   466,   483,   484,   486,   488,   489,   490,   492,
     493,   494,   505,   506,   521,   525,   528,   530,   531,   532,
     538,   539,   540,   571,   572,   573,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   589,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,     3,     4,     5,    13,    14,    15,
      16,    18,    22,    23,    24,    25,    26,    30,    33,    35,
      37,    39,    40,    43,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    64,    65,
      66,    69,    70,    71,    72,    74,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   203,
     204,   205,   208,   212,   213,   214,   215,   216,   217,   218,
     219,   221,   222,   223,   224,   225,   226,   227,   228,   232,
     236,   237,   238,   240,   245,   249,   250,   251,   252,   258,
     259,   260,   261,   264,   269,   270,   272,   273,   274,   276,
     277,   278,   279,   280,   281,   284,   285,   286,   287,   289,
     292,   293,   294,   295,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   309,   312,   314,   317,   322,   325,
     326,   327,   328,   329,   330,   335,   337,   340,   347,   348,
     350,   351,   352,   353,   354,   356,   362,   363,   364,   367,
     368,   369,   370,   371,   373,   378,   384,   385,   386,   387,
     388,   393,   394,   395,   396,   400,   402,   403,   405,   411,
     413,   417,   420,   421,   424,   425,   426,   427,   428,   431,
     435,   437,   438,   442,   443,   444,   445,   446,   447,   448,
     449,   451,   452,   453,   454,   455,   456,   457,   458,   461,
     463,   465,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   485,   487,
     491,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     511,   512,   519,   521,   538,   539,   540,   544,   548,   563,
     564,   565,   566,   567,   568,   569,   570,   521,   558,   559,
     563,   563,   521,   538,   574,   563,   558,   559,   521,   556,
     563,   521,   552,   563,   521,   552,   552,   563,   552,   552,
     563,   521,   552,   553,   563,   521,   553,   563,   553,   563,
     521,   553,   556,   563,   538,   539,   540,   563,   521,   557,
     563,   552,   552,   521,   553,   556,   557,   563,   538,   538,
     538,   521,   538,   539,   541,   543,   538,   538,   553,   556,
     563,   563,   563,   563,   553,   563,   521,   556,   557,   558,
     559,   563,   521,   558,   563,   556,   557,   558,   559,   553,
     556,   553,   556,   553,   563,   521,   556,   557,   563,   563,
     521,   561,   562,   563,   521,   556,   557,   558,   563,   553,
     563,   521,   538,   540,   554,   555,   563,   538,   540,   554,
     555,   538,   540,   554,   555,   538,   540,   554,   555,   563,
     602,   603,   604,   557,   563,   543,   552,   563,   553,   556,
     553,   563,   553,   563,   538,   552,   538,   553,   563,   553,
     563,   521,   553,   556,   557,   558,   559,   560,   563,   563,
     563,   563,   563,   558,   559,   553,   563,   553,   521,   547,
     552,   563,   552,   552,   552,   552,   556,   521,   557,   558,
     559,   563,   539,   540,   552,   563,   552,   563,   552,   563,
     563,   563,   553,   563,   563,   563,   553,   556,   563,   552,
     563,   556,   553,   563,   521,   552,   557,   563,   556,   557,
     552,   553,   563,   553,   563,   552,   563,   552,   553,   563,
     552,   563,   553,   563,   552,   563,   563,   553,   563,   552,
     563,   553,   563,   563,   563,   553,   556,   557,   558,   559,
     556,   557,   558,   559,   553,   563,   558,   556,   557,   558,
     538,   563,   521,   556,   558,   559,   563,   563,   539,   540,
     563,   588,   539,   563,   552,   552,   563,   563,   552,   552,
     590,   553,   563,   553,   563,   553,   563,   538,   539,   540,
     521,   547,   552,   563,     0,   523,   529,   361,   532,   361,
       5,     6,     9,    75,   307,   377,   431,   432,   517,   533,
     537,   207,   510,     5,     6,     9,    75,   307,   377,   431,
     432,   510,   524,   532,   532,   521,   521,   521,   538,   540,
     521,   521,   521,   521,   563,   552,   552,   521,   552,   552,
     552,   521,   521,   552,   552,   552,   552,   521,   521,   521,
     521,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   521,   521,   521,   521,   552,   521,   521,   521,
     521,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   521,   521,   553,   556,   553,   521,
     552,   521,   552,   552,   552,   521,   521,   521,   521,   552,
     552,   552,   552,   552,   552,   521,   521,   557,   558,   563,
     552,   552,   552,   552,   552,   521,   552,   521,   521,   521,
     521,   552,   552,   552,   521,   521,   521,   521,   521,   521,
     552,   521,   552,   552,   552,   552,   552,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   521,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   521,
     552,   521,   552,   563,   521,   552,   552,   552,   552,   552,
     552,   552,   521,   521,   521,   552,   521,   552,   521,   552,
     521,   552,   521,   552,   552,   521,   521,   521,   521,   521,
     521,   521,   521,   552,   521,   521,   521,   552,   552,   552,
     552,   552,   521,   552,   521,   521,   521,   521,   552,   552,
     521,   552,   521,   521,   521,   521,   521,   521,   521,   521,
     521,   521,   538,   540,   521,   521,   552,   521,   521,   521,
     521,   521,   521,   521,   521,   521,   521,   552,   552,   552,
     552,   552,   552,   552,   521,   521,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   552,   521,   563,
     499,   500,   519,   545,   546,   547,   549,   563,   538,   539,
     540,   563,     5,   431,   517,   521,   533,   534,   535,   536,
       5,   431,     8,    10,    19,    20,    21,   239,   242,   271,
     288,   296,   308,   324,   376,   495,   508,   509,   510,   511,
     512,   513,   514,   516,   526,   558,   559,   563,   507,   538,
     521,   563,   556,   563,   507,   522,   553,   563,   507,   563,
     507,   207,   510,   553,   563,   207,   557,   563,   507,   563,
     507,   510,   242,   511,   521,   542,   538,   517,   507,   439,
     563,   507,   563,   507,   563,   507,   561,   562,   563,   507,
     563,   507,   554,   555,   563,   507,   521,   560,   563,   507,
     547,   563,   376,   507,   563,   507,   553,   563,   207,   542,
     563,   507,   563,   563,   522,   522,   522,   547,   376,   528,
     361,   563,   563,   563,   563,   563,   563,   518,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   532,    79,
     563,   563,   538,   517,   563,   563,   539,   540,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   507,   563,   563,   563,   563,   556,
     563,   553,   556,   563,   563,   563,   563,   563,   563,   563,
     563,   553,   556,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   556,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   556,   563,   563,   553,   556,   553,   563,   563,
     563,   563,   563,   563,   553,   563,   563,   553,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   553,   547,   520,   507,   520,
     511,   522,   507,   525,   358,   522,   550,   551,   563,   517,
     534,   533,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   522,   522,   563,   522,   550,
     522,   563,   522,   563,   563,   563,   563,   207,   207,   563,
     522,   563,   563,   563,   570,   509,   522,   543,   543,   563,
     563,   563,   522,   522,   563,   563,   522,   522,   538,   540,
     522,   550,   522,   563,   522,   547,   563,   563,   207,   207,
     563,   563,   522,   507,   518,   522,   522,   522,   522,   522,
     522,   522,   522,   522,   522,   507,   522,   522,   507,   507,
     507,   522,   507,   522,   507,   522,   507,   522,   507,   522,
     522,   522,   522,   522,   522,   522,   522,   522,   522,   522,
     507,   507,   563,   507,   522,   522,   522,   507,   522,   522,
     522,   522,   522,   507,   507,   522,   522,   522,   507,   522,
     522,   522,   522,   522,   522,   522,   522,   507,   507,   522,
     522,   522,   507,   522,   507,   522,   522,   522,   522,   522,
     507,   507,   522,   507,   507,   522,   522,   522,   522,   522,
     522,   522,   522,   522,   522,   522,   522,   522,   522,   522,
     522,   507,   522,   522,   522,   522,   522,   522,   522,   522,
     522,   522,   507,   507,   522,   522,   522,   522,   522,   522,
     507,   522,   522,   522,   522,   522,   522,   520,   545,   509,
     525,   507,   518,   521,   522,   507,   525,   507,   522,   507,
     563,   563,   507,   507,   441,   538,   522,   507,   507,   507,
     507,   522,   507,   507,   563,   563,   507,   563,   517,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   507,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   518,   518,
     538,   550,   563,   563,   563,   563,   563,   242,   563,   563,
     563,   563,   563,   563,   563,   518,   563,   522,   507,   522,
     522,   507,   522,   507,   522,   507,   522,   522,   507,   522,
     522,   522,   563,   507,   507,   522,   507,   522,   507,   522,
     522,   507,   507,   522,   522,   522,   507,   507,   507,   522,
     507,   522,   522,   522,   522,   507,   522,   507,   507,   430,
     570,   507,   507,   507,   507,   507,   518,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   549,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   522,   522,   522,   522,   522,   507,   522,   507,
     522,   522,   522,   522,   507,   522,   522,   507,   522,   522,
     507,   507,   507,   507,   563,   563,   563,   563,   563,   563,
     563,   563,   507,   522,   522,   522,   522,   507,   507,   507,
     563,   563,   563,   563,   522,   507,   507,   563,   563,   507,
     563,   507,   563,   507,   563
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   527,   528,   528,   529,   530,   530,   530,   530,   530,
     530,   530,   530,   531,   532,   532,   533,   534,   535,   535,
     536,   536,   537,   537,   537,   538,   538,   539,   539,   539,
     540,   540,   541,   542,   542,   543,   543,   544,   545,   545,
     545,   546,   547,   547,   548,   549,   549,   550,   550,   551,
     551,   552,   552,   553,   553,   554,   554,   555,   555,   556,
     556,   557,   557,   558,   558,   559,   559,   560,   560,   561,
     561,   562,   562,   563,   563,   563,   563,   563,   563,   563,
     563,   564,   564,   564,   564,   564,   565,   565,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   569,   569,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   572,   574,   573,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     588,   587,   590,   589,   591,   591,   591,   591,   591,   591,
     592,   593,   593,   593,   593,   593,   593,   593,   593,   594,
     594,   594,   594,   594,   594,   595,   596,   597,   597,   597,
     598,   599,   599,   600,   601,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   603,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   605,   605,   606,   606,   607,   607,
     608,   609,   610,   610,   611,   612,   612,   612,   613,   613,
     614,   614,   614,   615,   615,   616,   616,   616,   617,   617,
     618,   618,   619,   619,   620,   620,   621,   621,   622,   623,
     623,   623,   624,   624,   624,   625,   625,   626,   626,   627,
     627,   628,   628,   629,   630,   631,   632,   633,   633,   634,
     634,   635,   635,   636,   636,   636,   637,   637,   637,   638,
     638,   638,   638,   639,   640,   641,   642,   643,   643,   643,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     645,   645,   646,   646,   647,   647,   648,   648,   649,   649,
     650,   651,   651,   652,   652,   652,   652,   652,   652,   652,
     652,   652,   652,   652,   652,   652,   652,   652,   652,   653,
     653,   653,   653,   653,   653,   653,   653,   654,   655,   655,
     656,   657,   658,   659,   660,   660,   660,   661,   662,   663,
     664,   665,   665,   665,   665,   666,   666,   666,   666,   667,
     668,   669,   670,   671,   671,   672,   672,   673,   673,   674,
     674,   674,   675,   675,   675,   676,   676,   677,   677,   678,
     678,   679,   679,   680,   681,   682,   683,   684,   685,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   710,   711,   712,   713,   713,
     714,   714,   715,   715,   716,   716,   716,   716,   717,   717,
     717,   717,   718,   718,   719,   720,   720,   721,   722,   723,
     723,   724
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     1,     1,     2,     3,     1,     2,     1,
       2,     1,     0,     1,     3,     1,     2,     3,     4,     2,
       4,     2,     5,     6,     3,     1,     3,     1,     2,     3,
       2,     3,     1,     2,     3,     1,     3,     3,     1,     1,
       3,     3,     1,     3,     3,     4,     6,     1,     3,     1,
       4,     2,     0,     3,     3,     3,     3,     3,     3,     5,
       3,     7,     3,     9,     3,    11,     3,    13,     3,    17,
       3,    19,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     4,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     4,     4,     4,     6,     8,    10,     6,     8,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     2,     2,     2,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
       4,     2,     4,     2,     2,     2,     2,     2,     2,     6,
       8,    10,     2,     2,     2,     8,     6,     4,     4,     4,
       4,     4,     4,     4,     4,     2,     4,     6,     4,     6,
       8,     4,     6,     8,     4,     6,     8,     2,     2,     2,
       4,     4,     6,     8,     6,     2,     2,     4,     6,     2,
       6,     2,     4,     2,     2,     4,     2,     2,     2,     4,
       6,     4,     4,     4,     6,     1,     1,     1,     2,     2,
       2,     4,     4,     4,     2,     4,     2,     4,     2,     4,
       2,     2,     4,     4,     4,     4,     4,     4,     4,     2,
       2,     2,     2,     1,     4,     4,     4,     4,     8,     6,
       8,     6,     6,     2,     4,     2,     4,     2,     4,     6,
       8,     2,     2,     2,     4,     2,     4,     2,     2,     6,
       4,     2,     8,    10,     8,     4,     4,     4,     4,     4,
       6,     4,     4,     4,     6,     4,     4,     4,     4,     4,
       2,     2,     2,     4,     4,     4,     8,     6,     4,    12,
      10,     4,     2,     4,     4,     4,     4,     4,     4,     4,
       1,     1,     1,     4,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     2,     3,     1,
       0,     3,     0,     3,     2,     2,     2,     1,     1,     1,
       2,     2,     4,     3,     5,     3,     5,     4,     4,     2,
       4,     3,     5,     3,     5,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     3,     3,
       3,     3,     3,     3,     6,     8,     4,     7,     2,     1,
       2,     2,     4,     5,     2,     2,     4,     5,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     4,     2,     3,     2,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     3,
       3,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* programnewline: '\n'  */
             {
		linenumber++;
		column=0;
		addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
	}
    break;

  case 13: /* label: B256LABEL  */
                  {
		if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
			errorcode = COMPERR_FUNCTIONGOTO;
			return -1;
		}
		//
		//check if name of label is already used by a function, subroutine or another label
		if (symtableaddress[(yyvsp[0].number)] != -1) {
			errorcode = COMPERR_LABELREDEFINED;
			return -1;
		}
		symtableaddress[(yyvsp[0].number)] = wordOffset;
		symtableaddresstype[(yyvsp[0].number)] = ADDRESSTYPE_LABEL;
	}
    break;

  case 24: /* array_indexing: '[' expr ']'  */
                       {
		addIntOp(OP_PUSHINT, 0);
		addOp(OP_STACKSWAP);
	}
    break;

  case 25: /* variable: B256VARIABLE  */
                     {
		varnumber[nvarnumber++] = (yyvsp[0].number);
	}
    break;

  case 32: /* functionvariable: variable_a  */
                           {
			args[numargs] = varnumber[--nvarnumber]; argstype[numargs] = ARGSTYPEVALUE; numargs++;
			//printf("functionvariable %i %i %i\n", args[numargs-1], argstype[numargs-1],numargs);
		}
    break;

  case 37: /* listoflists: '{' listinlist '}'  */
                          {
		addIntOp(OP_PUSHINT, numberoflists);		// number of lists (y dim)
		addIntOp(OP_PUSHINT, listlenmax);			// maximum number of expressions (x dim)
#ifdef DEBUG
	fprintf(stderr, "listlenmax %d\n", listlenmax);
#endif
		numberoflists = 0;
		listlenmax=0;
	}
    break;

  case 38: /* listinlist: listitems  */
                  {
		addIntOp(OP_PUSHINT, listlen);
		if (listlen>listlenmax) listlenmax=listlen;
		listlen = 0;
		numberoflists = 1;
	}
    break;

  case 39: /* listinlist: listofitems  */
                      {numberoflists = 1; }
    break;

  case 40: /* listinlist: listofitems ',' listinlist  */
                                     {numberoflists++;}
    break;

  case 41: /* listofitems: '{' listitems '}'  */
                          {
		addIntOp(OP_PUSHINT, listlen);
		if (listlen>listlenmax) listlenmax=listlen;
		listlen = 0;
	}
    break;

  case 42: /* listitems: expr  */
             { listlen = 1; }
    break;

  case 43: /* listitems: expr ',' listitems  */
                             {listlen++;}
    break;

  case 44: /* listofmapitems: '{' mapitems '}'  */
                         {
		addIntOp(OP_PUSHINT, listlen);
		if (listlen>listlenmax) listlenmax=listlen;
		listlen = 0;
		numberoflists = 0;
		listlenmax=0;
	}
    break;

  case 45: /* mapitems: expr '-' '>' expr  */
                          { listlen = 1; }
    break;

  case 46: /* mapitems: expr '-' '>' expr ',' mapitems  */
                                         {listlen++;}
    break;

  case 47: /* callexprlist: callexpr  */
                 { listlen = 1; }
    break;

  case 48: /* callexprlist: callexpr ',' callexprlist  */
                                    {listlen++;}
    break;

  case 50: /* callexpr: B256REF '(' variable ')'  */
                                   { addIntOp(OP_VAR_REF, varnumber[--nvarnumber]); }
    break;

  case 80: /* expr: array_element  */
                        {
		addIntOp(OP_ARR_GET, varnumber[--nvarnumber]);
	}
    break;

  case 82: /* expr_multi: expr '+' expr  */
                        {
		addOp(OP_ADD);
	}
    break;

  case 83: /* expr_multi: expr B256SEMICOLON expr  */
                                  {
		addOp(OP_CONCATENATE);
	}
    break;

  case 84: /* expr_multi: expr B256AMP expr  */
                            {
		addOp(OP_BINARYAND);
	}
    break;

  case 85: /* expr_multi: expr '*' expr  */
                        {
		addOp(OP_MUL);
	}
    break;

  case 86: /* expr_function: variable '(' callexprlist ')'  */
                                      {
		// function call with arguments
		addIntOp(OP_PUSHINT, listlen); //push number of arguments passed to compare with FUNCTION definition
		addIntOp(OP_CALLFUNCTION, varnumber[--nvarnumber]);
		addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
	}
    break;

  case 87: /* expr_function: variable '(' ')'  */
                           {
		// function call without arguments
		addIntOp(OP_PUSHINT, 0); //push number of arguments passed to compare with FUNCTION definition
		addIntOp(OP_CALLFUNCTION, varnumber[--nvarnumber]);
		addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
	}
    break;

  case 88: /* expr_constants: B256BLACK args_none  */
                            { addIntOp(OP_PUSHINT, 0xff000000); }
    break;

  case 89: /* expr_constants: B256BLUE args_none  */
                             { addIntOp(OP_PUSHINT, 0xff0000ff); }
    break;

  case 90: /* expr_constants: B256BOOLFALSE args_none  */
                                  { addIntOp(OP_PUSHINT, 0); }
    break;

  case 91: /* expr_constants: B256BOOLTRUE args_none  */
                                 { addIntOp(OP_PUSHINT, 1); }
    break;

  case 92: /* expr_constants: B256CLEAR args_none  */
                              { addIntOp(OP_PUSHINT, 0x00); }
    break;

  case 93: /* expr_constants: B256CYAN args_none  */
                             { addIntOp(OP_PUSHINT, 0xff00ffff); }
    break;

  case 94: /* expr_constants: B256DARKBLUE args_none  */
                                 { addIntOp(OP_PUSHINT, 0xff000080); }
    break;

  case 95: /* expr_constants: B256DARKCYAN args_none  */
                                 { addIntOp(OP_PUSHINT, 0xff008080); }
    break;

  case 96: /* expr_constants: B256DARKGREEN args_none  */
                                  { addIntOp(OP_PUSHINT, 0xff008000); }
    break;

  case 97: /* expr_constants: B256DARKGREY args_none  */
                                 { addIntOp(OP_PUSHINT, 0xff808080); }
    break;

  case 98: /* expr_constants: B256DARKORANGE args_none  */
                                   { addIntOp(OP_PUSHINT, 0xffb03d00); }
    break;

  case 99: /* expr_constants: B256DARKPURPLE args_none  */
                                   { addIntOp(OP_PUSHINT, 0xff800080); }
    break;

  case 100: /* expr_constants: B256DARKRED args_none  */
                                { addIntOp(OP_PUSHINT, 0xff800000); }
    break;

  case 101: /* expr_constants: B256DARKYELLOW args_none  */
                                   { addIntOp(OP_PUSHINT, 0xff808000); }
    break;

  case 102: /* expr_constants: B256GREEN args_none  */
                              { addIntOp(OP_PUSHINT, 0xff00ff00); }
    break;

  case 103: /* expr_constants: B256GREY args_none  */
                             { addIntOp(OP_PUSHINT, 0xffa4a4a4); }
    break;

  case 104: /* expr_constants: B256MOUSEBUTTON_CENTER args_none  */
                                           { addIntOp(OP_PUSHINT, MOUSEBUTTON_CENTER); }
    break;

  case 105: /* expr_constants: B256MOUSEBUTTON_DOUBLECLICK args_none  */
                                                { addIntOp(OP_PUSHINT, MOUSEBUTTON_DOUBLECLICK); }
    break;

  case 106: /* expr_constants: B256MOUSEBUTTON_LEFT args_none  */
                                         { addIntOp(OP_PUSHINT, MOUSEBUTTON_LEFT); }
    break;

  case 107: /* expr_constants: B256MOUSEBUTTON_NONE args_none  */
                                         { addIntOp(OP_PUSHINT, MOUSEBUTTON_NONE); }
    break;

  case 108: /* expr_constants: B256MOUSEBUTTON_RIGHT args_none  */
                                          { addIntOp(OP_PUSHINT, MOUSEBUTTON_RIGHT); }
    break;

  case 109: /* expr_constants: B256ORANGE args_none  */
                               { addIntOp(OP_PUSHINT, 0xffff6600); }
    break;

  case 110: /* expr_constants: B256OSTYPE_ANDROID args_none  */
                                       { addIntOp(OP_PUSHINT, OSTYPE_ANDROID); }
    break;

  case 111: /* expr_constants: B256OSTYPE_LINUX args_none  */
                                     { addIntOp(OP_PUSHINT, OSTYPE_LINUX); }
    break;

  case 112: /* expr_constants: B256OSTYPE_MACINTOSH args_none  */
                                         { addIntOp(OP_PUSHINT, OSTYPE_MACINTOSH); }
    break;

  case 113: /* expr_constants: B256OSTYPE_WINDOWS args_none  */
                                       { addIntOp(OP_PUSHINT, OSTYPE_WINDOWS); }
    break;

  case 114: /* expr_constants: B256PURPLE args_none  */
                               { addIntOp(OP_PUSHINT, 0xffff00ff); }
    break;

  case 115: /* expr_constants: B256RED args_none  */
                            { addIntOp(OP_PUSHINT, 0xffff0000); }
    break;

  case 116: /* expr_constants: B256SLICE_ALL args_none  */
                                  { addIntOp(OP_PUSHINT, SLICE_ALL); }
    break;

  case 117: /* expr_constants: B256SLICE_PAINT args_none  */
                                    { addIntOp(OP_PUSHINT, SLICE_PAINT); }
    break;

  case 118: /* expr_constants: B256SLICE_SPRITE args_none  */
                                     { addIntOp(OP_PUSHINT, SLICE_SPRITE); }
    break;

  case 119: /* expr_constants: B256TYPE_ARRAY args_none  */
                                   { addIntOp(OP_PUSHINT, T_ARRAY); }
    break;

  case 120: /* expr_constants: B256TYPE_FLOAT args_none  */
                                   { addIntOp(OP_PUSHINT, T_FLOAT); }
    break;

  case 121: /* expr_constants: B256TYPE_INT args_none  */
                                 { addIntOp(OP_PUSHINT, T_INT); }
    break;

  case 122: /* expr_constants: B256TYPE_MAP args_none  */
                                 { addIntOp(OP_PUSHINT, T_MAP); }
    break;

  case 123: /* expr_constants: B256TYPE_REF args_none  */
                                 { addIntOp(OP_PUSHINT, T_REF); }
    break;

  case 124: /* expr_constants: B256TYPE_STRING args_none  */
                                    { addIntOp(OP_PUSHINT, T_STRING); }
    break;

  case 125: /* expr_constants: B256TYPE_UNASSIGNED args_none  */
                                        { addIntOp(OP_PUSHINT, T_UNASSIGNED); }
    break;

  case 126: /* expr_constants: B256WHITE args_none  */
                              { addIntOp(OP_PUSHINT, 0xffffffff); }
    break;

  case 127: /* expr_constants: B256YELLOW args_none  */
                               { addIntOp(OP_PUSHINT, 0xffffff00); }
    break;

  case 128: /* expr_errors: B256ERROR_ARGUMENTCOUNT args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_ARGUMENTCOUNT);
	}
    break;

  case 129: /* expr_errors: B256ERROR_ARRAYELEMENT args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_ARRAYELEMENT);
	}
    break;

  case 130: /* expr_errors: B256ERROR_ARRAYEVEN args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_ARRAYEVEN);
	}
    break;

  case 131: /* expr_errors: B256ERROR_ARRAYEXPR args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_ARRAYEXPR);
	}
    break;

  case 132: /* expr_errors: B256ERROR_ARRAYINDEX args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_ARRAYINDEX);
	}
    break;

  case 133: /* expr_errors: B256ERROR_ARRAYINDEXMISSING args_none  */
                                                {
		addIntOp(OP_PUSHINT, ERROR_ARRAYINDEXMISSING);
	}
    break;

  case 134: /* expr_errors: B256ERROR_ARRAYLENGTH2D args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_ARRAYLENGTH2D);
	}
    break;

  case 135: /* expr_errors: B256ERROR_ARRAYNITEMS args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_ARRAYNITEMS);
	}
    break;

  case 136: /* expr_errors: B256ERROR_ARRAYSIZELARGE args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_ARRAYSIZELARGE);
	}
    break;

  case 137: /* expr_errors: B256ERROR_ARRAYSIZESMALL args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_ARRAYSIZESMALL);
	}
    break;

  case 138: /* expr_errors: B256ERROR_ASINACOSRANGE args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_ASINACOSRANGE);
	}
    break;

  case 139: /* expr_errors: B256ERROR_BOOLEANCONV args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_BOOLEANCONV);
	}
    break;

  case 140: /* expr_errors: B256ERROR_DBCOLNO args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_DBCOLNO);
	}
    break;

  case 141: /* expr_errors: B256ERROR_DBCONNNUMBER args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_DBCONNNUMBER);
	}
    break;

  case 142: /* expr_errors: B256ERROR_DBNOTOPEN args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_DBNOTOPEN);
	}
    break;

  case 143: /* expr_errors: B256ERROR_DBNOTSET args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_DBNOTSET);
	}
    break;

  case 144: /* expr_errors: B256ERROR_DBNOTSETROW args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_DBNOTSETROW);
	}
    break;

  case 145: /* expr_errors: B256ERROR_DBOPEN args_none  */
                                     {
		addIntOp(OP_PUSHINT, ERROR_DBOPEN);
	}
    break;

  case 146: /* expr_errors: B256ERROR_DBQUERY args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_DBQUERY);
	}
    break;

  case 147: /* expr_errors: B256ERROR_DBSETNUMBER args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_DBSETNUMBER);
	}
    break;

  case 148: /* expr_errors: B256ERROR_DIVZERO args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_DIVZERO);
	}
    break;

  case 149: /* expr_errors: B256ERROR_DOWNLOAD args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_DOWNLOAD);
	}
    break;

  case 150: /* expr_errors: B256ERROR_ENVELOPEMAX args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_ENVELOPEMAX);
	}
    break;

  case 151: /* expr_errors: B256ERROR_ENVELOPEODD args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_ENVELOPEODD);
	}
    break;

  case 152: /* expr_errors: B256ERROR_EXPECTEDARRAY args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_EXPECTEDARRAY);
	}
    break;

  case 153: /* expr_errors: B256ERROR_EXPECTEDSOUND args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_EXPECTEDSOUND);
	}
    break;

  case 154: /* expr_errors: B256ERROR_FILENOTOPEN args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_FILENOTOPEN);
	}
    break;

  case 155: /* expr_errors: B256ERROR_FILENUMBER args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_FILENUMBER);
	}
    break;

  case 156: /* expr_errors: B256ERROR_FILEOPEN args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_FILEOPEN);
	}
    break;

  case 157: /* expr_errors: B256ERROR_FILEOPERATION args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_FILEOPERATION);
	}
    break;

  case 158: /* expr_errors: B256ERROR_FILERESET args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_FILERESET);
	}
    break;

  case 159: /* expr_errors: B256ERROR_FILEWRITE args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_FILEWRITE);
	}
    break;

  case 160: /* expr_errors: B256ERROR_FOLDER args_none  */
                                     {
		addIntOp(OP_PUSHINT, ERROR_FOLDER);
	}
    break;

  case 161: /* expr_errors: B256ERROR_FREEDB args_none  */
                                     {
		addIntOp(OP_PUSHINT, ERROR_FREEDB);
	}
    break;

  case 162: /* expr_errors: B256ERROR_FREEDBSET args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_FREEDBSET);
	}
    break;

  case 163: /* expr_errors: B256ERROR_FREEFILE args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_FREEFILE);
	}
    break;

  case 164: /* expr_errors: B256ERROR_FREENET args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_FREENET);
	}
    break;

  case 165: /* expr_errors: B256ERROR_HARMONICLIST args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_HARMONICLIST);
	}
    break;

  case 166: /* expr_errors: B256ERROR_HARMONICNUMBER args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_HARMONICNUMBER);
	}
    break;

  case 167: /* expr_errors: B256ERROR_IMAGEFILE args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_IMAGEFILE);
	}
    break;

  case 168: /* expr_errors: B256ERROR_IMAGERESOURCE args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_IMAGERESOURCE);
	}
    break;

  case 169: /* expr_errors: B256ERROR_IMAGESAVETYPE args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_IMAGESAVETYPE);
	}
    break;

  case 170: /* expr_errors: B256ERROR_IMAGESCALE args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_IMAGESCALE);
	}
    break;

  case 171: /* expr_errors: B256ERROR_INFINITY args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_INFINITY);
	}
    break;

  case 172: /* expr_errors: B256ERROR_INTEGERRANGE args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_INTEGERRANGE);
	}
    break;

  case 173: /* expr_errors: B256ERROR_INVALIDKEYNAME args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_INVALIDKEYNAME);
	}
    break;

  case 174: /* expr_errors: B256ERROR_INVALIDPROGNAME args_none  */
                                              {
		addIntOp(OP_PUSHINT, ERROR_INVALIDPROGNAME);
	}
    break;

  case 175: /* expr_errors: B256ERROR_INVALIDRESOURCE args_none  */
                                              {
		addIntOp(OP_PUSHINT, ERROR_INVALIDRESOURCE);
	}
    break;

  case 176: /* expr_errors: B256ERROR_LOGRANGE args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_LOGRANGE);
	}
    break;

  case 177: /* expr_errors: B256ERROR_LONGRANGE args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_LONGRANGE);
	}
    break;

  case 178: /* expr_errors: B256ERROR_MAXRECURSE args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_MAXRECURSE);
	}
    break;

  case 179: /* expr_errors: B256ERROR_NETACCEPT args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_NETACCEPT);
	}
    break;

  case 180: /* expr_errors: B256ERROR_NETBIND args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETBIND);
	}
    break;

  case 181: /* expr_errors: B256ERROR_NETCONN args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETCONN);
	}
    break;

  case 182: /* expr_errors: B256ERROR_NETHOST args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETHOST);
	}
    break;

  case 183: /* expr_errors: B256ERROR_NETNONE args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETNONE);
	}
    break;

  case 184: /* expr_errors: B256ERROR_NETREAD args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETREAD);
	}
    break;

  case 185: /* expr_errors: B256ERROR_NETSOCK args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_NETSOCK);
	}
    break;

  case 186: /* expr_errors: B256ERROR_NETSOCKNUMBER args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_NETSOCKNUMBER);
	}
    break;

  case 187: /* expr_errors: B256ERROR_NETSOCKOPT args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_NETSOCKOPT);
	}
    break;

  case 188: /* expr_errors: B256ERROR_NETWRITE args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_NETWRITE);
	}
    break;

  case 189: /* expr_errors: B256ERROR_NEXTNOFOR args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_NEXTNOFOR);
	}
    break;

  case 190: /* expr_errors: B256ERROR_NONE args_none  */
                                   {
		addIntOp(OP_PUSHINT, ERROR_NONE);
	}
    break;

  case 191: /* expr_errors: B256ERROR_NOSUCHFUNCTION args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_NOSUCHFUNCTION);
	}
    break;

  case 192: /* expr_errors: B256ERROR_NOSUCHLABEL args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_NOSUCHLABEL);
	}
    break;

  case 193: /* expr_errors: B256ERROR_NOSUCHSUBROUTINE args_none  */
                                               {
		addIntOp(OP_PUSHINT, ERROR_NOSUCHSUBROUTINE);
	}
    break;

  case 194: /* expr_errors: B256ERROR_NOTARRAY args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_NOTARRAY);
	}
    break;

  case 195: /* expr_errors: B256ERROR_NOTIMPLEMENTED args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_NOTIMPLEMENTED);
	}
    break;

  case 196: /* expr_errors: B256ERROR_NUMBERCONV args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_NUMBERCONV);
	}
    break;

  case 197: /* expr_errors: B256ERROR_NUMBEREXPR args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_NUMBEREXPR);
	}
    break;

  case 198: /* expr_errors: B256ERROR_ONEDIMENSIONAL args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_ONEDIMENSIONAL);
	}
    break;

  case 199: /* expr_errors: B256ERROR_ONERRORSUB args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_ONERRORSUB);
	}
    break;

  case 200: /* expr_errors: B256ERROR_PENWIDTH args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_PENWIDTH);
	}
    break;

  case 201: /* expr_errors: B256ERROR_PERMISSION args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_PERMISSION);
	}
    break;

  case 202: /* expr_errors: B256ERROR_POLYPOINTS args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_POLYPOINTS);
	}
    break;

  case 203: /* expr_errors: B256ERROR_PRINTERNOTOFF args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_PRINTERNOTOFF);
	}
    break;

  case 204: /* expr_errors: B256ERROR_PRINTERNOTON args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_PRINTERNOTON);
	}
    break;

  case 205: /* expr_errors: B256ERROR_PRINTEROPEN args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_PRINTEROPEN);
	}
    break;

  case 206: /* expr_errors: B256ERROR_RADIX args_none  */
                                    {
		addIntOp(OP_PUSHINT, ERROR_RADIX);
	}
    break;

  case 207: /* expr_errors: B256ERROR_RADIXSTRING args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_RADIXSTRING);
	}
    break;

  case 208: /* expr_errors: B256ERROR_REFNOTASSIGNED args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_REFNOTASSIGNED);
	}
    break;

  case 209: /* expr_errors: B256ERROR_RGB args_none  */
                                  {
		addIntOp(OP_PUSHINT, ERROR_RGB);
	}
    break;

  case 210: /* expr_errors: B256ERROR_SERIALPARAMETER args_none  */
                                              {
		addIntOp(OP_PUSHINT, ERROR_SERIALPARAMETER);
	}
    break;

  case 211: /* expr_errors: B256ERROR_SETTINGMAXKEYS args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_SETTINGMAXKEYS);
	}
    break;

  case 212: /* expr_errors: B256ERROR_SETTINGMAXLEN args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_SETTINGMAXLEN);
	}
    break;

  case 213: /* expr_errors: B256ERROR_SETTINGSGETACCESS args_none  */
                                                {
		addIntOp(OP_PUSHINT, ERROR_SETTINGSGETACCESS);
	}
    break;

  case 214: /* expr_errors: B256ERROR_SETTINGSSETACCESS args_none  */
                                                {
		addIntOp(OP_PUSHINT, ERROR_SETTINGSSETACCESS);
	}
    break;

  case 215: /* expr_errors: B256ERROR_SLICESIZE args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_SLICESIZE);
	}
    break;

  case 216: /* expr_errors: B256ERROR_SOUNDERROR args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_SOUNDERROR);
	}
    break;

  case 217: /* expr_errors: B256ERROR_SOUNDFILE args_none  */
                                        {
		addIntOp(OP_PUSHINT, ERROR_SOUNDFILE);
	}
    break;

  case 218: /* expr_errors: B256ERROR_SOUNDFILEFORMAT args_none  */
                                              {
		addIntOp(OP_PUSHINT, ERROR_SOUNDFILEFORMAT);
	}
    break;

  case 219: /* expr_errors: B256ERROR_SOUNDLENGTH args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_SOUNDLENGTH);
	}
    break;

  case 220: /* expr_errors: B256ERROR_SOUNDNOTSEEKABLE args_none  */
                                               {
		addIntOp(OP_PUSHINT, ERROR_SOUNDNOTSEEKABLE);
	}
    break;

  case 221: /* expr_errors: B256ERROR_SOUNDRESOURCE args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_SOUNDRESOURCE);
	}
    break;

  case 222: /* expr_errors: B256ERROR_SPRITENA args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_SPRITENA);
	}
    break;

  case 223: /* expr_errors: B256ERROR_SPRITENUMBER args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_SPRITENUMBER);
	}
    break;

  case 224: /* expr_errors: B256ERROR_SPRITESLICE args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_SPRITESLICE);
	}
    break;

  case 225: /* expr_errors: B256ERROR_SQRRANGE args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_SQRRANGE);
	}
    break;

  case 226: /* expr_errors: B256ERROR_STACKUNDERFLOW args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_STACKUNDERFLOW);
	}
    break;

  case 227: /* expr_errors: B256ERROR_STRING2NOTE args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_STRING2NOTE);
	}
    break;

  case 228: /* expr_errors: B256ERROR_STRINGCONV args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_STRINGCONV);
	}
    break;

  case 229: /* expr_errors: B256ERROR_STRINGEXPR args_none  */
                                         {
		addIntOp(OP_PUSHINT, ERROR_STRINGEXPR);
	}
    break;

  case 230: /* expr_errors: B256ERROR_STRINGMAXLEN args_none  */
                                           {
		addIntOp(OP_PUSHINT, ERROR_STRINGMAXLEN);
	}
    break;

  case 231: /* expr_errors: B256ERROR_STRSTART args_none  */
                                       {
		addIntOp(OP_PUSHINT, ERROR_STRSTART);
	}
    break;

  case 232: /* expr_errors: B256ERROR_TOOMANYSOUNDS args_none  */
                                            {
		addIntOp(OP_PUSHINT, ERROR_TOOMANYSOUNDS);
	}
    break;

  case 233: /* expr_errors: B256ERROR_UNEXPECTEDRETURN args_none  */
                                               {
		addIntOp(OP_PUSHINT, ERROR_UNEXPECTEDRETURN);
	}
    break;

  case 234: /* expr_errors: B256ERROR_UNSERIALIZEFORMAT args_none  */
                                                {
		addIntOp(OP_PUSHINT, ERROR_UNSERIALIZEFORMAT);
	}
    break;

  case 235: /* expr_errors: B256ERROR_VARCIRCULAR args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_VARCIRCULAR);
	}
    break;

  case 236: /* expr_errors: B256ERROR_VARNOTASSIGNED args_none  */
                                             {
		addIntOp(OP_PUSHINT, ERROR_VARNOTASSIGNED);
	}
    break;

  case 237: /* expr_errors: B256ERROR_VARNULL args_none  */
                                      {
		addIntOp(OP_PUSHINT, ERROR_VARNULL);
	}
    break;

  case 238: /* expr_errors: B256ERROR_WAVEFORMLOGICAL args_none  */
                                              {
		addIntOp(OP_PUSHINT, ERROR_WAVEFORMLOGICAL);
	}
    break;

  case 239: /* expr_errors: B256ERROR_WAVOBSOLETE args_none  */
                                          {
		addIntOp(OP_PUSHINT, ERROR_WAVOBSOLETE);
	}
    break;

  case 240: /* expr_errors: B256WARNING_ARRAYELEMENT args_none  */
                                             {
		addIntOp(OP_PUSHINT, WARNING_ARRAYELEMENT);
	}
    break;

  case 241: /* expr_errors: B256WARNING_BOOLEANCONV args_none  */
                                            {
		addIntOp(OP_PUSHINT, WARNING_BOOLEANCONV);
	}
    break;

  case 242: /* expr_errors: B256WARNING_INTEGERRANGE args_none  */
                                             {
		addIntOp(OP_PUSHINT, WARNING_INTEGERRANGE);
	}
    break;

  case 243: /* expr_errors: B256WARNING_LONGRANGE args_none  */
                                          {
		addIntOp(OP_PUSHINT, WARNING_LONGRANGE);
	}
    break;

  case 244: /* expr_errors: B256WARNING_NUMBERCONV args_none  */
                                           {
		addIntOp(OP_PUSHINT, WARNING_NUMBERCONV);
	}
    break;

  case 245: /* expr_errors: B256WARNING_REFNOTASSIGNED args_none  */
                                               {
		addIntOp(OP_PUSHINT, WARNING_REFNOTASSIGNED);
	}
    break;

  case 246: /* expr_errors: B256WARNING_SOUNDERROR args_none  */
                                           {
		addIntOp(OP_PUSHINT, WARNING_SOUNDERROR);
	}
    break;

  case 247: /* expr_errors: B256WARNING_SOUNDFILEFORMAT args_none  */
                                                {
		addIntOp(OP_PUSHINT, WARNING_SOUNDFILEFORMAT);
	}
    break;

  case 248: /* expr_errors: B256WARNING_SOUNDLENGTH args_none  */
                                            {
		addIntOp(OP_PUSHINT, WARNING_SOUNDLENGTH);
	}
    break;

  case 249: /* expr_errors: B256WARNING_SOUNDNOTSEEKABLE args_none  */
                                                 {
		addIntOp(OP_PUSHINT, WARNING_SOUNDNOTSEEKABLE);
	}
    break;

  case 250: /* expr_errors: B256WARNING_START args_none  */
                                      {
		addIntOp(OP_PUSHINT, WARNING_START);
	}
    break;

  case 251: /* expr_errors: B256WARNING_STRING2NOTE args_none  */
                                            {
		addIntOp(OP_PUSHINT, WARNING_STRING2NOTE);
	}
    break;

  case 252: /* expr_errors: B256WARNING_STRINGCONV args_none  */
                                           {
		addIntOp(OP_PUSHINT, WARNING_STRINGCONV);
	}
    break;

  case 253: /* expr_errors: B256WARNING_VARNOTASSIGNED args_none  */
                                               {
		addIntOp(OP_PUSHINT, WARNING_VARNOTASSIGNED);
	}
    break;

  case 254: /* expr_errors: B256WARNING_WAVOBSOLETE args_none  */
                                            {
		addIntOp(OP_PUSHINT, WARNING_WAVOBSOLETE);
	}
    break;

  case 255: /* expr_numeric: B256INTEGER  */
                    { addIntOp(OP_PUSHINT, (yyvsp[0].number)); }
    break;

  case 256: /* expr_numeric: B256FLOAT  */
                      {
		if(isfinite((yyvsp[0].floatnum))){
			addFloatOp(OP_PUSHFLOAT, (yyvsp[0].floatnum));
		}else{
			errorcode = COMPERR_NUMBERTOOLARGE;
			return -1;
		}
	}
    break;

  case 257: /* expr_numeric: '+' B256INTEGER  */
                                          {
		 // accept/eat unary plus only for numbers
		 addIntOp(OP_PUSHINT, (yyvsp[0].number));
	}
    break;

  case 258: /* expr_numeric: '+' B256FLOAT  */
                                        {
		// accept/eat unary plus only for numbers
		if(isfinite((yyvsp[0].floatnum))){
			addFloatOp(OP_PUSHFLOAT, (yyvsp[0].floatnum));
		}else{
			errorcode = COMPERR_NUMBERTOOLARGE;
			return -1;
		}
	}
    break;

  case 259: /* expr_numeric: '-' expr  */
                                   {
		addOp(OP_NEGATE);
	}
    break;

  case 260: /* expr_numeric: expr '-' expr  */
                        {
		addOp(OP_SUB);
	}
    break;

  case 261: /* expr_numeric: expr B256MOD expr  */
                            {
		addOp(OP_MOD);
	}
    break;

  case 262: /* expr_numeric: expr '%' expr  */
                                      {
		addOp(OP_MOD);
	}
    break;

  case 263: /* expr_numeric: expr '%'  */
                                   {
		/* expression% is actually a percentage */
		addIntOp(OP_PUSHINT, 100);
		addOp(OP_DIV);
	}
    break;

  case 264: /* expr_numeric: expr B256INTDIV expr  */
                               {
		addOp(OP_INTDIV);
	}
    break;

  case 265: /* expr_numeric: expr '/' expr  */
                        {
		addOp(OP_DIV);
	}
    break;

  case 266: /* expr_numeric: expr '^' expr  */
                        { addOp(OP_EX); }
    break;

  case 267: /* expr_numeric: expr B256BINARYOR expr  */
                                 { addOp(OP_BINARYOR); }
    break;

  case 268: /* expr_numeric: expr B256BITSHIFTL expr  */
                                  { addOp(OP_BITSHIFTL); }
    break;

  case 269: /* expr_numeric: expr B256BITSHIFTR expr  */
                                  { addOp(OP_BITSHIFTR); }
    break;

  case 270: /* expr_numeric: B256BINARYNOT expr  */
                             { addOp(OP_BINARYNOT); }
    break;

  case 271: /* expr_numeric: expr B256AND expr  */
                            {
		addOp(OP_AND);
	}
    break;

  case 272: /* expr_numeric: expr B256OR expr  */
                           {
		addOp(OP_OR);
	}
    break;

  case 273: /* expr_numeric: expr B256XOR expr  */
                            { addOp(OP_XOR); }
    break;

  case 274: /* expr_numeric: B256NOT expr  */
                                     { addOp(OP_NOT); }
    break;

  case 275: /* expr_numeric: expr '=' expr  */
                        { addOp(OP_EQUAL); }
    break;

  case 276: /* expr_numeric: expr B256NE expr  */
                           { addOp(OP_NEQUAL); }
    break;

  case 277: /* expr_numeric: expr '<' expr  */
                        { addOp(OP_LT); }
    break;

  case 278: /* expr_numeric: expr '>' expr  */
                        { addOp(OP_GT); }
    break;

  case 279: /* expr_numeric: expr B256GTE expr  */
                            { addOp(OP_GTE); }
    break;

  case 280: /* expr_numeric: expr B256LTE expr  */
                            { addOp(OP_LTE); }
    break;

  case 281: /* expr_numeric: expr B256IN expr  */
                           {
		addOp(OP_IN);
	}
    break;

  case 282: /* expr_numeric: array_element B256ADD1  */
                                 {
		// a[b,c]++ - pushing value before to stack
		int v = varnumber[--nvarnumber];
		addOp(OP_STACKDUP2);			// save indexes
		addIntOp(OP_ARR_GET, v);		// get current value
		addOp(OP_STACKDUP);				// duplicate (1 to save and 1 to increment)
		addOp(OP_STACKSAVE);			// save original
		addIntOp(OP_PUSHINT,1);			// add 1
		addOp(OP_ADD);
		addIntOp(OP_ARR_SET, v);		// assign new value
		addOp(OP_STACKUNSAVE);			// put original value on the stack
	}
    break;

  case 283: /* expr_numeric: array_element B256SUB1  */
                                 {
		// a[b,c]-- - pushing value before to stack
		int v = varnumber[--nvarnumber];
		addOp(OP_STACKDUP2);			// save indexes
		addIntOp(OP_ARR_GET, v);		// get current value
		addOp(OP_STACKDUP);				// duplicate (1 to save and 1 to increment)
		addOp(OP_STACKSAVE);			// save original
		addIntOp(OP_PUSHINT,-1);		// subtract 1
		addOp(OP_ADD);
		addIntOp(OP_ARR_SET, v);		// assign new value
		addOp(OP_STACKUNSAVE);			// put original value on the stack
	}
    break;

  case 284: /* expr_numeric: B256ADD1 array_element  */
                                 {
		// ++a[b,c] - pushing value after to stack
		int v = varnumber[--nvarnumber];
		addOp(OP_STACKDUP2);			// save indexes
		addIntOp(OP_ARR_GET, v);		// get current value
		addIntOp(OP_PUSHINT,1);			// add 1
		addOp(OP_ADD);
		addOp(OP_STACKDUP);				// duplicate (1 to set 1 to stack)
		addOp(OP_STACKSAVE);			// save 1 to stack
		addIntOp(OP_ARR_SET, v);		// assign new value
		addOp(OP_STACKUNSAVE);			// put new value on the stack
	}
    break;

  case 285: /* expr_numeric: B256SUB1 array_element  */
                                 {
		// --a[b,c] - pushing value after to stack
		int v = varnumber[--nvarnumber];
		addOp(OP_STACKDUP2);			// save indexes
		addIntOp(OP_ARR_GET, v);		// get current value
		addIntOp(OP_PUSHINT,-1);		// subtract 1
		addOp(OP_ADD);
		addOp(OP_STACKDUP);				// duplicate (1 to set 1 to stack)
		addOp(OP_STACKSAVE);			// save 1 to stack
		addIntOp(OP_ARR_SET, v);		// assign new value
		addOp(OP_STACKUNSAVE);			// put new value on the stack
	}
    break;

  case 286: /* expr_numeric: variable B256ADD1  */
                            {
		addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
		addIntOp(OP_VAR_GET,varnumber[nvarnumber]);
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
	}
    break;

  case 287: /* expr_numeric: variable B256SUB1  */
                            {
		addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
		addIntOp(OP_VAR_GET,varnumber[nvarnumber]);
		addIntOp(OP_PUSHINT,-1);
		addOp(OP_ADD);
		addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
	}
    break;

  case 288: /* expr_numeric: B256ADD1 variable  */
                            {
		addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
		addIntOp(OP_PUSHINT,1);
		addOp(OP_ADD);
		addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
		addIntOp(OP_VAR_GET,varnumber[nvarnumber]);
	}
    break;

  case 289: /* expr_numeric: B256SUB1 variable  */
                            {
		addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
		addIntOp(OP_PUSHINT,-1);
		addOp(OP_ADD);
		addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
		addIntOp(OP_VAR_GET,varnumber[nvarnumber]);
	}
    break;

  case 290: /* expr_numeric: B256TOINT '(' expr ')'  */
                                 { addOp(OP_INT); }
    break;

  case 291: /* expr_numeric: B256TOFLOAT '(' expr ')'  */
                                   { addOp(OP_FLOAT); }
    break;

  case 292: /* expr_numeric: B256LENGTH '(' expr ')'  */
                                  { addOp(OP_LENGTH); }
    break;

  case 293: /* expr_numeric: B256ASC '(' expr ')'  */
                               { addOp(OP_ASC); }
    break;

  case 294: /* expr_numeric: B256INSTR '(' expr ',' expr ')'  */
                                          {
		addIntOp(OP_PUSHINT, 1);	// start
		addIntOp(OP_PUSHINT, 0);	// case sens flag
		addOp(OP_INSTR);
	}
    break;

  case 295: /* expr_numeric: B256INSTR '(' expr ',' expr ',' expr ')'  */
                                                   {
		addIntOp(OP_PUSHINT, 0);	// case sens flag
		addOp(OP_INSTR);
	 }
    break;

  case 296: /* expr_numeric: B256INSTR '(' expr ',' expr ',' expr ',' expr ')'  */
                                                           { addOp(OP_INSTR); }
    break;

  case 297: /* expr_numeric: B256INSTRX '(' expr ',' expr ')'  */
                                           {
		addIntOp(OP_PUSHINT, 1);	//start
		addOp(OP_INSTRX);
	}
    break;

  case 298: /* expr_numeric: B256INSTRX '(' expr ',' expr ',' expr ')'  */
                                                    { addOp(OP_INSTRX); }
    break;

  case 299: /* expr_numeric: B256CEIL '(' expr ')'  */
                                { addOp(OP_CEIL); }
    break;

  case 300: /* expr_numeric: B256FLOOR '(' expr ')'  */
                                 { addOp(OP_FLOOR); }
    break;

  case 301: /* expr_numeric: B256SIN '(' expr ')'  */
                               { addOp(OP_SIN); }
    break;

  case 302: /* expr_numeric: B256COS '(' expr ')'  */
                               { addOp(OP_COS); }
    break;

  case 303: /* expr_numeric: B256TAN '(' expr ')'  */
                               { addOp(OP_TAN); }
    break;

  case 304: /* expr_numeric: B256ASIN '(' expr ')'  */
                                { addOp(OP_ASIN); }
    break;

  case 305: /* expr_numeric: B256ACOS '(' expr ')'  */
                                { addOp(OP_ACOS); }
    break;

  case 306: /* expr_numeric: B256ATAN '(' expr ')'  */
                                { addOp(OP_ATAN); }
    break;

  case 307: /* expr_numeric: B256DEGREES '(' expr ')'  */
                                   { addOp(OP_DEGREES); }
    break;

  case 308: /* expr_numeric: B256RADIANS '(' expr ')'  */
                                   { addOp(OP_RADIANS); }
    break;

  case 309: /* expr_numeric: B256LOG '(' expr ')'  */
                               { addOp(OP_LOG); }
    break;

  case 310: /* expr_numeric: B256LOGTEN '(' expr ')'  */
                                  { addOp(OP_LOGTEN); }
    break;

  case 311: /* expr_numeric: B256SQR '(' expr ')'  */
                               { addOp(OP_SQR); }
    break;

  case 312: /* expr_numeric: B256EXP '(' expr ')'  */
                               { addOp(OP_EXP); }
    break;

  case 313: /* expr_numeric: B256ABS '(' expr ')'  */
                               { addOp(OP_ABS); }
    break;

  case 314: /* expr_numeric: B256RAND args_none  */
                             { addOp(OP_RAND); }
    break;

  case 315: /* expr_numeric: B256PI args_none  */
                                                   { addFloatOp(OP_PUSHFLOAT, 3.14159265358979323846); }
    break;

  case 316: /* expr_numeric: B256BOOLEOF args_none  */
                                {
		addIntOp(OP_PUSHINT, 0);
		addOp(OP_EOF);
	}
    break;

  case 317: /* expr_numeric: B256BOOLEOF '(' expr ')'  */
                                   { addOp(OP_EOF); }
    break;

  case 318: /* expr_numeric: B256EXISTS '(' expr ')'  */
                                  { addOp(OP_EXISTS); }
    break;

  case 319: /* expr_numeric: B256YEAR args_none  */
                             { addOp(OP_YEAR); }
    break;

  case 320: /* expr_numeric: B256MONTH args_none  */
                              { addOp(OP_MONTH); }
    break;

  case 321: /* expr_numeric: B256DAY args_none  */
                            { addOp(OP_DAY); }
    break;

  case 322: /* expr_numeric: B256HOUR args_none  */
                             { addOp(OP_HOUR); }
    break;

  case 323: /* expr_numeric: B256MINUTE args_none  */
                               { addOp(OP_MINUTE); }
    break;

  case 324: /* expr_numeric: B256SECOND args_none  */
                               { addOp(OP_SECOND); }
    break;

  case 325: /* expr_numeric: B256GRAPHWIDTH args_none  */
                                   { addOp(OP_GRAPHWIDTH); }
    break;

  case 326: /* expr_numeric: B256GRAPHHEIGHT args_none  */
                                    { addOp(OP_GRAPHHEIGHT); }
    break;

  case 327: /* expr_numeric: B256SIZE args_none  */
                             {
		addIntOp(OP_PUSHINT, 0);
		addOp(OP_SIZE);
	}
    break;

  case 328: /* expr_numeric: B256SIZE '(' expr ')'  */
                                { addOp(OP_SIZE); }
    break;

  case 329: /* expr_numeric: B256KEYPRESSED args_none  */
                                   {
		addIntOp(OP_PUSHINT, 0x00);
		addOp(OP_KEYPRESSED);
	}
    break;

  case 330: /* expr_numeric: B256KEYPRESSED '(' expr ')'  */
                                      { addOp(OP_KEYPRESSED); }
    break;

  case 331: /* expr_numeric: B256KEY args_none  */
                                {
		addIntOp(OP_PUSHINT, 0x00);
		addOp(OP_KEY);
	}
    break;

  case 332: /* expr_numeric: B256KEY '(' expr ')'  */
                                   {
		addOp(OP_KEY);
	}
    break;

  case 333: /* expr_numeric: B256MOUSEX args_none  */
                               { addOp(OP_MOUSEX); }
    break;

  case 334: /* expr_numeric: B256MOUSEY args_none  */
                               { addOp(OP_MOUSEY); }
    break;

  case 335: /* expr_numeric: B256MOUSEB args_none  */
                               { addOp(OP_MOUSEB); }
    break;

  case 336: /* expr_numeric: B256CLICKX args_none  */
                               { addOp(OP_CLICKX); }
    break;

  case 337: /* expr_numeric: B256CLICKY args_none  */
                               { addOp(OP_CLICKY); }
    break;

  case 338: /* expr_numeric: B256CLICKB args_none  */
                               { addOp(OP_CLICKB); }
    break;

  case 339: /* expr_numeric: B256PIXEL '(' expr ',' expr ')'  */
                                          { addOp(OP_PIXEL); }
    break;

  case 340: /* expr_numeric: B256RGB '(' expr ',' expr ',' expr ')'  */
                                                 {
		addIntOp(OP_PUSHINT,255);	// a
		addOp(OP_RGB);
	}
    break;

  case 341: /* expr_numeric: B256RGB '(' expr ',' expr ',' expr ',' expr ')'  */
                                                          {
		addOp(OP_RGB);
	}
    break;

  case 342: /* expr_numeric: B256GETCOLOR args_none  */
                                 { addOp(OP_GETCOLOR); }
    break;

  case 343: /* expr_numeric: B256GETBRUSHCOLOR args_none  */
                                      { addOp(OP_GETBRUSHCOLOR); }
    break;

  case 344: /* expr_numeric: B256GETPENWIDTH args_none  */
                                    { addOp(OP_GETPENWIDTH); }
    break;

  case 345: /* expr_numeric: B256SPRITECOLLIDE '(' expr ',' expr ',' expr ')'  */
                                                           { addOp(OP_SPRITECOLLIDE); }
    break;

  case 346: /* expr_numeric: B256SPRITECOLLIDE '(' expr ',' expr ')'  */
                                                  { addIntOp(OP_PUSHINT, 0); addOp(OP_SPRITECOLLIDE); }
    break;

  case 347: /* expr_numeric: B256SPRITEX '(' expr ')'  */
                                   { addOp(OP_SPRITEX); }
    break;

  case 348: /* expr_numeric: B256SPRITEY '(' expr ')'  */
                                   { addOp(OP_SPRITEY); }
    break;

  case 349: /* expr_numeric: B256SPRITEH '(' expr ')'  */
                                   { addOp(OP_SPRITEH); }
    break;

  case 350: /* expr_numeric: B256SPRITEW '(' expr ')'  */
                                   { addOp(OP_SPRITEW); }
    break;

  case 351: /* expr_numeric: B256SPRITEV '(' expr ')'  */
                                   { addOp(OP_SPRITEV); }
    break;

  case 352: /* expr_numeric: B256SPRITER '(' expr ')'  */
                                   { addOp(OP_SPRITER); }
    break;

  case 353: /* expr_numeric: B256SPRITES '(' expr ')'  */
                                   { addOp(OP_SPRITES); }
    break;

  case 354: /* expr_numeric: B256SPRITEO '(' expr ')'  */
                                   { addOp(OP_SPRITEO); }
    break;

  case 355: /* expr_numeric: B256DBROW args_none  */
                              {
		addIntOp(OP_PUSHINT,0);	// default db number
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_DBROW);
	}
    break;

  case 356: /* expr_numeric: B256DBROW '(' expr ')'  */
                                 {
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_DBROW);
	}
    break;

  case 357: /* expr_numeric: B256DBROW '(' expr ',' expr ')'  */
                                         {
		addOp(OP_DBROW);
	}
    break;

  case 358: /* expr_numeric: B256DBINT '(' expr ')'  */
                                 {
		addIntOp(OP_PUSHINT,0);	// default db number
		addOp(OP_STACKSWAP);
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBINT); }
    break;

  case 359: /* expr_numeric: B256DBINT '(' expr ',' expr ')'  */
                                          {
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBINT); }
    break;

  case 360: /* expr_numeric: B256DBINT '(' expr ',' expr ',' expr ')'  */
                                                   {
		addOp(OP_DBINT); }
    break;

  case 361: /* expr_numeric: B256DBFLOAT '(' expr ')'  */
                                   {
		addIntOp(OP_PUSHINT,0);	// default db number
		addOp(OP_STACKSWAP);
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBFLOAT); }
    break;

  case 362: /* expr_numeric: B256DBFLOAT '(' expr ',' expr ')'  */
                                            {
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBFLOAT); }
    break;

  case 363: /* expr_numeric: B256DBFLOAT '(' expr ',' expr ',' expr ')'  */
                                                     {
		addOp(OP_DBFLOAT); }
    break;

  case 364: /* expr_numeric: B256DBNULL '(' expr ')'  */
                                  {
		addIntOp(OP_PUSHINT,0);	// default db number
		addOp(OP_STACKSWAP);
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBNULL); }
    break;

  case 365: /* expr_numeric: B256DBNULL '(' expr ',' expr ')'  */
                                           {
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBNULL); }
    break;

  case 366: /* expr_numeric: B256DBNULL '(' expr ',' expr ',' expr ')'  */
                                                    {
		addOp(OP_DBNULL); }
    break;

  case 367: /* expr_numeric: B256LASTERROR args_none  */
                                  { addOp(OP_LASTERROR); }
    break;

  case 368: /* expr_numeric: B256LASTERRORLINE args_none  */
                                      { addOp(OP_LASTERRORLINE); }
    break;

  case 369: /* expr_numeric: B256NETDATA args_none  */
                                { addIntOp(OP_PUSHINT, 0); addOp(OP_NETDATA); }
    break;

  case 370: /* expr_numeric: B256NETDATA '(' expr ')'  */
                                   { addOp(OP_NETDATA); }
    break;

  case 371: /* expr_numeric: B256PORTIN '(' expr ')'  */
                                  { addOp(OP_PORTIN); }
    break;

  case 372: /* expr_numeric: B256COUNT '(' expr ',' expr ')'  */
                                          {
		addIntOp(OP_PUSHINT, 0); // case sens flag
		addOp(OP_COUNT);
	 }
    break;

  case 373: /* expr_numeric: B256COUNT '(' expr ',' expr ',' expr ')'  */
                                                   { addOp(OP_COUNT); }
    break;

  case 374: /* expr_numeric: B256COUNTX '(' expr ',' expr ')'  */
                                           { addOp(OP_COUNTX); }
    break;

  case 375: /* expr_numeric: B256OSTYPE args_none  */
                               { addOp(OP_OSTYPE); }
    break;

  case 376: /* expr_numeric: B256MSEC args_none  */
                             { addOp(OP_MSEC); }
    break;

  case 377: /* expr_numeric: B256TEXTWIDTH '(' expr ')'  */
                                     { addOp(OP_TEXTWIDTH); }
    break;

  case 378: /* expr_numeric: B256TEXTWIDTH '(' expr ',' expr ')'  */
                                              { addOp(OP_TEXTBOXWIDTH); }
    break;

  case 379: /* expr_numeric: B256TEXTHEIGHT args_none  */
                                   { addOp(OP_TEXTHEIGHT); }
    break;

  case 380: /* expr_numeric: B256TEXTHEIGHT '(' expr ',' expr ')'  */
                                               { addOp(OP_TEXTBOXHEIGHT); }
    break;

  case 381: /* expr_numeric: B256READBYTE args_none  */
                                 { addIntOp(OP_PUSHINT, 0); addOp(OP_READBYTE); }
    break;

  case 382: /* expr_numeric: B256READBYTE '(' expr ')'  */
                                    { addOp(OP_READBYTE); }
    break;

  case 383: /* expr_numeric: B256FREEDB args_none  */
                               { addOp(OP_FREEDB); }
    break;

  case 384: /* expr_numeric: B256FREEDBSET args_none  */
                                  {
		addIntOp(OP_PUSHINT,0);	// default db number
		addOp(OP_FREEDBSET);
	}
    break;

  case 385: /* expr_numeric: B256FREEDBSET '(' expr ')'  */
                                     { addOp(OP_FREEDBSET); }
    break;

  case 386: /* expr_numeric: B256FREEFILE args_none  */
                                 { addOp(OP_FREEFILE); }
    break;

  case 387: /* expr_numeric: B256FREENET args_none  */
                                { addOp(OP_FREENET); }
    break;

  case 388: /* expr_numeric: B256VERSION args_none  */
                                { addIntOp(OP_PUSHINT, VERSIONSIGNATURE); }
    break;

  case 389: /* expr_numeric: B256CONFIRM '(' expr ')'  */
                                   {
		addIntOp(OP_PUSHINT,-1);	// no default
		addOp(OP_CONFIRM);
	}
    break;

  case 390: /* expr_numeric: B256CONFIRM '(' expr ',' expr ')'  */
                                            {
		addOp(OP_CONFIRM);
	}
    break;

  case 391: /* expr_numeric: B256FROMBINARY '(' expr ')'  */
                                      {
		addIntOp(OP_PUSHINT,2);	// radix
		addOp(OP_FROMRADIX);
	}
    break;

  case 392: /* expr_numeric: B256FROMHEX '(' expr ')'  */
                                   {
		addIntOp(OP_PUSHINT,16);	// radix
		addOp(OP_FROMRADIX);
	}
    break;

  case 393: /* expr_numeric: B256FROMOCTAL '(' expr ')'  */
                                     {
		addIntOp(OP_PUSHINT,8);	// radix
		addOp(OP_FROMRADIX);
	}
    break;

  case 394: /* expr_numeric: B256FROMRADIX '(' expr ',' expr ')'  */
                                              {
		addOp(OP_FROMRADIX);
	}
    break;

  case 395: /* expr_numeric: B256BINCONST  */
                       {
		addIntOp(OP_PUSHINT,strtoul((yyvsp[0].string), NULL, 2));
		if(errno==ERANGE){
			errorcode = COMPERR_NUMBERTOOLARGE;
			return -1;
		}
		//addStringOp(OP_PUSHSTRING, $1);
		//addIntOp(OP_PUSHINT,2);	// radix
		//addOp(OP_FROMRADIX);
	}
    break;

  case 396: /* expr_numeric: B256HEXCONST  */
                       {
		addIntOp(OP_PUSHINT,strtoul((yyvsp[0].string), NULL, 16));
		if(errno==ERANGE){
			errorcode = COMPERR_NUMBERTOOLARGE;
			return -1;
		}
		//addStringOp(OP_PUSHSTRING, $1);
		//addIntOp(OP_PUSHINT,16);	// radix
		//addOp(OP_FROMRADIX);
	}
    break;

  case 397: /* expr_numeric: B256OCTCONST  */
                       {
		addIntOp(OP_PUSHINT,strtoul((yyvsp[0].string), NULL, 8));
		if(errno==ERANGE){
			errorcode = COMPERR_NUMBERTOOLARGE;
			return -1;
		}
		//addStringOp(OP_PUSHSTRING, $1);
		//addIntOp(OP_PUSHINT,8);	// radix
		//addOp(OP_FROMRADIX);
	}
    break;

  case 398: /* expr_numeric: B256WAVLENGTH args_none  */
                                  { addOp(OP_WAVLENGTH); }
    break;

  case 399: /* expr_numeric: B256WAVPOS args_none  */
                               { addOp(OP_WAVPOS); }
    break;

  case 400: /* expr_numeric: B256WAVSTATE args_none  */
                                 { addOp(OP_WAVSTATE); }
    break;

  case 401: /* expr_numeric: B256TYPEOF '(' expr ')'  */
                                  {
		addOp(OP_TYPEOF);
	}
    break;

  case 402: /* expr_numeric: B256SOUNDPLAYER '(' expr ')'  */
                                       {
		addOp(OP_SOUNDPLAYER);
	}
    break;

  case 403: /* expr_numeric: B256SOUNDPLAYER '(' args_ee ')'  */
                                          {
		addIntOp(OP_PUSHINT, 2);	// 2 columns
		addIntOp(OP_PUSHINT, 1);	// 1 row
		addOp(OP_LIST2ARRAY);
		addOp(OP_SOUNDPLAYER);
	}
    break;

  case 404: /* expr_numeric: B256SOUNDID args_none  */
                                {
		addOp(OP_SOUNDID);
	}
    break;

  case 405: /* expr_numeric: B256SOUNDPOSITION '(' expr ')'  */
                                         {
		addOp(OP_SOUNDPOSITION);
	}
    break;

  case 406: /* expr_numeric: B256SOUNDPOSITION args_none  */
                                      {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDPOSITION);
	}
    break;

  case 407: /* expr_numeric: B256SOUNDSTATE '(' expr ')'  */
                                      {
		addOp(OP_SOUNDSTATE);
	}
    break;

  case 408: /* expr_numeric: B256SOUNDSTATE args_none  */
                                   {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDSTATE);
	}
    break;

  case 409: /* expr_numeric: B256SOUNDLENGTH '(' expr ')'  */
                                       {
		addOp(OP_SOUNDLENGTH);
	}
    break;

  case 410: /* expr_numeric: B256SOUNDLENGTH args_none  */
                                    {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDLENGTH);
	}
    break;

  case 411: /* expr_numeric: B256SOUNDSAMPLERATE args_none  */
                                        {
		addOp(OP_SOUNDSAMPLERATE);
	}
    break;

  case 412: /* expr_numeric: B256IMAGEWIDTH '(' expr ')'  */
                                      {
		addOp(OP_IMAGEWIDTH);
	}
    break;

  case 413: /* expr_numeric: B256IMAGEHEIGHT '(' expr ')'  */
                                       {
		addOp(OP_IMAGEHEIGHT);
	}
    break;

  case 414: /* expr_numeric: B256IMAGEPIXEL '(' args_eee ')'  */
                                          {
		addOp(OP_IMAGEPIXEL);
	}
    break;

  case 415: /* expr_numeric: B256ROUND '(' expr ')'  */
                                 {
		addIntOp(OP_PUSHINT,0);		// default decimal places
		addOp(OP_ROUND);
	}
    break;

  case 416: /* expr_numeric: B256ROUND '(' args_ee ')'  */
                                    {
		addOp(OP_ROUND);
	}
    break;

  case 417: /* expr_numeric: B256ASSIGNED '(' variable_a ')'  */
                                          {
		addIntOp(OP_VAR_ASSIGNED, varnumber[--nvarnumber]);
	}
    break;

  case 418: /* expr_numeric: B256ASSIGNED '(' array_element ')'  */
                                             {
		addIntOp(OP_ARR_ASSIGNED, varnumber[--nvarnumber]);
	}
    break;

  case 419: /* expr_numeric: variable array_size  */
                              {
		addIntOp(OP_ALEN, varnumber[--nvarnumber]);
	}
    break;

  case 420: /* expr_numeric: variable array_size_rows  */
                                   {
		addIntOp(OP_ALENROWS, varnumber[--nvarnumber]);
	}
    break;

  case 421: /* expr_numeric: variable array_size_cols  */
                                   {
		addIntOp(OP_ALENCOLS, varnumber[--nvarnumber]);
	}
    break;

  case 422: /* expr_numeric: B256GETARRAYBASE args_none  */
                                     { addOp(OP_GETARRAYBASE); }
    break;

  case 423: /* expr_string: B256STRING  */
                   { addStringOp(OP_PUSHSTRING, (yyvsp[0].string)); }
    break;

  case 424: /* expr_string: B256CHR '(' expr ')'  */
                               { addOp(OP_CHR); }
    break;

  case 425: /* expr_string: B256TOSTRING '(' expr ')'  */
                                    { addOp(OP_STRING); }
    break;

  case 426: /* expr_string: B256UPPER '(' expr ')'  */
                                 { addOp(OP_UPPER); }
    break;

  case 427: /* expr_string: B256LOWER '(' expr ')'  */
                                 { addOp(OP_LOWER); }
    break;

  case 428: /* expr_string: B256MID '(' expr ',' expr ',' expr ')'  */
                                                 { addOp(OP_MID); }
    break;

  case 429: /* expr_string: B256MIDX '(' expr ',' expr ')'  */
                                         { addIntOp(OP_PUSHINT, 1); addOp(OP_MIDX); }
    break;

  case 430: /* expr_string: B256MIDX '(' expr ',' expr ',' expr ')'  */
                                                  { addOp(OP_MIDX); }
    break;

  case 431: /* expr_string: B256LEFT '(' expr ',' expr ')'  */
                                         { addOp(OP_LEFT); }
    break;

  case 432: /* expr_string: B256RIGHT '(' expr ',' expr ')'  */
                                          { addOp(OP_RIGHT); }
    break;

  case 433: /* expr_string: B256READ args_none  */
                             { addIntOp(OP_PUSHINT, 0); addOp(OP_READ); }
    break;

  case 434: /* expr_string: B256READ '(' expr ')'  */
                                { addOp(OP_READ); }
    break;

  case 435: /* expr_string: B256READLINE args_none  */
                                 { addIntOp(OP_PUSHINT, 0); addOp(OP_READLINE); }
    break;

  case 436: /* expr_string: B256READLINE '(' expr ')'  */
                                    { addOp(OP_READLINE); }
    break;

  case 437: /* expr_string: B256CURRENTDIR args_none  */
                                   { addOp(OP_CURRENTDIR); }
    break;

  case 438: /* expr_string: B256DBSTRING '(' expr ')'  */
                                    {
		addIntOp(OP_PUSHINT,0);	// default db number
		addOp(OP_STACKSWAP);
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBSTRING); }
    break;

  case 439: /* expr_string: B256DBSTRING '(' expr ',' expr ')'  */
                                             {
		addIntOp(OP_PUSHINT,0);	// default dbset number
		addOp(OP_STACKSWAP);
		addOp(OP_DBSTRING); }
    break;

  case 440: /* expr_string: B256DBSTRING '(' expr ',' expr ',' expr ')'  */
                                                      {
		addOp(OP_DBSTRING); }
    break;

  case 441: /* expr_string: B256LASTERRORMESSAGE args_none  */
                                         { addOp(OP_LASTERRORMESSAGE); }
    break;

  case 442: /* expr_string: B256LASTERROREXTRA args_none  */
                                       { addOp(OP_LASTERROREXTRA); }
    break;

  case 443: /* expr_string: B256NETREAD args_none  */
                                 { addIntOp(OP_PUSHINT, 0); addOp(OP_NETREAD); }
    break;

  case 444: /* expr_string: B256NETREAD '(' expr ')'  */
                                   { addOp(OP_NETREAD); }
    break;

  case 445: /* expr_string: B256NETADDRESS args_none  */
                                   { addOp(OP_NETADDRESS); }
    break;

  case 446: /* expr_string: B256MD5 '(' expr ')'  */
                               { addOp(OP_MD5); }
    break;

  case 447: /* expr_string: B256GETCLIPBOARDIMAGE args_none  */
                                          { addOp(OP_GETCLIPBOARDIMAGE); }
    break;

  case 448: /* expr_string: B256GETCLIPBOARDSTRING args_none  */
                                           { addOp(OP_GETCLIPBOARDSTRING); }
    break;

  case 449: /* expr_string: B256GETSETTING '(' expr ',' expr ')'  */
                                               { addOp(OP_GETSETTING); }
    break;

  case 450: /* expr_string: B256DIR '(' expr ')'  */
                               { addOp(OP_DIR); }
    break;

  case 451: /* expr_string: B256DIR args_none  */
                            { addStringOp(OP_PUSHSTRING, ""); addOp(OP_DIR); }
    break;

  case 452: /* expr_string: B256REPLACE '(' expr ',' expr ',' expr ')'  */
                                                     {
		addIntOp(OP_PUSHINT, 0);	// case sens flag
		addOp(OP_REPLACE);
	}
    break;

  case 453: /* expr_string: B256REPLACE '(' expr ',' expr ',' expr ',' expr ')'  */
                                                              { addOp(OP_REPLACE); }
    break;

  case 454: /* expr_string: B256REPLACEX '(' expr ',' expr ',' expr ')'  */
                                                      { addOp(OP_REPLACEX); }
    break;

  case 455: /* expr_string: B256SERIALIZE '(' expr ')'  */
                                     {
		addOp(OP_SERIALIZE);
	}
    break;

  case 456: /* expr_string: B256IMPLODE '(' expr ')'  */
                                   {
		addStringOp(OP_PUSHSTRING, ""); // no delimiter
		addOp(OP_STACKDUP);
		addOp(OP_IMPLODE);
	}
    break;

  case 457: /* expr_string: B256IMPLODE '(' args_ee ')'  */
                                      {
		addOp(OP_STACKDUP);				// same delimiter for rows and columns
		addOp(OP_IMPLODE);
	}
    break;

  case 458: /* expr_string: B256IMPLODE '(' args_eee ')'  */
                                       {
		addOp(OP_IMPLODE);
	}
    break;

  case 459: /* expr_string: B256PROMPT '(' expr ')'  */
                                  {
		addStringOp(OP_PUSHSTRING, "");
		addOp(OP_PROMPT); }
    break;

  case 460: /* expr_string: B256PROMPT '(' expr ',' expr ')'  */
                                           {
		addOp(OP_PROMPT); }
    break;

  case 461: /* expr_string: B256TOBINARY '(' expr ')'  */
                                    {
		addIntOp(OP_PUSHINT,2);	// radix
		addOp(OP_TORADIX);
	}
    break;

  case 462: /* expr_string: B256TOHEX '(' expr ')'  */
                                 {
		addIntOp(OP_PUSHINT,16);	// radix
		addOp(OP_TORADIX);
	}
    break;

  case 463: /* expr_string: B256TOOCTAL '(' expr ')'  */
                                   {
		addIntOp(OP_PUSHINT,8);	// radix
		addOp(OP_TORADIX);
	}
    break;

  case 464: /* expr_string: B256TORADIX '(' expr ',' expr ')'  */
                                            {
		addOp(OP_TORADIX);
	}
    break;

  case 465: /* expr_string: B256DEBUGINFO '(' expr ')'  */
                                     {
		addOp(OP_DEBUGINFO);
	}
    break;

  case 466: /* expr_string: B256ISNUMERIC '(' expr ')'  */
                                     { addOp(OP_ISNUMERIC); }
    break;

  case 467: /* expr_string: B256LTRIM '(' expr ')'  */
                                 { addOp(OP_LTRIM); }
    break;

  case 468: /* expr_string: B256RTRIM '(' expr ')'  */
                                 { addOp(OP_RTRIM); }
    break;

  case 469: /* expr_string: B256TRIM '(' expr ')'  */
                                { addOp(OP_TRIM); }
    break;

  case 470: /* expr_string: B256IMAGETYPE_BMP args_none  */
                                      { addStringOp(OP_PUSHSTRING, IMAGETYPE_BMP); }
    break;

  case 471: /* expr_string: B256IMAGETYPE_JPG args_none  */
                                      { addStringOp(OP_PUSHSTRING, IMAGETYPE_JPG); }
    break;

  case 472: /* expr_string: B256IMAGETYPE_PNG args_none  */
                                      { addStringOp(OP_PUSHSTRING, IMAGETYPE_PNG); }
    break;

  case 473: /* expr_string: B256SOUNDLOAD '(' expr ')'  */
                                     {
		addOp(OP_SOUNDLOAD);
	}
    break;

  case 474: /* expr_string: B256SOUNDLOAD '(' args_ee ')'  */
                                        {
		addIntOp(OP_PUSHINT, 2);	// 2 columns
		addIntOp(OP_PUSHINT, 1);	// 1 row
		addOp(OP_LIST2ARRAY);
		addOp(OP_SOUNDLOAD);
	}
    break;

  case 475: /* expr_string: B256SOUNDLOADRAW '(' expr ')'  */
                                        {
		addOp(OP_SOUNDLOADRAW);
	}
    break;

  case 476: /* expr_string: B256IMAGENEW '(' expr ',' expr ',' expr ')'  */
                                                      {
		addOp(OP_IMAGENEW);
	}
    break;

  case 477: /* expr_string: B256IMAGENEW '(' expr ',' expr ')'  */
                                             {
		addIntOp(OP_PUSHINT, 0x00);
		addOp(OP_IMAGENEW);
	}
    break;

  case 478: /* expr_string: B256IMAGELOAD '(' expr ')'  */
                                     {
		addOp(OP_IMAGELOAD);
	}
    break;

  case 479: /* expr_string: B256IMAGECOPY '(' expr ',' expr ',' expr ',' expr ',' expr ')'  */
                                                                         {
		addIntOp(OP_PUSHINT, 5); //number of arguments
		addOp(OP_IMAGECOPY);
	}
    break;

  case 480: /* expr_string: B256IMAGECOPY '(' expr ',' expr ',' expr ',' expr ')'  */
                                                                {
		addIntOp(OP_PUSHINT, 4); //number of arguments
		addOp(OP_IMAGECOPY);
	}
    break;

  case 481: /* expr_string: B256IMAGECOPY '(' expr ')'  */
                                     {
		addIntOp(OP_PUSHINT, 1); //number of arguments
		addOp(OP_IMAGECOPY);
	}
    break;

  case 482: /* expr_string: B256IMAGECOPY args_none  */
                                  {
		addIntOp(OP_PUSHINT, 0); //number of arguments
		addOp(OP_IMAGECOPY);
	}
    break;

  case 483: /* expr_string: B256LJUST '(' args_ee ')'  */
                                    {
		addStringOp(OP_PUSHSTRING, " ");
		addOp(OP_LJUST);
	}
    break;

  case 484: /* expr_string: B256LJUST '(' args_eee ')'  */
                                     {
		addOp(OP_LJUST);
	}
    break;

  case 485: /* expr_string: B256RJUST '(' args_ee ')'  */
                                    {
		addStringOp(OP_PUSHSTRING, " ");
		addOp(OP_RJUST);
	}
    break;

  case 486: /* expr_string: B256RJUST '(' args_eee ')'  */
                                     {
		addOp(OP_RJUST);
	}
    break;

  case 487: /* expr_string: B256ZFILL '(' args_ee ')'  */
                                    {
		addStringOp(OP_PUSHSTRING, "0");
		addOp(OP_RJUST);
	}
    break;

  case 488: /* expr_string: B256OPENFILEDIALOG '(' args_eee ')'  */
                                              {
		addOp(OP_OPENFILEDIALOG);
	}
    break;

  case 489: /* expr_string: B256SAVEFILEDIALOG '(' args_eee ')'  */
                                              {
		addOp(OP_SAVEFILEDIALOG);
	}
    break;

  case 490: /* expr_dataelement: variable_a  */
                   {
		addIntOp(OP_VAR_GET, varnumber[--nvarnumber]);
	}
    break;

  case 491: /* expr_dataelement: listoflists  */
                      {
		addOp(OP_LIST2ARRAY);
	}
    break;

  case 492: /* expr_dataelement: listofmapitems  */
                         {
		addOp(OP_LIST2MAP);
	}
    break;

  case 493: /* expr_dataelement: B256UNSERIALIZE '(' expr ')'  */
                                      {
		addOp(OP_UNSERIALIZE);
	}
    break;

  case 494: /* expr_dataelement: B256EXPLODE args_ee  */
                              {
		addIntOp(OP_PUSHINT, 0);	// case sensitive flag
		addOp(OP_EXPLODE);
	}
    break;

  case 495: /* expr_dataelement: B256EXPLODE args_eee  */
                               {
		addOp(OP_EXPLODE);
	}
    break;

  case 496: /* expr_dataelement: B256EXPLODEX args_ee  */
                               {
		addOp(OP_EXPLODEX);
	}
    break;

  case 497: /* expr_dataelement: B256GETSLICE args_eeee  */
                                 {
		addIntOp(OP_PUSHINT, SLICE_ALL);	// get everything
		addOp(OP_GETSLICE);
	}
    break;

  case 498: /* expr_dataelement: B256GETSLICE args_eeeee  */
                                  {
		addOp(OP_GETSLICE);
	}
    break;

  case 645: /* begincasestmt: B256BEGINCASE  */
                      {
		// start a case block
		newIf(linenumber, IFTABLETYPEBEGINCASE,-1);
	}
    break;

  case 646: /* $@1: %empty  */
                         {
		// if not first case then add jump to to "endcase" and resolve the branchfalse
		if (numifs>1) {
			if (iftabletype[numifs-1]==IFTABLETYPECASE) {
				if (iftabletype[numifs-2]==IFTABLETYPEBEGINCASE) {
					//
					// create jump around from end of the CASE to end of the END CASE
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[numifs-2],INTERNALSYMBOLEXIT));
				} else {
					errorcode = COMPERR_ENDBEGINCASE;
					linenumber = iftablesourceline[numifs-1];
					return -1;
				}
				//
				// resolve branchfalse from previous case
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
				//
				numifs--;
			}
		}
		//
	}
    break;

  case 647: /* casestmt: B256CASE $@1 expr  */
               {
		//
		// add branch to the end if false
		addIntOp(OP_BRANCH, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
		//
		// put new CASE on the frame for the IF
		newIf(linenumber, IFTABLETYPECASE,-1);
	}
    break;

  case 648: /* catchstmt: B256CATCH  */
                          {
	//
	// create jump around from end of the TRY to end of the CATCH
	// OP_OFFERRORCATCH label - close try/catch trap and jump over the CATCH part
	addIntOp(OP_OFFERRORCATCH, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
	//
	if (numifs>0) {
		if (iftabletype[numifs-1]==IFTABLETYPETRY) {
			//
			// resolve the try onerrorcatch to the catch address
			symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
			numifs--;
			//
			// put new if on the frame for the catch
			newIf(linenumber, IFTABLETYPECATCH,-1);
		} else {
			errorcode = testIfOnTableError(numincludes);
			linenumber = testIfOnTable(numincludes);
			return -1;
		}
	} else {
		errorcode = COMPERR_CATCH;
		return -1;
	}
}
    break;

  case 649: /* dostmt: B256DO  */
                       {
		//
		// create internal symbol and add to the label table for the top of the loop
		symtableaddress[getInternalSymbol(nextifid,INTERNALSYMBOLTOP)] = wordOffset;
		//
		// add to if frame
		newIf(linenumber, IFTABLETYPEDO, -1);
	}
    break;

  case 650: /* elsestmt: B256ELSE  */
                         {
		//
		// create jump around from end of the THEN to end of the ELSE
		addIntOp(OP_GOTO, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
		//
		if (numifs>0) {
			if (iftabletype[numifs-1]==IFTABLETYPEIF) {
				//
				// resolve the label on the if to the current location
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
				numifs--;
				//
				// put new if on the frame for the else
				newIf(linenumber, IFTABLETYPEELSE, -1);
			} else if (iftabletype[numifs-1]==IFTABLETYPECASE) {
				if (numifs>1) {
					if (iftabletype[numifs-2]==IFTABLETYPEBEGINCASE) {
						//
						// create jump around from end of the CASE to end of the END CASE
						addIntOp(OP_GOTO, getInternalSymbol(iftableid[numifs-2],INTERNALSYMBOLEXIT));
					} else {
						errorcode = COMPERR_ENDBEGINCASE;
						linenumber = iftablesourceline[numifs-1];
						return -1;
					}
					//
					// resolve branchfalse from previous case
					symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
					//
					numifs--;
					// put new if on the frame for the else
					newIf(linenumber, IFTABLETYPEELSE, -1);
				}
			} else {
				errorcode = testIfOnTableError(numincludes);
				linenumber = testIfOnTable(numincludes);
				return -1;
			}
		} else {
			errorcode = COMPERR_ELSE;
			return -1;
		}
	}
    break;

  case 651: /* endcasestmt: B256ENDCASE  */
                                    {
				// add label for last case branchfalse to jump to
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPECASE || iftabletype[numifs-1]==IFTABLETYPEELSE) {
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						numifs--;
					} else {
						errorcode = COMPERR_ENDENDCASE;
						return -1;
					}
				} else {
					errorcode = COMPERR_ENDENDCASE;
					return -1;
				}
				// add label for all cases to jump to after execution
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEBEGINCASE) {
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						numifs--;
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_ENDENDCASEBEGIN;
					return -1;
				}
			}
    break;

  case 652: /* endifstmt: B256ENDIF  */
                          {
				// if there is an if branch or jump on the iftable stack get where it is
				// in the wordcode array and then put the current wordcode address there
				// - so we can jump over code
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEIF||iftabletype[numifs-1]==IFTABLETYPEELSE) {
						//
						// resolve the label on the if/else to the current location
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						numifs--;
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_ENDIF;
					return -1;
				}
			}
    break;

  case 653: /* endtrystmt: B256ENDTRY  */
                           {
				// if there is an if branch or jump on the iftable stack get where it is
				// in the wordcode array and then put the current wordcode address there
				// - so we can jump over code
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPECATCH) {
						//
						// resolve the label on the Catch to the current location
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						numifs--;
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_ENDTRY;
					return -1;
				}
			}
    break;

  case 654: /* endwhilestmt: B256ENDWHILE  */
                                     {
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEWHILE) {
						//
						// jump to the top
						addIntOp(OP_GOTO, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLCONTINUE));
						//
						// resolve the label to the bottom
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						//
						// remove the single placeholder from the if frame
						numifs--;
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_ENDWHILE;
					return -1;
				}
			}
    break;

  case 655: /* ifstmt: B256IF expr B256THEN  */
                                     {
					//
					// add branch to the end if false
					addIntOp(OP_BRANCH, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
					//
					// put new if on the frame for the IF
					newIf(linenumber, IFTABLETYPEIF, -1);
			}
    break;

  case 656: /* ifthenstmt: ifstmt compoundstmt  */
                                            {
				// if there is an if branch or jump on the iftable stack get where it is
				// in the wordcode array and then resolve the lable
				if (numifs>0) {
					symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
					numifs--;
				}
			}
    break;

  case 657: /* ifthenelsestmt: ifthenelse compoundstmt  */
                                                {
				//
				// resolve the label on the else to the current location
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
				numifs--;
			}
    break;

  case 658: /* ifthenelse: ifstmt compoundstmt B256ELSE  */
                                                     {
				//
				// create jump around from end of the THEN to end of the ELSE
				addIntOp(OP_GOTO, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
				//
				// jump point for else
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
				numifs--;
				//
				// put new if on the frame for the else
				newIf(linenumber, IFTABLETYPEELSE, -1);
			}
    break;

  case 659: /* trystmt: B256TRY  */
                        {
				//
				// add on error branch
                                addIntOp(OP_ONERRORCATCH, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
				//
				// put new if on the frame for the TRY
				newIf(linenumber, IFTABLETYPETRY, -1);
			}
    break;

  case 660: /* $@2: %empty  */
                          {
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEDO) {
						//
						// create label for CONTINUE DO
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLCONTINUE)] = wordOffset;
						//
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_UNTIL;
					return -1;
				}
			}
    break;

  case 661: /* untilstmt: B256UNTIL $@2 expr  */
                               {
				//
				// branch back to top if condition holds
				addIntOp(OP_BRANCH, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLTOP));
				//
				// create label for EXIT DO
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
				numifs--;
			}
    break;

  case 662: /* $@3: %empty  */
                                  {
				//
				// create internal symbol and add to the label table for the top of the loop
				newIf(linenumber, IFTABLETYPEWHILE, -1);
				symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLCONTINUE)] = wordOffset;
			}
    break;

  case 663: /* whilestmt: B256WHILE $@3 expr  */
                               {
				//
				// add branch to end if false
				addIntOp(OP_BRANCH, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT));
			}
    break;

  case 670: /* mapstmt: B256MAP functionvariables  */
                                          {
				for(int t=numargs-1;t>=0;t--) {
					addIntOp(OP_MAP_DIM, args[t]);
				}
				numargs=0;	// clear the list for next function
			}
    break;

  case 671: /* dimstmt: B256DIM array_element  */
                                      {
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
			}
    break;

  case 672: /* dimstmt: B256DIM array_element B256FILL expr  */
                                                              {
				addOp(OP_STACKTOPTO2);
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 1);		// fill all elements
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 673: /* dimstmt: B256DIM variable_a expr  */
                                                  {
				addIntOp(OP_PUSHINT, 1);
				addOp(OP_STACKSWAP);
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
			}
    break;

  case 674: /* dimstmt: B256DIM variable_a expr B256FILL expr  */
                                                                {
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT, 1);
				addOp(OP_STACKSWAP);
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 1);		// fill all elements
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 675: /* dimstmt: B256DIM variable_a args_ee  */
                                                     {
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
			}
    break;

  case 676: /* dimstmt: B256DIM variable_a args_ee B256FILL expr  */
                                                                   {
				addOp(OP_STACKTOPTO2);
				addIntOp(OP_DIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 1);		// fill all elements
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 677: /* dimstmt: B256DIM variable_a '=' expr  */
                                                      {
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 678: /* dimstmt: B256DIM variable_a B256FILL expr  */
                                                           {
				addIntOp(OP_PUSHINT, 1);
				addIntOp(OP_ARRAYFILL, varnumber[--nvarnumber]);
			}
    break;

  case 679: /* redimstmt: B256REDIM array_element  */
                                        {
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
			}
    break;

  case 680: /* redimstmt: B256REDIM array_element B256FILL expr  */
                                                                {
				addOp(OP_STACKTOPTO2);
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 0);		// just fill unassigned
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 681: /* redimstmt: B256REDIM variable_a expr  */
                                                    {
				addIntOp(OP_PUSHINT, 1);
				addOp(OP_STACKSWAP);
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
			}
    break;

  case 682: /* redimstmt: B256REDIM variable_a expr B256FILL expr  */
                                                                  {
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT, 1);
				addOp(OP_STACKSWAP);
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 0);		// just fill unassigned
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 683: /* redimstmt: B256REDIM variable_a args_ee  */
                                                       {
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
			}
    break;

  case 684: /* redimstmt: B256REDIM variable_a args_ee B256FILL expr  */
                                                                     {
				addOp(OP_STACKTOPTO2);
				addIntOp(OP_REDIM, varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT, 0);		// just fill unassigned
				addIntOp(OP_ARRAYFILL, varnumber[nvarnumber]);
			}
    break;

  case 685: /* pausestmt: B256PAUSE expr  */
                               {
				addOp(OP_PAUSE);
			}
    break;

  case 686: /* throwerrorstmt: B256THROWERROR expr  */
                                            {
				addOp(OP_THROWERROR);
			}
    break;

  case 687: /* clearstmt: B256CLS args_none  */
                                  {
				addOp(OP_CLS);
			}
    break;

  case 688: /* clearstmt: B256CLG args_none  */
                                            {
				// push the color clear if there are no arguments
				addIntOp(OP_PUSHINT, 0x00);
				//addIntOp(OP_PUSHINT, 0x00);
				//addIntOp(OP_PUSHINT, 0x00);
				//addIntOp(OP_PUSHINT, 0x00);
				//addIntOp(OP_PUSHINT, 0x00);
				//addOp(OP_RGB);
				addOp(OP_CLG);
			}
    break;

  case 689: /* clearstmt: B256CLG expr  */
                                       {
				addOp(OP_CLG);
			}
    break;

  case 690: /* fastgraphicsstmt: B256FASTGRAPHICS args_none  */
                                                   {
				addOp(OP_FASTGRAPHICS);
			}
    break;

  case 691: /* graphsizestmt: B256GRAPHSIZE args_ee  */
                                              {
                                addFloatOp(OP_PUSHFLOAT, 1.0);
				addOp(OP_GRAPHSIZE);
			}
    break;

  case 692: /* graphsizestmt: B256GRAPHSIZE args_eee  */
                                                 {
					addOp(OP_GRAPHSIZE);
			}
    break;

  case 693: /* refreshstmt: B256REFRESH args_none  */
                                              {
				addOp(OP_REFRESH);
			}
    break;

  case 694: /* endstmt: B256END args_none  */
                                  {
				addOp(OP_END);
			}
    break;

  case 695: /* arrayelementassign: array_element '=' expr  */
                                               {
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 696: /* arrayelementassign: array_element B256ADD1  */
                                                 {
				// a[r,c]++ - NO PUSH as this is a statement
				int v = varnumber[--nvarnumber];
				addOp(OP_STACKDUP2);			// save indexes
				addIntOp(OP_ARR_GET, v);		// get current value
				addIntOp(OP_PUSHINT,1);			// add 1
				addOp(OP_ADD);
				addIntOp(OP_ARR_SET, v);		// assign new value
			}
    break;

  case 697: /* arrayelementassign: array_element B256SUB1  */
                                                 {
				// a[r,c]-- - NO PUSH as this is a statement
				int v = varnumber[--nvarnumber];
				addOp(OP_STACKDUP2);			// save indexes
				addIntOp(OP_ARR_GET, v);		// get current value
				addIntOp(OP_PUSHINT,-1);		// subtract 1
				addOp(OP_ADD);
				addIntOp(OP_ARR_SET, v);		// assign new value
			}
    break;

  case 698: /* arrayelementassign: array_element B256ADDEQUAL expr  */
                                                          {
				// a[b,c] += n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_ADD);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 699: /* arrayelementassign: array_element B256SUBEQUAL expr  */
                                                          {
				// a[b,c] -= n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_STACKSWAP);
				addOp(OP_SUB);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 700: /* arrayelementassign: array_element B256MULEQUAL expr  */
                                                          {
				// a[b,c] *= n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_MUL);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 701: /* arrayelementassign: array_element B256DIVEQUAL expr  */
                                                          {
				// a[b,c] /= n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_STACKSWAP);
				addOp(OP_DIV);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 702: /* arrayelementassign: array_element B256AMPEQUAL expr  */
                                                          {
				// a[b,c] &= n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_STACKSWAP);
				addOp(OP_BINARYAND);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 703: /* arrayelementassign: array_element B256SEMICOLONEQUAL expr  */
                                                                {
				// a[b,c] /= n
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKDUP2);
				addIntOp(OP_ARR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKTOPTO2);
				addOp(OP_STACKSWAP2);
				addOp(OP_STACKSWAP);
				addOp(OP_CONCATENATE);
				addIntOp(OP_ARR_SET, varnumber[nvarnumber]);
			}
    break;

  case 704: /* arrayassign: variable_a B256FILL expr  */
                                                 {
				addIntOp(OP_PUSHINT, 1);		// fill all elements
				addIntOp(OP_ARRAYFILL, varnumber[--nvarnumber]);
			}
    break;

  case 705: /* assign: variable_a '=' expr  */
                                            {
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 706: /* assign: variable B256ADD1  */
                                            {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT,1);
				addOp(OP_ADD);
				addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
			}
    break;

  case 707: /* assign: variable B256SUB1  */
                                            {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addIntOp(OP_PUSHINT,-1);
				addOp(OP_ADD);
				addIntOp(OP_VAR_SET,varnumber[nvarnumber]);
			}
    break;

  case 708: /* assign: variable B256ADDEQUAL expr  */
                                                     {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKSWAP);
				addOp(OP_ADD);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 709: /* assign: variable B256SUBEQUAL expr  */
                                                     {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKSWAP);
				addOp(OP_SUB);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 710: /* assign: variable B256MULEQUAL expr  */
                                                     {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_MUL);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 711: /* assign: variable B256DIVEQUAL expr  */
                                                     {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKSWAP);
				addOp(OP_DIV);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 712: /* assign: variable B256AMPEQUAL expr  */
                                                     {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKSWAP);
				addOp(OP_BINARYAND);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 713: /* assign: variable B256SEMICOLONEQUAL expr  */
                                                           {
				addIntOp(OP_VAR_GET,varnumber[--nvarnumber]);
				addOp(OP_STACKSWAP);
				addOp(OP_CONCATENATE);
				addIntOp(OP_VAR_SET, varnumber[nvarnumber]);
			}
    break;

  case 714: /* forstmt: B256FOR variable '=' expr B256TO expr  */
                                                      {
				// add to iftable to make sure it is not broken with an if
				// do, while, else, and to report if it is
				// next ed before end of program
				int var =  varnumber[--nvarnumber];
				newIf(linenumber, IFTABLETYPEFOR, var);
				// push default step 1 and exit address
				addIntOp(OP_PUSHINT, 1); //step
				addIntOp(OP_PUSHLABEL, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT));
				addIntOp(OP_FOR, var);
			}
    break;

  case 715: /* forstmt: B256FOR variable '=' expr B256TO expr B256STEP expr  */
                                                                              {
				// add to iftable to make sure it is not broken with an if
				// do, while, else, and to report if it is
				// next ed before end of program
				int var =  varnumber[--nvarnumber];
				newIf(linenumber, IFTABLETYPEFOR, var);
				// push exit address
				addIntOp(OP_PUSHLABEL, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT));
				addIntOp(OP_FOR, var);
			}
    break;

  case 716: /* foreachstmt: B256FOREACH variable B256IN expr_dataelement  */
                                                             {
				// add to iftable to make sure it is not broken with an if
				// do, while, else, and to report if it is
				// next ed before end of program
				int var =  varnumber[--nvarnumber];
				newIf(linenumber, IFTABLETYPEFOR, var);
				addIntOp(OP_PUSHLABEL, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT));
				addIntIntOp(OP_FOREACH, var, -1 );
			}
    break;

  case 717: /* foreachstmt: B256FOREACH variable '-' '>' variable B256IN expr_dataelement  */
                                                                                        {
				// add to iftable to make sure it is not broken with an if
				// do, while, else, and to report if it is
				// next ed before end of program
				int value_var =  varnumber[--nvarnumber];
				int key_var =  varnumber[--nvarnumber];
				newIf(linenumber, IFTABLETYPEFOR, key_var);
				addIntOp(OP_PUSHLABEL, getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT));
				addIntIntOp(OP_FOREACH, key_var, value_var);
			}
    break;

  case 718: /* nextstmt: B256NEXT variable  */
                                  {
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEFOR) {
						if (iftablevariable[numifs-1]==varnumber[nvarnumber-1]) {
							symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLCONTINUE)] = wordOffset;
							addOp(OP_NEXT);
							symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
							numifs--;
						} else {
							errorcode = COMPERR_NEXTWRONGFOR;
							return -1;
						}
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_NEXT;
					return -1;
				}
			}
    break;

  case 719: /* nextstmt: B256NEXT  */
                                   {
				// allow relaxed next without the variable name
				if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPEFOR) {
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLCONTINUE)] = wordOffset;
						addOp(OP_NEXT);
						symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
						numifs--;
					} else {
						errorcode = testIfOnTableError(numincludes);
						linenumber = testIfOnTable(numincludes);
						return -1;
					}
				} else {
					errorcode = COMPERR_NEXT;
					return -1;
				}
			}
    break;

  case 720: /* gotostmt: B256GOTO variable  */
                                  {
				if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
					errorcode = COMPERR_FUNCTIONGOTO;
					return -1;
				}
				addIntOp(OP_GOTO, varnumber[--nvarnumber]);
			}
    break;

  case 721: /* gosubstmt: B256GOSUB variable  */
                                   {
				if (functionDefSymbol != -1 || subroutineDefSymbol !=-1) {
					errorcode = COMPERR_FUNCTIONGOTO;
					return -1;
				}
				addIntOp(OP_GOSUB, varnumber[--nvarnumber]);
				addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
			}
    break;

  case 722: /* callstmt: B256CALL variable '(' ')'  */
                                          {
				addIntOp(OP_PUSHINT, 0); //push number of arguments passed to compare with SUBROUTINE definition
				addIntOp(OP_CALLSUBROUTINE, varnumber[--nvarnumber]);
				addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
			}
    break;

  case 723: /* callstmt: B256CALL variable '(' callexprlist ')'  */
                                                                 {
					addIntOp(OP_PUSHINT, listlen); //push number of arguments passed to compare with SUBROUTINE definition
					addIntOp(OP_CALLSUBROUTINE, varnumber[--nvarnumber]);
					addIntOp(OP_CURRLINE, filenumber * 0x1000000 + linenumber);
			}
    break;

  case 724: /* offerrorstmt: B256OFFERROR args_none  */
                                               {
				addOp(OP_OFFERROR);
			}
    break;

  case 725: /* onerrorstmt: B256ONERROR variable  */
                                             {
				addIntOp(OP_ONERRORGOSUB, varnumber[--nvarnumber]);
			}
    break;

  case 726: /* onerrorstmt: B256ONERROR variable '(' ')'  */
                                                       {
				addIntOp(OP_ONERRORCALL, varnumber[--nvarnumber]);
			}
    break;

  case 727: /* onerrorstmt: B256ONERROR variable '(' callexprlist ')'  */
                                                                    {
				errorcode = COMPERR_ONERRORCALL;
				return -1;
			}
    break;

  case 728: /* returnstmt: B256RETURN args_none  */
                                     {
				if (functionDefSymbol!=-1) {
					// if we are defining a function return pushes a variable value
					addIntOp(OP_VAR_GET, functionDefSymbol);
					addOp(OP_DECREASERECURSE);
				}
				if (subroutineDefSymbol!=-1) {
					// if we are defining a subroutine
					addOp(OP_DECREASERECURSE);
				}
				addOp(OP_RETURN);
			}
    break;

  case 729: /* returnstmt: B256RETURN expr  */
                                          {
				if (functionDefSymbol!=-1) {
					// value on stack gets returned
					addOp(OP_DECREASERECURSE);
					addOp(OP_RETURN);
				} else {
					errorcode = COMPERR_RETURNVALUE;
					return -1;
				}
			}
    break;

  case 730: /* colorstmt: B256SETCOLOR expr  */
                                  {
				addOp(OP_STACKDUP);
				addOp(OP_SETCOLOR);
			}
    break;

  case 731: /* colorstmt: B256SETCOLOR args_ee  */
                                                {
				addOp(OP_SETCOLOR);
			}
    break;

  case 732: /* colorstmt: B256SETCOLOR args_eee  */
                                                {
				addIntOp(OP_PUSHINT, 255);
				addOp(OP_RGB);
				addOp(OP_STACKDUP);
				addOp(OP_SETCOLOR);
				newParseWarning(COMPWARNING_DEPRECATED_FORM);
			}
    break;

  case 733: /* soundstmt: B256SOUND args_ee  */
                                  {
				addIntOp(OP_PUSHINT, 2);	// 2 columns (this)
				addIntOp(OP_PUSHINT, 1);	// 1 row
				addIntOp(OP_PUSHINT, 2);	// 2 columns (max)
				addOp(OP_LIST2ARRAY);
				addOp(OP_SOUND);
			}
    break;

  case 734: /* soundstmt: B256SOUND expr  */
                                         {
				addOp(OP_SOUND);
			}
    break;

  case 735: /* soundplaystmt: B256SOUNDPLAY args_none  */
                                        {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDPLAY);
	}
    break;

  case 736: /* soundplaystmt: B256SOUNDPLAY args_ee  */
                                {
		addIntOp(OP_PUSHINT, 2);	// 2 columns
		addIntOp(OP_PUSHINT, 1);	// 1 row
		addOp(OP_LIST2ARRAY);
		addOp(OP_SOUNDPLAY);
	}
    break;

  case 737: /* soundplaystmt: B256SOUNDPLAY expr  */
                             {
		// either string - lodresource
		// int - player number
		// array - from a variable
		addOp(OP_SOUNDPLAY);
	}
    break;

  case 738: /* soundpausestmt: B256SOUNDPAUSE expr  */
                                     {
		addOp(OP_SOUNDPAUSE);
	}
    break;

  case 739: /* soundpausestmt: B256SOUNDPAUSE args_none  */
                                   {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDPAUSE);
	}
    break;

  case 740: /* soundplayeroffstmt: B256SOUNDPLAYEROFF expr  */
                                             {
		addOp(OP_SOUNDPLAYEROFF);
	}
    break;

  case 741: /* soundplayeroffstmt: B256SOUNDPLAYEROFF args_none  */
                                       {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDPLAYEROFF);
	}
    break;

  case 742: /* soundstopstmt: B256SOUNDSTOP expr  */
                                   {
		addOp(OP_SOUNDSTOP);
	}
    break;

  case 743: /* soundstopstmt: B256SOUNDSTOP args_none  */
                                  {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDSTOP);
	}
    break;

  case 744: /* soundwaitstmt: B256SOUNDWAIT expr  */
                           {
		addOp(OP_SOUNDWAIT);
	}
    break;

  case 745: /* soundwaitstmt: B256SOUNDWAIT args_none  */
                                  {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_SOUNDWAIT);
	}
    break;

  case 746: /* soundwaveformstmt: B256SOUNDWAVEFORM expr  */
                               {
		addIntOp(OP_PUSHINT,0);
		addOp(OP_SOUNDWAVEFORM);
	}
    break;

  case 747: /* soundwaveformstmt: B256SOUNDWAVEFORM args_ee  */
                                    {
		addOp(OP_SOUNDWAVEFORM);
	}
    break;

  case 748: /* soundsystemstmt: B256SOUNDSYSTEM expr  */
                                       {
		addOp(OP_SOUNDSYSTEM);
	}
    break;

  case 749: /* soundenvelopestmt: B256SOUNDENVELOPE args_none  */
                                                {
		addOp(OP_SOUNDNOENVELOPE);
	}
    break;

  case 750: /* soundenvelopestmt: B256SOUNDENVELOPE args_eeee  */
                                      {
		addOp(OP_SOUNDENVELOPE);
	}
    break;

  case 751: /* soundenvelopestmt: B256SOUNDENVELOPE expr  */
                                 {
		addOp(OP_SOUNDENVELOPE);
	}
    break;

  case 752: /* soundharmonicsstmt: B256SOUNDHARMONICS args_none  */
                                                  {
		addOp(OP_SOUNDNOHARMONICS);
	}
    break;

  case 753: /* soundharmonicsstmt: B256SOUNDHARMONICS args_ee  */
                                     {
		addOp(OP_SOUNDHARMONICS);
	}
    break;

  case 754: /* soundharmonicsstmt: B256SOUNDHARMONICS expr  */
                                  {
		addOp(OP_SOUNDHARMONICS);
	}
    break;

  case 755: /* soundfadestmt: B256SOUNDFADE args_eeee  */
                                        {
		addOp(OP_SOUNDFADE);
	}
    break;

  case 756: /* soundfadestmt: B256SOUNDFADE args_eee  */
                                 {
		addOp(OP_STACKTOPTO2);
		addOp(OP_STACKTOPTO2);
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_STACKSWAP);
		addOp(OP_STACKSWAP2);
		addOp(OP_SOUNDFADE);
	}
    break;

  case 757: /* soundseekstmt: B256SOUNDSEEK args_ee  */
                                      {
		addOp(OP_SOUNDSEEK);
	}
    break;

  case 758: /* soundseekstmt: B256SOUNDSEEK expr  */
                             {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_STACKSWAP);
		addOp(OP_SOUNDSEEK);
	}
    break;

  case 759: /* soundvolumestmt: B256SOUNDVOLUME args_ee  */
                                          {
		addOp(OP_SOUNDVOLUME);
	}
    break;

  case 760: /* soundvolumestmt: B256SOUNDVOLUME expr  */
                               {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_STACKSWAP);
		addOp(OP_SOUNDVOLUME);
	}
    break;

  case 761: /* soundloopstmt: B256SOUNDLOOP args_ee  */
                                      {
		addOp(OP_SOUNDLOOP);
	}
    break;

  case 762: /* soundloopstmt: B256SOUNDLOOP expr  */
                             {
		addIntOp(OP_PUSHINT, -1);
		addOp(OP_STACKSWAP);
		addOp(OP_SOUNDLOOP);
	}
    break;

  case 763: /* plotstmt: B256PLOT args_ee  */
                                 {
				addOp(OP_PLOT);
			}
    break;

  case 764: /* linestmt: B256LINE args_eeee  */
                                   {
				addOp(OP_LINE);
			}
    break;

  case 765: /* circlestmt: B256CIRCLE args_eee  */
                            {
		addOp(OP_CIRCLE);
	}
    break;

  case 766: /* ellipsestmt: B256ELLIPSE args_eeee  */
                              {
		addOp(OP_ELLIPSE);
	}
    break;

  case 767: /* arcstmt: B256ARC args_eeeee  */
                           {
		addIntOp(OP_PUSHINT, 5); // with bounding circle
		addOp(OP_ARC);
	}
    break;

  case 768: /* arcstmt: B256ARC args_eeeeee  */
                              {
		addIntOp(OP_PUSHINT, 6); // with bounding rectangle
		addOp(OP_ARC);
	}
    break;

  case 769: /* chordstmt: B256CHORD args_eeeee  */
                             {
		addIntOp(OP_PUSHINT, 5); // with bounding circle
		addOp(OP_CHORD);
	}
    break;

  case 770: /* chordstmt: B256CHORD args_eeeeee  */
                                {
		addIntOp(OP_PUSHINT, 6); // with bounding rectangle
		addOp(OP_CHORD);
	}
    break;

  case 771: /* piestmt: B256PIE args_eeeee  */
                           {
		addIntOp(OP_PUSHINT, 5); // with bounding circle
		addOp(OP_PIE);
	}
    break;

  case 772: /* piestmt: B256PIE args_eeeeee  */
                              {
		addIntOp(OP_PUSHINT, 6); // with bounding rectangle
		addOp(OP_PIE);
	}
    break;

  case 773: /* rectstmt: B256RECT args_eeee  */
                           {
		addOp(OP_RECT);
	}
    break;

  case 774: /* rectstmt: B256RECT args_eeeee  */
                              {
		addOp(OP_STACKDUP);
		addOp(OP_ROUNDEDRECT);
	}
    break;

  case 775: /* rectstmt: B256RECT args_eeeeee  */
                               {
		addOp(OP_ROUNDEDRECT);
	}
    break;

  case 776: /* textstmt: B256TEXT args_eee  */
                          {
		addOp(OP_TEXT);
	}
    break;

  case 777: /* textstmt: B256TEXT args_eeeee  */
                              {
		addIntOp(OP_PUSHINT, 0); // flags
		addOp(OP_TEXTBOX);
	}
    break;

  case 778: /* textstmt: B256TEXT args_eeeeee  */
                               {
		addOp(OP_TEXTBOX);
	}
    break;

  case 779: /* fontstmt: B256FONT args_eeee  */
                           {
		addOp(OP_FONT);
	}
    break;

  case 780: /* fontstmt: B256FONT args_eee  */
                            {
		addIntOp(OP_PUSHINT, 0); // font is not italic
		addOp(OP_FONT);
	}
    break;

  case 781: /* fontstmt: B256FONT args_ee  */
                           {
		addIntOp(OP_PUSHINT, -1); // default weight
		addIntOp(OP_PUSHINT, 0); // font is not italic
		addOp(OP_FONT);
	}
    break;

  case 782: /* fontstmt: B256FONT expr  */
                        {
		addIntOp(OP_PUSHINT, -1); // default size
		addIntOp(OP_PUSHINT, -1); // default weight
		addIntOp(OP_PUSHINT, 0); // font is not italic
		addOp(OP_FONT);
	}
    break;

  case 783: /* saystmt: B256SAY expr  */
                             {
				addOp(OP_SAY);
			}
    break;

  case 784: /* systemstmt: B256SYSTEM expr  */
                                        {
				addOp(OP_SYSTEM);
			}
    break;

  case 785: /* volumestmt: B256VOLUME expr  */
                                        {
				addOp(OP_VOLUME);
			}
    break;

  case 786: /* polystmt: B256POLY expr  */
                                      {
				addOp(OP_POLY);
			}
    break;

  case 787: /* stampstmt: B256STAMP args_eeeee  */
                                     {
				addOp(OP_STAMP);
			}
    break;

  case 788: /* stampstmt: B256STAMP args_eeee  */
                                              {
				addFloatOp(OP_PUSHFLOAT, 0.0); // default rotate
				addOp(OP_STACKSWAP);
				addOp(OP_STAMP);
			}
    break;

  case 789: /* stampstmt: B256STAMP args_eee  */
                                             {
				addFloatOp(OP_PUSHFLOAT, 1.0); // default scale
				addOp(OP_STACKSWAP);
				addFloatOp(OP_PUSHFLOAT, 0.0); // default rotate
				addOp(OP_STACKSWAP);
				addOp(OP_STAMP);
			}
    break;

  case 790: /* openstmt: B256OPEN expr  */
                               {
				addIntOp(OP_PUSHINT, 0); // file number zero
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT, 0); // not binary
				addOp(OP_OPEN);
			}
    break;

  case 791: /* openstmt: B256OPEN args_ee  */
                                           {
				addIntOp(OP_PUSHINT, 0); // not binary
				addOp(OP_OPEN);
			}
    break;

  case 792: /* openstmt: B256OPENB expr  */
                                          {
				addIntOp(OP_PUSHINT, 0); // file number zero
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT, 1); // binary
				addOp(OP_OPEN);
			}
    break;

  case 793: /* openstmt: B256OPENB args_ee  */
                                            {
				addIntOp(OP_PUSHINT, 1); // binary
				addOp(OP_OPEN);
			}
    break;

  case 794: /* openstmt: B256OPENSERIAL args_ee  */
                                                 {
				addIntOp(OP_PUSHINT, 9600); // baud
				addIntOp(OP_PUSHINT, 8); // data bits
				addIntOp(OP_PUSHINT, 1); // stop bits
				addIntOp(OP_PUSHINT, 0); // parity
				addIntOp(OP_PUSHINT, 0); // flow
				addOp(OP_OPENSERIAL);
			}
    break;

  case 795: /* openstmt: B256OPENSERIAL args_eee  */
                                                  {
				addIntOp(OP_PUSHINT, 8); // data bits
				addIntOp(OP_PUSHINT, 1); // stop bits
				addIntOp(OP_PUSHINT, 0); // parity
				addIntOp(OP_PUSHINT, 0); // flow
				addOp(OP_OPENSERIAL);
			}
    break;

  case 796: /* openstmt: B256OPENSERIAL args_eeee  */
                                                   {
				addIntOp(OP_PUSHINT, 1); // stop bits
				addIntOp(OP_PUSHINT, 0); // parity
				addIntOp(OP_PUSHINT, 0); // flow
				addOp(OP_OPENSERIAL);
			}
    break;

  case 797: /* openstmt: B256OPENSERIAL args_eeeee  */
                                                    {
				addIntOp(OP_PUSHINT, 0); // parity
				addIntOp(OP_PUSHINT, 0); // flow
				addOp(OP_OPENSERIAL);
			}
    break;

  case 798: /* openstmt: B256OPENSERIAL args_eeeeee  */
                                                     {
				addIntOp(OP_PUSHINT, 0); // flow
				addOp(OP_OPENSERIAL);
			}
    break;

  case 799: /* openstmt: B256OPENSERIAL args_eeeeeee  */
                                                      {
				addOp(OP_OPENSERIAL);
			}
    break;

  case 800: /* writestmt: B256WRITE expr  */
                               {
				addIntOp(OP_PUSHINT, 0);  // file number zero
				addOp(OP_STACKSWAP);
				addOp(OP_WRITE);
			}
    break;

  case 801: /* writestmt: B256WRITE args_ee  */
                                            {
				addOp(OP_WRITE);
			}
    break;

  case 802: /* writelinestmt: B256WRITELINE expr  */
                                           {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKSWAP);
				addOp(OP_WRITELINE);
			}
    break;

  case 803: /* writelinestmt: B256WRITELINE args_ee  */
                                                {
				addOp(OP_WRITELINE);
			}
    break;

  case 804: /* writebytestmt: B256WRITEBYTE expr  */
                                           {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKSWAP);
				addOp(OP_WRITEBYTE);
			}
    break;

  case 805: /* writebytestmt: B256WRITEBYTE args_ee  */
                                                {
				addOp(OP_WRITEBYTE);
			}
    break;

  case 806: /* closestmt: B256CLOSE args_none  */
                                    {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_CLOSE);
			}
    break;

  case 807: /* closestmt: B256CLOSE expr  */
                                         {
				addOp(OP_CLOSE);
			}
    break;

  case 808: /* resetstmt: B256RESET args_none  */
                                    {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_RESET);
			}
    break;

  case 809: /* resetstmt: B256RESET expr  */
                                         {
				addOp(OP_RESET);
			}
    break;

  case 810: /* seedstmt: B256SEED expr  */
                              {
				addOp(OP_SEED);
			}
    break;

  case 811: /* seekstmt: B256SEEK expr  */
                              {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKSWAP);
				addOp(OP_SEEK);
			}
    break;

  case 812: /* seekstmt: B256SEEK args_ee  */
                                           {
				addOp(OP_SEEK);
			}
    break;

  case 813: /* inputstmt: B256INPUT args_ev  */
                                  {
				addIntOp(OP_PUSHINT,T_UNASSIGNED);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 814: /* inputstmt: B256INPUT variable  */
                                              {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_UNASSIGNED);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 815: /* inputstmt: B256INPUT args_ea  */
                                            {
				addOp(OP_STACKTOPTO2); addOp(OP_STACKTOPTO2);		// bring prompt to top
				addIntOp(OP_PUSHINT,T_UNASSIGNED);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 816: /* inputstmt: B256INPUT array_element  */
                                                  {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_UNASSIGNED);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 817: /* inputstmt: B256INPUTSTRING args_ev  */
                                                  {
				addIntOp(OP_PUSHINT,T_STRING);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 818: /* inputstmt: B256INPUTSTRING variable  */
                                                    {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_STRING);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 819: /* inputstmt: B256INPUTSTRING args_ea  */
                                                  {
				addOp(OP_STACKTOPTO2); addOp(OP_STACKTOPTO2);		// bring prompt to top
				addIntOp(OP_PUSHINT,T_STRING);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 820: /* inputstmt: B256INPUTSTRING array_element  */
                                                        {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_STRING);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 821: /* inputstmt: B256INPUTINT args_ev  */
                                               {
				addIntOp(OP_PUSHINT,T_INT);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 822: /* inputstmt: B256INPUTINT variable  */
                                                 {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_INT);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 823: /* inputstmt: B256INPUTINT args_ea  */
                                               {
				addOp(OP_STACKTOPTO2); addOp(OP_STACKTOPTO2);		// bring prompt to top
				addIntOp(OP_PUSHINT,T_INT);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 824: /* inputstmt: B256INPUTINT array_element  */
                                                     {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_INT);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 825: /* inputstmt: B256INPUTFLOAT args_ev  */
                                                 {
				addIntOp(OP_PUSHINT,T_FLOAT);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 826: /* inputstmt: B256INPUTFLOAT variable  */
                                                   {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_FLOAT);
				addOp(OP_INPUT);
				addIntOp(OP_VAR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 827: /* inputstmt: B256INPUTFLOAT args_ea  */
                                                 {
				addOp(OP_STACKTOPTO2); addOp(OP_STACKTOPTO2);		// bring prompt to top
				addIntOp(OP_PUSHINT,T_FLOAT);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 828: /* inputstmt: B256INPUTFLOAT array_element  */
                                                       {
				addStringOp(OP_PUSHSTRING, "");
				addIntOp(OP_PUSHINT,T_FLOAT);
				addOp(OP_INPUT);
				addIntOp(OP_ARR_SET, varnumber[--nvarnumber]);
			}
    break;

  case 829: /* printstmt: B256PRINT args_none  */
                                            {
				addIntOp(OP_PUSHINT, 0); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 830: /* printstmt: B256PRINT expr B256SEMICOLON  */
                                                       {
				addIntOp(OP_PUSHINT, 1); //push number of arguments passed
				addIntOp(OP_PUSHINT, 0); // suppress NL
				addOp(OP_PRINT);
			}
    break;

  case 831: /* printstmt: B256PRINT listitems  */
                                              {
				addIntOp(OP_PUSHINT, listlen); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 832: /* printstmt: B256PRINT '(' listitems ')'  */
                                                      {
				addIntOp(OP_PUSHINT, listlen); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 833: /* printstmt: '?' args_none  */
                                        {
				addIntOp(OP_PUSHINT, 0); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 834: /* printstmt: '?' expr B256SEMICOLON  */
                                                 {
				addIntOp(OP_PUSHINT, 1); //push number of arguments passed
				addIntOp(OP_PUSHINT, 0); // suppress NL
				addOp(OP_PRINT);
			}
    break;

  case 835: /* printstmt: '?' listitems  */
                                        {
				addIntOp(OP_PUSHINT, listlen); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 836: /* printstmt: '?' '(' listitems ')'  */
                                                {
				addIntOp(OP_PUSHINT, listlen); //push number of arguments passed
				addIntOp(OP_PUSHINT, 1); // need NL
				addOp(OP_PRINT);
			}
    break;

  case 837: /* wavpausestmt: B256WAVPAUSE args_none  */
                                               {
				addOp(OP_WAVPAUSE);
			}
    break;

  case 838: /* wavplaystmt: B256WAVPLAY args_none  */
                                              {
				addStringOp(OP_PUSHSTRING, "");
				addOp(OP_WAVPLAY);
			}
    break;

  case 839: /* wavplaystmt: B256WAVPLAY expr  */
                                           {
				addOp(OP_WAVPLAY);
			}
    break;

  case 840: /* wavseekstmt: B256WAVSEEK expr  */
                                         {
				addOp(OP_WAVSEEK);
			}
    break;

  case 841: /* wavstopstmt: B256WAVSTOP args_none  */
                                              {
				addOp(OP_WAVSTOP);
			}
    break;

  case 842: /* wavwaitstmt: B256WAVWAIT args_none  */
                                              {
				addOp(OP_WAVWAIT);
			}
    break;

  case 843: /* putslicestmt: B256PUTSLICE args_eee  */
                                               {
				addOp(OP_PUTSLICE);
			}
    break;

  case 844: /* imgloadstmt: B256IMGLOAD args_eee  */
                        {
				addIntOp(OP_PUSHINT, 1); // scale
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT, 0); // rotate
				addOp(OP_STACKSWAP);
				addOp(OP_IMGLOAD);
			}
    break;

  case 845: /* imgloadstmt: B256IMGLOAD args_eeee  */
                        {
				addIntOp(OP_PUSHINT, 0); // rotate
				addOp(OP_STACKSWAP);
				addOp(OP_IMGLOAD);
			}
    break;

  case 846: /* imgloadstmt: B256IMGLOAD args_eeeee  */
                        {
				addOp(OP_IMGLOAD);
			}
    break;

  case 847: /* spritedimstmt: B256SPRITEDIM expr  */
                                           {
				addOp(OP_SPRITEDIM);
			}
    break;

  case 848: /* spriteloadstmt: B256SPRITELOAD args_ee  */
                                                {
				addOp(OP_SPRITELOAD);
			}
    break;

  case 849: /* spriteslicestmt: B256SPRITESLICE args_eeeee  */
                                                   {
				addOp(OP_SPRITESLICE);
			}
    break;

  case 850: /* spritepolystmt: B256SPRITEPOLY args_ee  */
                                               {
				addOp(OP_SPRITEPOLY);
			}
    break;

  case 851: /* spriteplacestmt: B256SPRITEPLACE args_eee  */
                        {
				addIntOp(OP_PUSHINT,3);	// nr of arguments
				addOp(OP_SPRITEPLACE);
			}
    break;

  case 852: /* spriteplacestmt: B256SPRITEPLACE args_eeee  */
                        {
				addIntOp(OP_PUSHINT,4);	// nr of arguments
				addOp(OP_SPRITEPLACE);
			}
    break;

  case 853: /* spriteplacestmt: B256SPRITEPLACE args_eeeee  */
                        {
				addIntOp(OP_PUSHINT,5);	// nr of arguments
				addOp(OP_SPRITEPLACE);
			}
    break;

  case 854: /* spriteplacestmt: B256SPRITEPLACE args_eeeeee  */
                        {
					addIntOp(OP_PUSHINT,6);	// nr of arguments
					addOp(OP_SPRITEPLACE);
			}
    break;

  case 855: /* spritemovestmt: B256SPRITEMOVE args_eee  */
                        {
				addIntOp(OP_PUSHINT,3);	// nr of arguments
				addOp(OP_SPRITEMOVE);
			}
    break;

  case 856: /* spritemovestmt: B256SPRITEMOVE args_eeee  */
                                                    {
				addIntOp(OP_PUSHINT,4);	// nr of arguments
				addOp(OP_SPRITEMOVE);
			}
    break;

  case 857: /* spritemovestmt: B256SPRITEMOVE args_eeeee  */
                                                    {
				addIntOp(OP_PUSHINT,5);	// nr of arguments
				addOp(OP_SPRITEMOVE);
			}
    break;

  case 858: /* spritemovestmt: B256SPRITEMOVE args_eeeeee  */
                                                     {
					addIntOp(OP_PUSHINT,6);	// nr of arguments
					addOp(OP_SPRITEMOVE);
			}
    break;

  case 859: /* spritehidestmt: B256SPRITEHIDE expr  */
                                            {
				addOp(OP_SPRITEHIDE);
			}
    break;

  case 860: /* spriteshowstmt: B256SPRITESHOW expr  */
                                            {
				addOp(OP_SPRITESHOW);
			}
    break;

  case 861: /* clickclearstmt: B256CLICKCLEAR args_none  */
                                                 {
				addOp(OP_CLICKCLEAR);
			}
    break;

  case 862: /* changedirstmt: B256CHANGEDIR expr  */
                                           {
				addOp(OP_CHANGEDIR);
			}
    break;

  case 863: /* dbopenstmt: B256DBOPEN expr  */
                                        {
				addIntOp(OP_PUSHINT,0);	// default db number
				addOp(OP_STACKSWAP);
				addOp(OP_DBOPEN);
			}
    break;

  case 864: /* dbopenstmt: B256DBOPEN args_ee  */
                                             {
				addOp(OP_DBOPEN);
			}
    break;

  case 865: /* dbclosestmt: B256DBCLOSE args_none  */
                                              {
				addIntOp(OP_PUSHINT,0);	// default db number
				addOp(OP_DBCLOSE);
			}
    break;

  case 866: /* dbclosestmt: B256DBCLOSE expr  */
                                           {
				addOp(OP_DBCLOSE);
			}
    break;

  case 867: /* dbexecutestmt: B256DBEXECUTE expr  */
                                           {
				addIntOp(OP_PUSHINT,0);	// default db number
				addOp(OP_STACKSWAP);
				addOp(OP_DBEXECUTE);
			}
    break;

  case 868: /* dbexecutestmt: B256DBEXECUTE args_ee  */
                                                {
				addOp(OP_DBEXECUTE);
			}
    break;

  case 869: /* dbopensetstmt: B256DBOPENSET expr  */
                                           {
				addIntOp(OP_PUSHINT,0);	// default db number
				addOp(OP_STACKSWAP);
				addIntOp(OP_PUSHINT,0);	// default dbset number
				addOp(OP_STACKSWAP);
				addOp(OP_DBOPENSET);
			}
    break;

  case 870: /* dbopensetstmt: B256DBOPENSET args_ee  */
                                                {
				addIntOp(OP_PUSHINT,0);	// default dbset number
				addOp(OP_STACKSWAP);
				addOp(OP_DBOPENSET);
			}
    break;

  case 871: /* dbopensetstmt: B256DBOPENSET args_eee  */
                                                 {
				addOp(OP_DBOPENSET);
			}
    break;

  case 872: /* dbclosesetstmt: B256DBCLOSESET args_none  */
                                                 {
				addIntOp(OP_PUSHINT,0);	// default db number
				addIntOp(OP_PUSHINT,0);	// default dbset number
				addOp(OP_DBCLOSESET);
			}
    break;

  case 873: /* dbclosesetstmt: B256DBCLOSESET expr  */
                                              {
				addIntOp(OP_PUSHINT,0);	// default dbset number
				addOp(OP_DBCLOSESET);
			}
    break;

  case 874: /* dbclosesetstmt: B256DBCLOSESET args_ee  */
                                                 {
				addOp(OP_DBCLOSESET);
			}
    break;

  case 875: /* netlistenstmt: B256NETLISTEN expr  */
                                           {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKSWAP);
				addOp(OP_NETLISTEN);
			}
    break;

  case 876: /* netlistenstmt: B256NETLISTEN args_ee  */
                                                {
				addOp(OP_NETLISTEN);
			}
    break;

  case 877: /* netconnectstmt: B256NETCONNECT args_ee  */
                                               {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKTOPTO2);
				addOp(OP_NETCONNECT);
			}
    break;

  case 878: /* netconnectstmt: B256NETCONNECT args_eee  */
                                                  {
				addOp(OP_NETCONNECT);
			}
    break;

  case 879: /* netwritestmt: B256NETWRITE expr  */
                                          {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_STACKSWAP);
				addOp(OP_NETWRITE);
			}
    break;

  case 880: /* netwritestmt: B256NETWRITE args_ee  */
                                               {
				addOp(OP_NETWRITE);
			}
    break;

  case 881: /* netclosestmt: B256NETCLOSE args_none  */
                                               {
				addIntOp(OP_PUSHINT, 0);
				addOp(OP_NETCLOSE);
			}
    break;

  case 882: /* netclosestmt: B256NETCLOSE expr  */
                                            {
				addOp(OP_NETCLOSE);
			}
    break;

  case 883: /* killstmt: B256KILL expr  */
                              {
				addOp(OP_KILL);
			}
    break;

  case 884: /* setclipboardimagestmt: B256SETCLIPBOARDIMAGE expr  */
                                                   {
				addOp(OP_SETCLIPBOARDIMAGE);
			}
    break;

  case 885: /* setclipboardstringstmt: B256SETCLIPBOARDSTRING expr  */
                                                    {
				addOp(OP_SETCLIPBOARDSTRING);
			}
    break;

  case 886: /* setsettingstmt: B256SETSETTING args_eee  */
                                                {
				addOp(OP_SETSETTING);
			}
    break;

  case 887: /* portoutstmt: B256PORTOUT args_ee  */
                                            {
				addOp(OP_PORTOUT);
			}
    break;

  case 888: /* imgsavestmt: B256IMGSAVE expr  */
                                          {
				addStringOp(OP_PUSHSTRING, "PNG");
				addOp(OP_IMGSAVE);
			}
    break;

  case 889: /* imgsavestmt: B256IMGSAVE args_ee  */
                                              {
				addOp(OP_IMGSAVE);
			}
    break;

  case 890: /* editvisiblestmt: B256EDITVISIBLE expr  */
                                             {
				addOp(OP_EDITVISIBLE);
			}
    break;

  case 891: /* graphvisiblestmt: B256GRAPHVISIBLE expr  */
                                              {
				addOp(OP_GRAPHVISIBLE);
			}
    break;

  case 892: /* outputvisiblestmt: B256OUTPUTVISIBLE expr  */
                                               {
				addOp(OP_OUTPUTVISIBLE);
			}
    break;

  case 893: /* maintoolbarvisiblestmt: B256MAINTOOLBARVISIBLE expr  */
                                                    {
				addOp(OP_MAINTOOLBARVISIBLE);
			}
    break;

  case 894: /* graphtoolbarvisiblestmt: B256GRAPHTOOLBARVISIBLE expr  */
                                                     {
				addOp(OP_GRAPHTOOLBARVISIBLE);
			}
    break;

  case 895: /* outputtoolbarvisiblestmt: B256OUTPUTTOOLBARVISIBLE expr  */
                                                      {
				addOp(OP_OUTPUTTOOLBARVISIBLE);
			}
    break;

  case 896: /* globalstmt: B256GLOBAL functionvariables  */
                                                     {
				// create ops to make all of the variables listed globals
				if (numifs>0) {
					errorcode = COMPERR_GLOBALNOTHERE;
					return -1;
				}
				int t;
				for(t=numargs-1;t>=0;t--) {
					addIntOp(OP_GLOBAL, args[t]);
				}
				numargs=0;	// clear the list for next function
			}
    break;

  case 897: /* penwidthstmt: B256PENWIDTH expr  */
                                          {
				addOp(OP_PENWIDTH);
			}
    break;

  case 898: /* alertstmt: B256ALERT expr  */
                                       {
				addOp(OP_ALERT);
			}
    break;

  case 899: /* continuedostmt: B256CONTINUEDO  */
                                       {
				// find most recent DO and jump to CONTINUE
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEDO) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[n],INTERNALSYMBOLCONTINUE));
				} else {
					errorcode = COMPERR_CONTINUEDO;
					return -1;
				}
			}
    break;

  case 900: /* continueforstmt: B256CONTINUEFOR  */
                                        {
				// find most recent FOR and jump to CONTINUE
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEFOR) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[n],INTERNALSYMBOLCONTINUE));
				} else {
					errorcode = COMPERR_CONTINUEFOR;
					return -1;
				}
			}
    break;

  case 901: /* continuewhilestmt: B256CONTINUEWHILE  */
                                          {
				// find most recent WHILE and jump to CONTINUE
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEWHILE) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[n],INTERNALSYMBOLCONTINUE));
				} else {
                                        errorcode = COMPERR_CONTINUEWHILE;
					return -1;
				}
			}
    break;

  case 902: /* exitdostmt: B256EXITDO  */
                                   {
				// find most recent DO and jump to exit
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEDO) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[n],INTERNALSYMBOLEXIT));
				} else {
					errorcode = COMPERR_EXITDO;
					return -1;
				}
			}
    break;

  case 903: /* exitforstmt: B256EXITFOR  */
                                    {
				// find most recent FOR and jump to exit
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEFOR) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_EXITFOR, getInternalSymbol(iftableid[n],INTERNALSYMBOLEXIT));
				} else {
					errorcode = COMPERR_EXITFOR;
					return -1;
				}
			}
    break;

  case 904: /* exitwhilestmt: B256EXITWHILE  */
                                      {
				// find most recent WHILE and jump to exit
				int n=numifs-1;
				while(n>=0&&iftabletype[n]!=IFTABLETYPEWHILE) {
					n--;
				}
				if (n>=0) {
					addIntOp(OP_GOTO, getInternalSymbol(iftableid[n],INTERNALSYMBOLEXIT));
				} else {
					errorcode = COMPERR_EXITWHILE;
					return -1;
				}
			}
    break;

  case 905: /* printercancelstmt: B256PRINTERCANCEL args_none  */
                                                    {
				addOp(OP_PRINTERCANCEL);
			}
    break;

  case 906: /* printeroffstmt: B256PRINTEROFF args_none  */
                                                 {
				addOp(OP_PRINTEROFF);
			}
    break;

  case 907: /* printeronstmt: B256PRINTERON args_none  */
                                                {
				addOp(OP_PRINTERON);
			}
    break;

  case 908: /* printerpagestmt: B256PRINTERPAGE args_none  */
                                                  {
				addOp(OP_PRINTERPAGE);
			}
    break;

  case 909: /* functionstmt: B256FUNCTION variable functionvariablelist  */
                                                                   {
				if (numifs>0) {
					errorcode = COMPERR_FUNCTIONNOTHERE;
					return -1;
				}
				//
				// $2 is the symbol for the function - add the start to the label table
				functionDefSymbol = varnumber[--nvarnumber];
				//
				//check if name of function is already used by a label, subroutine or another function
				if (symtableaddress[functionDefSymbol] != -1) {
						errorcode = COMPERR_LABELREDEFINED;
						return -1;
				}
				//
				// create jump around function definition (use nextifid and 0 for jump after)
				addIntOp(OP_GOTO, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
				//
				// create the new if frame for this function
				symtableaddress[functionDefSymbol] = wordOffset;
				symtableaddresstype[functionDefSymbol] = ADDRESSTYPE_FUNCTION;
				newIf(linenumber, IFTABLETYPEFUNCTION, -1);
				//
				// store the number of the arguments required by FUNCTION
				// to check if number of arguments passed match definition when is called
				symtableaddressargs[functionDefSymbol] = numargs;
				//
				// add the assigns of the function arguments
				addOp(OP_INCREASERECURSE);
				{ 	int t;
					for(t=numargs-1;t>=0;t--) {
						addIntOp(OP_VAR_SET, args[t]);
					}
				}
				//
				// initialize return variable
				addIntOp(OP_PUSHINT, 0);
				addIntOp(OP_VAR_SET, functionDefSymbol);
				//
				numargs=0;	// clear the list for next function
			}
    break;

  case 910: /* subroutinestmt: B256SUBROUTINE variable functionvariablelist  */
                                                                     {
				if (numifs>0) {
					errorcode = COMPERR_FUNCTIONNOTHERE;
					return -1;
				}
				//
				// $2 is the symbol for the subroutine - add the start to the label table
				subroutineDefSymbol = varnumber[--nvarnumber];
				//
				//check if name of subroutine is already used by a label, function or another subroutine
				if (symtableaddress[subroutineDefSymbol] != -1) {
						errorcode = COMPERR_LABELREDEFINED;
						return -1;
				}
				//
				// create jump around subroutine definition (use nextifid and 0 for jump after)
				addIntOp(OP_GOTO, getInternalSymbol(nextifid,INTERNALSYMBOLEXIT));
				//
				// create the new if frame for this subroutine
				symtableaddress[subroutineDefSymbol] = wordOffset;
				symtableaddresstype[subroutineDefSymbol] = ADDRESSTYPE_SUBROUTINE;
				newIf(linenumber, IFTABLETYPESUBROUTINE, -1);
				//
				// store the number of the arguments required by SUBROUTINE
				// to check if number of arguments passed match definition when is called
				symtableaddressargs[subroutineDefSymbol] = numargs;
				//
				// add the assigns of the function arguments
				addOp(OP_INCREASERECURSE);
				{ 	int t;
					for(t=numargs-1;t>=0;t--) {
						addIntOp(OP_VAR_SET, args[t]);
					}
				}
				numargs=0;	// clear the list for next function
			}
    break;

  case 911: /* endfunctionstmt: B256ENDFUNCTION  */
                                        {
				if (numifs>0) {
				if (iftabletype[numifs-1]==IFTABLETYPEFUNCTION) {
					//
					// add return if there is not one
					addIntOp(OP_VAR_GET, functionDefSymbol);
					addOp(OP_DECREASERECURSE);
					addOp(OP_RETURN);
					//
					// add address for jump around function definition
					symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
					functionDefSymbol = -1;
					//
					numifs--;
				//
				} else {
					errorcode = testIfOnTableError(numincludes);
					linenumber = testIfOnTable(numincludes);
					return -1;
				}
			} else {
				errorcode = COMPERR_ENDFUNCTION;
				return -1;
			}
		}
    break;

  case 912: /* endsubroutinestmt: B256ENDSUBROUTINE  */
                                  {
			if (numifs>0) {
					if (iftabletype[numifs-1]==IFTABLETYPESUBROUTINE) {
					addOp(OP_DECREASERECURSE);
					addOp(OP_RETURN);
					//
					// add address for jump around function definition
					symtableaddress[getInternalSymbol(iftableid[numifs-1],INTERNALSYMBOLEXIT)] = wordOffset;
					subroutineDefSymbol = -1;
					//
					numifs--;
				} else {
					errorcode = testIfOnTableError(numincludes);
					linenumber = testIfOnTable(numincludes);
					return -1;
				}
			} else {
                                errorcode = COMPERR_ENDSUBROUTINE;
				return -1;
			}
		}
    break;

  case 913: /* regexminimalstmt: B256REGEXMINIMAL expr  */
                              {
		addOp(OP_REGEXMINIMAL);
	}
    break;

  case 914: /* unassignstmt: B256UNASSIGN variable_a  */
                                {
		addIntOp(OP_VAR_UN, varnumber[--nvarnumber]);
	}
    break;

  case 915: /* unassignstmt: B256UNASSIGN array_element  */
                                     {
		addIntOp(OP_ARR_UN, varnumber[--nvarnumber]);
	}
    break;

  case 916: /* variablewatchstmt: B256VARIABLEWATCH variable_a  */
                                     {
		addIntOp(OP_VARIABLEWATCH, varnumber[--nvarnumber]);
	}
    break;

  case 917: /* imagecropstmt: B256IMAGECROP args_eeeee  */
                                 {
		addOp(OP_IMAGECROP);
	}
    break;

  case 918: /* imageautocropstmt: B256IMAGEAUTOCROP expr  */
                               {
		addIntOp(OP_PUSHINT,1);	// nr of arguments
		addOp(OP_IMAGEAUTOCROP);
	}
    break;

  case 919: /* imageautocropstmt: B256IMAGEAUTOCROP args_ee  */
                                    {
		addIntOp(OP_PUSHINT,2);	// nr of arguments
		addOp(OP_IMAGEAUTOCROP);
	}
    break;

  case 920: /* imageresizestmt: B256IMAGERESIZE args_eee  */
                                 {
		addIntOp(OP_PUSHINT,3);	// nr of arguments
		addOp(OP_IMAGERESIZE);
	}
    break;

  case 921: /* imageresizestmt: B256IMAGERESIZE args_ee  */
                                  {
		addIntOp(OP_PUSHINT,2);	// nr of arguments
		addOp(OP_IMAGERESIZE);
	}
    break;

  case 922: /* imagesetpixelstmt: B256IMAGESETPIXEL args_eeee  */
                                    {
		addOp(OP_IMAGESETPIXEL);
	}
    break;

  case 923: /* imagesetpixelstmt: B256IMAGESETPIXEL args_eee  */
                                     {
		addOp(OP_GETCOLOR);
		addOp(OP_IMAGESETPIXEL);
	}
    break;

  case 924: /* imagedrawstmt: B256IMAGEDRAW args_eeeeee  */
                                  {
		addIntOp(OP_PUSHINT,6);	// nr of arguments
		addOp(OP_IMAGEDRAW);
	}
    break;

  case 925: /* imagedrawstmt: B256IMAGEDRAW args_eeeee  */
                                   {
		addIntOp(OP_PUSHINT,5);	// nr of arguments
		addOp(OP_IMAGEDRAW);
	}
    break;

  case 926: /* imagedrawstmt: B256IMAGEDRAW args_eeee  */
                                  {
		addIntOp(OP_PUSHINT,4);	// nr of arguments
		addOp(OP_IMAGEDRAW);
	}
    break;

  case 927: /* imagedrawstmt: B256IMAGEDRAW args_eee  */
                                 {
		addIntOp(OP_PUSHINT,3);	// nr of arguments
		addOp(OP_IMAGEDRAW);
	}
    break;

  case 928: /* imagecenteredstmt: B256IMAGECENTERED args_eeeeee  */
        {
		addIntOp(OP_PUSHINT,6);	// nr of arguments
		addOp(OP_IMAGECENTERED);
	}
    break;

  case 929: /* imagecenteredstmt: B256IMAGECENTERED args_eeeee  */
                                        {
		addIntOp(OP_PUSHINT,5);	// nr of arguments
		addOp(OP_IMAGECENTERED);
	}
    break;

  case 930: /* imagecenteredstmt: B256IMAGECENTERED args_eeee  */
                                      {
		addIntOp(OP_PUSHINT,4);	// nr of arguments
		addOp(OP_IMAGECENTERED);
	}
    break;

  case 931: /* imagecenteredstmt: B256IMAGECENTERED args_eee  */
                                     {
		addIntOp(OP_PUSHINT,3);	// nr of arguments
		addOp(OP_IMAGECENTERED);
	}
    break;

  case 932: /* imagetransformedstmt: B256IMAGETRANSFORMED args_eeeeeeeeee  */
                                             {
		addOp(OP_IMAGETRANSFORMED);
	}
    break;

  case 933: /* imagetransformedstmt: B256IMAGETRANSFORMED args_eeeeeeeee  */
                                              {
		addIntOp(OP_PUSHINT,1); // opacity
		addOp(OP_IMAGETRANSFORMED);
	}
    break;

  case 934: /* imagerotatestmt: B256IMAGEROTATE args_ee  */
                                {
		addOp(OP_IMAGEROTATE);
	}
    break;

  case 935: /* imageflipstmt: B256IMAGEFLIP args_eee  */
                               {
		addOp(OP_IMAGEFLIP);
	}
    break;

  case 936: /* imageflipstmt: B256IMAGEFLIP args_ee  */
                                {
		addIntOp(OP_PUSHINT,0);
		addOp(OP_IMAGEFLIP);
	}
    break;

  case 937: /* imagesmoothstmt: B256IMAGESMOOTH expr  */
                             {
		addOp(OP_IMAGESMOOTH);
	}
    break;

  case 938: /* unloadstmt: B256UNLOAD expr  */
                        {
		addOp(OP_UNLOAD);
	}
    break;

  case 939: /* setgraphstmt: B256SETGRAPH expr  */
                          {
		addOp(OP_SETGRAPH);
	}
    break;

  case 940: /* setgraphstmt: B256SETGRAPH args_none  */
                                 {
		addStringOp(OP_PUSHSTRING, "");
		addOp(OP_SETGRAPH);
	}
    break;

  case 941: /* arraybasestmt: B256ARRAYBASE expr  */
                           {
		addOp(OP_ARRAYBASE);
	}
    break;



      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}



int
yyerror(const char *msg) {
        (void) msg;
        errorcode = COMPERR_SYNTAX;
	return -1;
}
